(set-logic QF_NIA)
(set-info
  :source |
SMT script generated by Ultimate LassoRanker [1].
Ultimate LassoRanker is a tool that analyzes termination and nontermination of 
lasso-shaped programs. This script contains the SMT commands that Ultimate 
LassoRanker used while checking if a lasso-shaped program has a geometric 
nontermination argument [2].

This SMT script belongs to a set of SMT scripts that was generated by applying
Ultimate Buchi Automizer [3,4] to the benchmarks from the SV-COMP 2015 [5,6] 
which are available at [7]. Ultimate Buchi Automizer takes omega-traces
(lasso-shaped programs) and uses LassoRanker in order to check if the 
lasso-shaped program is terminating.

2015-04-30, Matthias Heizmann (heizmann@informatik.uni-freiburg.de)


[1] https://ultimate.informatik.uni-freiburg.de/LassoRanker/
[2] Jan Leike, Matthias Heizmann:
Geometric Series as Nontermination Arguments for Linear Lasso Programs. 
CoRR abs/1405.4413 (2014)
http://arxiv.org/abs/1405.4413
[3] http://ultimate.informatik.uni-freiburg.de/BuchiAutomizer/
[4] Matthias Heizmann, Jochen Hoenicke, Andreas Podelski: Software Model 
Checking for People Who Love Automata. CAV 2013:36-52
[5] http://sv-comp.sosy-lab.org/2015/
[6] Dirk Beyer: Software Verification and Verifiable Witnesses - (Report on 
SV-COMP 2015). TACAS 2015: 401-416
[7] https://svn.sosy-lab.org/software/sv-benchmarks/tags/svcomp15/
|)
(set-info :smt-lib-version 2.0)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun |init_(ite (select #valid substring_~ps~2.base) 1 0)| () Int)
(declare-fun |honda_(ite (select #valid substring_~ps~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid substring_~ps~2.base) 1 0)| () Int)
(declare-fun |init_substring_#t~post8.offset| () Int)
(declare-fun |honda_substring_#t~post8.offset| () Int)
(declare-fun |ray_substring_#t~post8.offset| () Int)
(declare-fun init_substring_~ps2~3.offset () Int)
(declare-fun honda_substring_~ps2~3.offset () Int)
(declare-fun ray_substring_~ps2~3.offset () Int)
(declare-fun init_substring_~s.offset () Int)
(declare-fun honda_substring_~s.offset () Int)
(declare-fun ray_substring_~s.offset () Int)
(declare-fun |init_substring_#t~mem1| () Int)
(declare-fun |honda_substring_#t~mem1| () Int)
(declare-fun |ray_substring_#t~mem1| () Int)
(declare-fun |init_substring_#in~s.base| () Int)
(declare-fun |honda_substring_#in~s.base| () Int)
(declare-fun |ray_substring_#in~s.base| () Int)
(declare-fun init_substring_~pt~3.offset () Int)
(declare-fun honda_substring_~pt~3.offset () Int)
(declare-fun ray_substring_~pt~3.offset () Int)
(declare-fun
  |init_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
  () Int)
(declare-fun
  |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
  () Int)
(declare-fun
  |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
  () Int)
(declare-fun |init_substring_#t~mem2| () Int)
(declare-fun |honda_substring_#t~mem2| () Int)
(declare-fun |ray_substring_#t~mem2| () Int)
(declare-fun init_substring_~ps~2.base () Int)
(declare-fun honda_substring_~ps~2.base () Int)
(declare-fun ray_substring_~ps~2.base () Int)
(declare-fun |init_substring_#in~s.offset| () Int)
(declare-fun |honda_substring_#in~s.offset| () Int)
(declare-fun |ray_substring_#in~s.offset| () Int)
(declare-fun |init_substring_#in~t.offset| () Int)
(declare-fun |honda_substring_#in~t.offset| () Int)
(declare-fun |ray_substring_#in~t.offset| () Int)
(declare-fun |init_(ite (select #valid 0) 1 0)| () Int)
(declare-fun |honda_(ite (select #valid 0) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid 0) 1 0)| () Int)
(declare-fun init_substring_~t.offset () Int)
(declare-fun honda_substring_~t.offset () Int)
(declare-fun ray_substring_~t.offset () Int)
(declare-fun init_substring_~ps~2.offset () Int)
(declare-fun honda_substring_~ps~2.offset () Int)
(declare-fun ray_substring_~ps~2.offset () Int)
(declare-fun |init_#NULL.offset| () Int)
(declare-fun |honda_#NULL.offset| () Int)
(declare-fun |ray_#NULL.offset| () Int)
(declare-fun |init_substring_#t~mem3| () Int)
(declare-fun |honda_substring_#t~mem3| () Int)
(declare-fun |ray_substring_#t~mem3| () Int)
(declare-fun |init_substring_#t~mem0| () Int)
(declare-fun |honda_substring_#t~mem0| () Int)
(declare-fun |ray_substring_#t~mem0| () Int)
(declare-fun init_substring_~s.base () Int)
(declare-fun honda_substring_~s.base () Int)
(declare-fun ray_substring_~s.base () Int)
(declare-fun init_substring_~pt~3.base () Int)
(declare-fun honda_substring_~pt~3.base () Int)
(declare-fun ray_substring_~pt~3.base () Int)
(declare-fun init_substring_~t.base () Int)
(declare-fun honda_substring_~t.base () Int)
(declare-fun ray_substring_~t.base () Int)
(declare-fun |init_substring_#t~mem7| () Int)
(declare-fun |honda_substring_#t~mem7| () Int)
(declare-fun |ray_substring_#t~mem7| () Int)
(declare-fun |init_substring_#in~t.base| () Int)
(declare-fun |honda_substring_#in~t.base| () Int)
(declare-fun |ray_substring_#in~t.base| () Int)
(declare-fun |init_substring_#t~post8.base| () Int)
(declare-fun |honda_substring_#t~post8.base| () Int)
(declare-fun |ray_substring_#t~post8.base| () Int)
(declare-fun |init_(select #length substring_~ps~2.base)| () Int)
(declare-fun |honda_(select #length substring_~ps~2.base)| () Int)
(declare-fun |ray_(select #length substring_~ps~2.base)| () Int)
(declare-fun init_substring_~ps2~3.base () Int)
(declare-fun honda_substring_~ps2~3.base () Int)
(declare-fun ray_substring_~ps2~3.base () Int)
(declare-fun |init_#NULL.base| () Int)
(declare-fun |honda_#NULL.base| () Int)
(declare-fun |ray_#NULL.base| () Int)
(declare-fun |init_(ite substring_#t~short4 1 0)| () Int)
(declare-fun |honda_(ite substring_#t~short4 1 0)| () Int)
(declare-fun |ray_(ite substring_#t~short4 1 0)| () Int)
(declare-fun |honda_(select old(#length) substring_#in~t.base)| () Int)
(declare-fun |ray_(select old(#length) substring_#in~t.base)| () Int)
(declare-fun |honda_(select old(#length) substring_#in~s.base)| () Int)
(declare-fun |ray_(select old(#length) substring_#in~s.base)| () Int)
(declare-fun |honda_(ite (select #valid substring_#in~t.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid substring_#in~t.base) 1 0)| () Int)
(declare-fun |honda_(ite (select old(#valid) 0) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) 0) 1 0)| () Int)
(declare-fun |honda_(select #length substring_#in~s.base)| () Int)
(declare-fun |ray_(select #length substring_#in~s.base)| () Int)
(declare-fun |honda_(select #length substring_#in~t.base)| () Int)
(declare-fun |ray_(select #length substring_#in~t.base)| () Int)
(declare-fun |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| ()
  Int)
(declare-fun |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| ()
  Int)
(declare-fun |honda_(ite (select #valid substring_#in~s.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid substring_#in~s.base) 1 0)| () Int)
(declare-fun |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| ()
  Int)
(declare-fun |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| ()
  Int)
(declare-fun
  |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
  () Int)
(declare-fun
  |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
  () Int)
(declare-fun |honda_(select #length substring_~pt~3.base)| () Int)
(declare-fun |ray_(select #length substring_~pt~3.base)| () Int)
(declare-fun
  |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
  () Int)
(declare-fun
  |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
  () Int)
(declare-fun |honda_(ite (select #valid substring_~pt~3.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid substring_~pt~3.base) 1 0)| () Int)
(declare-fun lambda () Int)
(declare-fun aux_6122 () Int)
(declare-fun aux_6124 () Int)
(declare-fun aux_6128 () Int)
(declare-fun aux_6130 () Int)
(declare-fun aux_6134 () Int)
(declare-fun aux_6136 () Int)
(declare-fun aux_6140 () Int)
(declare-fun aux_6142 () Int)
(declare-fun aux_6146 () Int)
(declare-fun aux_6148 () Int)
(declare-fun aux_6152 () Int)
(declare-fun aux_6154 () Int)
(assert
 (and
 (or
 (and
 (= |init_(ite (select #valid substring_~ps~2.base) 1 0)|
 |honda_(ite (select #valid substring_~ps~2.base) 1 0)|)
 (= |init_substring_#t~post8.offset| |honda_substring_#t~post8.offset|)
 (= init_substring_~ps2~3.offset honda_substring_~ps2~3.offset)
 (= |init_substring_#t~mem1| |honda_substring_#t~mem1|)
 (= init_substring_~pt~3.offset honda_substring_~pt~3.offset)
 (=
 |init_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 (= |init_substring_#t~mem2| |honda_substring_#t~mem2|)
 (= |init_substring_#t~mem3| |honda_substring_#t~mem3|)
 (= |init_substring_#t~mem0| |honda_substring_#t~mem0|)
 (= init_substring_~pt~3.base honda_substring_~pt~3.base)
 (= |init_substring_#t~mem7| |honda_substring_#t~mem7|)
 (= |init_substring_#t~post8.base| |honda_substring_#t~post8.base|)
 (= |init_(select #length substring_~ps~2.base)|
 |honda_(select #length substring_~ps~2.base)|)
 (= init_substring_~ps2~3.base honda_substring_~ps2~3.base)
 (= |init_(ite substring_#t~short4 1 0)|
 |honda_(ite substring_#t~short4 1 0)|)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| (- 1))
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6122 1) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 1)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6122 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 1)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6124 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 1) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0)
 (* |honda_substring_#in~s.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| (- 1))
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset (- 1)) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 1) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 1) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 1) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| (- 1))
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| (- 1))
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6124 1) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 1)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 1) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 1) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| (- 1)) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6124 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base (- 1)) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 1) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 1) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 1)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0)
 (* |honda_substring_#in~s.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base (- 1)) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6122 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 1)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| (- 1)) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 1)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base (- 1)) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset (- 1)) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| (- 1))
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 1) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| (- 1))
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| (- 1))
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and
 (= |init_(ite (select #valid substring_~ps~2.base) 1 0)|
 |honda_(ite (select #valid substring_~ps~2.base) 1 0)|)
 (= |init_substring_#t~post8.offset| |honda_substring_#t~post8.offset|)
 (= init_substring_~ps2~3.offset honda_substring_~ps2~3.offset)
 (= |init_substring_#t~mem1| |honda_substring_#t~mem1|)
 (= init_substring_~pt~3.offset honda_substring_~pt~3.offset)
 (=
 |init_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 (= |init_substring_#t~mem2| |honda_substring_#t~mem2|)
 (= |init_substring_#t~mem3| |honda_substring_#t~mem3|)
 (= |init_substring_#t~mem0| |honda_substring_#t~mem0|)
 (= init_substring_~pt~3.base honda_substring_~pt~3.base)
 (= |init_substring_#t~mem7| |honda_substring_#t~mem7|)
 (= |init_substring_#t~post8.base| |honda_substring_#t~post8.base|)
 (= |init_(select #length substring_~ps~2.base)|
 |honda_(select #length substring_~ps~2.base)|)
 (= init_substring_~ps2~3.base honda_substring_~ps2~3.base)
 (= |init_(ite substring_#t~short4 1 0)|
 |honda_(ite substring_#t~short4 1 0)|)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| (- 1))
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6128 1) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 1)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6128 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 1)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6130 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 1) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0)
 (* |honda_substring_#in~s.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| (- 1))
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset (- 1)) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 1) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 1) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 1)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 1) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| (- 1))
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6130 1) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 1)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 1) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 1) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| (- 1)) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6130 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base (- 1)) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 1) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 1) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 1)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0)
 (* |honda_substring_#in~s.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base (- 1)) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6128 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 1)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base (- 1)) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset (- 1)) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| (- 1))
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 1) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| (- 1))
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 1) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| (- 1))
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| (- 1))
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and
 (= |init_(ite (select #valid substring_~ps~2.base) 1 0)|
 |honda_(ite (select #valid substring_~ps~2.base) 1 0)|)
 (= |init_substring_#t~post8.offset| |honda_substring_#t~post8.offset|)
 (= init_substring_~ps2~3.offset honda_substring_~ps2~3.offset)
 (= |init_substring_#t~mem1| |honda_substring_#t~mem1|)
 (= init_substring_~pt~3.offset honda_substring_~pt~3.offset)
 (=
 |init_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 (= |init_substring_#t~mem2| |honda_substring_#t~mem2|)
 (= |init_substring_#t~mem3| |honda_substring_#t~mem3|)
 (= |init_substring_#t~mem0| |honda_substring_#t~mem0|)
 (= init_substring_~pt~3.base honda_substring_~pt~3.base)
 (= |init_substring_#t~mem7| |honda_substring_#t~mem7|)
 (= |init_substring_#t~post8.base| |honda_substring_#t~post8.base|)
 (= |init_(select #length substring_~ps~2.base)|
 |honda_(select #length substring_~ps~2.base)|)
 (= init_substring_~ps2~3.base honda_substring_~ps2~3.base)
 (= |init_(ite substring_#t~short4 1 0)|
 |honda_(ite substring_#t~short4 1 0)|)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| (- 1))
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6134 1) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 1)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6134 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 1)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6136 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 1) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0)
 (* |honda_substring_#in~s.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| (- 1))
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset (- 1)) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 1) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 1) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| (- 1)) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 1)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 1) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| (- 1))
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6136 1) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 1)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 1) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 1) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| (- 1)) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6136 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base (- 1)) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 1) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 1) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 1)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0)
 (* |honda_substring_#in~s.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base (- 1)) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6134 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 1)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base (- 1)) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset (- 1)) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| (- 1))
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 1) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| (- 1))
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| (- 1))
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and
 (= |init_(ite (select #valid substring_~ps~2.base) 1 0)|
 |honda_(ite (select #valid substring_~ps~2.base) 1 0)|)
 (= |init_substring_#t~post8.offset| |honda_substring_#t~post8.offset|)
 (= init_substring_~ps2~3.offset honda_substring_~ps2~3.offset)
 (= |init_substring_#t~mem1| |honda_substring_#t~mem1|)
 (= init_substring_~pt~3.offset honda_substring_~pt~3.offset)
 (=
 |init_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 (= |init_substring_#t~mem2| |honda_substring_#t~mem2|)
 (= |init_substring_#t~mem3| |honda_substring_#t~mem3|)
 (= |init_substring_#t~mem0| |honda_substring_#t~mem0|)
 (= init_substring_~pt~3.base honda_substring_~pt~3.base)
 (= |init_substring_#t~mem7| |honda_substring_#t~mem7|)
 (= |init_substring_#t~post8.base| |honda_substring_#t~post8.base|)
 (= |init_(select #length substring_~ps~2.base)|
 |honda_(select #length substring_~ps~2.base)|)
 (= init_substring_~ps2~3.base honda_substring_~ps2~3.base)
 (= |init_(ite substring_#t~short4 1 0)|
 |honda_(ite substring_#t~short4 1 0)|)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| (- 1))
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6140 1) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 1)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6140 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 1)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6142 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 1) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0)
 (* |honda_substring_#in~s.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| (- 1))
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset (- 1)) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 1) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 1) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 1) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 1) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| (- 1))
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| (- 1))
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6142 1) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 1)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 1) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 1) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| (- 1)) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6142 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base (- 1)) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 1) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 1) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 1)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0)
 (* |honda_substring_#in~s.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base (- 1)) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6140 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 1)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base (- 1)) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset (- 1)) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| (- 1))
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 1) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| (- 1))
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| (- 1))
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and
 (= |init_(ite (select #valid substring_~ps~2.base) 1 0)|
 |honda_(ite (select #valid substring_~ps~2.base) 1 0)|)
 (= |init_substring_#t~post8.offset| |honda_substring_#t~post8.offset|)
 (= init_substring_~ps2~3.offset honda_substring_~ps2~3.offset)
 (= |init_substring_#t~mem1| |honda_substring_#t~mem1|)
 (= init_substring_~pt~3.offset honda_substring_~pt~3.offset)
 (=
 |init_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 (= |init_substring_#t~mem2| |honda_substring_#t~mem2|)
 (= |init_substring_#t~mem3| |honda_substring_#t~mem3|)
 (= |init_substring_#t~mem0| |honda_substring_#t~mem0|)
 (= init_substring_~pt~3.base honda_substring_~pt~3.base)
 (= |init_substring_#t~mem7| |honda_substring_#t~mem7|)
 (= |init_substring_#t~post8.base| |honda_substring_#t~post8.base|)
 (= |init_(select #length substring_~ps~2.base)|
 |honda_(select #length substring_~ps~2.base)|)
 (= init_substring_~ps2~3.base honda_substring_~ps2~3.base)
 (= |init_(ite substring_#t~short4 1 0)|
 |honda_(ite substring_#t~short4 1 0)|)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| (- 1))
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6146 1) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 1)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6146 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 1)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6148 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 1) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0)
 (* |honda_substring_#in~s.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| (- 1))
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset (- 1)) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 1) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 1) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| (- 1)) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 1) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| (- 1))
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6148 1) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 1)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 1) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 1) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| (- 1)) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6148 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base (- 1)) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 1) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 1) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 1)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0)
 (* |honda_substring_#in~s.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base (- 1)) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6146 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 1)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base (- 1)) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset (- 1)) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| (- 1))
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 1) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| (- 1))
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 1) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| (- 1))
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| (- 1))
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and
 (= |init_(ite (select #valid substring_~ps~2.base) 1 0)|
 |honda_(ite (select #valid substring_~ps~2.base) 1 0)|)
 (= |init_substring_#t~post8.offset| |honda_substring_#t~post8.offset|)
 (= init_substring_~ps2~3.offset honda_substring_~ps2~3.offset)
 (= |init_substring_#t~mem1| |honda_substring_#t~mem1|)
 (= init_substring_~pt~3.offset honda_substring_~pt~3.offset)
 (=
 |init_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 (= |init_substring_#t~mem2| |honda_substring_#t~mem2|)
 (= |init_substring_#t~mem3| |honda_substring_#t~mem3|)
 (= |init_substring_#t~mem0| |honda_substring_#t~mem0|)
 (= init_substring_~pt~3.base honda_substring_~pt~3.base)
 (= |init_substring_#t~mem7| |honda_substring_#t~mem7|)
 (= |init_substring_#t~post8.base| |honda_substring_#t~post8.base|)
 (= |init_(select #length substring_~ps~2.base)|
 |honda_(select #length substring_~ps~2.base)|)
 (= init_substring_~ps2~3.base honda_substring_~ps2~3.base)
 (= |init_(ite substring_#t~short4 1 0)|
 |honda_(ite substring_#t~short4 1 0)|)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| (- 1))
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6152 1) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 1)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6152 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 1)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6154 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 1) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0)
 (* |honda_substring_#in~s.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| (- 1))
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset (- 1)) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 1) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 1) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 1) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 1) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| (- 1))
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6154 1) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 1)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 1) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 1) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| (- 1)) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6154 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base (- 1)) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 1) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 1) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 1)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0)
 (* |honda_substring_#in~s.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base (- 1)) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (* aux_6152 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 1)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| (- 1)) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 1)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base (- 1)) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset (- 1)) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| (- 1))
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 1) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| 0) 
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| (- 1))
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select old(#length) substring_#in~t.base)| 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* |honda_(select old(#length) substring_#in~s.base)| 0)
 (* |honda_(ite (select #valid substring_#in~t.base) 1 0)| 0)
 (* honda_substring_~s.offset 0) 
 (* honda_substring_~ps2~3.offset 0) 
 (* |honda_substring_#in~s.base| 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#in~t.offset| (- 1))
 (* |honda_substring_#in~s.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* honda_substring_~t.base 0) 
 (* |honda_substring_#t~mem7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_(select #length substring_#in~s.base)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0)
 (* |honda_(select #length substring_#in~t.base)| 0)
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* |honda_#NULL.offset| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* honda_substring_~t.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~s.base 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#in~t.base| 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid substring_#in~s.base) 1 0)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)| 0)
 (* init_substring_~s.offset 0) 
 (* |init_substring_#in~s.base| 0) 
 (* init_substring_~ps~2.base 0) 
 (* |init_substring_#in~s.offset| 0) 
 (* |init_substring_#in~t.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_substring_~t.offset 0) 
 (* init_substring_~ps~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* init_substring_~s.base 0) 
 (* init_substring_~t.base 0) 
 (* |init_substring_#in~t.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)))
 (or
 (and
 (= |honda_(select old(#length) substring_#in~t.base)|
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|))
 (= |honda_(select old(#length) substring_#in~s.base)|
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|))
 (= |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|))
 (= honda_substring_~s.offset
 (+ honda_substring_~s.offset ray_substring_~s.offset))
 (= |honda_substring_#in~s.base|
 (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|))
 (= |honda_substring_#in~s.offset|
 (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|))
 (= |honda_substring_#in~t.offset|
 (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_substring_~t.base
 (+ honda_substring_~t.base ray_substring_~t.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(select #length substring_#in~s.base)|
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|))
 (= |honda_(select #length substring_#in~t.base)|
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_substring_~t.offset
 (+ honda_substring_~t.offset ray_substring_~t.offset))
 (= honda_substring_~s.base
 (+ honda_substring_~s.base ray_substring_~s.base))
 (= |honda_substring_#in~t.base|
 (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|))
 (= |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|))
 (= |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 1)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) (- 1))
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 1)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 1)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 1)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 1)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 
 (- 1)) (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 1)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) (- 1))
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 1)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) (- 1))
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (= |ray_(select old(#length) substring_#in~t.base)|
 (* |ray_(select old(#length) substring_#in~t.base)| lambda))
 (= |ray_(select old(#length) substring_#in~s.base)|
 (* |ray_(select old(#length) substring_#in~s.base)| lambda))
 (= |ray_(ite (select #valid substring_#in~t.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda))
 (= ray_substring_~s.offset (* ray_substring_~s.offset lambda))
 (= |ray_substring_#in~s.base| (* |ray_substring_#in~s.base| lambda))
 (= |ray_substring_#in~s.offset| (* |ray_substring_#in~s.offset| lambda))
 (= |ray_substring_#in~t.offset| (* |ray_substring_#in~t.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_substring_~t.base (* ray_substring_~t.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select #length substring_#in~s.base)|
 (* |ray_(select #length substring_#in~s.base)| lambda))
 (= |ray_(select #length substring_#in~t.base)|
 (* |ray_(select #length substring_#in~t.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_substring_~t.offset (* ray_substring_~t.offset lambda))
 (= ray_substring_~s.base (* ray_substring_~s.base lambda))
 (= |ray_substring_#in~t.base| (* |ray_substring_#in~t.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda))
 (= |ray_(ite (select #valid substring_#in~s.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 1)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_substring_~t.offset lambda) (- 1))
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 1)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 1)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 1)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 1)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) (- 1))
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 1)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) (- 1))
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 1)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) (- 1))
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select old(#length) substring_#in~t.base)|
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|))
 (= |honda_(select old(#length) substring_#in~s.base)|
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|))
 (= |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|))
 (= honda_substring_~s.offset
 (+ honda_substring_~s.offset ray_substring_~s.offset))
 (= |honda_substring_#in~s.base|
 (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|))
 (= |honda_substring_#in~s.offset|
 (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|))
 (= |honda_substring_#in~t.offset|
 (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_substring_~t.base
 (+ honda_substring_~t.base ray_substring_~t.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(select #length substring_#in~s.base)|
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|))
 (= |honda_(select #length substring_#in~t.base)|
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_substring_~t.offset
 (+ honda_substring_~t.offset ray_substring_~t.offset))
 (= honda_substring_~s.base
 (+ honda_substring_~s.base ray_substring_~s.base))
 (= |honda_substring_#in~t.base|
 (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|))
 (= |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|))
 (= |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 1)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) (- 1))
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 1)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 1)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 1)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 1)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 
 (- 1)) (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 1)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) (- 1))
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 1)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) (- 1))
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (= |ray_(select old(#length) substring_#in~t.base)|
 (* |ray_(select old(#length) substring_#in~t.base)| lambda))
 (= |ray_(select old(#length) substring_#in~s.base)|
 (* |ray_(select old(#length) substring_#in~s.base)| lambda))
 (= |ray_(ite (select #valid substring_#in~t.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda))
 (= ray_substring_~s.offset (* ray_substring_~s.offset lambda))
 (= |ray_substring_#in~s.base| (* |ray_substring_#in~s.base| lambda))
 (= |ray_substring_#in~s.offset| (* |ray_substring_#in~s.offset| lambda))
 (= |ray_substring_#in~t.offset| (* |ray_substring_#in~t.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_substring_~t.base (* ray_substring_~t.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select #length substring_#in~s.base)|
 (* |ray_(select #length substring_#in~s.base)| lambda))
 (= |ray_(select #length substring_#in~t.base)|
 (* |ray_(select #length substring_#in~t.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_substring_~t.offset (* ray_substring_~t.offset lambda))
 (= ray_substring_~s.base (* ray_substring_~s.base lambda))
 (= |ray_substring_#in~t.base| (* |ray_substring_#in~t.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda))
 (= |ray_(ite (select #valid substring_#in~s.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 1)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_substring_~t.offset lambda) (- 1))
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 1)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 1)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 1)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 1)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) (- 1))
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 1)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) (- 1))
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 1)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) (- 1))
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select old(#length) substring_#in~t.base)|
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|))
 (= |honda_(select old(#length) substring_#in~s.base)|
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|))
 (= |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|))
 (= honda_substring_~s.offset
 (+ honda_substring_~s.offset ray_substring_~s.offset))
 (= |honda_substring_#in~s.base|
 (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|))
 (= |honda_substring_#in~s.offset|
 (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|))
 (= |honda_substring_#in~t.offset|
 (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_substring_~t.base
 (+ honda_substring_~t.base ray_substring_~t.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(select #length substring_#in~s.base)|
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|))
 (= |honda_(select #length substring_#in~t.base)|
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_substring_~t.offset
 (+ honda_substring_~t.offset ray_substring_~t.offset))
 (= honda_substring_~s.base
 (+ honda_substring_~s.base ray_substring_~s.base))
 (= |honda_substring_#in~t.base|
 (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|))
 (= |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|))
 (= |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 1)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) (- 1))
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 1)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 1)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 1)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 1)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 
 (- 1)) (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 1)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 
 (- 1)) (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) (- 1))
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 (- 1)) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 1) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 1)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) (- 1))
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (= |ray_(select old(#length) substring_#in~t.base)|
 (* |ray_(select old(#length) substring_#in~t.base)| lambda))
 (= |ray_(select old(#length) substring_#in~s.base)|
 (* |ray_(select old(#length) substring_#in~s.base)| lambda))
 (= |ray_(ite (select #valid substring_#in~t.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda))
 (= ray_substring_~s.offset (* ray_substring_~s.offset lambda))
 (= |ray_substring_#in~s.base| (* |ray_substring_#in~s.base| lambda))
 (= |ray_substring_#in~s.offset| (* |ray_substring_#in~s.offset| lambda))
 (= |ray_substring_#in~t.offset| (* |ray_substring_#in~t.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_substring_~t.base (* ray_substring_~t.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select #length substring_#in~s.base)|
 (* |ray_(select #length substring_#in~s.base)| lambda))
 (= |ray_(select #length substring_#in~t.base)|
 (* |ray_(select #length substring_#in~t.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_substring_~t.offset (* ray_substring_~t.offset lambda))
 (= ray_substring_~s.base (* ray_substring_~s.base lambda))
 (= |ray_substring_#in~t.base| (* |ray_substring_#in~t.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda))
 (= |ray_(ite (select #valid substring_#in~s.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 1)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_substring_~t.offset lambda) (- 1))
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 1)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 1)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 1)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 1)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) (- 1))
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 1)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) (- 1))
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) (- 1))
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) (- 1)) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 1) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 1)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) (- 1))
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select old(#length) substring_#in~t.base)|
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|))
 (= |honda_(select old(#length) substring_#in~s.base)|
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|))
 (= |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|))
 (= honda_substring_~s.offset
 (+ honda_substring_~s.offset ray_substring_~s.offset))
 (= |honda_substring_#in~s.base|
 (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|))
 (= |honda_substring_#in~s.offset|
 (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|))
 (= |honda_substring_#in~t.offset|
 (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_substring_~t.base
 (+ honda_substring_~t.base ray_substring_~t.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(select #length substring_#in~s.base)|
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|))
 (= |honda_(select #length substring_#in~t.base)|
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_substring_~t.offset
 (+ honda_substring_~t.offset ray_substring_~t.offset))
 (= honda_substring_~s.base
 (+ honda_substring_~s.base ray_substring_~s.base))
 (= |honda_substring_#in~t.base|
 (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|))
 (= |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|))
 (= |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 1)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) (- 1))
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 1)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 1)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 1)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 1)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 
 (- 1)) (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 1)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) (- 1))
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 1)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) (- 1))
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (= |ray_(select old(#length) substring_#in~t.base)|
 (* |ray_(select old(#length) substring_#in~t.base)| lambda))
 (= |ray_(select old(#length) substring_#in~s.base)|
 (* |ray_(select old(#length) substring_#in~s.base)| lambda))
 (= |ray_(ite (select #valid substring_#in~t.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda))
 (= ray_substring_~s.offset (* ray_substring_~s.offset lambda))
 (= |ray_substring_#in~s.base| (* |ray_substring_#in~s.base| lambda))
 (= |ray_substring_#in~s.offset| (* |ray_substring_#in~s.offset| lambda))
 (= |ray_substring_#in~t.offset| (* |ray_substring_#in~t.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_substring_~t.base (* ray_substring_~t.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select #length substring_#in~s.base)|
 (* |ray_(select #length substring_#in~s.base)| lambda))
 (= |ray_(select #length substring_#in~t.base)|
 (* |ray_(select #length substring_#in~t.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_substring_~t.offset (* ray_substring_~t.offset lambda))
 (= ray_substring_~s.base (* ray_substring_~s.base lambda))
 (= |ray_substring_#in~t.base| (* |ray_substring_#in~t.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda))
 (= |ray_(ite (select #valid substring_#in~s.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 1)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_substring_~t.offset lambda) (- 1))
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 1)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 1)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 1)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 1)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) (- 1))
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 1)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) (- 1))
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 1)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) (- 1))
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select old(#length) substring_#in~t.base)|
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|))
 (= |honda_(select old(#length) substring_#in~s.base)|
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|))
 (= |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|))
 (= honda_substring_~s.offset
 (+ honda_substring_~s.offset ray_substring_~s.offset))
 (= |honda_substring_#in~s.base|
 (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|))
 (= |honda_substring_#in~s.offset|
 (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|))
 (= |honda_substring_#in~t.offset|
 (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_substring_~t.base
 (+ honda_substring_~t.base ray_substring_~t.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(select #length substring_#in~s.base)|
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|))
 (= |honda_(select #length substring_#in~t.base)|
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_substring_~t.offset
 (+ honda_substring_~t.offset ray_substring_~t.offset))
 (= honda_substring_~s.base
 (+ honda_substring_~s.base ray_substring_~s.base))
 (= |honda_substring_#in~t.base|
 (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|))
 (= |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|))
 (= |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 1)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) (- 1))
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 1)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 1)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 1)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 1)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 
 (- 1)) (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 1)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) (- 1))
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 1)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) (- 1))
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (= |ray_(select old(#length) substring_#in~t.base)|
 (* |ray_(select old(#length) substring_#in~t.base)| lambda))
 (= |ray_(select old(#length) substring_#in~s.base)|
 (* |ray_(select old(#length) substring_#in~s.base)| lambda))
 (= |ray_(ite (select #valid substring_#in~t.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda))
 (= ray_substring_~s.offset (* ray_substring_~s.offset lambda))
 (= |ray_substring_#in~s.base| (* |ray_substring_#in~s.base| lambda))
 (= |ray_substring_#in~s.offset| (* |ray_substring_#in~s.offset| lambda))
 (= |ray_substring_#in~t.offset| (* |ray_substring_#in~t.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_substring_~t.base (* ray_substring_~t.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select #length substring_#in~s.base)|
 (* |ray_(select #length substring_#in~s.base)| lambda))
 (= |ray_(select #length substring_#in~t.base)|
 (* |ray_(select #length substring_#in~t.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_substring_~t.offset (* ray_substring_~t.offset lambda))
 (= ray_substring_~s.base (* ray_substring_~s.base lambda))
 (= |ray_substring_#in~t.base| (* |ray_substring_#in~t.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda))
 (= |ray_(ite (select #valid substring_#in~s.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 1)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_substring_~t.offset lambda) (- 1))
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 1)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 1)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 1)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 1)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) (- 1))
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 1)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) (- 1))
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 1)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) (- 1))
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select old(#length) substring_#in~t.base)|
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|))
 (= |honda_(select old(#length) substring_#in~s.base)|
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|))
 (= |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|))
 (= honda_substring_~s.offset
 (+ honda_substring_~s.offset ray_substring_~s.offset))
 (= |honda_substring_#in~s.base|
 (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|))
 (= |honda_substring_#in~s.offset|
 (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|))
 (= |honda_substring_#in~t.offset|
 (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_substring_~t.base
 (+ honda_substring_~t.base ray_substring_~t.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(select #length substring_#in~s.base)|
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|))
 (= |honda_(select #length substring_#in~t.base)|
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_substring_~t.offset
 (+ honda_substring_~t.offset ray_substring_~t.offset))
 (= honda_substring_~s.base
 (+ honda_substring_~s.base ray_substring_~s.base))
 (= |honda_substring_#in~t.base|
 (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|))
 (= |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|))
 (= |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 1)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) (- 1))
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 1)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 1)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 1)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 1)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 
 (- 1)) (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 1)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 
 (- 1)) (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) (- 1))
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 1)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) (- 1))
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (= |ray_(select old(#length) substring_#in~t.base)|
 (* |ray_(select old(#length) substring_#in~t.base)| lambda))
 (= |ray_(select old(#length) substring_#in~s.base)|
 (* |ray_(select old(#length) substring_#in~s.base)| lambda))
 (= |ray_(ite (select #valid substring_#in~t.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda))
 (= ray_substring_~s.offset (* ray_substring_~s.offset lambda))
 (= |ray_substring_#in~s.base| (* |ray_substring_#in~s.base| lambda))
 (= |ray_substring_#in~s.offset| (* |ray_substring_#in~s.offset| lambda))
 (= |ray_substring_#in~t.offset| (* |ray_substring_#in~t.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_substring_~t.base (* ray_substring_~t.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select #length substring_#in~s.base)|
 (* |ray_(select #length substring_#in~s.base)| lambda))
 (= |ray_(select #length substring_#in~t.base)|
 (* |ray_(select #length substring_#in~t.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_substring_~t.offset (* ray_substring_~t.offset lambda))
 (= ray_substring_~s.base (* ray_substring_~s.base lambda))
 (= |ray_substring_#in~t.base| (* |ray_substring_#in~t.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda))
 (= |ray_(ite (select #valid substring_#in~s.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 1)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_substring_~t.offset lambda) (- 1))
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 1)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 1)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 1)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 1)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) (- 1))
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 1)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) (- 1))
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) (- 1))
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 1)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) (- 1))
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select old(#length) substring_#in~t.base)|
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|))
 (= |honda_(select old(#length) substring_#in~s.base)|
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|))
 (= |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|))
 (= honda_substring_~s.offset
 (+ honda_substring_~s.offset ray_substring_~s.offset))
 (= |honda_substring_#in~s.base|
 (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|))
 (= |honda_substring_#in~s.offset|
 (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|))
 (= |honda_substring_#in~t.offset|
 (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_substring_~t.base
 (+ honda_substring_~t.base ray_substring_~t.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(select #length substring_#in~s.base)|
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|))
 (= |honda_(select #length substring_#in~t.base)|
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_substring_~t.offset
 (+ honda_substring_~t.offset ray_substring_~t.offset))
 (= honda_substring_~s.base
 (+ honda_substring_~s.base ray_substring_~s.base))
 (= |honda_substring_#in~t.base|
 (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|))
 (= |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|))
 (= |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 1)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) (- 1))
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 1)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 1)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 1)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 1)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 
 (- 1)) (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 1)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 
 (- 1)) (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) (- 1))
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 1)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) (- 1))
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (= |ray_(select old(#length) substring_#in~t.base)|
 (* |ray_(select old(#length) substring_#in~t.base)| lambda))
 (= |ray_(select old(#length) substring_#in~s.base)|
 (* |ray_(select old(#length) substring_#in~s.base)| lambda))
 (= |ray_(ite (select #valid substring_#in~t.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda))
 (= ray_substring_~s.offset (* ray_substring_~s.offset lambda))
 (= |ray_substring_#in~s.base| (* |ray_substring_#in~s.base| lambda))
 (= |ray_substring_#in~s.offset| (* |ray_substring_#in~s.offset| lambda))
 (= |ray_substring_#in~t.offset| (* |ray_substring_#in~t.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_substring_~t.base (* ray_substring_~t.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select #length substring_#in~s.base)|
 (* |ray_(select #length substring_#in~s.base)| lambda))
 (= |ray_(select #length substring_#in~t.base)|
 (* |ray_(select #length substring_#in~t.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_substring_~t.offset (* ray_substring_~t.offset lambda))
 (= ray_substring_~s.base (* ray_substring_~s.base lambda))
 (= |ray_substring_#in~t.base| (* |ray_substring_#in~t.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda))
 (= |ray_(ite (select #valid substring_#in~s.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 1)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_substring_~t.offset lambda) (- 1))
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 1)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 1)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 1)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 1)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) (- 1))
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 1)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) (- 1))
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) (- 1))
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 1)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) (- 1))
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select old(#length) substring_#in~t.base)|
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|))
 (= |honda_(select old(#length) substring_#in~s.base)|
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|))
 (= |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|))
 (= honda_substring_~s.offset
 (+ honda_substring_~s.offset ray_substring_~s.offset))
 (= |honda_substring_#in~s.base|
 (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|))
 (= |honda_substring_#in~s.offset|
 (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|))
 (= |honda_substring_#in~t.offset|
 (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_substring_~t.base
 (+ honda_substring_~t.base ray_substring_~t.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(select #length substring_#in~s.base)|
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|))
 (= |honda_(select #length substring_#in~t.base)|
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_substring_~t.offset
 (+ honda_substring_~t.offset ray_substring_~t.offset))
 (= honda_substring_~s.base
 (+ honda_substring_~s.base ray_substring_~s.base))
 (= |honda_substring_#in~t.base|
 (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|))
 (= |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|))
 (= |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 1)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) (- 1))
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 1)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 1)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 1)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 1)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 
 (- 1)) (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 1)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) (- 1))
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 1)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) (- 1))
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (= |ray_(select old(#length) substring_#in~t.base)|
 (* |ray_(select old(#length) substring_#in~t.base)| lambda))
 (= |ray_(select old(#length) substring_#in~s.base)|
 (* |ray_(select old(#length) substring_#in~s.base)| lambda))
 (= |ray_(ite (select #valid substring_#in~t.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda))
 (= ray_substring_~s.offset (* ray_substring_~s.offset lambda))
 (= |ray_substring_#in~s.base| (* |ray_substring_#in~s.base| lambda))
 (= |ray_substring_#in~s.offset| (* |ray_substring_#in~s.offset| lambda))
 (= |ray_substring_#in~t.offset| (* |ray_substring_#in~t.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_substring_~t.base (* ray_substring_~t.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select #length substring_#in~s.base)|
 (* |ray_(select #length substring_#in~s.base)| lambda))
 (= |ray_(select #length substring_#in~t.base)|
 (* |ray_(select #length substring_#in~t.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_substring_~t.offset (* ray_substring_~t.offset lambda))
 (= ray_substring_~s.base (* ray_substring_~s.base lambda))
 (= |ray_substring_#in~t.base| (* |ray_substring_#in~t.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda))
 (= |ray_(ite (select #valid substring_#in~s.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 1)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_substring_~t.offset lambda) (- 1))
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 1)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 1)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 1)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 1)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) (- 1))
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 1)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) (- 1))
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 1)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) (- 1))
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select old(#length) substring_#in~t.base)|
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|))
 (= |honda_(select old(#length) substring_#in~s.base)|
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|))
 (= |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|))
 (= honda_substring_~s.offset
 (+ honda_substring_~s.offset ray_substring_~s.offset))
 (= |honda_substring_#in~s.base|
 (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|))
 (= |honda_substring_#in~s.offset|
 (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|))
 (= |honda_substring_#in~t.offset|
 (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_substring_~t.base
 (+ honda_substring_~t.base ray_substring_~t.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(select #length substring_#in~s.base)|
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|))
 (= |honda_(select #length substring_#in~t.base)|
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_substring_~t.offset
 (+ honda_substring_~t.offset ray_substring_~t.offset))
 (= honda_substring_~s.base
 (+ honda_substring_~s.base ray_substring_~s.base))
 (= |honda_substring_#in~t.base|
 (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|))
 (= |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|))
 (= |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 1)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) (- 1))
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 1)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 1)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 1)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 1)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 
 (- 1)) (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 1)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 
 (- 1)) (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) (- 1))
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 (- 1)) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 1) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 1)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) (- 1))
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (= |ray_(select old(#length) substring_#in~t.base)|
 (* |ray_(select old(#length) substring_#in~t.base)| lambda))
 (= |ray_(select old(#length) substring_#in~s.base)|
 (* |ray_(select old(#length) substring_#in~s.base)| lambda))
 (= |ray_(ite (select #valid substring_#in~t.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda))
 (= ray_substring_~s.offset (* ray_substring_~s.offset lambda))
 (= |ray_substring_#in~s.base| (* |ray_substring_#in~s.base| lambda))
 (= |ray_substring_#in~s.offset| (* |ray_substring_#in~s.offset| lambda))
 (= |ray_substring_#in~t.offset| (* |ray_substring_#in~t.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_substring_~t.base (* ray_substring_~t.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select #length substring_#in~s.base)|
 (* |ray_(select #length substring_#in~s.base)| lambda))
 (= |ray_(select #length substring_#in~t.base)|
 (* |ray_(select #length substring_#in~t.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_substring_~t.offset (* ray_substring_~t.offset lambda))
 (= ray_substring_~s.base (* ray_substring_~s.base lambda))
 (= |ray_substring_#in~t.base| (* |ray_substring_#in~t.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda))
 (= |ray_(ite (select #valid substring_#in~s.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 1)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_substring_~t.offset lambda) (- 1))
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 1)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 1)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 1)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 1)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) (- 1))
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 1)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) (- 1))
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) (- 1))
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) (- 1)) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 1) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 1)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) (- 1))
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select old(#length) substring_#in~t.base)|
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|))
 (= |honda_(select old(#length) substring_#in~s.base)|
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|))
 (= |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|))
 (= honda_substring_~s.offset
 (+ honda_substring_~s.offset ray_substring_~s.offset))
 (= |honda_substring_#in~s.base|
 (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|))
 (= |honda_substring_#in~s.offset|
 (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|))
 (= |honda_substring_#in~t.offset|
 (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_substring_~t.base
 (+ honda_substring_~t.base ray_substring_~t.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(select #length substring_#in~s.base)|
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|))
 (= |honda_(select #length substring_#in~t.base)|
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_substring_~t.offset
 (+ honda_substring_~t.offset ray_substring_~t.offset))
 (= honda_substring_~s.base
 (+ honda_substring_~s.base ray_substring_~s.base))
 (= |honda_substring_#in~t.base|
 (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|))
 (= |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|))
 (= |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 1)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) (- 1))
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 1)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 1)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 1)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 1)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 
 (- 1)) (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 1)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 
 (- 1)) (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) (- 1))
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 (- 1)) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 1) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 1)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) (- 1))
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (= |ray_(select old(#length) substring_#in~t.base)|
 (* |ray_(select old(#length) substring_#in~t.base)| lambda))
 (= |ray_(select old(#length) substring_#in~s.base)|
 (* |ray_(select old(#length) substring_#in~s.base)| lambda))
 (= |ray_(ite (select #valid substring_#in~t.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda))
 (= ray_substring_~s.offset (* ray_substring_~s.offset lambda))
 (= |ray_substring_#in~s.base| (* |ray_substring_#in~s.base| lambda))
 (= |ray_substring_#in~s.offset| (* |ray_substring_#in~s.offset| lambda))
 (= |ray_substring_#in~t.offset| (* |ray_substring_#in~t.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_substring_~t.base (* ray_substring_~t.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select #length substring_#in~s.base)|
 (* |ray_(select #length substring_#in~s.base)| lambda))
 (= |ray_(select #length substring_#in~t.base)|
 (* |ray_(select #length substring_#in~t.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_substring_~t.offset (* ray_substring_~t.offset lambda))
 (= ray_substring_~s.base (* ray_substring_~s.base lambda))
 (= |ray_substring_#in~t.base| (* |ray_substring_#in~t.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda))
 (= |ray_(ite (select #valid substring_#in~s.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 1)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_substring_~t.offset lambda) (- 1))
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 1)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 1)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 1)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 1)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) (- 1))
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 1)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) (- 1))
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) (- 1))
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) (- 1)) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 1) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 1)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) (- 1))
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select old(#length) substring_#in~t.base)|
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|))
 (= |honda_(select old(#length) substring_#in~s.base)|
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|))
 (= |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|))
 (= honda_substring_~s.offset
 (+ honda_substring_~s.offset ray_substring_~s.offset))
 (= |honda_substring_#in~s.base|
 (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|))
 (= |honda_substring_#in~s.offset|
 (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|))
 (= |honda_substring_#in~t.offset|
 (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_substring_~t.base
 (+ honda_substring_~t.base ray_substring_~t.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(select #length substring_#in~s.base)|
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|))
 (= |honda_(select #length substring_#in~t.base)|
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_substring_~t.offset
 (+ honda_substring_~t.offset ray_substring_~t.offset))
 (= honda_substring_~s.base
 (+ honda_substring_~s.base ray_substring_~s.base))
 (= |honda_substring_#in~t.base|
 (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|))
 (= |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|))
 (= |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 1)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) (- 1))
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 1)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 1)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 1)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 1)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 
 (- 1)) (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 1)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 
 (- 1)) (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) (- 1))
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 1)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) (- 1))
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (= |ray_(select old(#length) substring_#in~t.base)|
 (* |ray_(select old(#length) substring_#in~t.base)| lambda))
 (= |ray_(select old(#length) substring_#in~s.base)|
 (* |ray_(select old(#length) substring_#in~s.base)| lambda))
 (= |ray_(ite (select #valid substring_#in~t.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda))
 (= ray_substring_~s.offset (* ray_substring_~s.offset lambda))
 (= |ray_substring_#in~s.base| (* |ray_substring_#in~s.base| lambda))
 (= |ray_substring_#in~s.offset| (* |ray_substring_#in~s.offset| lambda))
 (= |ray_substring_#in~t.offset| (* |ray_substring_#in~t.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_substring_~t.base (* ray_substring_~t.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select #length substring_#in~s.base)|
 (* |ray_(select #length substring_#in~s.base)| lambda))
 (= |ray_(select #length substring_#in~t.base)|
 (* |ray_(select #length substring_#in~t.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_substring_~t.offset (* ray_substring_~t.offset lambda))
 (= ray_substring_~s.base (* ray_substring_~s.base lambda))
 (= |ray_substring_#in~t.base| (* |ray_substring_#in~t.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda))
 (= |ray_(ite (select #valid substring_#in~s.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 1)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_substring_~t.offset lambda) (- 1))
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 1)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 1)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 1)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 1)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) (- 1))
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 1)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) (- 1))
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) (- 1))
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 1)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) (- 1))
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select old(#length) substring_#in~t.base)|
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|))
 (= |honda_(select old(#length) substring_#in~s.base)|
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|))
 (= |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|))
 (= honda_substring_~s.offset
 (+ honda_substring_~s.offset ray_substring_~s.offset))
 (= |honda_substring_#in~s.base|
 (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|))
 (= |honda_substring_#in~s.offset|
 (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|))
 (= |honda_substring_#in~t.offset|
 (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_substring_~t.base
 (+ honda_substring_~t.base ray_substring_~t.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(select #length substring_#in~s.base)|
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|))
 (= |honda_(select #length substring_#in~t.base)|
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_substring_~t.offset
 (+ honda_substring_~t.offset ray_substring_~t.offset))
 (= honda_substring_~s.base
 (+ honda_substring_~s.base ray_substring_~s.base))
 (= |honda_substring_#in~t.base|
 (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|))
 (= |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|))
 (= |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 1)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) (- 1))
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 1)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 1)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 1)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 1)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 
 (- 1)) (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 1)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) (- 1))
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 1)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) (- 1))
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (= |ray_(select old(#length) substring_#in~t.base)|
 (* |ray_(select old(#length) substring_#in~t.base)| lambda))
 (= |ray_(select old(#length) substring_#in~s.base)|
 (* |ray_(select old(#length) substring_#in~s.base)| lambda))
 (= |ray_(ite (select #valid substring_#in~t.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda))
 (= ray_substring_~s.offset (* ray_substring_~s.offset lambda))
 (= |ray_substring_#in~s.base| (* |ray_substring_#in~s.base| lambda))
 (= |ray_substring_#in~s.offset| (* |ray_substring_#in~s.offset| lambda))
 (= |ray_substring_#in~t.offset| (* |ray_substring_#in~t.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_substring_~t.base (* ray_substring_~t.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select #length substring_#in~s.base)|
 (* |ray_(select #length substring_#in~s.base)| lambda))
 (= |ray_(select #length substring_#in~t.base)|
 (* |ray_(select #length substring_#in~t.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_substring_~t.offset (* ray_substring_~t.offset lambda))
 (= ray_substring_~s.base (* ray_substring_~s.base lambda))
 (= |ray_substring_#in~t.base| (* |ray_substring_#in~t.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda))
 (= |ray_(ite (select #valid substring_#in~s.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 1)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_substring_~t.offset lambda) (- 1))
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 1)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 1)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 1)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 1)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) (- 1))
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 1)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) (- 1))
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 1)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) (- 1))
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select old(#length) substring_#in~t.base)|
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|))
 (= |honda_(select old(#length) substring_#in~s.base)|
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|))
 (= |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|))
 (= honda_substring_~s.offset
 (+ honda_substring_~s.offset ray_substring_~s.offset))
 (= |honda_substring_#in~s.base|
 (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|))
 (= |honda_substring_#in~s.offset|
 (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|))
 (= |honda_substring_#in~t.offset|
 (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_substring_~t.base
 (+ honda_substring_~t.base ray_substring_~t.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(select #length substring_#in~s.base)|
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|))
 (= |honda_(select #length substring_#in~t.base)|
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_substring_~t.offset
 (+ honda_substring_~t.offset ray_substring_~t.offset))
 (= honda_substring_~s.base
 (+ honda_substring_~s.base ray_substring_~s.base))
 (= |honda_substring_#in~t.base|
 (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|))
 (= |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|))
 (= |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 1)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) (- 1))
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 1)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 1)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 1)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 1)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 
 (- 1)) (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 1)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) (- 1))
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 1)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) (- 1))
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (= |ray_(select old(#length) substring_#in~t.base)|
 (* |ray_(select old(#length) substring_#in~t.base)| lambda))
 (= |ray_(select old(#length) substring_#in~s.base)|
 (* |ray_(select old(#length) substring_#in~s.base)| lambda))
 (= |ray_(ite (select #valid substring_#in~t.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda))
 (= ray_substring_~s.offset (* ray_substring_~s.offset lambda))
 (= |ray_substring_#in~s.base| (* |ray_substring_#in~s.base| lambda))
 (= |ray_substring_#in~s.offset| (* |ray_substring_#in~s.offset| lambda))
 (= |ray_substring_#in~t.offset| (* |ray_substring_#in~t.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_substring_~t.base (* ray_substring_~t.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select #length substring_#in~s.base)|
 (* |ray_(select #length substring_#in~s.base)| lambda))
 (= |ray_(select #length substring_#in~t.base)|
 (* |ray_(select #length substring_#in~t.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_substring_~t.offset (* ray_substring_~t.offset lambda))
 (= ray_substring_~s.base (* ray_substring_~s.base lambda))
 (= |ray_substring_#in~t.base| (* |ray_substring_#in~t.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda))
 (= |ray_(ite (select #valid substring_#in~s.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 1)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_substring_~t.offset lambda) (- 1))
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 1)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 1)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 1)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 1)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) (- 1))
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 1)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) (- 1))
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 1)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) (- 1))
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select old(#length) substring_#in~t.base)|
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|))
 (= |honda_(select old(#length) substring_#in~s.base)|
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|))
 (= |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|))
 (= honda_substring_~s.offset
 (+ honda_substring_~s.offset ray_substring_~s.offset))
 (= |honda_substring_#in~s.base|
 (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|))
 (= |honda_substring_#in~s.offset|
 (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|))
 (= |honda_substring_#in~t.offset|
 (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_substring_~t.base
 (+ honda_substring_~t.base ray_substring_~t.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(select #length substring_#in~s.base)|
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|))
 (= |honda_(select #length substring_#in~t.base)|
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_substring_~t.offset
 (+ honda_substring_~t.offset ray_substring_~t.offset))
 (= honda_substring_~s.base
 (+ honda_substring_~s.base ray_substring_~s.base))
 (= |honda_substring_#in~t.base|
 (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|))
 (= |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|))
 (= |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 1)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) (- 1))
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 1)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 1)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 1)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 1)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 
 (- 1)) (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 1)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 
 (- 1)) (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) (- 1))
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 1)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) (- 1))
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (= |ray_(select old(#length) substring_#in~t.base)|
 (* |ray_(select old(#length) substring_#in~t.base)| lambda))
 (= |ray_(select old(#length) substring_#in~s.base)|
 (* |ray_(select old(#length) substring_#in~s.base)| lambda))
 (= |ray_(ite (select #valid substring_#in~t.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda))
 (= ray_substring_~s.offset (* ray_substring_~s.offset lambda))
 (= |ray_substring_#in~s.base| (* |ray_substring_#in~s.base| lambda))
 (= |ray_substring_#in~s.offset| (* |ray_substring_#in~s.offset| lambda))
 (= |ray_substring_#in~t.offset| (* |ray_substring_#in~t.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_substring_~t.base (* ray_substring_~t.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select #length substring_#in~s.base)|
 (* |ray_(select #length substring_#in~s.base)| lambda))
 (= |ray_(select #length substring_#in~t.base)|
 (* |ray_(select #length substring_#in~t.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_substring_~t.offset (* ray_substring_~t.offset lambda))
 (= ray_substring_~s.base (* ray_substring_~s.base lambda))
 (= |ray_substring_#in~t.base| (* |ray_substring_#in~t.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda))
 (= |ray_(ite (select #valid substring_#in~s.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 1)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_substring_~t.offset lambda) (- 1))
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 1)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 1)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 1)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 1)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) (- 1))
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 1)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) (- 1))
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) (- 1))
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 1)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) (- 1))
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select old(#length) substring_#in~t.base)|
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|))
 (= |honda_(select old(#length) substring_#in~s.base)|
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|))
 (= |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|))
 (= honda_substring_~s.offset
 (+ honda_substring_~s.offset ray_substring_~s.offset))
 (= |honda_substring_#in~s.base|
 (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|))
 (= |honda_substring_#in~s.offset|
 (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|))
 (= |honda_substring_#in~t.offset|
 (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_substring_~t.base
 (+ honda_substring_~t.base ray_substring_~t.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(select #length substring_#in~s.base)|
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|))
 (= |honda_(select #length substring_#in~t.base)|
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_substring_~t.offset
 (+ honda_substring_~t.offset ray_substring_~t.offset))
 (= honda_substring_~s.base
 (+ honda_substring_~s.base ray_substring_~s.base))
 (= |honda_substring_#in~t.base|
 (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|))
 (= |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|))
 (= |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 1)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) (- 1))
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 1)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 1)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 1)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 1)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 
 (- 1)) (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 1)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 
 (- 1)) (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) (- 1))
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 1)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) (- 1))
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (= |ray_(select old(#length) substring_#in~t.base)|
 (* |ray_(select old(#length) substring_#in~t.base)| lambda))
 (= |ray_(select old(#length) substring_#in~s.base)|
 (* |ray_(select old(#length) substring_#in~s.base)| lambda))
 (= |ray_(ite (select #valid substring_#in~t.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda))
 (= ray_substring_~s.offset (* ray_substring_~s.offset lambda))
 (= |ray_substring_#in~s.base| (* |ray_substring_#in~s.base| lambda))
 (= |ray_substring_#in~s.offset| (* |ray_substring_#in~s.offset| lambda))
 (= |ray_substring_#in~t.offset| (* |ray_substring_#in~t.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_substring_~t.base (* ray_substring_~t.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select #length substring_#in~s.base)|
 (* |ray_(select #length substring_#in~s.base)| lambda))
 (= |ray_(select #length substring_#in~t.base)|
 (* |ray_(select #length substring_#in~t.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_substring_~t.offset (* ray_substring_~t.offset lambda))
 (= ray_substring_~s.base (* ray_substring_~s.base lambda))
 (= |ray_substring_#in~t.base| (* |ray_substring_#in~t.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda))
 (= |ray_(ite (select #valid substring_#in~s.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 1)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_substring_~t.offset lambda) (- 1))
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 1)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 1)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 1)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 1)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) (- 1))
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 1)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) (- 1))
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) (- 1))
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 1)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) (- 1))
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select old(#length) substring_#in~t.base)|
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|))
 (= |honda_(select old(#length) substring_#in~s.base)|
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|))
 (= |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|))
 (= honda_substring_~s.offset
 (+ honda_substring_~s.offset ray_substring_~s.offset))
 (= |honda_substring_#in~s.base|
 (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|))
 (= |honda_substring_#in~s.offset|
 (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|))
 (= |honda_substring_#in~t.offset|
 (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_substring_~t.base
 (+ honda_substring_~t.base ray_substring_~t.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(select #length substring_#in~s.base)|
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|))
 (= |honda_(select #length substring_#in~t.base)|
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_substring_~t.offset
 (+ honda_substring_~t.offset ray_substring_~t.offset))
 (= honda_substring_~s.base
 (+ honda_substring_~s.base ray_substring_~s.base))
 (= |honda_substring_#in~t.base|
 (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|))
 (= |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|))
 (= |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 1)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) (- 1))
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 1)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 1)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 1)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 1)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 
 (- 1)) (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 1)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) (- 1))
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 1)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) (- 1))
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (= |ray_(select old(#length) substring_#in~t.base)|
 (* |ray_(select old(#length) substring_#in~t.base)| lambda))
 (= |ray_(select old(#length) substring_#in~s.base)|
 (* |ray_(select old(#length) substring_#in~s.base)| lambda))
 (= |ray_(ite (select #valid substring_#in~t.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda))
 (= ray_substring_~s.offset (* ray_substring_~s.offset lambda))
 (= |ray_substring_#in~s.base| (* |ray_substring_#in~s.base| lambda))
 (= |ray_substring_#in~s.offset| (* |ray_substring_#in~s.offset| lambda))
 (= |ray_substring_#in~t.offset| (* |ray_substring_#in~t.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_substring_~t.base (* ray_substring_~t.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select #length substring_#in~s.base)|
 (* |ray_(select #length substring_#in~s.base)| lambda))
 (= |ray_(select #length substring_#in~t.base)|
 (* |ray_(select #length substring_#in~t.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_substring_~t.offset (* ray_substring_~t.offset lambda))
 (= ray_substring_~s.base (* ray_substring_~s.base lambda))
 (= |ray_substring_#in~t.base| (* |ray_substring_#in~t.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda))
 (= |ray_(ite (select #valid substring_#in~s.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 1)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_substring_~t.offset lambda) (- 1))
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 1)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 1)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 1)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 1)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) (- 1))
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 1)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) (- 1))
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 1)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) (- 1))
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select old(#length) substring_#in~t.base)|
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|))
 (= |honda_(select old(#length) substring_#in~s.base)|
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|))
 (= |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|))
 (= honda_substring_~s.offset
 (+ honda_substring_~s.offset ray_substring_~s.offset))
 (= |honda_substring_#in~s.base|
 (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|))
 (= |honda_substring_#in~s.offset|
 (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|))
 (= |honda_substring_#in~t.offset|
 (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_substring_~t.base
 (+ honda_substring_~t.base ray_substring_~t.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(select #length substring_#in~s.base)|
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|))
 (= |honda_(select #length substring_#in~t.base)|
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_substring_~t.offset
 (+ honda_substring_~t.offset ray_substring_~t.offset))
 (= honda_substring_~s.base
 (+ honda_substring_~s.base ray_substring_~s.base))
 (= |honda_substring_#in~t.base|
 (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|))
 (= |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|))
 (= |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 1)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) (- 1))
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 1)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 1)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 1)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 1)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 
 (- 1)) (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 1)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 
 (- 1)) (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) (- 1))
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 1)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) (- 1))
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (= |ray_(select old(#length) substring_#in~t.base)|
 (* |ray_(select old(#length) substring_#in~t.base)| lambda))
 (= |ray_(select old(#length) substring_#in~s.base)|
 (* |ray_(select old(#length) substring_#in~s.base)| lambda))
 (= |ray_(ite (select #valid substring_#in~t.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda))
 (= ray_substring_~s.offset (* ray_substring_~s.offset lambda))
 (= |ray_substring_#in~s.base| (* |ray_substring_#in~s.base| lambda))
 (= |ray_substring_#in~s.offset| (* |ray_substring_#in~s.offset| lambda))
 (= |ray_substring_#in~t.offset| (* |ray_substring_#in~t.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_substring_~t.base (* ray_substring_~t.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select #length substring_#in~s.base)|
 (* |ray_(select #length substring_#in~s.base)| lambda))
 (= |ray_(select #length substring_#in~t.base)|
 (* |ray_(select #length substring_#in~t.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_substring_~t.offset (* ray_substring_~t.offset lambda))
 (= ray_substring_~s.base (* ray_substring_~s.base lambda))
 (= |ray_substring_#in~t.base| (* |ray_substring_#in~t.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda))
 (= |ray_(ite (select #valid substring_#in~s.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 1)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_substring_~t.offset lambda) (- 1))
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 1)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 1)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 1)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 1)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) (- 1))
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 1)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) (- 1))
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) (- 1))
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 1)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) (- 1))
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select old(#length) substring_#in~t.base)|
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|))
 (= |honda_(select old(#length) substring_#in~s.base)|
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|))
 (= |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|))
 (= honda_substring_~s.offset
 (+ honda_substring_~s.offset ray_substring_~s.offset))
 (= |honda_substring_#in~s.base|
 (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|))
 (= |honda_substring_#in~s.offset|
 (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|))
 (= |honda_substring_#in~t.offset|
 (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_substring_~t.base
 (+ honda_substring_~t.base ray_substring_~t.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(select #length substring_#in~s.base)|
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|))
 (= |honda_(select #length substring_#in~t.base)|
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_substring_~t.offset
 (+ honda_substring_~t.offset ray_substring_~t.offset))
 (= honda_substring_~s.base
 (+ honda_substring_~s.base ray_substring_~s.base))
 (= |honda_substring_#in~t.base|
 (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|))
 (= |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|))
 (= |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 1)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) (- 1))
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 1)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 1)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 1)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 1)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 
 (- 1)) (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 1)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) (- 1))
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 1)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) (- 1))
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (= |ray_(select old(#length) substring_#in~t.base)|
 (* |ray_(select old(#length) substring_#in~t.base)| lambda))
 (= |ray_(select old(#length) substring_#in~s.base)|
 (* |ray_(select old(#length) substring_#in~s.base)| lambda))
 (= |ray_(ite (select #valid substring_#in~t.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda))
 (= ray_substring_~s.offset (* ray_substring_~s.offset lambda))
 (= |ray_substring_#in~s.base| (* |ray_substring_#in~s.base| lambda))
 (= |ray_substring_#in~s.offset| (* |ray_substring_#in~s.offset| lambda))
 (= |ray_substring_#in~t.offset| (* |ray_substring_#in~t.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_substring_~t.base (* ray_substring_~t.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select #length substring_#in~s.base)|
 (* |ray_(select #length substring_#in~s.base)| lambda))
 (= |ray_(select #length substring_#in~t.base)|
 (* |ray_(select #length substring_#in~t.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_substring_~t.offset (* ray_substring_~t.offset lambda))
 (= ray_substring_~s.base (* ray_substring_~s.base lambda))
 (= |ray_substring_#in~t.base| (* |ray_substring_#in~t.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda))
 (= |ray_(ite (select #valid substring_#in~s.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 1)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_substring_~t.offset lambda) (- 1))
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 1)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 1)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 1)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 1)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) (- 1))
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 1)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) (- 1))
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 1)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) (- 1))
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select old(#length) substring_#in~t.base)|
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|))
 (= |honda_(select old(#length) substring_#in~s.base)|
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|))
 (= |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|))
 (= honda_substring_~s.offset
 (+ honda_substring_~s.offset ray_substring_~s.offset))
 (= |honda_substring_#in~s.base|
 (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|))
 (= |honda_substring_#in~s.offset|
 (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|))
 (= |honda_substring_#in~t.offset|
 (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_substring_~t.base
 (+ honda_substring_~t.base ray_substring_~t.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(select #length substring_#in~s.base)|
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|))
 (= |honda_(select #length substring_#in~t.base)|
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_substring_~t.offset
 (+ honda_substring_~t.offset ray_substring_~t.offset))
 (= honda_substring_~s.base
 (+ honda_substring_~s.base ray_substring_~s.base))
 (= |honda_substring_#in~t.base|
 (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|))
 (= |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|))
 (= |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 1)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) (- 1))
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 1)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 1)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 1)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 1)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 
 (- 1)) (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 1)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 
 (- 1)) (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) (- 1))
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 1)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) (- 1))
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (= |ray_(select old(#length) substring_#in~t.base)|
 (* |ray_(select old(#length) substring_#in~t.base)| lambda))
 (= |ray_(select old(#length) substring_#in~s.base)|
 (* |ray_(select old(#length) substring_#in~s.base)| lambda))
 (= |ray_(ite (select #valid substring_#in~t.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda))
 (= ray_substring_~s.offset (* ray_substring_~s.offset lambda))
 (= |ray_substring_#in~s.base| (* |ray_substring_#in~s.base| lambda))
 (= |ray_substring_#in~s.offset| (* |ray_substring_#in~s.offset| lambda))
 (= |ray_substring_#in~t.offset| (* |ray_substring_#in~t.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_substring_~t.base (* ray_substring_~t.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select #length substring_#in~s.base)|
 (* |ray_(select #length substring_#in~s.base)| lambda))
 (= |ray_(select #length substring_#in~t.base)|
 (* |ray_(select #length substring_#in~t.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_substring_~t.offset (* ray_substring_~t.offset lambda))
 (= ray_substring_~s.base (* ray_substring_~s.base lambda))
 (= |ray_substring_#in~t.base| (* |ray_substring_#in~t.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda))
 (= |ray_(ite (select #valid substring_#in~s.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 1)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_substring_~t.offset lambda) (- 1))
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 1)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 1)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 1)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 1)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) (- 1))
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 1)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) (- 1))
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) (- 1))
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 1)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) (- 1))
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select old(#length) substring_#in~t.base)|
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|))
 (= |honda_(select old(#length) substring_#in~s.base)|
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|))
 (= |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|))
 (= honda_substring_~s.offset
 (+ honda_substring_~s.offset ray_substring_~s.offset))
 (= |honda_substring_#in~s.base|
 (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|))
 (= |honda_substring_#in~s.offset|
 (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|))
 (= |honda_substring_#in~t.offset|
 (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_substring_~t.base
 (+ honda_substring_~t.base ray_substring_~t.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(select #length substring_#in~s.base)|
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|))
 (= |honda_(select #length substring_#in~t.base)|
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_substring_~t.offset
 (+ honda_substring_~t.offset ray_substring_~t.offset))
 (= honda_substring_~s.base
 (+ honda_substring_~s.base ray_substring_~s.base))
 (= |honda_substring_#in~t.base|
 (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|))
 (= |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|))
 (= |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 1)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) (- 1))
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 1)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 1)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 1)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 1)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 
 (- 1)) (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 1)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) (- 1))
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 1)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) (- 1))
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (= |ray_(select old(#length) substring_#in~t.base)|
 (* |ray_(select old(#length) substring_#in~t.base)| lambda))
 (= |ray_(select old(#length) substring_#in~s.base)|
 (* |ray_(select old(#length) substring_#in~s.base)| lambda))
 (= |ray_(ite (select #valid substring_#in~t.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda))
 (= ray_substring_~s.offset (* ray_substring_~s.offset lambda))
 (= |ray_substring_#in~s.base| (* |ray_substring_#in~s.base| lambda))
 (= |ray_substring_#in~s.offset| (* |ray_substring_#in~s.offset| lambda))
 (= |ray_substring_#in~t.offset| (* |ray_substring_#in~t.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_substring_~t.base (* ray_substring_~t.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select #length substring_#in~s.base)|
 (* |ray_(select #length substring_#in~s.base)| lambda))
 (= |ray_(select #length substring_#in~t.base)|
 (* |ray_(select #length substring_#in~t.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_substring_~t.offset (* ray_substring_~t.offset lambda))
 (= ray_substring_~s.base (* ray_substring_~s.base lambda))
 (= |ray_substring_#in~t.base| (* |ray_substring_#in~t.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda))
 (= |ray_(ite (select #valid substring_#in~s.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 1)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_substring_~t.offset lambda) (- 1))
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 1)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 1)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 1)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 1)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) (- 1))
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 1)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) (- 1))
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 1)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) (- 1))
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select old(#length) substring_#in~t.base)|
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|))
 (= |honda_(select old(#length) substring_#in~s.base)|
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|))
 (= |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|))
 (= honda_substring_~s.offset
 (+ honda_substring_~s.offset ray_substring_~s.offset))
 (= |honda_substring_#in~s.base|
 (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|))
 (= |honda_substring_#in~s.offset|
 (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|))
 (= |honda_substring_#in~t.offset|
 (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_substring_~t.base
 (+ honda_substring_~t.base ray_substring_~t.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(select #length substring_#in~s.base)|
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|))
 (= |honda_(select #length substring_#in~t.base)|
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_substring_~t.offset
 (+ honda_substring_~t.offset ray_substring_~t.offset))
 (= honda_substring_~s.base
 (+ honda_substring_~s.base ray_substring_~s.base))
 (= |honda_substring_#in~t.base|
 (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|))
 (= |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|))
 (= |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 1)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) (- 1))
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 1)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 1)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 1)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 1)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 
 (- 1)) (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 1)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) (- 1))
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 1)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) (- 1))
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (= |ray_(select old(#length) substring_#in~t.base)|
 (* |ray_(select old(#length) substring_#in~t.base)| lambda))
 (= |ray_(select old(#length) substring_#in~s.base)|
 (* |ray_(select old(#length) substring_#in~s.base)| lambda))
 (= |ray_(ite (select #valid substring_#in~t.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda))
 (= ray_substring_~s.offset (* ray_substring_~s.offset lambda))
 (= |ray_substring_#in~s.base| (* |ray_substring_#in~s.base| lambda))
 (= |ray_substring_#in~s.offset| (* |ray_substring_#in~s.offset| lambda))
 (= |ray_substring_#in~t.offset| (* |ray_substring_#in~t.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_substring_~t.base (* ray_substring_~t.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select #length substring_#in~s.base)|
 (* |ray_(select #length substring_#in~s.base)| lambda))
 (= |ray_(select #length substring_#in~t.base)|
 (* |ray_(select #length substring_#in~t.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_substring_~t.offset (* ray_substring_~t.offset lambda))
 (= ray_substring_~s.base (* ray_substring_~s.base lambda))
 (= |ray_substring_#in~t.base| (* |ray_substring_#in~t.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda))
 (= |ray_(ite (select #valid substring_#in~s.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 1)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_substring_~t.offset lambda) (- 1))
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 1)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 1)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 1)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 1)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) (- 1))
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 1)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) (- 1))
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 1)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) (- 1))
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select old(#length) substring_#in~t.base)|
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|))
 (= |honda_(select old(#length) substring_#in~s.base)|
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|))
 (= |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|))
 (= honda_substring_~s.offset
 (+ honda_substring_~s.offset ray_substring_~s.offset))
 (= |honda_substring_#in~s.base|
 (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|))
 (= |honda_substring_#in~s.offset|
 (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|))
 (= |honda_substring_#in~t.offset|
 (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_substring_~t.base
 (+ honda_substring_~t.base ray_substring_~t.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(select #length substring_#in~s.base)|
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|))
 (= |honda_(select #length substring_#in~t.base)|
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_substring_~t.offset
 (+ honda_substring_~t.offset ray_substring_~t.offset))
 (= honda_substring_~s.base
 (+ honda_substring_~s.base ray_substring_~s.base))
 (= |honda_substring_#in~t.base|
 (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|))
 (= |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|))
 (= |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 1)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) (- 1))
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 1)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 1)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 1)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 1)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 
 (- 1)) (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 1)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 
 (- 1)) (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) (- 1))
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 (- 1)) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 1) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 1)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) (- 1))
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (= |ray_(select old(#length) substring_#in~t.base)|
 (* |ray_(select old(#length) substring_#in~t.base)| lambda))
 (= |ray_(select old(#length) substring_#in~s.base)|
 (* |ray_(select old(#length) substring_#in~s.base)| lambda))
 (= |ray_(ite (select #valid substring_#in~t.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda))
 (= ray_substring_~s.offset (* ray_substring_~s.offset lambda))
 (= |ray_substring_#in~s.base| (* |ray_substring_#in~s.base| lambda))
 (= |ray_substring_#in~s.offset| (* |ray_substring_#in~s.offset| lambda))
 (= |ray_substring_#in~t.offset| (* |ray_substring_#in~t.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_substring_~t.base (* ray_substring_~t.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select #length substring_#in~s.base)|
 (* |ray_(select #length substring_#in~s.base)| lambda))
 (= |ray_(select #length substring_#in~t.base)|
 (* |ray_(select #length substring_#in~t.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_substring_~t.offset (* ray_substring_~t.offset lambda))
 (= ray_substring_~s.base (* ray_substring_~s.base lambda))
 (= |ray_substring_#in~t.base| (* |ray_substring_#in~t.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda))
 (= |ray_(ite (select #valid substring_#in~s.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 1)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_substring_~t.offset lambda) (- 1))
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 1)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 1)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 1)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 1)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) (- 1))
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 1)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) (- 1))
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) (- 1))
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) (- 1)) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 1) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 1)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) (- 1))
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select old(#length) substring_#in~t.base)|
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|))
 (= |honda_(select old(#length) substring_#in~s.base)|
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|))
 (= |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|))
 (= honda_substring_~s.offset
 (+ honda_substring_~s.offset ray_substring_~s.offset))
 (= |honda_substring_#in~s.base|
 (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|))
 (= |honda_substring_#in~s.offset|
 (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|))
 (= |honda_substring_#in~t.offset|
 (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_substring_~t.base
 (+ honda_substring_~t.base ray_substring_~t.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(select #length substring_#in~s.base)|
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|))
 (= |honda_(select #length substring_#in~t.base)|
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_substring_~t.offset
 (+ honda_substring_~t.offset ray_substring_~t.offset))
 (= honda_substring_~s.base
 (+ honda_substring_~s.base ray_substring_~s.base))
 (= |honda_substring_#in~t.base|
 (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|))
 (= |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|))
 (= |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 1)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) (- 1))
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 1)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 1)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 1)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 1)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 
 (- 1)) (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 1)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 
 (- 1)) (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) (- 1))
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 1)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) (- 1))
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (= |ray_(select old(#length) substring_#in~t.base)|
 (* |ray_(select old(#length) substring_#in~t.base)| lambda))
 (= |ray_(select old(#length) substring_#in~s.base)|
 (* |ray_(select old(#length) substring_#in~s.base)| lambda))
 (= |ray_(ite (select #valid substring_#in~t.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda))
 (= ray_substring_~s.offset (* ray_substring_~s.offset lambda))
 (= |ray_substring_#in~s.base| (* |ray_substring_#in~s.base| lambda))
 (= |ray_substring_#in~s.offset| (* |ray_substring_#in~s.offset| lambda))
 (= |ray_substring_#in~t.offset| (* |ray_substring_#in~t.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_substring_~t.base (* ray_substring_~t.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select #length substring_#in~s.base)|
 (* |ray_(select #length substring_#in~s.base)| lambda))
 (= |ray_(select #length substring_#in~t.base)|
 (* |ray_(select #length substring_#in~t.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_substring_~t.offset (* ray_substring_~t.offset lambda))
 (= ray_substring_~s.base (* ray_substring_~s.base lambda))
 (= |ray_substring_#in~t.base| (* |ray_substring_#in~t.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda))
 (= |ray_(ite (select #valid substring_#in~s.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 1)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_substring_~t.offset lambda) (- 1))
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 1)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 1)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 1)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 1)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) (- 1))
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 1)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) (- 1))
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) (- 1))
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 1)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) (- 1))
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select old(#length) substring_#in~t.base)|
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|))
 (= |honda_(select old(#length) substring_#in~s.base)|
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|))
 (= |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|))
 (= honda_substring_~s.offset
 (+ honda_substring_~s.offset ray_substring_~s.offset))
 (= |honda_substring_#in~s.base|
 (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|))
 (= |honda_substring_#in~s.offset|
 (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|))
 (= |honda_substring_#in~t.offset|
 (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_substring_~t.base
 (+ honda_substring_~t.base ray_substring_~t.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(select #length substring_#in~s.base)|
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|))
 (= |honda_(select #length substring_#in~t.base)|
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_substring_~t.offset
 (+ honda_substring_~t.offset ray_substring_~t.offset))
 (= honda_substring_~s.base
 (+ honda_substring_~s.base ray_substring_~s.base))
 (= |honda_substring_#in~t.base|
 (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|))
 (= |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|))
 (= |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 1)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) (- 1))
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 1)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 1)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 1)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 1)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 
 (- 1)) (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 1)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 
 (- 1)) (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) (- 1))
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 (- 1)) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 1) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 1)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) (- 1))
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (= |ray_(select old(#length) substring_#in~t.base)|
 (* |ray_(select old(#length) substring_#in~t.base)| lambda))
 (= |ray_(select old(#length) substring_#in~s.base)|
 (* |ray_(select old(#length) substring_#in~s.base)| lambda))
 (= |ray_(ite (select #valid substring_#in~t.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda))
 (= ray_substring_~s.offset (* ray_substring_~s.offset lambda))
 (= |ray_substring_#in~s.base| (* |ray_substring_#in~s.base| lambda))
 (= |ray_substring_#in~s.offset| (* |ray_substring_#in~s.offset| lambda))
 (= |ray_substring_#in~t.offset| (* |ray_substring_#in~t.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_substring_~t.base (* ray_substring_~t.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select #length substring_#in~s.base)|
 (* |ray_(select #length substring_#in~s.base)| lambda))
 (= |ray_(select #length substring_#in~t.base)|
 (* |ray_(select #length substring_#in~t.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_substring_~t.offset (* ray_substring_~t.offset lambda))
 (= ray_substring_~s.base (* ray_substring_~s.base lambda))
 (= |ray_substring_#in~t.base| (* |ray_substring_#in~t.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda))
 (= |ray_(ite (select #valid substring_#in~s.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 1)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_substring_~t.offset lambda) (- 1))
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 1)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 1)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 1)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 1)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) (- 1))
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 1)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) (- 1))
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) (- 1))
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) (- 1)) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 1) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 1)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) (- 1))
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select old(#length) substring_#in~t.base)|
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|))
 (= |honda_(select old(#length) substring_#in~s.base)|
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|))
 (= |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|))
 (= honda_substring_~s.offset
 (+ honda_substring_~s.offset ray_substring_~s.offset))
 (= |honda_substring_#in~s.base|
 (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|))
 (= |honda_substring_#in~s.offset|
 (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|))
 (= |honda_substring_#in~t.offset|
 (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_substring_~t.base
 (+ honda_substring_~t.base ray_substring_~t.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(select #length substring_#in~s.base)|
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|))
 (= |honda_(select #length substring_#in~t.base)|
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_substring_~t.offset
 (+ honda_substring_~t.offset ray_substring_~t.offset))
 (= honda_substring_~s.base
 (+ honda_substring_~s.base ray_substring_~s.base))
 (= |honda_substring_#in~t.base|
 (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|))
 (= |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|))
 (= |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 1)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) (- 1))
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 1)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 1)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 1)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 1)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 
 (- 1)) (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 1)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) (- 1))
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 1)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) (- 1))
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (= |ray_(select old(#length) substring_#in~t.base)|
 (* |ray_(select old(#length) substring_#in~t.base)| lambda))
 (= |ray_(select old(#length) substring_#in~s.base)|
 (* |ray_(select old(#length) substring_#in~s.base)| lambda))
 (= |ray_(ite (select #valid substring_#in~t.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda))
 (= ray_substring_~s.offset (* ray_substring_~s.offset lambda))
 (= |ray_substring_#in~s.base| (* |ray_substring_#in~s.base| lambda))
 (= |ray_substring_#in~s.offset| (* |ray_substring_#in~s.offset| lambda))
 (= |ray_substring_#in~t.offset| (* |ray_substring_#in~t.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_substring_~t.base (* ray_substring_~t.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select #length substring_#in~s.base)|
 (* |ray_(select #length substring_#in~s.base)| lambda))
 (= |ray_(select #length substring_#in~t.base)|
 (* |ray_(select #length substring_#in~t.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_substring_~t.offset (* ray_substring_~t.offset lambda))
 (= ray_substring_~s.base (* ray_substring_~s.base lambda))
 (= |ray_substring_#in~t.base| (* |ray_substring_#in~t.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda))
 (= |ray_(ite (select #valid substring_#in~s.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 1)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_substring_~t.offset lambda) (- 1))
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 1)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 1)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 1)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 1)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) (- 1))
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 1)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) (- 1))
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 1)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) (- 1))
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select old(#length) substring_#in~t.base)|
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|))
 (= |honda_(select old(#length) substring_#in~s.base)|
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|))
 (= |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|))
 (= honda_substring_~s.offset
 (+ honda_substring_~s.offset ray_substring_~s.offset))
 (= |honda_substring_#in~s.base|
 (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|))
 (= |honda_substring_#in~s.offset|
 (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|))
 (= |honda_substring_#in~t.offset|
 (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_substring_~t.base
 (+ honda_substring_~t.base ray_substring_~t.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(select #length substring_#in~s.base)|
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|))
 (= |honda_(select #length substring_#in~t.base)|
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_substring_~t.offset
 (+ honda_substring_~t.offset ray_substring_~t.offset))
 (= honda_substring_~s.base
 (+ honda_substring_~s.base ray_substring_~s.base))
 (= |honda_substring_#in~t.base|
 (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|))
 (= |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|))
 (= |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 1)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) (- 1))
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 1)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 1)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 1)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 1)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 
 (- 1)) (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 1)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 
 (- 1)) (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) (- 1))
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 1)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) (- 1))
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (= |ray_(select old(#length) substring_#in~t.base)|
 (* |ray_(select old(#length) substring_#in~t.base)| lambda))
 (= |ray_(select old(#length) substring_#in~s.base)|
 (* |ray_(select old(#length) substring_#in~s.base)| lambda))
 (= |ray_(ite (select #valid substring_#in~t.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda))
 (= ray_substring_~s.offset (* ray_substring_~s.offset lambda))
 (= |ray_substring_#in~s.base| (* |ray_substring_#in~s.base| lambda))
 (= |ray_substring_#in~s.offset| (* |ray_substring_#in~s.offset| lambda))
 (= |ray_substring_#in~t.offset| (* |ray_substring_#in~t.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_substring_~t.base (* ray_substring_~t.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select #length substring_#in~s.base)|
 (* |ray_(select #length substring_#in~s.base)| lambda))
 (= |ray_(select #length substring_#in~t.base)|
 (* |ray_(select #length substring_#in~t.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_substring_~t.offset (* ray_substring_~t.offset lambda))
 (= ray_substring_~s.base (* ray_substring_~s.base lambda))
 (= |ray_substring_#in~t.base| (* |ray_substring_#in~t.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda))
 (= |ray_(ite (select #valid substring_#in~s.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 1)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_substring_~t.offset lambda) (- 1))
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 1)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 1)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 1)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 1)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) (- 1))
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 1)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) (- 1))
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) (- 1))
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 1)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) (- 1))
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select old(#length) substring_#in~t.base)|
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|))
 (= |honda_(select old(#length) substring_#in~s.base)|
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|))
 (= |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|))
 (= honda_substring_~s.offset
 (+ honda_substring_~s.offset ray_substring_~s.offset))
 (= |honda_substring_#in~s.base|
 (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|))
 (= |honda_substring_#in~s.offset|
 (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|))
 (= |honda_substring_#in~t.offset|
 (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_substring_~t.base
 (+ honda_substring_~t.base ray_substring_~t.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(select #length substring_#in~s.base)|
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|))
 (= |honda_(select #length substring_#in~t.base)|
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_substring_~t.offset
 (+ honda_substring_~t.offset ray_substring_~t.offset))
 (= honda_substring_~s.base
 (+ honda_substring_~s.base ray_substring_~s.base))
 (= |honda_substring_#in~t.base|
 (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|))
 (= |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|))
 (= |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 1)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) (- 1))
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 1)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 1)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 1)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 1)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 
 (- 1)) (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 1)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 
 (- 1)) (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) (- 1))
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 1)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) (- 1))
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (= |ray_(select old(#length) substring_#in~t.base)|
 (* |ray_(select old(#length) substring_#in~t.base)| lambda))
 (= |ray_(select old(#length) substring_#in~s.base)|
 (* |ray_(select old(#length) substring_#in~s.base)| lambda))
 (= |ray_(ite (select #valid substring_#in~t.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda))
 (= ray_substring_~s.offset (* ray_substring_~s.offset lambda))
 (= |ray_substring_#in~s.base| (* |ray_substring_#in~s.base| lambda))
 (= |ray_substring_#in~s.offset| (* |ray_substring_#in~s.offset| lambda))
 (= |ray_substring_#in~t.offset| (* |ray_substring_#in~t.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_substring_~t.base (* ray_substring_~t.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select #length substring_#in~s.base)|
 (* |ray_(select #length substring_#in~s.base)| lambda))
 (= |ray_(select #length substring_#in~t.base)|
 (* |ray_(select #length substring_#in~t.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_substring_~t.offset (* ray_substring_~t.offset lambda))
 (= ray_substring_~s.base (* ray_substring_~s.base lambda))
 (= |ray_substring_#in~t.base| (* |ray_substring_#in~t.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda))
 (= |ray_(ite (select #valid substring_#in~s.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 1)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_substring_~t.offset lambda) (- 1))
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 1)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 1)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 1)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 1)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) (- 1))
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 1)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) (- 1))
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) (- 1))
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 1)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) (- 1))
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select old(#length) substring_#in~t.base)|
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|))
 (= |honda_(select old(#length) substring_#in~s.base)|
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|))
 (= |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|))
 (= honda_substring_~s.offset
 (+ honda_substring_~s.offset ray_substring_~s.offset))
 (= |honda_substring_#in~s.base|
 (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|))
 (= |honda_substring_#in~s.offset|
 (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|))
 (= |honda_substring_#in~t.offset|
 (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_substring_~t.base
 (+ honda_substring_~t.base ray_substring_~t.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(select #length substring_#in~s.base)|
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|))
 (= |honda_(select #length substring_#in~t.base)|
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_substring_~t.offset
 (+ honda_substring_~t.offset ray_substring_~t.offset))
 (= honda_substring_~s.base
 (+ honda_substring_~s.base ray_substring_~s.base))
 (= |honda_substring_#in~t.base|
 (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|))
 (= |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|))
 (= |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 1)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) (- 1))
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 1)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 1)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 1)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 1)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 
 (- 1)) (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 1)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 
 (- 1)) (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) (- 1))
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 (- 1)) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 1) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 1)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) (- 1))
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (= |ray_(select old(#length) substring_#in~t.base)|
 (* |ray_(select old(#length) substring_#in~t.base)| lambda))
 (= |ray_(select old(#length) substring_#in~s.base)|
 (* |ray_(select old(#length) substring_#in~s.base)| lambda))
 (= |ray_(ite (select #valid substring_#in~t.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda))
 (= ray_substring_~s.offset (* ray_substring_~s.offset lambda))
 (= |ray_substring_#in~s.base| (* |ray_substring_#in~s.base| lambda))
 (= |ray_substring_#in~s.offset| (* |ray_substring_#in~s.offset| lambda))
 (= |ray_substring_#in~t.offset| (* |ray_substring_#in~t.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_substring_~t.base (* ray_substring_~t.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select #length substring_#in~s.base)|
 (* |ray_(select #length substring_#in~s.base)| lambda))
 (= |ray_(select #length substring_#in~t.base)|
 (* |ray_(select #length substring_#in~t.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_substring_~t.offset (* ray_substring_~t.offset lambda))
 (= ray_substring_~s.base (* ray_substring_~s.base lambda))
 (= |ray_substring_#in~t.base| (* |ray_substring_#in~t.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda))
 (= |ray_(ite (select #valid substring_#in~s.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 1)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_substring_~t.offset lambda) (- 1))
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 1)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 1)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 1)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 1)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) (- 1))
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 1)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) (- 1))
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) (- 1))
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) (- 1)) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 1) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 1)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) (- 1))
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select old(#length) substring_#in~t.base)|
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|))
 (= |honda_(select old(#length) substring_#in~s.base)|
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|))
 (= |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|))
 (= honda_substring_~s.offset
 (+ honda_substring_~s.offset ray_substring_~s.offset))
 (= |honda_substring_#in~s.base|
 (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|))
 (= |honda_substring_#in~s.offset|
 (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|))
 (= |honda_substring_#in~t.offset|
 (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_substring_~t.base
 (+ honda_substring_~t.base ray_substring_~t.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(select #length substring_#in~s.base)|
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|))
 (= |honda_(select #length substring_#in~t.base)|
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_substring_~t.offset
 (+ honda_substring_~t.offset ray_substring_~t.offset))
 (= honda_substring_~s.base
 (+ honda_substring_~s.base ray_substring_~s.base))
 (= |honda_substring_#in~t.base|
 (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|))
 (= |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|))
 (= |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 1)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) (- 1))
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 1)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 1)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 1)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 1)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 
 (- 1)) (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 1)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 
 (- 1)) (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) (- 1))
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 1)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) (- 1))
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (= |ray_(select old(#length) substring_#in~t.base)|
 (* |ray_(select old(#length) substring_#in~t.base)| lambda))
 (= |ray_(select old(#length) substring_#in~s.base)|
 (* |ray_(select old(#length) substring_#in~s.base)| lambda))
 (= |ray_(ite (select #valid substring_#in~t.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda))
 (= ray_substring_~s.offset (* ray_substring_~s.offset lambda))
 (= |ray_substring_#in~s.base| (* |ray_substring_#in~s.base| lambda))
 (= |ray_substring_#in~s.offset| (* |ray_substring_#in~s.offset| lambda))
 (= |ray_substring_#in~t.offset| (* |ray_substring_#in~t.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_substring_~t.base (* ray_substring_~t.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select #length substring_#in~s.base)|
 (* |ray_(select #length substring_#in~s.base)| lambda))
 (= |ray_(select #length substring_#in~t.base)|
 (* |ray_(select #length substring_#in~t.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_substring_~t.offset (* ray_substring_~t.offset lambda))
 (= ray_substring_~s.base (* ray_substring_~s.base lambda))
 (= |ray_substring_#in~t.base| (* |ray_substring_#in~t.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda))
 (= |ray_(ite (select #valid substring_#in~s.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 1)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_substring_~t.offset lambda) (- 1))
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 1)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 1)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 1)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 1)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) (- 1))
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 1)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) (- 1))
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) (- 1))
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 1)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) (- 1))
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select old(#length) substring_#in~t.base)|
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|))
 (= |honda_(select old(#length) substring_#in~s.base)|
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|))
 (= |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|))
 (= honda_substring_~s.offset
 (+ honda_substring_~s.offset ray_substring_~s.offset))
 (= |honda_substring_#in~s.base|
 (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|))
 (= |honda_substring_#in~s.offset|
 (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|))
 (= |honda_substring_#in~t.offset|
 (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_substring_~t.base
 (+ honda_substring_~t.base ray_substring_~t.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(select #length substring_#in~s.base)|
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|))
 (= |honda_(select #length substring_#in~t.base)|
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_substring_~t.offset
 (+ honda_substring_~t.offset ray_substring_~t.offset))
 (= honda_substring_~s.base
 (+ honda_substring_~s.base ray_substring_~s.base))
 (= |honda_substring_#in~t.base|
 (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|))
 (= |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|))
 (= |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 1)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 1)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) (- 1))
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 1)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset (- 1)) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 1)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 1)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) (- 1))
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base (- 1)) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 1)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) (- 1))
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 1) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 
 (- 1)) (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 1)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 1)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| (- 1))
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 
 (- 1)) (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 1)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) (- 1))
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 1)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) (- 1))
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 1)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) 0)
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) (- 1))
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 1)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 0) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select old(#length) substring_#in~t.base)|
 |ray_(select old(#length) substring_#in~t.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~ps~2.base) 1 0)|
 |ray_(ite (select #valid substring_~ps~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) substring_#in~s.base)|
 |ray_(select old(#length) substring_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~t.base) 1 0)|
 |ray_(ite (select #valid substring_#in~t.base) 1 0)|) 0)
 (* (+ honda_substring_~s.offset ray_substring_~s.offset) 0)
 (* (+ honda_substring_~ps2~3.offset ray_substring_~ps2~3.offset) (- 1))
 (* (+ |honda_substring_#in~s.base| |ray_substring_#in~s.base|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|)
 0) (* (+ honda_substring_~ps~2.base ray_substring_~ps~2.base) 0)
 (*
 (+ |honda_(select #length substring_~pt~3.base)|
 |ray_(select #length substring_~pt~3.base)|) 0)
 (* (+ |honda_substring_#in~s.offset| |ray_substring_#in~s.offset|) 0)
 (* (+ |honda_substring_#in~t.offset| |ray_substring_#in~t.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_substring_#t~mem3| |ray_substring_#t~mem3|) 0)
 (* (+ honda_substring_~t.base ray_substring_~t.base) 0)
 (* (+ |honda_substring_#t~mem7| |ray_substring_#t~mem7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite substring_#t~short4 1 0)|
 |ray_(ite substring_#t~short4 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_#in~s.base)|
 |ray_(select #length substring_#in~s.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid substring_~pt~3.base) 1 0)|
 |ray_(ite (select #valid substring_~pt~3.base) 1 0)|) 0)
 (* (+ |honda_substring_#t~post8.offset| |ray_substring_#t~post8.offset|) 0)
 (* (+ |honda_substring_#t~mem1| |ray_substring_#t~mem1|) 0)
 (*
 (+ |honda_(select #length substring_#in~t.base)|
 |ray_(select #length substring_#in~t.base)|) 0)
 (* (+ honda_substring_~pt~3.offset ray_substring_~pt~3.offset) 0)
 (* (+ |honda_substring_#t~mem2| |ray_substring_#t~mem2|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_substring_~t.offset ray_substring_~t.offset) 0)
 (* (+ honda_substring_~ps~2.offset ray_substring_~ps~2.offset) 0)
 (* (+ honda_substring_~s.base ray_substring_~s.base) 0)
 (* (+ |honda_substring_#t~mem0| |ray_substring_#t~mem0|) 0)
 (* (+ honda_substring_~pt~3.base ray_substring_~pt~3.base) 0)
 (* (+ |honda_substring_#in~t.base| |ray_substring_#in~t.base|) 0)
 (* (+ |honda_substring_#t~post8.base| |ray_substring_#t~post8.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid substring_#in~s.base) 1 0)|
 |ray_(ite (select #valid substring_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length substring_~ps~2.base)|
 |ray_(select #length substring_~ps~2.base)|) 0)
 (* (+ honda_substring_~ps2~3.base ray_substring_~ps2~3.base) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|) 0)
 (* |honda_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* honda_substring_~ps2~3.offset 0)
 (*
 |honda_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* honda_substring_~ps~2.base 0) 
 (* |honda_substring_#t~mem3| 0) 
 (* |honda_substring_#t~mem7| 0) 
 (* |honda_(ite substring_#t~short4 1 0)| 0)
 (* |honda_substring_#t~post8.offset| 0) 
 (* |honda_substring_#t~mem1| 0) 
 (* honda_substring_~pt~3.offset 0) 
 (* |honda_substring_#t~mem2| 0) 
 (* honda_substring_~ps~2.offset 1) 
 (* |honda_substring_#t~mem0| 0) 
 (* honda_substring_~pt~3.base 0) 
 (* |honda_substring_#t~post8.base| 0)
 (* |honda_(select #length substring_~ps~2.base)| 0)
 (* honda_substring_~ps2~3.base 0) 0) 0)
 (= |ray_(select old(#length) substring_#in~t.base)|
 (* |ray_(select old(#length) substring_#in~t.base)| lambda))
 (= |ray_(select old(#length) substring_#in~s.base)|
 (* |ray_(select old(#length) substring_#in~s.base)| lambda))
 (= |ray_(ite (select #valid substring_#in~t.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda))
 (= ray_substring_~s.offset (* ray_substring_~s.offset lambda))
 (= |ray_substring_#in~s.base| (* |ray_substring_#in~s.base| lambda))
 (= |ray_substring_#in~s.offset| (* |ray_substring_#in~s.offset| lambda))
 (= |ray_substring_#in~t.offset| (* |ray_substring_#in~t.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_substring_~t.base (* ray_substring_~t.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select #length substring_#in~s.base)|
 (* |ray_(select #length substring_#in~s.base)| lambda))
 (= |ray_(select #length substring_#in~t.base)|
 (* |ray_(select #length substring_#in~t.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_substring_~t.offset (* ray_substring_~t.offset lambda))
 (= ray_substring_~s.base (* ray_substring_~s.base lambda))
 (= |ray_substring_#in~t.base| (* |ray_substring_#in~t.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda))
 (= |ray_(ite (select #valid substring_#in~s.base) 1 0)|
 (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)|
 (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 1)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 1)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_substring_~t.offset lambda) (- 1))
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 1)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset (- 1)) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 1)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 1)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 1)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) (- 1))
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 1) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base (- 1)) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 1)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) (- 1))
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 1) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) (- 1))
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 1)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 1)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| (- 1))
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) (- 1))
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 1)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) (- 1))
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 1)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 (- 1)) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) (- 1))
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 1)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) 0)
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) (- 1))
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 1)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 0) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0)
 (>=
 (+ (* (* |ray_(select old(#length) substring_#in~t.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~pt~3.base) substring_~pt~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) substring_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~t.base) 1 0)| lambda) 0)
 (* (* ray_substring_~s.offset lambda) 0)
 (* (* ray_substring_~ps2~3.offset lambda) (- 1))
 (* (* |ray_substring_#in~s.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 lambda) 0) (* (* ray_substring_~ps~2.base lambda) 0)
 (* (* |ray_(select #length substring_~pt~3.base)| lambda) 0)
 (* (* |ray_substring_#in~s.offset| lambda) 0)
 (* (* |ray_substring_#in~t.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~mem3| lambda) 0)
 (* (* ray_substring_~t.base lambda) 0)
 (* (* |ray_substring_#t~mem7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite substring_#t~short4 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_#in~s.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int substring_~ps2~3.base) substring_~ps2~3.offset)|
 lambda) 0)
 (* (* |ray_(ite (select #valid substring_~pt~3.base) 1 0)| lambda) 0)
 (* (* |ray_substring_#t~post8.offset| lambda) 0)
 (* (* |ray_substring_#t~mem1| lambda) 0)
 (* (* |ray_(select #length substring_#in~t.base)| lambda) 0)
 (* (* ray_substring_~pt~3.offset lambda) 0)
 (* (* |ray_substring_#t~mem2| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_substring_~t.offset lambda) 0)
 (* (* ray_substring_~ps~2.offset lambda) 0)
 (* (* ray_substring_~s.base lambda) 0)
 (* (* |ray_substring_#t~mem0| lambda) 0)
 (* (* ray_substring_~pt~3.base lambda) 0)
 (* (* |ray_substring_#in~t.base| lambda) 0)
 (* (* |ray_substring_#t~post8.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid substring_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length substring_~ps~2.base)| lambda) 0)
 (* (* ray_substring_~ps2~3.base lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) substring_#in~t.base) 1 0)| lambda) 0)
 (* |ray_(ite (select #valid substring_~ps~2.base) 1 0)| 0)
 (* ray_substring_~ps2~3.offset 0)
 (*
 |ray_(select (select #memory_int substring_~ps~2.base) substring_~ps~2.offset)|
 0) (* ray_substring_~ps~2.base 0) 
 (* |ray_substring_#t~mem3| 0) 
 (* |ray_substring_#t~mem7| 0) 
 (* |ray_(ite substring_#t~short4 1 0)| 0)
 (* |ray_substring_#t~post8.offset| 0) 
 (* |ray_substring_#t~mem1| 0) 
 (* ray_substring_~pt~3.offset 0) 
 (* |ray_substring_#t~mem2| 0) 
 (* ray_substring_~ps~2.offset 1) 
 (* |ray_substring_#t~mem0| 0) 
 (* ray_substring_~pt~3.base 0) 
 (* |ray_substring_#t~post8.base| 0)
 (* |ray_(select #length substring_~ps~2.base)| 0)
 (* ray_substring_~ps2~3.base 0)) 0) 
 (= lambda lambda))) (>= lambda 0)))
(check-sat)
(exit)

