(set-logic QF_NIA)
(set-info :source |
 more info in 'N. P. Lopes, L. Aksoy, V. Manquinho, J. Monteiro.
 Optimally Solving the MCM Problem Using Pseudo-Boolean Satisfiability.
 Technical Report RT/43/2010, INESC-ID, Nov. 2010'. |)
(set-info :smt-lib-version 2.0)
(set-info :category "industrial")
(set-info :status unknown)
(declare-fun X29 () Int)
(declare-fun X30 () Int)
(declare-fun S0 () Int)
(declare-fun S1 () Int)
(declare-fun S2 () Int)
(declare-fun S3 () Int)
(define-fun power2 ((x Int)) Bool
  (or (= x 2048) (= x 1024) (= x 512) (= x 256) (= x 128) (= x 64) (= x 32) (= x 16) (= x 8) (= x 4) (= x 2) (= x 1)))
(assert (or
 (= X29 (+ S0 S1))
 (= X29 (- S0 S1))
 (= X29 (+ (* 31 S0) S1))
 (= X29 (- (* 31 S0) S1))
 (= X29 (- S0 (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 31 S1)))
 (= X29 (- (* 31 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 33 S1)))
 (= X29 (- (* 31 S0) (* 33 S1)))
 (= X29 (- (* 33 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 39 S1)))
 (= X29 (- (* 31 S0) (* 39 S1)))
 (= X29 (- (* 39 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 47 S1)))
 (= X29 (- (* 31 S0) (* 47 S1)))
 (= X29 (- (* 47 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 41 S1)))
 (= X29 (- (* 31 S0) (* 41 S1)))
 (= X29 (- (* 41 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 217 S1)))
 (= X29 (- (* 31 S0) (* 217 S1)))
 (= X29 (- (* 217 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 295 S1)))
 (= X29 (- (* 31 S0) (* 295 S1)))
 (= X29 (- (* 295 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 167 S1)))
 (= X29 (- (* 31 S0) (* 167 S1)))
 (= X29 (- (* 167 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 1313 S1)))
 (= X29 (- (* 31 S0) (* 1313 S1)))
 (= X29 (- (* 1313 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 281 S1)))
 (= X29 (- (* 31 S0) (* 281 S1)))
 (= X29 (- (* 281 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 1191 S1)))
 (= X29 (- (* 31 S0) (* 1191 S1)))
 (= X29 (- (* 1191 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 1945 S1)))
 (= X29 (- (* 31 S0) (* 1945 S1)))
 (= X29 (- (* 1945 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 775 S1)))
 (= X29 (- (* 31 S0) (* 775 S1)))
 (= X29 (- (* 775 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 1367 S1)))
 (= X29 (- (* 31 S0) (* 1367 S1)))
 (= X29 (- (* 1367 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 1015 S1)))
 (= X29 (- (* 31 S0) (* 1015 S1)))
 (= X29 (- (* 1015 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 173 S1)))
 (= X29 (- (* 31 S0) (* 173 S1)))
 (= X29 (- (* 173 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 1097 S1)))
 (= X29 (- (* 31 S0) (* 1097 S1)))
 (= X29 (- (* 1097 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 973 S1)))
 (= X29 (- (* 31 S0) (* 973 S1)))
 (= X29 (- (* 973 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 1517 S1)))
 (= X29 (- (* 31 S0) (* 1517 S1)))
 (= X29 (- (* 1517 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 493 S1)))
 (= X29 (- (* 31 S0) (* 493 S1)))
 (= X29 (- (* 493 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 379 S1)))
 (= X29 (- (* 31 S0) (* 379 S1)))
 (= X29 (- (* 379 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 577 S1)))
 (= X29 (- (* 31 S0) (* 577 S1)))
 (= X29 (- (* 577 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 271 S1)))
 (= X29 (- (* 31 S0) (* 271 S1)))
 (= X29 (- (* 271 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 653 S1)))
 (= X29 (- (* 31 S0) (* 653 S1)))
 (= X29 (- (* 653 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 1395 S1)))
 (= X29 (- (* 31 S0) (* 1395 S1)))
 (= X29 (- (* 1395 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 747 S1)))
 (= X29 (- (* 31 S0) (* 747 S1)))
 (= X29 (- (* 747 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 1803 S1)))
 (= X29 (- (* 31 S0) (* 1803 S1)))
 (= X29 (- (* 1803 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 933 S1)))
 (= X29 (- (* 31 S0) (* 933 S1)))
 (= X29 (- (* 933 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 1041 S1)))
 (= X29 (- (* 31 S0) (* 1041 S1)))
 (= X29 (- (* 1041 S0) (* 31 S1)))
 (= X29 (+ (* 33 S0) S1))
 (= X29 (- (* 33 S0) S1))
 (= X29 (- S0 (* 33 S1)))
 (= X29 (+ (* 33 S0) (* 33 S1)))
 (= X29 (- (* 33 S0) (* 33 S1)))
 (= X29 (+ (* 33 S0) (* 39 S1)))
 (= X29 (- (* 33 S0) (* 39 S1)))
 (= X29 (- (* 39 S0) (* 33 S1)))
 (= X29 (+ (* 33 S0) (* 47 S1)))
 (= X29 (- (* 33 S0) (* 47 S1)))
 (= X29 (- (* 47 S0) (* 33 S1)))
 (= X29 (+ (* 33 S0) (* 41 S1)))
 (= X29 (- (* 33 S0) (* 41 S1)))
 (= X29 (- (* 41 S0) (* 33 S1)))
 (= X29 (+ (* 33 S0) (* 217 S1)))
 (= X29 (- (* 33 S0) (* 217 S1)))
 (= X29 (- (* 217 S0) (* 33 S1)))
 (= X29 (+ (* 33 S0) (* 295 S1)))
 (= X29 (- (* 33 S0) (* 295 S1)))
 (= X29 (- (* 295 S0) (* 33 S1)))
 (= X29 (+ (* 33 S0) (* 167 S1)))
 (= X29 (- (* 33 S0) (* 167 S1)))
 (= X29 (- (* 167 S0) (* 33 S1)))
 (= X29 (+ (* 33 S0) (* 1313 S1)))
 (= X29 (- (* 33 S0) (* 1313 S1)))
 (= X29 (- (* 1313 S0) (* 33 S1)))
 (= X29 (+ (* 33 S0) (* 281 S1)))
 (= X29 (- (* 33 S0) (* 281 S1)))
 (= X29 (- (* 281 S0) (* 33 S1)))
 (= X29 (+ (* 33 S0) (* 1191 S1)))
 (= X29 (- (* 33 S0) (* 1191 S1)))
 (= X29 (- (* 1191 S0) (* 33 S1)))
 (= X29 (+ (* 33 S0) (* 1945 S1)))
 (= X29 (- (* 33 S0) (* 1945 S1)))
 (= X29 (- (* 1945 S0) (* 33 S1)))
 (= X29 (+ (* 33 S0) (* 775 S1)))
 (= X29 (- (* 33 S0) (* 775 S1)))
 (= X29 (- (* 775 S0) (* 33 S1)))
 (= X29 (+ (* 33 S0) (* 1367 S1)))
 (= X29 (- (* 33 S0) (* 1367 S1)))
 (= X29 (- (* 1367 S0) (* 33 S1)))
 (= X29 (+ (* 33 S0) (* 1015 S1)))
 (= X29 (- (* 33 S0) (* 1015 S1)))
 (= X29 (- (* 1015 S0) (* 33 S1)))
 (= X29 (+ (* 33 S0) (* 173 S1)))
 (= X29 (- (* 33 S0) (* 173 S1)))
 (= X29 (- (* 173 S0) (* 33 S1)))
 (= X29 (+ (* 33 S0) (* 1097 S1)))
 (= X29 (- (* 33 S0) (* 1097 S1)))
 (= X29 (- (* 1097 S0) (* 33 S1)))
 (= X29 (+ (* 33 S0) (* 973 S1)))
 (= X29 (- (* 33 S0) (* 973 S1)))
 (= X29 (- (* 973 S0) (* 33 S1)))
 (= X29 (+ (* 33 S0) (* 1517 S1)))
 (= X29 (- (* 33 S0) (* 1517 S1)))
 (= X29 (- (* 1517 S0) (* 33 S1)))
 (= X29 (+ (* 33 S0) (* 493 S1)))
 (= X29 (- (* 33 S0) (* 493 S1)))
 (= X29 (- (* 493 S0) (* 33 S1)))
 (= X29 (+ (* 33 S0) (* 379 S1)))
 (= X29 (- (* 33 S0) (* 379 S1)))
 (= X29 (- (* 379 S0) (* 33 S1)))
 (= X29 (+ (* 33 S0) (* 577 S1)))
 (= X29 (- (* 33 S0) (* 577 S1)))
 (= X29 (- (* 577 S0) (* 33 S1)))
 (= X29 (+ (* 33 S0) (* 271 S1)))
 (= X29 (- (* 33 S0) (* 271 S1)))
 (= X29 (- (* 271 S0) (* 33 S1)))
 (= X29 (+ (* 33 S0) (* 653 S1)))
 (= X29 (- (* 33 S0) (* 653 S1)))
 (= X29 (- (* 653 S0) (* 33 S1)))
 (= X29 (+ (* 33 S0) (* 1395 S1)))
 (= X29 (- (* 33 S0) (* 1395 S1)))
 (= X29 (- (* 1395 S0) (* 33 S1)))
 (= X29 (+ (* 33 S0) (* 747 S1)))
 (= X29 (- (* 33 S0) (* 747 S1)))
 (= X29 (- (* 747 S0) (* 33 S1)))
 (= X29 (+ (* 33 S0) (* 1803 S1)))
 (= X29 (- (* 33 S0) (* 1803 S1)))
 (= X29 (- (* 1803 S0) (* 33 S1)))
 (= X29 (+ (* 33 S0) (* 933 S1)))
 (= X29 (- (* 33 S0) (* 933 S1)))
 (= X29 (- (* 933 S0) (* 33 S1)))
 (= X29 (+ (* 33 S0) (* 1041 S1)))
 (= X29 (- (* 33 S0) (* 1041 S1)))
 (= X29 (- (* 1041 S0) (* 33 S1)))
 (= X29 (+ (* 39 S0) S1))
 (= X29 (- (* 39 S0) S1))
 (= X29 (- S0 (* 39 S1)))
 (= X29 (+ (* 39 S0) (* 39 S1)))
 (= X29 (- (* 39 S0) (* 39 S1)))
 (= X29 (+ (* 39 S0) (* 47 S1)))
 (= X29 (- (* 39 S0) (* 47 S1)))
 (= X29 (- (* 47 S0) (* 39 S1)))
 (= X29 (+ (* 39 S0) (* 41 S1)))
 (= X29 (- (* 39 S0) (* 41 S1)))
 (= X29 (- (* 41 S0) (* 39 S1)))
 (= X29 (+ (* 39 S0) (* 217 S1)))
 (= X29 (- (* 39 S0) (* 217 S1)))
 (= X29 (- (* 217 S0) (* 39 S1)))
 (= X29 (+ (* 39 S0) (* 295 S1)))
 (= X29 (- (* 39 S0) (* 295 S1)))
 (= X29 (- (* 295 S0) (* 39 S1)))
 (= X29 (+ (* 39 S0) (* 167 S1)))
 (= X29 (- (* 39 S0) (* 167 S1)))
 (= X29 (- (* 167 S0) (* 39 S1)))
 (= X29 (+ (* 39 S0) (* 1313 S1)))
 (= X29 (- (* 39 S0) (* 1313 S1)))
 (= X29 (- (* 1313 S0) (* 39 S1)))
 (= X29 (+ (* 39 S0) (* 281 S1)))
 (= X29 (- (* 39 S0) (* 281 S1)))
 (= X29 (- (* 281 S0) (* 39 S1)))
 (= X29 (+ (* 39 S0) (* 1191 S1)))
 (= X29 (- (* 39 S0) (* 1191 S1)))
 (= X29 (- (* 1191 S0) (* 39 S1)))
 (= X29 (+ (* 39 S0) (* 1945 S1)))
 (= X29 (- (* 39 S0) (* 1945 S1)))
 (= X29 (- (* 1945 S0) (* 39 S1)))
 (= X29 (+ (* 39 S0) (* 775 S1)))
 (= X29 (- (* 39 S0) (* 775 S1)))
 (= X29 (- (* 775 S0) (* 39 S1)))
 (= X29 (+ (* 39 S0) (* 1367 S1)))
 (= X29 (- (* 39 S0) (* 1367 S1)))
 (= X29 (- (* 1367 S0) (* 39 S1)))
 (= X29 (+ (* 39 S0) (* 1015 S1)))
 (= X29 (- (* 39 S0) (* 1015 S1)))
 (= X29 (- (* 1015 S0) (* 39 S1)))
 (= X29 (+ (* 39 S0) (* 173 S1)))
 (= X29 (- (* 39 S0) (* 173 S1)))
 (= X29 (- (* 173 S0) (* 39 S1)))
 (= X29 (+ (* 39 S0) (* 1097 S1)))
 (= X29 (- (* 39 S0) (* 1097 S1)))
 (= X29 (- (* 1097 S0) (* 39 S1)))
 (= X29 (+ (* 39 S0) (* 973 S1)))
 (= X29 (- (* 39 S0) (* 973 S1)))
 (= X29 (- (* 973 S0) (* 39 S1)))
 (= X29 (+ (* 39 S0) (* 1517 S1)))
 (= X29 (- (* 39 S0) (* 1517 S1)))
 (= X29 (- (* 1517 S0) (* 39 S1)))
 (= X29 (+ (* 39 S0) (* 493 S1)))
 (= X29 (- (* 39 S0) (* 493 S1)))
 (= X29 (- (* 493 S0) (* 39 S1)))
 (= X29 (+ (* 39 S0) (* 379 S1)))
 (= X29 (- (* 39 S0) (* 379 S1)))
 (= X29 (- (* 379 S0) (* 39 S1)))
 (= X29 (+ (* 39 S0) (* 577 S1)))
 (= X29 (- (* 39 S0) (* 577 S1)))
 (= X29 (- (* 577 S0) (* 39 S1)))
 (= X29 (+ (* 39 S0) (* 271 S1)))
 (= X29 (- (* 39 S0) (* 271 S1)))
 (= X29 (- (* 271 S0) (* 39 S1)))
 (= X29 (+ (* 39 S0) (* 653 S1)))
 (= X29 (- (* 39 S0) (* 653 S1)))
 (= X29 (- (* 653 S0) (* 39 S1)))
 (= X29 (+ (* 39 S0) (* 1395 S1)))
 (= X29 (- (* 39 S0) (* 1395 S1)))
 (= X29 (- (* 1395 S0) (* 39 S1)))
 (= X29 (+ (* 39 S0) (* 747 S1)))
 (= X29 (- (* 39 S0) (* 747 S1)))
 (= X29 (- (* 747 S0) (* 39 S1)))
 (= X29 (+ (* 39 S0) (* 1803 S1)))
 (= X29 (- (* 39 S0) (* 1803 S1)))
 (= X29 (- (* 1803 S0) (* 39 S1)))
 (= X29 (+ (* 39 S0) (* 933 S1)))
 (= X29 (- (* 39 S0) (* 933 S1)))
 (= X29 (- (* 933 S0) (* 39 S1)))
 (= X29 (+ (* 39 S0) (* 1041 S1)))
 (= X29 (- (* 39 S0) (* 1041 S1)))
 (= X29 (- (* 1041 S0) (* 39 S1)))
 (= X29 (+ (* 47 S0) S1))
 (= X29 (- (* 47 S0) S1))
 (= X29 (- S0 (* 47 S1)))
 (= X29 (+ (* 47 S0) (* 47 S1)))
 (= X29 (- (* 47 S0) (* 47 S1)))
 (= X29 (+ (* 47 S0) (* 41 S1)))
 (= X29 (- (* 47 S0) (* 41 S1)))
 (= X29 (- (* 41 S0) (* 47 S1)))
 (= X29 (+ (* 47 S0) (* 217 S1)))
 (= X29 (- (* 47 S0) (* 217 S1)))
 (= X29 (- (* 217 S0) (* 47 S1)))
 (= X29 (+ (* 47 S0) (* 295 S1)))
 (= X29 (- (* 47 S0) (* 295 S1)))
 (= X29 (- (* 295 S0) (* 47 S1)))
 (= X29 (+ (* 47 S0) (* 167 S1)))
 (= X29 (- (* 47 S0) (* 167 S1)))
 (= X29 (- (* 167 S0) (* 47 S1)))
 (= X29 (+ (* 47 S0) (* 1313 S1)))
 (= X29 (- (* 47 S0) (* 1313 S1)))
 (= X29 (- (* 1313 S0) (* 47 S1)))
 (= X29 (+ (* 47 S0) (* 281 S1)))
 (= X29 (- (* 47 S0) (* 281 S1)))
 (= X29 (- (* 281 S0) (* 47 S1)))
 (= X29 (+ (* 47 S0) (* 1191 S1)))
 (= X29 (- (* 47 S0) (* 1191 S1)))
 (= X29 (- (* 1191 S0) (* 47 S1)))
 (= X29 (+ (* 47 S0) (* 1945 S1)))
 (= X29 (- (* 47 S0) (* 1945 S1)))
 (= X29 (- (* 1945 S0) (* 47 S1)))
 (= X29 (+ (* 47 S0) (* 775 S1)))
 (= X29 (- (* 47 S0) (* 775 S1)))
 (= X29 (- (* 775 S0) (* 47 S1)))
 (= X29 (+ (* 47 S0) (* 1367 S1)))
 (= X29 (- (* 47 S0) (* 1367 S1)))
 (= X29 (- (* 1367 S0) (* 47 S1)))
 (= X29 (+ (* 47 S0) (* 1015 S1)))
 (= X29 (- (* 47 S0) (* 1015 S1)))
 (= X29 (- (* 1015 S0) (* 47 S1)))
 (= X29 (+ (* 47 S0) (* 173 S1)))
 (= X29 (- (* 47 S0) (* 173 S1)))
 (= X29 (- (* 173 S0) (* 47 S1)))
 (= X29 (+ (* 47 S0) (* 1097 S1)))
 (= X29 (- (* 47 S0) (* 1097 S1)))
 (= X29 (- (* 1097 S0) (* 47 S1)))
 (= X29 (+ (* 47 S0) (* 973 S1)))
 (= X29 (- (* 47 S0) (* 973 S1)))
 (= X29 (- (* 973 S0) (* 47 S1)))
 (= X29 (+ (* 47 S0) (* 1517 S1)))
 (= X29 (- (* 47 S0) (* 1517 S1)))
 (= X29 (- (* 1517 S0) (* 47 S1)))
 (= X29 (+ (* 47 S0) (* 493 S1)))
 (= X29 (- (* 47 S0) (* 493 S1)))
 (= X29 (- (* 493 S0) (* 47 S1)))
 (= X29 (+ (* 47 S0) (* 379 S1)))
 (= X29 (- (* 47 S0) (* 379 S1)))
 (= X29 (- (* 379 S0) (* 47 S1)))
 (= X29 (+ (* 47 S0) (* 577 S1)))
 (= X29 (- (* 47 S0) (* 577 S1)))
 (= X29 (- (* 577 S0) (* 47 S1)))
 (= X29 (+ (* 47 S0) (* 271 S1)))
 (= X29 (- (* 47 S0) (* 271 S1)))
 (= X29 (- (* 271 S0) (* 47 S1)))
 (= X29 (+ (* 47 S0) (* 653 S1)))
 (= X29 (- (* 47 S0) (* 653 S1)))
 (= X29 (- (* 653 S0) (* 47 S1)))
 (= X29 (+ (* 47 S0) (* 1395 S1)))
 (= X29 (- (* 47 S0) (* 1395 S1)))
 (= X29 (- (* 1395 S0) (* 47 S1)))
 (= X29 (+ (* 47 S0) (* 747 S1)))
 (= X29 (- (* 47 S0) (* 747 S1)))
 (= X29 (- (* 747 S0) (* 47 S1)))
 (= X29 (+ (* 47 S0) (* 1803 S1)))
 (= X29 (- (* 47 S0) (* 1803 S1)))
 (= X29 (- (* 1803 S0) (* 47 S1)))
 (= X29 (+ (* 47 S0) (* 933 S1)))
 (= X29 (- (* 47 S0) (* 933 S1)))
 (= X29 (- (* 933 S0) (* 47 S1)))
 (= X29 (+ (* 47 S0) (* 1041 S1)))
 (= X29 (- (* 47 S0) (* 1041 S1)))
 (= X29 (- (* 1041 S0) (* 47 S1)))
 (= X29 (+ (* 41 S0) S1))
 (= X29 (- (* 41 S0) S1))
 (= X29 (- S0 (* 41 S1)))
 (= X29 (+ (* 41 S0) (* 41 S1)))
 (= X29 (- (* 41 S0) (* 41 S1)))
 (= X29 (+ (* 41 S0) (* 217 S1)))
 (= X29 (- (* 41 S0) (* 217 S1)))
 (= X29 (- (* 217 S0) (* 41 S1)))
 (= X29 (+ (* 41 S0) (* 295 S1)))
 (= X29 (- (* 41 S0) (* 295 S1)))
 (= X29 (- (* 295 S0) (* 41 S1)))
 (= X29 (+ (* 41 S0) (* 167 S1)))
 (= X29 (- (* 41 S0) (* 167 S1)))
 (= X29 (- (* 167 S0) (* 41 S1)))
 (= X29 (+ (* 41 S0) (* 1313 S1)))
 (= X29 (- (* 41 S0) (* 1313 S1)))
 (= X29 (- (* 1313 S0) (* 41 S1)))
 (= X29 (+ (* 41 S0) (* 281 S1)))
 (= X29 (- (* 41 S0) (* 281 S1)))
 (= X29 (- (* 281 S0) (* 41 S1)))
 (= X29 (+ (* 41 S0) (* 1191 S1)))
 (= X29 (- (* 41 S0) (* 1191 S1)))
 (= X29 (- (* 1191 S0) (* 41 S1)))
 (= X29 (+ (* 41 S0) (* 1945 S1)))
 (= X29 (- (* 41 S0) (* 1945 S1)))
 (= X29 (- (* 1945 S0) (* 41 S1)))
 (= X29 (+ (* 41 S0) (* 775 S1)))
 (= X29 (- (* 41 S0) (* 775 S1)))
 (= X29 (- (* 775 S0) (* 41 S1)))
 (= X29 (+ (* 41 S0) (* 1367 S1)))
 (= X29 (- (* 41 S0) (* 1367 S1)))
 (= X29 (- (* 1367 S0) (* 41 S1)))
 (= X29 (+ (* 41 S0) (* 1015 S1)))
 (= X29 (- (* 41 S0) (* 1015 S1)))
 (= X29 (- (* 1015 S0) (* 41 S1)))
 (= X29 (+ (* 41 S0) (* 173 S1)))
 (= X29 (- (* 41 S0) (* 173 S1)))
 (= X29 (- (* 173 S0) (* 41 S1)))
 (= X29 (+ (* 41 S0) (* 1097 S1)))
 (= X29 (- (* 41 S0) (* 1097 S1)))
 (= X29 (- (* 1097 S0) (* 41 S1)))
 (= X29 (+ (* 41 S0) (* 973 S1)))
 (= X29 (- (* 41 S0) (* 973 S1)))
 (= X29 (- (* 973 S0) (* 41 S1)))
 (= X29 (+ (* 41 S0) (* 1517 S1)))
 (= X29 (- (* 41 S0) (* 1517 S1)))
 (= X29 (- (* 1517 S0) (* 41 S1)))
 (= X29 (+ (* 41 S0) (* 493 S1)))
 (= X29 (- (* 41 S0) (* 493 S1)))
 (= X29 (- (* 493 S0) (* 41 S1)))
 (= X29 (+ (* 41 S0) (* 379 S1)))
 (= X29 (- (* 41 S0) (* 379 S1)))
 (= X29 (- (* 379 S0) (* 41 S1)))
 (= X29 (+ (* 41 S0) (* 577 S1)))
 (= X29 (- (* 41 S0) (* 577 S1)))
 (= X29 (- (* 577 S0) (* 41 S1)))
 (= X29 (+ (* 41 S0) (* 271 S1)))
 (= X29 (- (* 41 S0) (* 271 S1)))
 (= X29 (- (* 271 S0) (* 41 S1)))
 (= X29 (+ (* 41 S0) (* 653 S1)))
 (= X29 (- (* 41 S0) (* 653 S1)))
 (= X29 (- (* 653 S0) (* 41 S1)))
 (= X29 (+ (* 41 S0) (* 1395 S1)))
 (= X29 (- (* 41 S0) (* 1395 S1)))
 (= X29 (- (* 1395 S0) (* 41 S1)))
 (= X29 (+ (* 41 S0) (* 747 S1)))
 (= X29 (- (* 41 S0) (* 747 S1)))
 (= X29 (- (* 747 S0) (* 41 S1)))
 (= X29 (+ (* 41 S0) (* 1803 S1)))
 (= X29 (- (* 41 S0) (* 1803 S1)))
 (= X29 (- (* 1803 S0) (* 41 S1)))
 (= X29 (+ (* 41 S0) (* 933 S1)))
 (= X29 (- (* 41 S0) (* 933 S1)))
 (= X29 (- (* 933 S0) (* 41 S1)))
 (= X29 (+ (* 41 S0) (* 1041 S1)))
 (= X29 (- (* 41 S0) (* 1041 S1)))
 (= X29 (- (* 1041 S0) (* 41 S1)))
 (= X29 (+ (* 217 S0) S1))
 (= X29 (- (* 217 S0) S1))
 (= X29 (- S0 (* 217 S1)))
 (= X29 (+ (* 217 S0) (* 217 S1)))
 (= X29 (- (* 217 S0) (* 217 S1)))
 (= X29 (+ (* 217 S0) (* 295 S1)))
 (= X29 (- (* 217 S0) (* 295 S1)))
 (= X29 (- (* 295 S0) (* 217 S1)))
 (= X29 (+ (* 217 S0) (* 167 S1)))
 (= X29 (- (* 217 S0) (* 167 S1)))
 (= X29 (- (* 167 S0) (* 217 S1)))
 (= X29 (+ (* 217 S0) (* 1313 S1)))
 (= X29 (- (* 217 S0) (* 1313 S1)))
 (= X29 (- (* 1313 S0) (* 217 S1)))
 (= X29 (+ (* 217 S0) (* 281 S1)))
 (= X29 (- (* 217 S0) (* 281 S1)))
 (= X29 (- (* 281 S0) (* 217 S1)))
 (= X29 (+ (* 217 S0) (* 1191 S1)))
 (= X29 (- (* 217 S0) (* 1191 S1)))
 (= X29 (- (* 1191 S0) (* 217 S1)))
 (= X29 (+ (* 217 S0) (* 1945 S1)))
 (= X29 (- (* 217 S0) (* 1945 S1)))
 (= X29 (- (* 1945 S0) (* 217 S1)))
 (= X29 (+ (* 217 S0) (* 775 S1)))
 (= X29 (- (* 217 S0) (* 775 S1)))
 (= X29 (- (* 775 S0) (* 217 S1)))
 (= X29 (+ (* 217 S0) (* 1367 S1)))
 (= X29 (- (* 217 S0) (* 1367 S1)))
 (= X29 (- (* 1367 S0) (* 217 S1)))
 (= X29 (+ (* 217 S0) (* 1015 S1)))
 (= X29 (- (* 217 S0) (* 1015 S1)))
 (= X29 (- (* 1015 S0) (* 217 S1)))
 (= X29 (+ (* 217 S0) (* 173 S1)))
 (= X29 (- (* 217 S0) (* 173 S1)))
 (= X29 (- (* 173 S0) (* 217 S1)))
 (= X29 (+ (* 217 S0) (* 1097 S1)))
 (= X29 (- (* 217 S0) (* 1097 S1)))
 (= X29 (- (* 1097 S0) (* 217 S1)))
 (= X29 (+ (* 217 S0) (* 973 S1)))
 (= X29 (- (* 217 S0) (* 973 S1)))
 (= X29 (- (* 973 S0) (* 217 S1)))
 (= X29 (+ (* 217 S0) (* 1517 S1)))
 (= X29 (- (* 217 S0) (* 1517 S1)))
 (= X29 (- (* 1517 S0) (* 217 S1)))
 (= X29 (+ (* 217 S0) (* 493 S1)))
 (= X29 (- (* 217 S0) (* 493 S1)))
 (= X29 (- (* 493 S0) (* 217 S1)))
 (= X29 (+ (* 217 S0) (* 379 S1)))
 (= X29 (- (* 217 S0) (* 379 S1)))
 (= X29 (- (* 379 S0) (* 217 S1)))
 (= X29 (+ (* 217 S0) (* 577 S1)))
 (= X29 (- (* 217 S0) (* 577 S1)))
 (= X29 (- (* 577 S0) (* 217 S1)))
 (= X29 (+ (* 217 S0) (* 271 S1)))
 (= X29 (- (* 217 S0) (* 271 S1)))
 (= X29 (- (* 271 S0) (* 217 S1)))
 (= X29 (+ (* 217 S0) (* 653 S1)))
 (= X29 (- (* 217 S0) (* 653 S1)))
 (= X29 (- (* 653 S0) (* 217 S1)))
 (= X29 (+ (* 217 S0) (* 1395 S1)))
 (= X29 (- (* 217 S0) (* 1395 S1)))
 (= X29 (- (* 1395 S0) (* 217 S1)))
 (= X29 (+ (* 217 S0) (* 747 S1)))
 (= X29 (- (* 217 S0) (* 747 S1)))
 (= X29 (- (* 747 S0) (* 217 S1)))
 (= X29 (+ (* 217 S0) (* 1803 S1)))
 (= X29 (- (* 217 S0) (* 1803 S1)))
 (= X29 (- (* 1803 S0) (* 217 S1)))
 (= X29 (+ (* 217 S0) (* 933 S1)))
 (= X29 (- (* 217 S0) (* 933 S1)))
 (= X29 (- (* 933 S0) (* 217 S1)))
 (= X29 (+ (* 217 S0) (* 1041 S1)))
 (= X29 (- (* 217 S0) (* 1041 S1)))
 (= X29 (- (* 1041 S0) (* 217 S1)))
 (= X29 (+ (* 295 S0) S1))
 (= X29 (- (* 295 S0) S1))
 (= X29 (- S0 (* 295 S1)))
 (= X29 (+ (* 295 S0) (* 295 S1)))
 (= X29 (- (* 295 S0) (* 295 S1)))
 (= X29 (+ (* 295 S0) (* 167 S1)))
 (= X29 (- (* 295 S0) (* 167 S1)))
 (= X29 (- (* 167 S0) (* 295 S1)))
 (= X29 (+ (* 295 S0) (* 1313 S1)))
 (= X29 (- (* 295 S0) (* 1313 S1)))
 (= X29 (- (* 1313 S0) (* 295 S1)))
 (= X29 (+ (* 295 S0) (* 281 S1)))
 (= X29 (- (* 295 S0) (* 281 S1)))
 (= X29 (- (* 281 S0) (* 295 S1)))
 (= X29 (+ (* 295 S0) (* 1191 S1)))
 (= X29 (- (* 295 S0) (* 1191 S1)))
 (= X29 (- (* 1191 S0) (* 295 S1)))
 (= X29 (+ (* 295 S0) (* 1945 S1)))
 (= X29 (- (* 295 S0) (* 1945 S1)))
 (= X29 (- (* 1945 S0) (* 295 S1)))
 (= X29 (+ (* 295 S0) (* 775 S1)))
 (= X29 (- (* 295 S0) (* 775 S1)))
 (= X29 (- (* 775 S0) (* 295 S1)))
 (= X29 (+ (* 295 S0) (* 1367 S1)))
 (= X29 (- (* 295 S0) (* 1367 S1)))
 (= X29 (- (* 1367 S0) (* 295 S1)))
 (= X29 (+ (* 295 S0) (* 1015 S1)))
 (= X29 (- (* 295 S0) (* 1015 S1)))
 (= X29 (- (* 1015 S0) (* 295 S1)))
 (= X29 (+ (* 295 S0) (* 173 S1)))
 (= X29 (- (* 295 S0) (* 173 S1)))
 (= X29 (- (* 173 S0) (* 295 S1)))
 (= X29 (+ (* 295 S0) (* 1097 S1)))
 (= X29 (- (* 295 S0) (* 1097 S1)))
 (= X29 (- (* 1097 S0) (* 295 S1)))
 (= X29 (+ (* 295 S0) (* 973 S1)))
 (= X29 (- (* 295 S0) (* 973 S1)))
 (= X29 (- (* 973 S0) (* 295 S1)))
 (= X29 (+ (* 295 S0) (* 1517 S1)))
 (= X29 (- (* 295 S0) (* 1517 S1)))
 (= X29 (- (* 1517 S0) (* 295 S1)))
 (= X29 (+ (* 295 S0) (* 493 S1)))
 (= X29 (- (* 295 S0) (* 493 S1)))
 (= X29 (- (* 493 S0) (* 295 S1)))
 (= X29 (+ (* 295 S0) (* 379 S1)))
 (= X29 (- (* 295 S0) (* 379 S1)))
 (= X29 (- (* 379 S0) (* 295 S1)))
 (= X29 (+ (* 295 S0) (* 577 S1)))
 (= X29 (- (* 295 S0) (* 577 S1)))
 (= X29 (- (* 577 S0) (* 295 S1)))
 (= X29 (+ (* 295 S0) (* 271 S1)))
 (= X29 (- (* 295 S0) (* 271 S1)))
 (= X29 (- (* 271 S0) (* 295 S1)))
 (= X29 (+ (* 295 S0) (* 653 S1)))
 (= X29 (- (* 295 S0) (* 653 S1)))
 (= X29 (- (* 653 S0) (* 295 S1)))
 (= X29 (+ (* 295 S0) (* 1395 S1)))
 (= X29 (- (* 295 S0) (* 1395 S1)))
 (= X29 (- (* 1395 S0) (* 295 S1)))
 (= X29 (+ (* 295 S0) (* 747 S1)))
 (= X29 (- (* 295 S0) (* 747 S1)))
 (= X29 (- (* 747 S0) (* 295 S1)))
 (= X29 (+ (* 295 S0) (* 1803 S1)))
 (= X29 (- (* 295 S0) (* 1803 S1)))
 (= X29 (- (* 1803 S0) (* 295 S1)))
 (= X29 (+ (* 295 S0) (* 933 S1)))
 (= X29 (- (* 295 S0) (* 933 S1)))
 (= X29 (- (* 933 S0) (* 295 S1)))
 (= X29 (+ (* 295 S0) (* 1041 S1)))
 (= X29 (- (* 295 S0) (* 1041 S1)))
 (= X29 (- (* 1041 S0) (* 295 S1)))
 (= X29 (+ (* 167 S0) S1))
 (= X29 (- (* 167 S0) S1))
 (= X29 (- S0 (* 167 S1)))
 (= X29 (+ (* 167 S0) (* 167 S1)))
 (= X29 (- (* 167 S0) (* 167 S1)))
 (= X29 (+ (* 167 S0) (* 1313 S1)))
 (= X29 (- (* 167 S0) (* 1313 S1)))
 (= X29 (- (* 1313 S0) (* 167 S1)))
 (= X29 (+ (* 167 S0) (* 281 S1)))
 (= X29 (- (* 167 S0) (* 281 S1)))
 (= X29 (- (* 281 S0) (* 167 S1)))
 (= X29 (+ (* 167 S0) (* 1191 S1)))
 (= X29 (- (* 167 S0) (* 1191 S1)))
 (= X29 (- (* 1191 S0) (* 167 S1)))
 (= X29 (+ (* 167 S0) (* 1945 S1)))
 (= X29 (- (* 167 S0) (* 1945 S1)))
 (= X29 (- (* 1945 S0) (* 167 S1)))
 (= X29 (+ (* 167 S0) (* 775 S1)))
 (= X29 (- (* 167 S0) (* 775 S1)))
 (= X29 (- (* 775 S0) (* 167 S1)))
 (= X29 (+ (* 167 S0) (* 1367 S1)))
 (= X29 (- (* 167 S0) (* 1367 S1)))
 (= X29 (- (* 1367 S0) (* 167 S1)))
 (= X29 (+ (* 167 S0) (* 1015 S1)))
 (= X29 (- (* 167 S0) (* 1015 S1)))
 (= X29 (- (* 1015 S0) (* 167 S1)))
 (= X29 (+ (* 167 S0) (* 173 S1)))
 (= X29 (- (* 167 S0) (* 173 S1)))
 (= X29 (- (* 173 S0) (* 167 S1)))
 (= X29 (+ (* 167 S0) (* 1097 S1)))
 (= X29 (- (* 167 S0) (* 1097 S1)))
 (= X29 (- (* 1097 S0) (* 167 S1)))
 (= X29 (+ (* 167 S0) (* 973 S1)))
 (= X29 (- (* 167 S0) (* 973 S1)))
 (= X29 (- (* 973 S0) (* 167 S1)))
 (= X29 (+ (* 167 S0) (* 1517 S1)))
 (= X29 (- (* 167 S0) (* 1517 S1)))
 (= X29 (- (* 1517 S0) (* 167 S1)))
 (= X29 (+ (* 167 S0) (* 493 S1)))
 (= X29 (- (* 167 S0) (* 493 S1)))
 (= X29 (- (* 493 S0) (* 167 S1)))
 (= X29 (+ (* 167 S0) (* 379 S1)))
 (= X29 (- (* 167 S0) (* 379 S1)))
 (= X29 (- (* 379 S0) (* 167 S1)))
 (= X29 (+ (* 167 S0) (* 577 S1)))
 (= X29 (- (* 167 S0) (* 577 S1)))
 (= X29 (- (* 577 S0) (* 167 S1)))
 (= X29 (+ (* 167 S0) (* 271 S1)))
 (= X29 (- (* 167 S0) (* 271 S1)))
 (= X29 (- (* 271 S0) (* 167 S1)))
 (= X29 (+ (* 167 S0) (* 653 S1)))
 (= X29 (- (* 167 S0) (* 653 S1)))
 (= X29 (- (* 653 S0) (* 167 S1)))
 (= X29 (+ (* 167 S0) (* 1395 S1)))
 (= X29 (- (* 167 S0) (* 1395 S1)))
 (= X29 (- (* 1395 S0) (* 167 S1)))
 (= X29 (+ (* 167 S0) (* 747 S1)))
 (= X29 (- (* 167 S0) (* 747 S1)))
 (= X29 (- (* 747 S0) (* 167 S1)))
 (= X29 (+ (* 167 S0) (* 1803 S1)))
 (= X29 (- (* 167 S0) (* 1803 S1)))
 (= X29 (- (* 1803 S0) (* 167 S1)))
 (= X29 (+ (* 167 S0) (* 933 S1)))
 (= X29 (- (* 167 S0) (* 933 S1)))
 (= X29 (- (* 933 S0) (* 167 S1)))
 (= X29 (+ (* 167 S0) (* 1041 S1)))
 (= X29 (- (* 167 S0) (* 1041 S1)))
 (= X29 (- (* 1041 S0) (* 167 S1)))
 (= X29 (+ (* 1313 S0) S1))
 (= X29 (- (* 1313 S0) S1))
 (= X29 (- S0 (* 1313 S1)))
 (= X29 (+ (* 1313 S0) (* 1313 S1)))
 (= X29 (- (* 1313 S0) (* 1313 S1)))
 (= X29 (+ (* 1313 S0) (* 281 S1)))
 (= X29 (- (* 1313 S0) (* 281 S1)))
 (= X29 (- (* 281 S0) (* 1313 S1)))
 (= X29 (+ (* 1313 S0) (* 1191 S1)))
 (= X29 (- (* 1313 S0) (* 1191 S1)))
 (= X29 (- (* 1191 S0) (* 1313 S1)))
 (= X29 (+ (* 1313 S0) (* 1945 S1)))
 (= X29 (- (* 1313 S0) (* 1945 S1)))
 (= X29 (- (* 1945 S0) (* 1313 S1)))
 (= X29 (+ (* 1313 S0) (* 775 S1)))
 (= X29 (- (* 1313 S0) (* 775 S1)))
 (= X29 (- (* 775 S0) (* 1313 S1)))
 (= X29 (+ (* 1313 S0) (* 1367 S1)))
 (= X29 (- (* 1313 S0) (* 1367 S1)))
 (= X29 (- (* 1367 S0) (* 1313 S1)))
 (= X29 (+ (* 1313 S0) (* 1015 S1)))
 (= X29 (- (* 1313 S0) (* 1015 S1)))
 (= X29 (- (* 1015 S0) (* 1313 S1)))
 (= X29 (+ (* 1313 S0) (* 173 S1)))
 (= X29 (- (* 1313 S0) (* 173 S1)))
 (= X29 (- (* 173 S0) (* 1313 S1)))
 (= X29 (+ (* 1313 S0) (* 1097 S1)))
 (= X29 (- (* 1313 S0) (* 1097 S1)))
 (= X29 (- (* 1097 S0) (* 1313 S1)))
 (= X29 (+ (* 1313 S0) (* 973 S1)))
 (= X29 (- (* 1313 S0) (* 973 S1)))
 (= X29 (- (* 973 S0) (* 1313 S1)))
 (= X29 (+ (* 1313 S0) (* 1517 S1)))
 (= X29 (- (* 1313 S0) (* 1517 S1)))
 (= X29 (- (* 1517 S0) (* 1313 S1)))
 (= X29 (+ (* 1313 S0) (* 493 S1)))
 (= X29 (- (* 1313 S0) (* 493 S1)))
 (= X29 (- (* 493 S0) (* 1313 S1)))
 (= X29 (+ (* 1313 S0) (* 379 S1)))
 (= X29 (- (* 1313 S0) (* 379 S1)))
 (= X29 (- (* 379 S0) (* 1313 S1)))
 (= X29 (+ (* 1313 S0) (* 577 S1)))
 (= X29 (- (* 1313 S0) (* 577 S1)))
 (= X29 (- (* 577 S0) (* 1313 S1)))
 (= X29 (+ (* 1313 S0) (* 271 S1)))
 (= X29 (- (* 1313 S0) (* 271 S1)))
 (= X29 (- (* 271 S0) (* 1313 S1)))
 (= X29 (+ (* 1313 S0) (* 653 S1)))
 (= X29 (- (* 1313 S0) (* 653 S1)))
 (= X29 (- (* 653 S0) (* 1313 S1)))
 (= X29 (+ (* 1313 S0) (* 1395 S1)))
 (= X29 (- (* 1313 S0) (* 1395 S1)))
 (= X29 (- (* 1395 S0) (* 1313 S1)))
 (= X29 (+ (* 1313 S0) (* 747 S1)))
 (= X29 (- (* 1313 S0) (* 747 S1)))
 (= X29 (- (* 747 S0) (* 1313 S1)))
 (= X29 (+ (* 1313 S0) (* 1803 S1)))
 (= X29 (- (* 1313 S0) (* 1803 S1)))
 (= X29 (- (* 1803 S0) (* 1313 S1)))
 (= X29 (+ (* 1313 S0) (* 933 S1)))
 (= X29 (- (* 1313 S0) (* 933 S1)))
 (= X29 (- (* 933 S0) (* 1313 S1)))
 (= X29 (+ (* 1313 S0) (* 1041 S1)))
 (= X29 (- (* 1313 S0) (* 1041 S1)))
 (= X29 (- (* 1041 S0) (* 1313 S1)))
 (= X29 (+ (* 281 S0) S1))
 (= X29 (- (* 281 S0) S1))
 (= X29 (- S0 (* 281 S1)))
 (= X29 (+ (* 281 S0) (* 281 S1)))
 (= X29 (- (* 281 S0) (* 281 S1)))
 (= X29 (+ (* 281 S0) (* 1191 S1)))
 (= X29 (- (* 281 S0) (* 1191 S1)))
 (= X29 (- (* 1191 S0) (* 281 S1)))
 (= X29 (+ (* 281 S0) (* 1945 S1)))
 (= X29 (- (* 281 S0) (* 1945 S1)))
 (= X29 (- (* 1945 S0) (* 281 S1)))
 (= X29 (+ (* 281 S0) (* 775 S1)))
 (= X29 (- (* 281 S0) (* 775 S1)))
 (= X29 (- (* 775 S0) (* 281 S1)))
 (= X29 (+ (* 281 S0) (* 1367 S1)))
 (= X29 (- (* 281 S0) (* 1367 S1)))
 (= X29 (- (* 1367 S0) (* 281 S1)))
 (= X29 (+ (* 281 S0) (* 1015 S1)))
 (= X29 (- (* 281 S0) (* 1015 S1)))
 (= X29 (- (* 1015 S0) (* 281 S1)))
 (= X29 (+ (* 281 S0) (* 173 S1)))
 (= X29 (- (* 281 S0) (* 173 S1)))
 (= X29 (- (* 173 S0) (* 281 S1)))
 (= X29 (+ (* 281 S0) (* 1097 S1)))
 (= X29 (- (* 281 S0) (* 1097 S1)))
 (= X29 (- (* 1097 S0) (* 281 S1)))
 (= X29 (+ (* 281 S0) (* 973 S1)))
 (= X29 (- (* 281 S0) (* 973 S1)))
 (= X29 (- (* 973 S0) (* 281 S1)))
 (= X29 (+ (* 281 S0) (* 1517 S1)))
 (= X29 (- (* 281 S0) (* 1517 S1)))
 (= X29 (- (* 1517 S0) (* 281 S1)))
 (= X29 (+ (* 281 S0) (* 493 S1)))
 (= X29 (- (* 281 S0) (* 493 S1)))
 (= X29 (- (* 493 S0) (* 281 S1)))
 (= X29 (+ (* 281 S0) (* 379 S1)))
 (= X29 (- (* 281 S0) (* 379 S1)))
 (= X29 (- (* 379 S0) (* 281 S1)))
 (= X29 (+ (* 281 S0) (* 577 S1)))
 (= X29 (- (* 281 S0) (* 577 S1)))
 (= X29 (- (* 577 S0) (* 281 S1)))
 (= X29 (+ (* 281 S0) (* 271 S1)))
 (= X29 (- (* 281 S0) (* 271 S1)))
 (= X29 (- (* 271 S0) (* 281 S1)))
 (= X29 (+ (* 281 S0) (* 653 S1)))
 (= X29 (- (* 281 S0) (* 653 S1)))
 (= X29 (- (* 653 S0) (* 281 S1)))
 (= X29 (+ (* 281 S0) (* 1395 S1)))
 (= X29 (- (* 281 S0) (* 1395 S1)))
 (= X29 (- (* 1395 S0) (* 281 S1)))
 (= X29 (+ (* 281 S0) (* 747 S1)))
 (= X29 (- (* 281 S0) (* 747 S1)))
 (= X29 (- (* 747 S0) (* 281 S1)))
 (= X29 (+ (* 281 S0) (* 1803 S1)))
 (= X29 (- (* 281 S0) (* 1803 S1)))
 (= X29 (- (* 1803 S0) (* 281 S1)))
 (= X29 (+ (* 281 S0) (* 933 S1)))
 (= X29 (- (* 281 S0) (* 933 S1)))
 (= X29 (- (* 933 S0) (* 281 S1)))
 (= X29 (+ (* 281 S0) (* 1041 S1)))
 (= X29 (- (* 281 S0) (* 1041 S1)))
 (= X29 (- (* 1041 S0) (* 281 S1)))
 (= X29 (+ (* 1191 S0) S1))
 (= X29 (- (* 1191 S0) S1))
 (= X29 (- S0 (* 1191 S1)))
 (= X29 (+ (* 1191 S0) (* 1191 S1)))
 (= X29 (- (* 1191 S0) (* 1191 S1)))
 (= X29 (+ (* 1191 S0) (* 1945 S1)))
 (= X29 (- (* 1191 S0) (* 1945 S1)))
 (= X29 (- (* 1945 S0) (* 1191 S1)))
 (= X29 (+ (* 1191 S0) (* 775 S1)))
 (= X29 (- (* 1191 S0) (* 775 S1)))
 (= X29 (- (* 775 S0) (* 1191 S1)))
 (= X29 (+ (* 1191 S0) (* 1367 S1)))
 (= X29 (- (* 1191 S0) (* 1367 S1)))
 (= X29 (- (* 1367 S0) (* 1191 S1)))
 (= X29 (+ (* 1191 S0) (* 1015 S1)))
 (= X29 (- (* 1191 S0) (* 1015 S1)))
 (= X29 (- (* 1015 S0) (* 1191 S1)))
 (= X29 (+ (* 1191 S0) (* 173 S1)))
 (= X29 (- (* 1191 S0) (* 173 S1)))
 (= X29 (- (* 173 S0) (* 1191 S1)))
 (= X29 (+ (* 1191 S0) (* 1097 S1)))
 (= X29 (- (* 1191 S0) (* 1097 S1)))
 (= X29 (- (* 1097 S0) (* 1191 S1)))
 (= X29 (+ (* 1191 S0) (* 973 S1)))
 (= X29 (- (* 1191 S0) (* 973 S1)))
 (= X29 (- (* 973 S0) (* 1191 S1)))
 (= X29 (+ (* 1191 S0) (* 1517 S1)))
 (= X29 (- (* 1191 S0) (* 1517 S1)))
 (= X29 (- (* 1517 S0) (* 1191 S1)))
 (= X29 (+ (* 1191 S0) (* 493 S1)))
 (= X29 (- (* 1191 S0) (* 493 S1)))
 (= X29 (- (* 493 S0) (* 1191 S1)))
 (= X29 (+ (* 1191 S0) (* 379 S1)))
 (= X29 (- (* 1191 S0) (* 379 S1)))
 (= X29 (- (* 379 S0) (* 1191 S1)))
 (= X29 (+ (* 1191 S0) (* 577 S1)))
 (= X29 (- (* 1191 S0) (* 577 S1)))
 (= X29 (- (* 577 S0) (* 1191 S1)))
 (= X29 (+ (* 1191 S0) (* 271 S1)))
 (= X29 (- (* 1191 S0) (* 271 S1)))
 (= X29 (- (* 271 S0) (* 1191 S1)))
 (= X29 (+ (* 1191 S0) (* 653 S1)))
 (= X29 (- (* 1191 S0) (* 653 S1)))
 (= X29 (- (* 653 S0) (* 1191 S1)))
 (= X29 (+ (* 1191 S0) (* 1395 S1)))
 (= X29 (- (* 1191 S0) (* 1395 S1)))
 (= X29 (- (* 1395 S0) (* 1191 S1)))
 (= X29 (+ (* 1191 S0) (* 747 S1)))
 (= X29 (- (* 1191 S0) (* 747 S1)))
 (= X29 (- (* 747 S0) (* 1191 S1)))
 (= X29 (+ (* 1191 S0) (* 1803 S1)))
 (= X29 (- (* 1191 S0) (* 1803 S1)))
 (= X29 (- (* 1803 S0) (* 1191 S1)))
 (= X29 (+ (* 1191 S0) (* 933 S1)))
 (= X29 (- (* 1191 S0) (* 933 S1)))
 (= X29 (- (* 933 S0) (* 1191 S1)))
 (= X29 (+ (* 1191 S0) (* 1041 S1)))
 (= X29 (- (* 1191 S0) (* 1041 S1)))
 (= X29 (- (* 1041 S0) (* 1191 S1)))
 (= X29 (+ (* 1945 S0) S1))
 (= X29 (- (* 1945 S0) S1))
 (= X29 (- S0 (* 1945 S1)))
 (= X29 (+ (* 1945 S0) (* 1945 S1)))
 (= X29 (- (* 1945 S0) (* 1945 S1)))
 (= X29 (+ (* 1945 S0) (* 775 S1)))
 (= X29 (- (* 1945 S0) (* 775 S1)))
 (= X29 (- (* 775 S0) (* 1945 S1)))
 (= X29 (+ (* 1945 S0) (* 1367 S1)))
 (= X29 (- (* 1945 S0) (* 1367 S1)))
 (= X29 (- (* 1367 S0) (* 1945 S1)))
 (= X29 (+ (* 1945 S0) (* 1015 S1)))
 (= X29 (- (* 1945 S0) (* 1015 S1)))
 (= X29 (- (* 1015 S0) (* 1945 S1)))
 (= X29 (+ (* 1945 S0) (* 173 S1)))
 (= X29 (- (* 1945 S0) (* 173 S1)))
 (= X29 (- (* 173 S0) (* 1945 S1)))
 (= X29 (+ (* 1945 S0) (* 1097 S1)))
 (= X29 (- (* 1945 S0) (* 1097 S1)))
 (= X29 (- (* 1097 S0) (* 1945 S1)))
 (= X29 (+ (* 1945 S0) (* 973 S1)))
 (= X29 (- (* 1945 S0) (* 973 S1)))
 (= X29 (- (* 973 S0) (* 1945 S1)))
 (= X29 (+ (* 1945 S0) (* 1517 S1)))
 (= X29 (- (* 1945 S0) (* 1517 S1)))
 (= X29 (- (* 1517 S0) (* 1945 S1)))
 (= X29 (+ (* 1945 S0) (* 493 S1)))
 (= X29 (- (* 1945 S0) (* 493 S1)))
 (= X29 (- (* 493 S0) (* 1945 S1)))
 (= X29 (+ (* 1945 S0) (* 379 S1)))
 (= X29 (- (* 1945 S0) (* 379 S1)))
 (= X29 (- (* 379 S0) (* 1945 S1)))
 (= X29 (+ (* 1945 S0) (* 577 S1)))
 (= X29 (- (* 1945 S0) (* 577 S1)))
 (= X29 (- (* 577 S0) (* 1945 S1)))
 (= X29 (+ (* 1945 S0) (* 271 S1)))
 (= X29 (- (* 1945 S0) (* 271 S1)))
 (= X29 (- (* 271 S0) (* 1945 S1)))
 (= X29 (+ (* 1945 S0) (* 653 S1)))
 (= X29 (- (* 1945 S0) (* 653 S1)))
 (= X29 (- (* 653 S0) (* 1945 S1)))
 (= X29 (+ (* 1945 S0) (* 1395 S1)))
 (= X29 (- (* 1945 S0) (* 1395 S1)))
 (= X29 (- (* 1395 S0) (* 1945 S1)))
 (= X29 (+ (* 1945 S0) (* 747 S1)))
 (= X29 (- (* 1945 S0) (* 747 S1)))
 (= X29 (- (* 747 S0) (* 1945 S1)))
 (= X29 (+ (* 1945 S0) (* 1803 S1)))
 (= X29 (- (* 1945 S0) (* 1803 S1)))
 (= X29 (- (* 1803 S0) (* 1945 S1)))
 (= X29 (+ (* 1945 S0) (* 933 S1)))
 (= X29 (- (* 1945 S0) (* 933 S1)))
 (= X29 (- (* 933 S0) (* 1945 S1)))
 (= X29 (+ (* 1945 S0) (* 1041 S1)))
 (= X29 (- (* 1945 S0) (* 1041 S1)))
 (= X29 (- (* 1041 S0) (* 1945 S1)))
 (= X29 (+ (* 775 S0) S1))
 (= X29 (- (* 775 S0) S1))
 (= X29 (- S0 (* 775 S1)))
 (= X29 (+ (* 775 S0) (* 775 S1)))
 (= X29 (- (* 775 S0) (* 775 S1)))
 (= X29 (+ (* 775 S0) (* 1367 S1)))
 (= X29 (- (* 775 S0) (* 1367 S1)))
 (= X29 (- (* 1367 S0) (* 775 S1)))
 (= X29 (+ (* 775 S0) (* 1015 S1)))
 (= X29 (- (* 775 S0) (* 1015 S1)))
 (= X29 (- (* 1015 S0) (* 775 S1)))
 (= X29 (+ (* 775 S0) (* 173 S1)))
 (= X29 (- (* 775 S0) (* 173 S1)))
 (= X29 (- (* 173 S0) (* 775 S1)))
 (= X29 (+ (* 775 S0) (* 1097 S1)))
 (= X29 (- (* 775 S0) (* 1097 S1)))
 (= X29 (- (* 1097 S0) (* 775 S1)))
 (= X29 (+ (* 775 S0) (* 973 S1)))
 (= X29 (- (* 775 S0) (* 973 S1)))
 (= X29 (- (* 973 S0) (* 775 S1)))
 (= X29 (+ (* 775 S0) (* 1517 S1)))
 (= X29 (- (* 775 S0) (* 1517 S1)))
 (= X29 (- (* 1517 S0) (* 775 S1)))
 (= X29 (+ (* 775 S0) (* 493 S1)))
 (= X29 (- (* 775 S0) (* 493 S1)))
 (= X29 (- (* 493 S0) (* 775 S1)))
 (= X29 (+ (* 775 S0) (* 379 S1)))
 (= X29 (- (* 775 S0) (* 379 S1)))
 (= X29 (- (* 379 S0) (* 775 S1)))
 (= X29 (+ (* 775 S0) (* 577 S1)))
 (= X29 (- (* 775 S0) (* 577 S1)))
 (= X29 (- (* 577 S0) (* 775 S1)))
 (= X29 (+ (* 775 S0) (* 271 S1)))
 (= X29 (- (* 775 S0) (* 271 S1)))
 (= X29 (- (* 271 S0) (* 775 S1)))
 (= X29 (+ (* 775 S0) (* 653 S1)))
 (= X29 (- (* 775 S0) (* 653 S1)))
 (= X29 (- (* 653 S0) (* 775 S1)))
 (= X29 (+ (* 775 S0) (* 1395 S1)))
 (= X29 (- (* 775 S0) (* 1395 S1)))
 (= X29 (- (* 1395 S0) (* 775 S1)))
 (= X29 (+ (* 775 S0) (* 747 S1)))
 (= X29 (- (* 775 S0) (* 747 S1)))
 (= X29 (- (* 747 S0) (* 775 S1)))
 (= X29 (+ (* 775 S0) (* 1803 S1)))
 (= X29 (- (* 775 S0) (* 1803 S1)))
 (= X29 (- (* 1803 S0) (* 775 S1)))
 (= X29 (+ (* 775 S0) (* 933 S1)))
 (= X29 (- (* 775 S0) (* 933 S1)))
 (= X29 (- (* 933 S0) (* 775 S1)))
 (= X29 (+ (* 775 S0) (* 1041 S1)))
 (= X29 (- (* 775 S0) (* 1041 S1)))
 (= X29 (- (* 1041 S0) (* 775 S1)))
 (= X29 (+ (* 1367 S0) S1))
 (= X29 (- (* 1367 S0) S1))
 (= X29 (- S0 (* 1367 S1)))
 (= X29 (+ (* 1367 S0) (* 1367 S1)))
 (= X29 (- (* 1367 S0) (* 1367 S1)))
 (= X29 (+ (* 1367 S0) (* 1015 S1)))
 (= X29 (- (* 1367 S0) (* 1015 S1)))
 (= X29 (- (* 1015 S0) (* 1367 S1)))
 (= X29 (+ (* 1367 S0) (* 173 S1)))
 (= X29 (- (* 1367 S0) (* 173 S1)))
 (= X29 (- (* 173 S0) (* 1367 S1)))
 (= X29 (+ (* 1367 S0) (* 1097 S1)))
 (= X29 (- (* 1367 S0) (* 1097 S1)))
 (= X29 (- (* 1097 S0) (* 1367 S1)))
 (= X29 (+ (* 1367 S0) (* 973 S1)))
 (= X29 (- (* 1367 S0) (* 973 S1)))
 (= X29 (- (* 973 S0) (* 1367 S1)))
 (= X29 (+ (* 1367 S0) (* 1517 S1)))
 (= X29 (- (* 1367 S0) (* 1517 S1)))
 (= X29 (- (* 1517 S0) (* 1367 S1)))
 (= X29 (+ (* 1367 S0) (* 493 S1)))
 (= X29 (- (* 1367 S0) (* 493 S1)))
 (= X29 (- (* 493 S0) (* 1367 S1)))
 (= X29 (+ (* 1367 S0) (* 379 S1)))
 (= X29 (- (* 1367 S0) (* 379 S1)))
 (= X29 (- (* 379 S0) (* 1367 S1)))
 (= X29 (+ (* 1367 S0) (* 577 S1)))
 (= X29 (- (* 1367 S0) (* 577 S1)))
 (= X29 (- (* 577 S0) (* 1367 S1)))
 (= X29 (+ (* 1367 S0) (* 271 S1)))
 (= X29 (- (* 1367 S0) (* 271 S1)))
 (= X29 (- (* 271 S0) (* 1367 S1)))
 (= X29 (+ (* 1367 S0) (* 653 S1)))
 (= X29 (- (* 1367 S0) (* 653 S1)))
 (= X29 (- (* 653 S0) (* 1367 S1)))
 (= X29 (+ (* 1367 S0) (* 1395 S1)))
 (= X29 (- (* 1367 S0) (* 1395 S1)))
 (= X29 (- (* 1395 S0) (* 1367 S1)))
 (= X29 (+ (* 1367 S0) (* 747 S1)))
 (= X29 (- (* 1367 S0) (* 747 S1)))
 (= X29 (- (* 747 S0) (* 1367 S1)))
 (= X29 (+ (* 1367 S0) (* 1803 S1)))
 (= X29 (- (* 1367 S0) (* 1803 S1)))
 (= X29 (- (* 1803 S0) (* 1367 S1)))
 (= X29 (+ (* 1367 S0) (* 933 S1)))
 (= X29 (- (* 1367 S0) (* 933 S1)))
 (= X29 (- (* 933 S0) (* 1367 S1)))
 (= X29 (+ (* 1367 S0) (* 1041 S1)))
 (= X29 (- (* 1367 S0) (* 1041 S1)))
 (= X29 (- (* 1041 S0) (* 1367 S1)))
 (= X29 (+ (* 1015 S0) S1))
 (= X29 (- (* 1015 S0) S1))
 (= X29 (- S0 (* 1015 S1)))
 (= X29 (+ (* 1015 S0) (* 1015 S1)))
 (= X29 (- (* 1015 S0) (* 1015 S1)))
 (= X29 (+ (* 1015 S0) (* 173 S1)))
 (= X29 (- (* 1015 S0) (* 173 S1)))
 (= X29 (- (* 173 S0) (* 1015 S1)))
 (= X29 (+ (* 1015 S0) (* 1097 S1)))
 (= X29 (- (* 1015 S0) (* 1097 S1)))
 (= X29 (- (* 1097 S0) (* 1015 S1)))
 (= X29 (+ (* 1015 S0) (* 973 S1)))
 (= X29 (- (* 1015 S0) (* 973 S1)))
 (= X29 (- (* 973 S0) (* 1015 S1)))
 (= X29 (+ (* 1015 S0) (* 1517 S1)))
 (= X29 (- (* 1015 S0) (* 1517 S1)))
 (= X29 (- (* 1517 S0) (* 1015 S1)))
 (= X29 (+ (* 1015 S0) (* 493 S1)))
 (= X29 (- (* 1015 S0) (* 493 S1)))
 (= X29 (- (* 493 S0) (* 1015 S1)))
 (= X29 (+ (* 1015 S0) (* 379 S1)))
 (= X29 (- (* 1015 S0) (* 379 S1)))
 (= X29 (- (* 379 S0) (* 1015 S1)))
 (= X29 (+ (* 1015 S0) (* 577 S1)))
 (= X29 (- (* 1015 S0) (* 577 S1)))
 (= X29 (- (* 577 S0) (* 1015 S1)))
 (= X29 (+ (* 1015 S0) (* 271 S1)))
 (= X29 (- (* 1015 S0) (* 271 S1)))
 (= X29 (- (* 271 S0) (* 1015 S1)))
 (= X29 (+ (* 1015 S0) (* 653 S1)))
 (= X29 (- (* 1015 S0) (* 653 S1)))
 (= X29 (- (* 653 S0) (* 1015 S1)))
 (= X29 (+ (* 1015 S0) (* 1395 S1)))
 (= X29 (- (* 1015 S0) (* 1395 S1)))
 (= X29 (- (* 1395 S0) (* 1015 S1)))
 (= X29 (+ (* 1015 S0) (* 747 S1)))
 (= X29 (- (* 1015 S0) (* 747 S1)))
 (= X29 (- (* 747 S0) (* 1015 S1)))
 (= X29 (+ (* 1015 S0) (* 1803 S1)))
 (= X29 (- (* 1015 S0) (* 1803 S1)))
 (= X29 (- (* 1803 S0) (* 1015 S1)))
 (= X29 (+ (* 1015 S0) (* 933 S1)))
 (= X29 (- (* 1015 S0) (* 933 S1)))
 (= X29 (- (* 933 S0) (* 1015 S1)))
 (= X29 (+ (* 1015 S0) (* 1041 S1)))
 (= X29 (- (* 1015 S0) (* 1041 S1)))
 (= X29 (- (* 1041 S0) (* 1015 S1)))
 (= X29 (+ (* 173 S0) S1))
 (= X29 (- (* 173 S0) S1))
 (= X29 (- S0 (* 173 S1)))
 (= X29 (+ (* 173 S0) (* 173 S1)))
 (= X29 (- (* 173 S0) (* 173 S1)))
 (= X29 (+ (* 173 S0) (* 1097 S1)))
 (= X29 (- (* 173 S0) (* 1097 S1)))
 (= X29 (- (* 1097 S0) (* 173 S1)))
 (= X29 (+ (* 173 S0) (* 973 S1)))
 (= X29 (- (* 173 S0) (* 973 S1)))
 (= X29 (- (* 973 S0) (* 173 S1)))
 (= X29 (+ (* 173 S0) (* 1517 S1)))
 (= X29 (- (* 173 S0) (* 1517 S1)))
 (= X29 (- (* 1517 S0) (* 173 S1)))
 (= X29 (+ (* 173 S0) (* 493 S1)))
 (= X29 (- (* 173 S0) (* 493 S1)))
 (= X29 (- (* 493 S0) (* 173 S1)))
 (= X29 (+ (* 173 S0) (* 379 S1)))
 (= X29 (- (* 173 S0) (* 379 S1)))
 (= X29 (- (* 379 S0) (* 173 S1)))
 (= X29 (+ (* 173 S0) (* 577 S1)))
 (= X29 (- (* 173 S0) (* 577 S1)))
 (= X29 (- (* 577 S0) (* 173 S1)))
 (= X29 (+ (* 173 S0) (* 271 S1)))
 (= X29 (- (* 173 S0) (* 271 S1)))
 (= X29 (- (* 271 S0) (* 173 S1)))
 (= X29 (+ (* 173 S0) (* 653 S1)))
 (= X29 (- (* 173 S0) (* 653 S1)))
 (= X29 (- (* 653 S0) (* 173 S1)))
 (= X29 (+ (* 173 S0) (* 1395 S1)))
 (= X29 (- (* 173 S0) (* 1395 S1)))
 (= X29 (- (* 1395 S0) (* 173 S1)))
 (= X29 (+ (* 173 S0) (* 747 S1)))
 (= X29 (- (* 173 S0) (* 747 S1)))
 (= X29 (- (* 747 S0) (* 173 S1)))
 (= X29 (+ (* 173 S0) (* 1803 S1)))
 (= X29 (- (* 173 S0) (* 1803 S1)))
 (= X29 (- (* 1803 S0) (* 173 S1)))
 (= X29 (+ (* 173 S0) (* 933 S1)))
 (= X29 (- (* 173 S0) (* 933 S1)))
 (= X29 (- (* 933 S0) (* 173 S1)))
 (= X29 (+ (* 173 S0) (* 1041 S1)))
 (= X29 (- (* 173 S0) (* 1041 S1)))
 (= X29 (- (* 1041 S0) (* 173 S1)))
 (= X29 (+ (* 1097 S0) S1))
 (= X29 (- (* 1097 S0) S1))
 (= X29 (- S0 (* 1097 S1)))
 (= X29 (+ (* 1097 S0) (* 1097 S1)))
 (= X29 (- (* 1097 S0) (* 1097 S1)))
 (= X29 (+ (* 1097 S0) (* 973 S1)))
 (= X29 (- (* 1097 S0) (* 973 S1)))
 (= X29 (- (* 973 S0) (* 1097 S1)))
 (= X29 (+ (* 1097 S0) (* 1517 S1)))
 (= X29 (- (* 1097 S0) (* 1517 S1)))
 (= X29 (- (* 1517 S0) (* 1097 S1)))
 (= X29 (+ (* 1097 S0) (* 493 S1)))
 (= X29 (- (* 1097 S0) (* 493 S1)))
 (= X29 (- (* 493 S0) (* 1097 S1)))
 (= X29 (+ (* 1097 S0) (* 379 S1)))
 (= X29 (- (* 1097 S0) (* 379 S1)))
 (= X29 (- (* 379 S0) (* 1097 S1)))
 (= X29 (+ (* 1097 S0) (* 577 S1)))
 (= X29 (- (* 1097 S0) (* 577 S1)))
 (= X29 (- (* 577 S0) (* 1097 S1)))
 (= X29 (+ (* 1097 S0) (* 271 S1)))
 (= X29 (- (* 1097 S0) (* 271 S1)))
 (= X29 (- (* 271 S0) (* 1097 S1)))
 (= X29 (+ (* 1097 S0) (* 653 S1)))
 (= X29 (- (* 1097 S0) (* 653 S1)))
 (= X29 (- (* 653 S0) (* 1097 S1)))
 (= X29 (+ (* 1097 S0) (* 1395 S1)))
 (= X29 (- (* 1097 S0) (* 1395 S1)))
 (= X29 (- (* 1395 S0) (* 1097 S1)))
 (= X29 (+ (* 1097 S0) (* 747 S1)))
 (= X29 (- (* 1097 S0) (* 747 S1)))
 (= X29 (- (* 747 S0) (* 1097 S1)))
 (= X29 (+ (* 1097 S0) (* 1803 S1)))
 (= X29 (- (* 1097 S0) (* 1803 S1)))
 (= X29 (- (* 1803 S0) (* 1097 S1)))
 (= X29 (+ (* 1097 S0) (* 933 S1)))
 (= X29 (- (* 1097 S0) (* 933 S1)))
 (= X29 (- (* 933 S0) (* 1097 S1)))
 (= X29 (+ (* 1097 S0) (* 1041 S1)))
 (= X29 (- (* 1097 S0) (* 1041 S1)))
 (= X29 (- (* 1041 S0) (* 1097 S1)))
 (= X29 (+ (* 973 S0) S1))
 (= X29 (- (* 973 S0) S1))
 (= X29 (- S0 (* 973 S1)))
 (= X29 (+ (* 973 S0) (* 973 S1)))
 (= X29 (- (* 973 S0) (* 973 S1)))
 (= X29 (+ (* 973 S0) (* 1517 S1)))
 (= X29 (- (* 973 S0) (* 1517 S1)))
 (= X29 (- (* 1517 S0) (* 973 S1)))
 (= X29 (+ (* 973 S0) (* 493 S1)))
 (= X29 (- (* 973 S0) (* 493 S1)))
 (= X29 (- (* 493 S0) (* 973 S1)))
 (= X29 (+ (* 973 S0) (* 379 S1)))
 (= X29 (- (* 973 S0) (* 379 S1)))
 (= X29 (- (* 379 S0) (* 973 S1)))
 (= X29 (+ (* 973 S0) (* 577 S1)))
 (= X29 (- (* 973 S0) (* 577 S1)))
 (= X29 (- (* 577 S0) (* 973 S1)))
 (= X29 (+ (* 973 S0) (* 271 S1)))
 (= X29 (- (* 973 S0) (* 271 S1)))
 (= X29 (- (* 271 S0) (* 973 S1)))
 (= X29 (+ (* 973 S0) (* 653 S1)))
 (= X29 (- (* 973 S0) (* 653 S1)))
 (= X29 (- (* 653 S0) (* 973 S1)))
 (= X29 (+ (* 973 S0) (* 1395 S1)))
 (= X29 (- (* 973 S0) (* 1395 S1)))
 (= X29 (- (* 1395 S0) (* 973 S1)))
 (= X29 (+ (* 973 S0) (* 747 S1)))
 (= X29 (- (* 973 S0) (* 747 S1)))
 (= X29 (- (* 747 S0) (* 973 S1)))
 (= X29 (+ (* 973 S0) (* 1803 S1)))
 (= X29 (- (* 973 S0) (* 1803 S1)))
 (= X29 (- (* 1803 S0) (* 973 S1)))
 (= X29 (+ (* 973 S0) (* 933 S1)))
 (= X29 (- (* 973 S0) (* 933 S1)))
 (= X29 (- (* 933 S0) (* 973 S1)))
 (= X29 (+ (* 973 S0) (* 1041 S1)))
 (= X29 (- (* 973 S0) (* 1041 S1)))
 (= X29 (- (* 1041 S0) (* 973 S1)))
 (= X29 (+ (* 1517 S0) S1))
 (= X29 (- (* 1517 S0) S1))
 (= X29 (- S0 (* 1517 S1)))
 (= X29 (+ (* 1517 S0) (* 1517 S1)))
 (= X29 (- (* 1517 S0) (* 1517 S1)))
 (= X29 (+ (* 1517 S0) (* 493 S1)))
 (= X29 (- (* 1517 S0) (* 493 S1)))
 (= X29 (- (* 493 S0) (* 1517 S1)))
 (= X29 (+ (* 1517 S0) (* 379 S1)))
 (= X29 (- (* 1517 S0) (* 379 S1)))
 (= X29 (- (* 379 S0) (* 1517 S1)))
 (= X29 (+ (* 1517 S0) (* 577 S1)))
 (= X29 (- (* 1517 S0) (* 577 S1)))
 (= X29 (- (* 577 S0) (* 1517 S1)))
 (= X29 (+ (* 1517 S0) (* 271 S1)))
 (= X29 (- (* 1517 S0) (* 271 S1)))
 (= X29 (- (* 271 S0) (* 1517 S1)))
 (= X29 (+ (* 1517 S0) (* 653 S1)))
 (= X29 (- (* 1517 S0) (* 653 S1)))
 (= X29 (- (* 653 S0) (* 1517 S1)))
 (= X29 (+ (* 1517 S0) (* 1395 S1)))
 (= X29 (- (* 1517 S0) (* 1395 S1)))
 (= X29 (- (* 1395 S0) (* 1517 S1)))
 (= X29 (+ (* 1517 S0) (* 747 S1)))
 (= X29 (- (* 1517 S0) (* 747 S1)))
 (= X29 (- (* 747 S0) (* 1517 S1)))
 (= X29 (+ (* 1517 S0) (* 1803 S1)))
 (= X29 (- (* 1517 S0) (* 1803 S1)))
 (= X29 (- (* 1803 S0) (* 1517 S1)))
 (= X29 (+ (* 1517 S0) (* 933 S1)))
 (= X29 (- (* 1517 S0) (* 933 S1)))
 (= X29 (- (* 933 S0) (* 1517 S1)))
 (= X29 (+ (* 1517 S0) (* 1041 S1)))
 (= X29 (- (* 1517 S0) (* 1041 S1)))
 (= X29 (- (* 1041 S0) (* 1517 S1)))
 (= X29 (+ (* 493 S0) S1))
 (= X29 (- (* 493 S0) S1))
 (= X29 (- S0 (* 493 S1)))
 (= X29 (+ (* 493 S0) (* 493 S1)))
 (= X29 (- (* 493 S0) (* 493 S1)))
 (= X29 (+ (* 493 S0) (* 379 S1)))
 (= X29 (- (* 493 S0) (* 379 S1)))
 (= X29 (- (* 379 S0) (* 493 S1)))
 (= X29 (+ (* 493 S0) (* 577 S1)))
 (= X29 (- (* 493 S0) (* 577 S1)))
 (= X29 (- (* 577 S0) (* 493 S1)))
 (= X29 (+ (* 493 S0) (* 271 S1)))
 (= X29 (- (* 493 S0) (* 271 S1)))
 (= X29 (- (* 271 S0) (* 493 S1)))
 (= X29 (+ (* 493 S0) (* 653 S1)))
 (= X29 (- (* 493 S0) (* 653 S1)))
 (= X29 (- (* 653 S0) (* 493 S1)))
 (= X29 (+ (* 493 S0) (* 1395 S1)))
 (= X29 (- (* 493 S0) (* 1395 S1)))
 (= X29 (- (* 1395 S0) (* 493 S1)))
 (= X29 (+ (* 493 S0) (* 747 S1)))
 (= X29 (- (* 493 S0) (* 747 S1)))
 (= X29 (- (* 747 S0) (* 493 S1)))
 (= X29 (+ (* 493 S0) (* 1803 S1)))
 (= X29 (- (* 493 S0) (* 1803 S1)))
 (= X29 (- (* 1803 S0) (* 493 S1)))
 (= X29 (+ (* 493 S0) (* 933 S1)))
 (= X29 (- (* 493 S0) (* 933 S1)))
 (= X29 (- (* 933 S0) (* 493 S1)))
 (= X29 (+ (* 493 S0) (* 1041 S1)))
 (= X29 (- (* 493 S0) (* 1041 S1)))
 (= X29 (- (* 1041 S0) (* 493 S1)))
 (= X29 (+ (* 379 S0) S1))
 (= X29 (- (* 379 S0) S1))
 (= X29 (- S0 (* 379 S1)))
 (= X29 (+ (* 379 S0) (* 379 S1)))
 (= X29 (- (* 379 S0) (* 379 S1)))
 (= X29 (+ (* 379 S0) (* 577 S1)))
 (= X29 (- (* 379 S0) (* 577 S1)))
 (= X29 (- (* 577 S0) (* 379 S1)))
 (= X29 (+ (* 379 S0) (* 271 S1)))
 (= X29 (- (* 379 S0) (* 271 S1)))
 (= X29 (- (* 271 S0) (* 379 S1)))
 (= X29 (+ (* 379 S0) (* 653 S1)))
 (= X29 (- (* 379 S0) (* 653 S1)))
 (= X29 (- (* 653 S0) (* 379 S1)))
 (= X29 (+ (* 379 S0) (* 1395 S1)))
 (= X29 (- (* 379 S0) (* 1395 S1)))
 (= X29 (- (* 1395 S0) (* 379 S1)))
 (= X29 (+ (* 379 S0) (* 747 S1)))
 (= X29 (- (* 379 S0) (* 747 S1)))
 (= X29 (- (* 747 S0) (* 379 S1)))
 (= X29 (+ (* 379 S0) (* 1803 S1)))
 (= X29 (- (* 379 S0) (* 1803 S1)))
 (= X29 (- (* 1803 S0) (* 379 S1)))
 (= X29 (+ (* 379 S0) (* 933 S1)))
 (= X29 (- (* 379 S0) (* 933 S1)))
 (= X29 (- (* 933 S0) (* 379 S1)))
 (= X29 (+ (* 379 S0) (* 1041 S1)))
 (= X29 (- (* 379 S0) (* 1041 S1)))
 (= X29 (- (* 1041 S0) (* 379 S1)))
 (= X29 (+ (* 577 S0) S1))
 (= X29 (- (* 577 S0) S1))
 (= X29 (- S0 (* 577 S1)))
 (= X29 (+ (* 577 S0) (* 577 S1)))
 (= X29 (- (* 577 S0) (* 577 S1)))
 (= X29 (+ (* 577 S0) (* 271 S1)))
 (= X29 (- (* 577 S0) (* 271 S1)))
 (= X29 (- (* 271 S0) (* 577 S1)))
 (= X29 (+ (* 577 S0) (* 653 S1)))
 (= X29 (- (* 577 S0) (* 653 S1)))
 (= X29 (- (* 653 S0) (* 577 S1)))
 (= X29 (+ (* 577 S0) (* 1395 S1)))
 (= X29 (- (* 577 S0) (* 1395 S1)))
 (= X29 (- (* 1395 S0) (* 577 S1)))
 (= X29 (+ (* 577 S0) (* 747 S1)))
 (= X29 (- (* 577 S0) (* 747 S1)))
 (= X29 (- (* 747 S0) (* 577 S1)))
 (= X29 (+ (* 577 S0) (* 1803 S1)))
 (= X29 (- (* 577 S0) (* 1803 S1)))
 (= X29 (- (* 1803 S0) (* 577 S1)))
 (= X29 (+ (* 577 S0) (* 933 S1)))
 (= X29 (- (* 577 S0) (* 933 S1)))
 (= X29 (- (* 933 S0) (* 577 S1)))
 (= X29 (+ (* 577 S0) (* 1041 S1)))
 (= X29 (- (* 577 S0) (* 1041 S1)))
 (= X29 (- (* 1041 S0) (* 577 S1)))
 (= X29 (+ (* 271 S0) S1))
 (= X29 (- (* 271 S0) S1))
 (= X29 (- S0 (* 271 S1)))
 (= X29 (+ (* 271 S0) (* 271 S1)))
 (= X29 (- (* 271 S0) (* 271 S1)))
 (= X29 (+ (* 271 S0) (* 653 S1)))
 (= X29 (- (* 271 S0) (* 653 S1)))
 (= X29 (- (* 653 S0) (* 271 S1)))
 (= X29 (+ (* 271 S0) (* 1395 S1)))
 (= X29 (- (* 271 S0) (* 1395 S1)))
 (= X29 (- (* 1395 S0) (* 271 S1)))
 (= X29 (+ (* 271 S0) (* 747 S1)))
 (= X29 (- (* 271 S0) (* 747 S1)))
 (= X29 (- (* 747 S0) (* 271 S1)))
 (= X29 (+ (* 271 S0) (* 1803 S1)))
 (= X29 (- (* 271 S0) (* 1803 S1)))
 (= X29 (- (* 1803 S0) (* 271 S1)))
 (= X29 (+ (* 271 S0) (* 933 S1)))
 (= X29 (- (* 271 S0) (* 933 S1)))
 (= X29 (- (* 933 S0) (* 271 S1)))
 (= X29 (+ (* 271 S0) (* 1041 S1)))
 (= X29 (- (* 271 S0) (* 1041 S1)))
 (= X29 (- (* 1041 S0) (* 271 S1)))
 (= X29 (+ (* 653 S0) S1))
 (= X29 (- (* 653 S0) S1))
 (= X29 (- S0 (* 653 S1)))
 (= X29 (+ (* 653 S0) (* 653 S1)))
 (= X29 (- (* 653 S0) (* 653 S1)))
 (= X29 (+ (* 653 S0) (* 1395 S1)))
 (= X29 (- (* 653 S0) (* 1395 S1)))
 (= X29 (- (* 1395 S0) (* 653 S1)))
 (= X29 (+ (* 653 S0) (* 747 S1)))
 (= X29 (- (* 653 S0) (* 747 S1)))
 (= X29 (- (* 747 S0) (* 653 S1)))
 (= X29 (+ (* 653 S0) (* 1803 S1)))
 (= X29 (- (* 653 S0) (* 1803 S1)))
 (= X29 (- (* 1803 S0) (* 653 S1)))
 (= X29 (+ (* 653 S0) (* 933 S1)))
 (= X29 (- (* 653 S0) (* 933 S1)))
 (= X29 (- (* 933 S0) (* 653 S1)))
 (= X29 (+ (* 653 S0) (* 1041 S1)))
 (= X29 (- (* 653 S0) (* 1041 S1)))
 (= X29 (- (* 1041 S0) (* 653 S1)))
 (= X29 (+ (* 1395 S0) S1))
 (= X29 (- (* 1395 S0) S1))
 (= X29 (- S0 (* 1395 S1)))
 (= X29 (+ (* 1395 S0) (* 1395 S1)))
 (= X29 (- (* 1395 S0) (* 1395 S1)))
 (= X29 (+ (* 1395 S0) (* 747 S1)))
 (= X29 (- (* 1395 S0) (* 747 S1)))
 (= X29 (- (* 747 S0) (* 1395 S1)))
 (= X29 (+ (* 1395 S0) (* 1803 S1)))
 (= X29 (- (* 1395 S0) (* 1803 S1)))
 (= X29 (- (* 1803 S0) (* 1395 S1)))
 (= X29 (+ (* 1395 S0) (* 933 S1)))
 (= X29 (- (* 1395 S0) (* 933 S1)))
 (= X29 (- (* 933 S0) (* 1395 S1)))
 (= X29 (+ (* 1395 S0) (* 1041 S1)))
 (= X29 (- (* 1395 S0) (* 1041 S1)))
 (= X29 (- (* 1041 S0) (* 1395 S1)))
 (= X29 (+ (* 747 S0) S1))
 (= X29 (- (* 747 S0) S1))
 (= X29 (- S0 (* 747 S1)))
 (= X29 (+ (* 747 S0) (* 747 S1)))
 (= X29 (- (* 747 S0) (* 747 S1)))
 (= X29 (+ (* 747 S0) (* 1803 S1)))
 (= X29 (- (* 747 S0) (* 1803 S1)))
 (= X29 (- (* 1803 S0) (* 747 S1)))
 (= X29 (+ (* 747 S0) (* 933 S1)))
 (= X29 (- (* 747 S0) (* 933 S1)))
 (= X29 (- (* 933 S0) (* 747 S1)))
 (= X29 (+ (* 747 S0) (* 1041 S1)))
 (= X29 (- (* 747 S0) (* 1041 S1)))
 (= X29 (- (* 1041 S0) (* 747 S1)))
 (= X29 (+ (* 1803 S0) S1))
 (= X29 (- (* 1803 S0) S1))
 (= X29 (- S0 (* 1803 S1)))
 (= X29 (+ (* 1803 S0) (* 1803 S1)))
 (= X29 (- (* 1803 S0) (* 1803 S1)))
 (= X29 (+ (* 1803 S0) (* 933 S1)))
 (= X29 (- (* 1803 S0) (* 933 S1)))
 (= X29 (- (* 933 S0) (* 1803 S1)))
 (= X29 (+ (* 1803 S0) (* 1041 S1)))
 (= X29 (- (* 1803 S0) (* 1041 S1)))
 (= X29 (- (* 1041 S0) (* 1803 S1)))
 (= X29 (+ (* 933 S0) S1))
 (= X29 (- (* 933 S0) S1))
 (= X29 (- S0 (* 933 S1)))
 (= X29 (+ (* 933 S0) (* 933 S1)))
 (= X29 (- (* 933 S0) (* 933 S1)))
 (= X29 (+ (* 933 S0) (* 1041 S1)))
 (= X29 (- (* 933 S0) (* 1041 S1)))
 (= X29 (- (* 1041 S0) (* 933 S1)))
 (= X29 (+ (* 1041 S0) S1))
 (= X29 (- (* 1041 S0) S1))
 (= X29 (- S0 (* 1041 S1)))
 (= X29 (+ (* 1041 S0) (* 1041 S1)))
 (= X29 (- (* 1041 S0) (* 1041 S1)))
))
(assert (and (> X29 0) (< X29 4096) (power2 S0) (power2 S1)))
(assert (or
 (= X30 (+ (* 31 S2) S3))
 (= X30 (- (* 31 S2) S3))
 (= X30 (- S2 (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 31 S3)))
 (= X30 (- (* 31 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 33 S3)))
 (= X30 (- (* 31 S2) (* 33 S3)))
 (= X30 (- (* 33 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 39 S3)))
 (= X30 (- (* 31 S2) (* 39 S3)))
 (= X30 (- (* 39 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 47 S3)))
 (= X30 (- (* 31 S2) (* 47 S3)))
 (= X30 (- (* 47 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 41 S3)))
 (= X30 (- (* 31 S2) (* 41 S3)))
 (= X30 (- (* 41 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 217 S3)))
 (= X30 (- (* 31 S2) (* 217 S3)))
 (= X30 (- (* 217 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 295 S3)))
 (= X30 (- (* 31 S2) (* 295 S3)))
 (= X30 (- (* 295 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 167 S3)))
 (= X30 (- (* 31 S2) (* 167 S3)))
 (= X30 (- (* 167 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 1313 S3)))
 (= X30 (- (* 31 S2) (* 1313 S3)))
 (= X30 (- (* 1313 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 281 S3)))
 (= X30 (- (* 31 S2) (* 281 S3)))
 (= X30 (- (* 281 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 1191 S3)))
 (= X30 (- (* 31 S2) (* 1191 S3)))
 (= X30 (- (* 1191 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 1945 S3)))
 (= X30 (- (* 31 S2) (* 1945 S3)))
 (= X30 (- (* 1945 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 775 S3)))
 (= X30 (- (* 31 S2) (* 775 S3)))
 (= X30 (- (* 775 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 1367 S3)))
 (= X30 (- (* 31 S2) (* 1367 S3)))
 (= X30 (- (* 1367 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 1015 S3)))
 (= X30 (- (* 31 S2) (* 1015 S3)))
 (= X30 (- (* 1015 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 173 S3)))
 (= X30 (- (* 31 S2) (* 173 S3)))
 (= X30 (- (* 173 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 1097 S3)))
 (= X30 (- (* 31 S2) (* 1097 S3)))
 (= X30 (- (* 1097 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 973 S3)))
 (= X30 (- (* 31 S2) (* 973 S3)))
 (= X30 (- (* 973 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 1517 S3)))
 (= X30 (- (* 31 S2) (* 1517 S3)))
 (= X30 (- (* 1517 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 493 S3)))
 (= X30 (- (* 31 S2) (* 493 S3)))
 (= X30 (- (* 493 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 379 S3)))
 (= X30 (- (* 31 S2) (* 379 S3)))
 (= X30 (- (* 379 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 577 S3)))
 (= X30 (- (* 31 S2) (* 577 S3)))
 (= X30 (- (* 577 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 271 S3)))
 (= X30 (- (* 31 S2) (* 271 S3)))
 (= X30 (- (* 271 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 653 S3)))
 (= X30 (- (* 31 S2) (* 653 S3)))
 (= X30 (- (* 653 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 1395 S3)))
 (= X30 (- (* 31 S2) (* 1395 S3)))
 (= X30 (- (* 1395 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 747 S3)))
 (= X30 (- (* 31 S2) (* 747 S3)))
 (= X30 (- (* 747 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 1803 S3)))
 (= X30 (- (* 31 S2) (* 1803 S3)))
 (= X30 (- (* 1803 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 933 S3)))
 (= X30 (- (* 31 S2) (* 933 S3)))
 (= X30 (- (* 933 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 1041 S3)))
 (= X30 (- (* 31 S2) (* 1041 S3)))
 (= X30 (- (* 1041 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* X29 S3)))
 (= X30 (- (* 31 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 31 S3)))
 (= X30 (+ (* 33 S2) S3))
 (= X30 (- (* 33 S2) S3))
 (= X30 (- S2 (* 33 S3)))
 (= X30 (+ (* 33 S2) (* 33 S3)))
 (= X30 (- (* 33 S2) (* 33 S3)))
 (= X30 (+ (* 33 S2) (* 39 S3)))
 (= X30 (- (* 33 S2) (* 39 S3)))
 (= X30 (- (* 39 S2) (* 33 S3)))
 (= X30 (+ (* 33 S2) (* 47 S3)))
 (= X30 (- (* 33 S2) (* 47 S3)))
 (= X30 (- (* 47 S2) (* 33 S3)))
 (= X30 (+ (* 33 S2) (* 41 S3)))
 (= X30 (- (* 33 S2) (* 41 S3)))
 (= X30 (- (* 41 S2) (* 33 S3)))
 (= X30 (+ (* 33 S2) (* 217 S3)))
 (= X30 (- (* 33 S2) (* 217 S3)))
 (= X30 (- (* 217 S2) (* 33 S3)))
 (= X30 (+ (* 33 S2) (* 295 S3)))
 (= X30 (- (* 33 S2) (* 295 S3)))
 (= X30 (- (* 295 S2) (* 33 S3)))
 (= X30 (+ (* 33 S2) (* 167 S3)))
 (= X30 (- (* 33 S2) (* 167 S3)))
 (= X30 (- (* 167 S2) (* 33 S3)))
 (= X30 (+ (* 33 S2) (* 1313 S3)))
 (= X30 (- (* 33 S2) (* 1313 S3)))
 (= X30 (- (* 1313 S2) (* 33 S3)))
 (= X30 (+ (* 33 S2) (* 281 S3)))
 (= X30 (- (* 33 S2) (* 281 S3)))
 (= X30 (- (* 281 S2) (* 33 S3)))
 (= X30 (+ (* 33 S2) (* 1191 S3)))
 (= X30 (- (* 33 S2) (* 1191 S3)))
 (= X30 (- (* 1191 S2) (* 33 S3)))
 (= X30 (+ (* 33 S2) (* 1945 S3)))
 (= X30 (- (* 33 S2) (* 1945 S3)))
 (= X30 (- (* 1945 S2) (* 33 S3)))
 (= X30 (+ (* 33 S2) (* 775 S3)))
 (= X30 (- (* 33 S2) (* 775 S3)))
 (= X30 (- (* 775 S2) (* 33 S3)))
 (= X30 (+ (* 33 S2) (* 1367 S3)))
 (= X30 (- (* 33 S2) (* 1367 S3)))
 (= X30 (- (* 1367 S2) (* 33 S3)))
 (= X30 (+ (* 33 S2) (* 1015 S3)))
 (= X30 (- (* 33 S2) (* 1015 S3)))
 (= X30 (- (* 1015 S2) (* 33 S3)))
 (= X30 (+ (* 33 S2) (* 173 S3)))
 (= X30 (- (* 33 S2) (* 173 S3)))
 (= X30 (- (* 173 S2) (* 33 S3)))
 (= X30 (+ (* 33 S2) (* 1097 S3)))
 (= X30 (- (* 33 S2) (* 1097 S3)))
 (= X30 (- (* 1097 S2) (* 33 S3)))
 (= X30 (+ (* 33 S2) (* 973 S3)))
 (= X30 (- (* 33 S2) (* 973 S3)))
 (= X30 (- (* 973 S2) (* 33 S3)))
 (= X30 (+ (* 33 S2) (* 1517 S3)))
 (= X30 (- (* 33 S2) (* 1517 S3)))
 (= X30 (- (* 1517 S2) (* 33 S3)))
 (= X30 (+ (* 33 S2) (* 493 S3)))
 (= X30 (- (* 33 S2) (* 493 S3)))
 (= X30 (- (* 493 S2) (* 33 S3)))
 (= X30 (+ (* 33 S2) (* 379 S3)))
 (= X30 (- (* 33 S2) (* 379 S3)))
 (= X30 (- (* 379 S2) (* 33 S3)))
 (= X30 (+ (* 33 S2) (* 577 S3)))
 (= X30 (- (* 33 S2) (* 577 S3)))
 (= X30 (- (* 577 S2) (* 33 S3)))
 (= X30 (+ (* 33 S2) (* 271 S3)))
 (= X30 (- (* 33 S2) (* 271 S3)))
 (= X30 (- (* 271 S2) (* 33 S3)))
 (= X30 (+ (* 33 S2) (* 653 S3)))
 (= X30 (- (* 33 S2) (* 653 S3)))
 (= X30 (- (* 653 S2) (* 33 S3)))
 (= X30 (+ (* 33 S2) (* 1395 S3)))
 (= X30 (- (* 33 S2) (* 1395 S3)))
 (= X30 (- (* 1395 S2) (* 33 S3)))
 (= X30 (+ (* 33 S2) (* 747 S3)))
 (= X30 (- (* 33 S2) (* 747 S3)))
 (= X30 (- (* 747 S2) (* 33 S3)))
 (= X30 (+ (* 33 S2) (* 1803 S3)))
 (= X30 (- (* 33 S2) (* 1803 S3)))
 (= X30 (- (* 1803 S2) (* 33 S3)))
 (= X30 (+ (* 33 S2) (* 933 S3)))
 (= X30 (- (* 33 S2) (* 933 S3)))
 (= X30 (- (* 933 S2) (* 33 S3)))
 (= X30 (+ (* 33 S2) (* 1041 S3)))
 (= X30 (- (* 33 S2) (* 1041 S3)))
 (= X30 (- (* 1041 S2) (* 33 S3)))
 (= X30 (+ (* 33 S2) (* X29 S3)))
 (= X30 (- (* 33 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 33 S3)))
 (= X30 (+ (* 39 S2) S3))
 (= X30 (- (* 39 S2) S3))
 (= X30 (- S2 (* 39 S3)))
 (= X30 (+ (* 39 S2) (* 39 S3)))
 (= X30 (- (* 39 S2) (* 39 S3)))
 (= X30 (+ (* 39 S2) (* 47 S3)))
 (= X30 (- (* 39 S2) (* 47 S3)))
 (= X30 (- (* 47 S2) (* 39 S3)))
 (= X30 (+ (* 39 S2) (* 41 S3)))
 (= X30 (- (* 39 S2) (* 41 S3)))
 (= X30 (- (* 41 S2) (* 39 S3)))
 (= X30 (+ (* 39 S2) (* 217 S3)))
 (= X30 (- (* 39 S2) (* 217 S3)))
 (= X30 (- (* 217 S2) (* 39 S3)))
 (= X30 (+ (* 39 S2) (* 295 S3)))
 (= X30 (- (* 39 S2) (* 295 S3)))
 (= X30 (- (* 295 S2) (* 39 S3)))
 (= X30 (+ (* 39 S2) (* 167 S3)))
 (= X30 (- (* 39 S2) (* 167 S3)))
 (= X30 (- (* 167 S2) (* 39 S3)))
 (= X30 (+ (* 39 S2) (* 1313 S3)))
 (= X30 (- (* 39 S2) (* 1313 S3)))
 (= X30 (- (* 1313 S2) (* 39 S3)))
 (= X30 (+ (* 39 S2) (* 281 S3)))
 (= X30 (- (* 39 S2) (* 281 S3)))
 (= X30 (- (* 281 S2) (* 39 S3)))
 (= X30 (+ (* 39 S2) (* 1191 S3)))
 (= X30 (- (* 39 S2) (* 1191 S3)))
 (= X30 (- (* 1191 S2) (* 39 S3)))
 (= X30 (+ (* 39 S2) (* 1945 S3)))
 (= X30 (- (* 39 S2) (* 1945 S3)))
 (= X30 (- (* 1945 S2) (* 39 S3)))
 (= X30 (+ (* 39 S2) (* 775 S3)))
 (= X30 (- (* 39 S2) (* 775 S3)))
 (= X30 (- (* 775 S2) (* 39 S3)))
 (= X30 (+ (* 39 S2) (* 1367 S3)))
 (= X30 (- (* 39 S2) (* 1367 S3)))
 (= X30 (- (* 1367 S2) (* 39 S3)))
 (= X30 (+ (* 39 S2) (* 1015 S3)))
 (= X30 (- (* 39 S2) (* 1015 S3)))
 (= X30 (- (* 1015 S2) (* 39 S3)))
 (= X30 (+ (* 39 S2) (* 173 S3)))
 (= X30 (- (* 39 S2) (* 173 S3)))
 (= X30 (- (* 173 S2) (* 39 S3)))
 (= X30 (+ (* 39 S2) (* 1097 S3)))
 (= X30 (- (* 39 S2) (* 1097 S3)))
 (= X30 (- (* 1097 S2) (* 39 S3)))
 (= X30 (+ (* 39 S2) (* 973 S3)))
 (= X30 (- (* 39 S2) (* 973 S3)))
 (= X30 (- (* 973 S2) (* 39 S3)))
 (= X30 (+ (* 39 S2) (* 1517 S3)))
 (= X30 (- (* 39 S2) (* 1517 S3)))
 (= X30 (- (* 1517 S2) (* 39 S3)))
 (= X30 (+ (* 39 S2) (* 493 S3)))
 (= X30 (- (* 39 S2) (* 493 S3)))
 (= X30 (- (* 493 S2) (* 39 S3)))
 (= X30 (+ (* 39 S2) (* 379 S3)))
 (= X30 (- (* 39 S2) (* 379 S3)))
 (= X30 (- (* 379 S2) (* 39 S3)))
 (= X30 (+ (* 39 S2) (* 577 S3)))
 (= X30 (- (* 39 S2) (* 577 S3)))
 (= X30 (- (* 577 S2) (* 39 S3)))
 (= X30 (+ (* 39 S2) (* 271 S3)))
 (= X30 (- (* 39 S2) (* 271 S3)))
 (= X30 (- (* 271 S2) (* 39 S3)))
 (= X30 (+ (* 39 S2) (* 653 S3)))
 (= X30 (- (* 39 S2) (* 653 S3)))
 (= X30 (- (* 653 S2) (* 39 S3)))
 (= X30 (+ (* 39 S2) (* 1395 S3)))
 (= X30 (- (* 39 S2) (* 1395 S3)))
 (= X30 (- (* 1395 S2) (* 39 S3)))
 (= X30 (+ (* 39 S2) (* 747 S3)))
 (= X30 (- (* 39 S2) (* 747 S3)))
 (= X30 (- (* 747 S2) (* 39 S3)))
 (= X30 (+ (* 39 S2) (* 1803 S3)))
 (= X30 (- (* 39 S2) (* 1803 S3)))
 (= X30 (- (* 1803 S2) (* 39 S3)))
 (= X30 (+ (* 39 S2) (* 933 S3)))
 (= X30 (- (* 39 S2) (* 933 S3)))
 (= X30 (- (* 933 S2) (* 39 S3)))
 (= X30 (+ (* 39 S2) (* 1041 S3)))
 (= X30 (- (* 39 S2) (* 1041 S3)))
 (= X30 (- (* 1041 S2) (* 39 S3)))
 (= X30 (+ (* 39 S2) (* X29 S3)))
 (= X30 (- (* 39 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 39 S3)))
 (= X30 (+ (* 47 S2) S3))
 (= X30 (- (* 47 S2) S3))
 (= X30 (- S2 (* 47 S3)))
 (= X30 (+ (* 47 S2) (* 47 S3)))
 (= X30 (- (* 47 S2) (* 47 S3)))
 (= X30 (+ (* 47 S2) (* 41 S3)))
 (= X30 (- (* 47 S2) (* 41 S3)))
 (= X30 (- (* 41 S2) (* 47 S3)))
 (= X30 (+ (* 47 S2) (* 217 S3)))
 (= X30 (- (* 47 S2) (* 217 S3)))
 (= X30 (- (* 217 S2) (* 47 S3)))
 (= X30 (+ (* 47 S2) (* 295 S3)))
 (= X30 (- (* 47 S2) (* 295 S3)))
 (= X30 (- (* 295 S2) (* 47 S3)))
 (= X30 (+ (* 47 S2) (* 167 S3)))
 (= X30 (- (* 47 S2) (* 167 S3)))
 (= X30 (- (* 167 S2) (* 47 S3)))
 (= X30 (+ (* 47 S2) (* 1313 S3)))
 (= X30 (- (* 47 S2) (* 1313 S3)))
 (= X30 (- (* 1313 S2) (* 47 S3)))
 (= X30 (+ (* 47 S2) (* 281 S3)))
 (= X30 (- (* 47 S2) (* 281 S3)))
 (= X30 (- (* 281 S2) (* 47 S3)))
 (= X30 (+ (* 47 S2) (* 1191 S3)))
 (= X30 (- (* 47 S2) (* 1191 S3)))
 (= X30 (- (* 1191 S2) (* 47 S3)))
 (= X30 (+ (* 47 S2) (* 1945 S3)))
 (= X30 (- (* 47 S2) (* 1945 S3)))
 (= X30 (- (* 1945 S2) (* 47 S3)))
 (= X30 (+ (* 47 S2) (* 775 S3)))
 (= X30 (- (* 47 S2) (* 775 S3)))
 (= X30 (- (* 775 S2) (* 47 S3)))
 (= X30 (+ (* 47 S2) (* 1367 S3)))
 (= X30 (- (* 47 S2) (* 1367 S3)))
 (= X30 (- (* 1367 S2) (* 47 S3)))
 (= X30 (+ (* 47 S2) (* 1015 S3)))
 (= X30 (- (* 47 S2) (* 1015 S3)))
 (= X30 (- (* 1015 S2) (* 47 S3)))
 (= X30 (+ (* 47 S2) (* 173 S3)))
 (= X30 (- (* 47 S2) (* 173 S3)))
 (= X30 (- (* 173 S2) (* 47 S3)))
 (= X30 (+ (* 47 S2) (* 1097 S3)))
 (= X30 (- (* 47 S2) (* 1097 S3)))
 (= X30 (- (* 1097 S2) (* 47 S3)))
 (= X30 (+ (* 47 S2) (* 973 S3)))
 (= X30 (- (* 47 S2) (* 973 S3)))
 (= X30 (- (* 973 S2) (* 47 S3)))
 (= X30 (+ (* 47 S2) (* 1517 S3)))
 (= X30 (- (* 47 S2) (* 1517 S3)))
 (= X30 (- (* 1517 S2) (* 47 S3)))
 (= X30 (+ (* 47 S2) (* 493 S3)))
 (= X30 (- (* 47 S2) (* 493 S3)))
 (= X30 (- (* 493 S2) (* 47 S3)))
 (= X30 (+ (* 47 S2) (* 379 S3)))
 (= X30 (- (* 47 S2) (* 379 S3)))
 (= X30 (- (* 379 S2) (* 47 S3)))
 (= X30 (+ (* 47 S2) (* 577 S3)))
 (= X30 (- (* 47 S2) (* 577 S3)))
 (= X30 (- (* 577 S2) (* 47 S3)))
 (= X30 (+ (* 47 S2) (* 271 S3)))
 (= X30 (- (* 47 S2) (* 271 S3)))
 (= X30 (- (* 271 S2) (* 47 S3)))
 (= X30 (+ (* 47 S2) (* 653 S3)))
 (= X30 (- (* 47 S2) (* 653 S3)))
 (= X30 (- (* 653 S2) (* 47 S3)))
 (= X30 (+ (* 47 S2) (* 1395 S3)))
 (= X30 (- (* 47 S2) (* 1395 S3)))
 (= X30 (- (* 1395 S2) (* 47 S3)))
 (= X30 (+ (* 47 S2) (* 747 S3)))
 (= X30 (- (* 47 S2) (* 747 S3)))
 (= X30 (- (* 747 S2) (* 47 S3)))
 (= X30 (+ (* 47 S2) (* 1803 S3)))
 (= X30 (- (* 47 S2) (* 1803 S3)))
 (= X30 (- (* 1803 S2) (* 47 S3)))
 (= X30 (+ (* 47 S2) (* 933 S3)))
 (= X30 (- (* 47 S2) (* 933 S3)))
 (= X30 (- (* 933 S2) (* 47 S3)))
 (= X30 (+ (* 47 S2) (* 1041 S3)))
 (= X30 (- (* 47 S2) (* 1041 S3)))
 (= X30 (- (* 1041 S2) (* 47 S3)))
 (= X30 (+ (* 47 S2) (* X29 S3)))
 (= X30 (- (* 47 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 47 S3)))
 (= X30 (+ (* 41 S2) S3))
 (= X30 (- (* 41 S2) S3))
 (= X30 (- S2 (* 41 S3)))
 (= X30 (+ (* 41 S2) (* 41 S3)))
 (= X30 (- (* 41 S2) (* 41 S3)))
 (= X30 (+ (* 41 S2) (* 217 S3)))
 (= X30 (- (* 41 S2) (* 217 S3)))
 (= X30 (- (* 217 S2) (* 41 S3)))
 (= X30 (+ (* 41 S2) (* 295 S3)))
 (= X30 (- (* 41 S2) (* 295 S3)))
 (= X30 (- (* 295 S2) (* 41 S3)))
 (= X30 (+ (* 41 S2) (* 167 S3)))
 (= X30 (- (* 41 S2) (* 167 S3)))
 (= X30 (- (* 167 S2) (* 41 S3)))
 (= X30 (+ (* 41 S2) (* 1313 S3)))
 (= X30 (- (* 41 S2) (* 1313 S3)))
 (= X30 (- (* 1313 S2) (* 41 S3)))
 (= X30 (+ (* 41 S2) (* 281 S3)))
 (= X30 (- (* 41 S2) (* 281 S3)))
 (= X30 (- (* 281 S2) (* 41 S3)))
 (= X30 (+ (* 41 S2) (* 1191 S3)))
 (= X30 (- (* 41 S2) (* 1191 S3)))
 (= X30 (- (* 1191 S2) (* 41 S3)))
 (= X30 (+ (* 41 S2) (* 1945 S3)))
 (= X30 (- (* 41 S2) (* 1945 S3)))
 (= X30 (- (* 1945 S2) (* 41 S3)))
 (= X30 (+ (* 41 S2) (* 775 S3)))
 (= X30 (- (* 41 S2) (* 775 S3)))
 (= X30 (- (* 775 S2) (* 41 S3)))
 (= X30 (+ (* 41 S2) (* 1367 S3)))
 (= X30 (- (* 41 S2) (* 1367 S3)))
 (= X30 (- (* 1367 S2) (* 41 S3)))
 (= X30 (+ (* 41 S2) (* 1015 S3)))
 (= X30 (- (* 41 S2) (* 1015 S3)))
 (= X30 (- (* 1015 S2) (* 41 S3)))
 (= X30 (+ (* 41 S2) (* 173 S3)))
 (= X30 (- (* 41 S2) (* 173 S3)))
 (= X30 (- (* 173 S2) (* 41 S3)))
 (= X30 (+ (* 41 S2) (* 1097 S3)))
 (= X30 (- (* 41 S2) (* 1097 S3)))
 (= X30 (- (* 1097 S2) (* 41 S3)))
 (= X30 (+ (* 41 S2) (* 973 S3)))
 (= X30 (- (* 41 S2) (* 973 S3)))
 (= X30 (- (* 973 S2) (* 41 S3)))
 (= X30 (+ (* 41 S2) (* 1517 S3)))
 (= X30 (- (* 41 S2) (* 1517 S3)))
 (= X30 (- (* 1517 S2) (* 41 S3)))
 (= X30 (+ (* 41 S2) (* 493 S3)))
 (= X30 (- (* 41 S2) (* 493 S3)))
 (= X30 (- (* 493 S2) (* 41 S3)))
 (= X30 (+ (* 41 S2) (* 379 S3)))
 (= X30 (- (* 41 S2) (* 379 S3)))
 (= X30 (- (* 379 S2) (* 41 S3)))
 (= X30 (+ (* 41 S2) (* 577 S3)))
 (= X30 (- (* 41 S2) (* 577 S3)))
 (= X30 (- (* 577 S2) (* 41 S3)))
 (= X30 (+ (* 41 S2) (* 271 S3)))
 (= X30 (- (* 41 S2) (* 271 S3)))
 (= X30 (- (* 271 S2) (* 41 S3)))
 (= X30 (+ (* 41 S2) (* 653 S3)))
 (= X30 (- (* 41 S2) (* 653 S3)))
 (= X30 (- (* 653 S2) (* 41 S3)))
 (= X30 (+ (* 41 S2) (* 1395 S3)))
 (= X30 (- (* 41 S2) (* 1395 S3)))
 (= X30 (- (* 1395 S2) (* 41 S3)))
 (= X30 (+ (* 41 S2) (* 747 S3)))
 (= X30 (- (* 41 S2) (* 747 S3)))
 (= X30 (- (* 747 S2) (* 41 S3)))
 (= X30 (+ (* 41 S2) (* 1803 S3)))
 (= X30 (- (* 41 S2) (* 1803 S3)))
 (= X30 (- (* 1803 S2) (* 41 S3)))
 (= X30 (+ (* 41 S2) (* 933 S3)))
 (= X30 (- (* 41 S2) (* 933 S3)))
 (= X30 (- (* 933 S2) (* 41 S3)))
 (= X30 (+ (* 41 S2) (* 1041 S3)))
 (= X30 (- (* 41 S2) (* 1041 S3)))
 (= X30 (- (* 1041 S2) (* 41 S3)))
 (= X30 (+ (* 41 S2) (* X29 S3)))
 (= X30 (- (* 41 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 41 S3)))
 (= X30 (+ (* 217 S2) S3))
 (= X30 (- (* 217 S2) S3))
 (= X30 (- S2 (* 217 S3)))
 (= X30 (+ (* 217 S2) (* 217 S3)))
 (= X30 (- (* 217 S2) (* 217 S3)))
 (= X30 (+ (* 217 S2) (* 295 S3)))
 (= X30 (- (* 217 S2) (* 295 S3)))
 (= X30 (- (* 295 S2) (* 217 S3)))
 (= X30 (+ (* 217 S2) (* 167 S3)))
 (= X30 (- (* 217 S2) (* 167 S3)))
 (= X30 (- (* 167 S2) (* 217 S3)))
 (= X30 (+ (* 217 S2) (* 1313 S3)))
 (= X30 (- (* 217 S2) (* 1313 S3)))
 (= X30 (- (* 1313 S2) (* 217 S3)))
 (= X30 (+ (* 217 S2) (* 281 S3)))
 (= X30 (- (* 217 S2) (* 281 S3)))
 (= X30 (- (* 281 S2) (* 217 S3)))
 (= X30 (+ (* 217 S2) (* 1191 S3)))
 (= X30 (- (* 217 S2) (* 1191 S3)))
 (= X30 (- (* 1191 S2) (* 217 S3)))
 (= X30 (+ (* 217 S2) (* 1945 S3)))
 (= X30 (- (* 217 S2) (* 1945 S3)))
 (= X30 (- (* 1945 S2) (* 217 S3)))
 (= X30 (+ (* 217 S2) (* 775 S3)))
 (= X30 (- (* 217 S2) (* 775 S3)))
 (= X30 (- (* 775 S2) (* 217 S3)))
 (= X30 (+ (* 217 S2) (* 1367 S3)))
 (= X30 (- (* 217 S2) (* 1367 S3)))
 (= X30 (- (* 1367 S2) (* 217 S3)))
 (= X30 (+ (* 217 S2) (* 1015 S3)))
 (= X30 (- (* 217 S2) (* 1015 S3)))
 (= X30 (- (* 1015 S2) (* 217 S3)))
 (= X30 (+ (* 217 S2) (* 173 S3)))
 (= X30 (- (* 217 S2) (* 173 S3)))
 (= X30 (- (* 173 S2) (* 217 S3)))
 (= X30 (+ (* 217 S2) (* 1097 S3)))
 (= X30 (- (* 217 S2) (* 1097 S3)))
 (= X30 (- (* 1097 S2) (* 217 S3)))
 (= X30 (+ (* 217 S2) (* 973 S3)))
 (= X30 (- (* 217 S2) (* 973 S3)))
 (= X30 (- (* 973 S2) (* 217 S3)))
 (= X30 (+ (* 217 S2) (* 1517 S3)))
 (= X30 (- (* 217 S2) (* 1517 S3)))
 (= X30 (- (* 1517 S2) (* 217 S3)))
 (= X30 (+ (* 217 S2) (* 493 S3)))
 (= X30 (- (* 217 S2) (* 493 S3)))
 (= X30 (- (* 493 S2) (* 217 S3)))
 (= X30 (+ (* 217 S2) (* 379 S3)))
 (= X30 (- (* 217 S2) (* 379 S3)))
 (= X30 (- (* 379 S2) (* 217 S3)))
 (= X30 (+ (* 217 S2) (* 577 S3)))
 (= X30 (- (* 217 S2) (* 577 S3)))
 (= X30 (- (* 577 S2) (* 217 S3)))
 (= X30 (+ (* 217 S2) (* 271 S3)))
 (= X30 (- (* 217 S2) (* 271 S3)))
 (= X30 (- (* 271 S2) (* 217 S3)))
 (= X30 (+ (* 217 S2) (* 653 S3)))
 (= X30 (- (* 217 S2) (* 653 S3)))
 (= X30 (- (* 653 S2) (* 217 S3)))
 (= X30 (+ (* 217 S2) (* 1395 S3)))
 (= X30 (- (* 217 S2) (* 1395 S3)))
 (= X30 (- (* 1395 S2) (* 217 S3)))
 (= X30 (+ (* 217 S2) (* 747 S3)))
 (= X30 (- (* 217 S2) (* 747 S3)))
 (= X30 (- (* 747 S2) (* 217 S3)))
 (= X30 (+ (* 217 S2) (* 1803 S3)))
 (= X30 (- (* 217 S2) (* 1803 S3)))
 (= X30 (- (* 1803 S2) (* 217 S3)))
 (= X30 (+ (* 217 S2) (* 933 S3)))
 (= X30 (- (* 217 S2) (* 933 S3)))
 (= X30 (- (* 933 S2) (* 217 S3)))
 (= X30 (+ (* 217 S2) (* 1041 S3)))
 (= X30 (- (* 217 S2) (* 1041 S3)))
 (= X30 (- (* 1041 S2) (* 217 S3)))
 (= X30 (+ (* 217 S2) (* X29 S3)))
 (= X30 (- (* 217 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 217 S3)))
 (= X30 (+ (* 295 S2) S3))
 (= X30 (- (* 295 S2) S3))
 (= X30 (- S2 (* 295 S3)))
 (= X30 (+ (* 295 S2) (* 295 S3)))
 (= X30 (- (* 295 S2) (* 295 S3)))
 (= X30 (+ (* 295 S2) (* 167 S3)))
 (= X30 (- (* 295 S2) (* 167 S3)))
 (= X30 (- (* 167 S2) (* 295 S3)))
 (= X30 (+ (* 295 S2) (* 1313 S3)))
 (= X30 (- (* 295 S2) (* 1313 S3)))
 (= X30 (- (* 1313 S2) (* 295 S3)))
 (= X30 (+ (* 295 S2) (* 281 S3)))
 (= X30 (- (* 295 S2) (* 281 S3)))
 (= X30 (- (* 281 S2) (* 295 S3)))
 (= X30 (+ (* 295 S2) (* 1191 S3)))
 (= X30 (- (* 295 S2) (* 1191 S3)))
 (= X30 (- (* 1191 S2) (* 295 S3)))
 (= X30 (+ (* 295 S2) (* 1945 S3)))
 (= X30 (- (* 295 S2) (* 1945 S3)))
 (= X30 (- (* 1945 S2) (* 295 S3)))
 (= X30 (+ (* 295 S2) (* 775 S3)))
 (= X30 (- (* 295 S2) (* 775 S3)))
 (= X30 (- (* 775 S2) (* 295 S3)))
 (= X30 (+ (* 295 S2) (* 1367 S3)))
 (= X30 (- (* 295 S2) (* 1367 S3)))
 (= X30 (- (* 1367 S2) (* 295 S3)))
 (= X30 (+ (* 295 S2) (* 1015 S3)))
 (= X30 (- (* 295 S2) (* 1015 S3)))
 (= X30 (- (* 1015 S2) (* 295 S3)))
 (= X30 (+ (* 295 S2) (* 173 S3)))
 (= X30 (- (* 295 S2) (* 173 S3)))
 (= X30 (- (* 173 S2) (* 295 S3)))
 (= X30 (+ (* 295 S2) (* 1097 S3)))
 (= X30 (- (* 295 S2) (* 1097 S3)))
 (= X30 (- (* 1097 S2) (* 295 S3)))
 (= X30 (+ (* 295 S2) (* 973 S3)))
 (= X30 (- (* 295 S2) (* 973 S3)))
 (= X30 (- (* 973 S2) (* 295 S3)))
 (= X30 (+ (* 295 S2) (* 1517 S3)))
 (= X30 (- (* 295 S2) (* 1517 S3)))
 (= X30 (- (* 1517 S2) (* 295 S3)))
 (= X30 (+ (* 295 S2) (* 493 S3)))
 (= X30 (- (* 295 S2) (* 493 S3)))
 (= X30 (- (* 493 S2) (* 295 S3)))
 (= X30 (+ (* 295 S2) (* 379 S3)))
 (= X30 (- (* 295 S2) (* 379 S3)))
 (= X30 (- (* 379 S2) (* 295 S3)))
 (= X30 (+ (* 295 S2) (* 577 S3)))
 (= X30 (- (* 295 S2) (* 577 S3)))
 (= X30 (- (* 577 S2) (* 295 S3)))
 (= X30 (+ (* 295 S2) (* 271 S3)))
 (= X30 (- (* 295 S2) (* 271 S3)))
 (= X30 (- (* 271 S2) (* 295 S3)))
 (= X30 (+ (* 295 S2) (* 653 S3)))
 (= X30 (- (* 295 S2) (* 653 S3)))
 (= X30 (- (* 653 S2) (* 295 S3)))
 (= X30 (+ (* 295 S2) (* 1395 S3)))
 (= X30 (- (* 295 S2) (* 1395 S3)))
 (= X30 (- (* 1395 S2) (* 295 S3)))
 (= X30 (+ (* 295 S2) (* 747 S3)))
 (= X30 (- (* 295 S2) (* 747 S3)))
 (= X30 (- (* 747 S2) (* 295 S3)))
 (= X30 (+ (* 295 S2) (* 1803 S3)))
 (= X30 (- (* 295 S2) (* 1803 S3)))
 (= X30 (- (* 1803 S2) (* 295 S3)))
 (= X30 (+ (* 295 S2) (* 933 S3)))
 (= X30 (- (* 295 S2) (* 933 S3)))
 (= X30 (- (* 933 S2) (* 295 S3)))
 (= X30 (+ (* 295 S2) (* 1041 S3)))
 (= X30 (- (* 295 S2) (* 1041 S3)))
 (= X30 (- (* 1041 S2) (* 295 S3)))
 (= X30 (+ (* 295 S2) (* X29 S3)))
 (= X30 (- (* 295 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 295 S3)))
 (= X30 (+ (* 167 S2) S3))
 (= X30 (- (* 167 S2) S3))
 (= X30 (- S2 (* 167 S3)))
 (= X30 (+ (* 167 S2) (* 167 S3)))
 (= X30 (- (* 167 S2) (* 167 S3)))
 (= X30 (+ (* 167 S2) (* 1313 S3)))
 (= X30 (- (* 167 S2) (* 1313 S3)))
 (= X30 (- (* 1313 S2) (* 167 S3)))
 (= X30 (+ (* 167 S2) (* 281 S3)))
 (= X30 (- (* 167 S2) (* 281 S3)))
 (= X30 (- (* 281 S2) (* 167 S3)))
 (= X30 (+ (* 167 S2) (* 1191 S3)))
 (= X30 (- (* 167 S2) (* 1191 S3)))
 (= X30 (- (* 1191 S2) (* 167 S3)))
 (= X30 (+ (* 167 S2) (* 1945 S3)))
 (= X30 (- (* 167 S2) (* 1945 S3)))
 (= X30 (- (* 1945 S2) (* 167 S3)))
 (= X30 (+ (* 167 S2) (* 775 S3)))
 (= X30 (- (* 167 S2) (* 775 S3)))
 (= X30 (- (* 775 S2) (* 167 S3)))
 (= X30 (+ (* 167 S2) (* 1367 S3)))
 (= X30 (- (* 167 S2) (* 1367 S3)))
 (= X30 (- (* 1367 S2) (* 167 S3)))
 (= X30 (+ (* 167 S2) (* 1015 S3)))
 (= X30 (- (* 167 S2) (* 1015 S3)))
 (= X30 (- (* 1015 S2) (* 167 S3)))
 (= X30 (+ (* 167 S2) (* 173 S3)))
 (= X30 (- (* 167 S2) (* 173 S3)))
 (= X30 (- (* 173 S2) (* 167 S3)))
 (= X30 (+ (* 167 S2) (* 1097 S3)))
 (= X30 (- (* 167 S2) (* 1097 S3)))
 (= X30 (- (* 1097 S2) (* 167 S3)))
 (= X30 (+ (* 167 S2) (* 973 S3)))
 (= X30 (- (* 167 S2) (* 973 S3)))
 (= X30 (- (* 973 S2) (* 167 S3)))
 (= X30 (+ (* 167 S2) (* 1517 S3)))
 (= X30 (- (* 167 S2) (* 1517 S3)))
 (= X30 (- (* 1517 S2) (* 167 S3)))
 (= X30 (+ (* 167 S2) (* 493 S3)))
 (= X30 (- (* 167 S2) (* 493 S3)))
 (= X30 (- (* 493 S2) (* 167 S3)))
 (= X30 (+ (* 167 S2) (* 379 S3)))
 (= X30 (- (* 167 S2) (* 379 S3)))
 (= X30 (- (* 379 S2) (* 167 S3)))
 (= X30 (+ (* 167 S2) (* 577 S3)))
 (= X30 (- (* 167 S2) (* 577 S3)))
 (= X30 (- (* 577 S2) (* 167 S3)))
 (= X30 (+ (* 167 S2) (* 271 S3)))
 (= X30 (- (* 167 S2) (* 271 S3)))
 (= X30 (- (* 271 S2) (* 167 S3)))
 (= X30 (+ (* 167 S2) (* 653 S3)))
 (= X30 (- (* 167 S2) (* 653 S3)))
 (= X30 (- (* 653 S2) (* 167 S3)))
 (= X30 (+ (* 167 S2) (* 1395 S3)))
 (= X30 (- (* 167 S2) (* 1395 S3)))
 (= X30 (- (* 1395 S2) (* 167 S3)))
 (= X30 (+ (* 167 S2) (* 747 S3)))
 (= X30 (- (* 167 S2) (* 747 S3)))
 (= X30 (- (* 747 S2) (* 167 S3)))
 (= X30 (+ (* 167 S2) (* 1803 S3)))
 (= X30 (- (* 167 S2) (* 1803 S3)))
 (= X30 (- (* 1803 S2) (* 167 S3)))
 (= X30 (+ (* 167 S2) (* 933 S3)))
 (= X30 (- (* 167 S2) (* 933 S3)))
 (= X30 (- (* 933 S2) (* 167 S3)))
 (= X30 (+ (* 167 S2) (* 1041 S3)))
 (= X30 (- (* 167 S2) (* 1041 S3)))
 (= X30 (- (* 1041 S2) (* 167 S3)))
 (= X30 (+ (* 167 S2) (* X29 S3)))
 (= X30 (- (* 167 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 167 S3)))
 (= X30 (+ (* 1313 S2) S3))
 (= X30 (- (* 1313 S2) S3))
 (= X30 (- S2 (* 1313 S3)))
 (= X30 (+ (* 1313 S2) (* 1313 S3)))
 (= X30 (- (* 1313 S2) (* 1313 S3)))
 (= X30 (+ (* 1313 S2) (* 281 S3)))
 (= X30 (- (* 1313 S2) (* 281 S3)))
 (= X30 (- (* 281 S2) (* 1313 S3)))
 (= X30 (+ (* 1313 S2) (* 1191 S3)))
 (= X30 (- (* 1313 S2) (* 1191 S3)))
 (= X30 (- (* 1191 S2) (* 1313 S3)))
 (= X30 (+ (* 1313 S2) (* 1945 S3)))
 (= X30 (- (* 1313 S2) (* 1945 S3)))
 (= X30 (- (* 1945 S2) (* 1313 S3)))
 (= X30 (+ (* 1313 S2) (* 775 S3)))
 (= X30 (- (* 1313 S2) (* 775 S3)))
 (= X30 (- (* 775 S2) (* 1313 S3)))
 (= X30 (+ (* 1313 S2) (* 1367 S3)))
 (= X30 (- (* 1313 S2) (* 1367 S3)))
 (= X30 (- (* 1367 S2) (* 1313 S3)))
 (= X30 (+ (* 1313 S2) (* 1015 S3)))
 (= X30 (- (* 1313 S2) (* 1015 S3)))
 (= X30 (- (* 1015 S2) (* 1313 S3)))
 (= X30 (+ (* 1313 S2) (* 173 S3)))
 (= X30 (- (* 1313 S2) (* 173 S3)))
 (= X30 (- (* 173 S2) (* 1313 S3)))
 (= X30 (+ (* 1313 S2) (* 1097 S3)))
 (= X30 (- (* 1313 S2) (* 1097 S3)))
 (= X30 (- (* 1097 S2) (* 1313 S3)))
 (= X30 (+ (* 1313 S2) (* 973 S3)))
 (= X30 (- (* 1313 S2) (* 973 S3)))
 (= X30 (- (* 973 S2) (* 1313 S3)))
 (= X30 (+ (* 1313 S2) (* 1517 S3)))
 (= X30 (- (* 1313 S2) (* 1517 S3)))
 (= X30 (- (* 1517 S2) (* 1313 S3)))
 (= X30 (+ (* 1313 S2) (* 493 S3)))
 (= X30 (- (* 1313 S2) (* 493 S3)))
 (= X30 (- (* 493 S2) (* 1313 S3)))
 (= X30 (+ (* 1313 S2) (* 379 S3)))
 (= X30 (- (* 1313 S2) (* 379 S3)))
 (= X30 (- (* 379 S2) (* 1313 S3)))
 (= X30 (+ (* 1313 S2) (* 577 S3)))
 (= X30 (- (* 1313 S2) (* 577 S3)))
 (= X30 (- (* 577 S2) (* 1313 S3)))
 (= X30 (+ (* 1313 S2) (* 271 S3)))
 (= X30 (- (* 1313 S2) (* 271 S3)))
 (= X30 (- (* 271 S2) (* 1313 S3)))
 (= X30 (+ (* 1313 S2) (* 653 S3)))
 (= X30 (- (* 1313 S2) (* 653 S3)))
 (= X30 (- (* 653 S2) (* 1313 S3)))
 (= X30 (+ (* 1313 S2) (* 1395 S3)))
 (= X30 (- (* 1313 S2) (* 1395 S3)))
 (= X30 (- (* 1395 S2) (* 1313 S3)))
 (= X30 (+ (* 1313 S2) (* 747 S3)))
 (= X30 (- (* 1313 S2) (* 747 S3)))
 (= X30 (- (* 747 S2) (* 1313 S3)))
 (= X30 (+ (* 1313 S2) (* 1803 S3)))
 (= X30 (- (* 1313 S2) (* 1803 S3)))
 (= X30 (- (* 1803 S2) (* 1313 S3)))
 (= X30 (+ (* 1313 S2) (* 933 S3)))
 (= X30 (- (* 1313 S2) (* 933 S3)))
 (= X30 (- (* 933 S2) (* 1313 S3)))
 (= X30 (+ (* 1313 S2) (* 1041 S3)))
 (= X30 (- (* 1313 S2) (* 1041 S3)))
 (= X30 (- (* 1041 S2) (* 1313 S3)))
 (= X30 (+ (* 1313 S2) (* X29 S3)))
 (= X30 (- (* 1313 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 1313 S3)))
 (= X30 (+ (* 281 S2) S3))
 (= X30 (- (* 281 S2) S3))
 (= X30 (- S2 (* 281 S3)))
 (= X30 (+ (* 281 S2) (* 281 S3)))
 (= X30 (- (* 281 S2) (* 281 S3)))
 (= X30 (+ (* 281 S2) (* 1191 S3)))
 (= X30 (- (* 281 S2) (* 1191 S3)))
 (= X30 (- (* 1191 S2) (* 281 S3)))
 (= X30 (+ (* 281 S2) (* 1945 S3)))
 (= X30 (- (* 281 S2) (* 1945 S3)))
 (= X30 (- (* 1945 S2) (* 281 S3)))
 (= X30 (+ (* 281 S2) (* 775 S3)))
 (= X30 (- (* 281 S2) (* 775 S3)))
 (= X30 (- (* 775 S2) (* 281 S3)))
 (= X30 (+ (* 281 S2) (* 1367 S3)))
 (= X30 (- (* 281 S2) (* 1367 S3)))
 (= X30 (- (* 1367 S2) (* 281 S3)))
 (= X30 (+ (* 281 S2) (* 1015 S3)))
 (= X30 (- (* 281 S2) (* 1015 S3)))
 (= X30 (- (* 1015 S2) (* 281 S3)))
 (= X30 (+ (* 281 S2) (* 173 S3)))
 (= X30 (- (* 281 S2) (* 173 S3)))
 (= X30 (- (* 173 S2) (* 281 S3)))
 (= X30 (+ (* 281 S2) (* 1097 S3)))
 (= X30 (- (* 281 S2) (* 1097 S3)))
 (= X30 (- (* 1097 S2) (* 281 S3)))
 (= X30 (+ (* 281 S2) (* 973 S3)))
 (= X30 (- (* 281 S2) (* 973 S3)))
 (= X30 (- (* 973 S2) (* 281 S3)))
 (= X30 (+ (* 281 S2) (* 1517 S3)))
 (= X30 (- (* 281 S2) (* 1517 S3)))
 (= X30 (- (* 1517 S2) (* 281 S3)))
 (= X30 (+ (* 281 S2) (* 493 S3)))
 (= X30 (- (* 281 S2) (* 493 S3)))
 (= X30 (- (* 493 S2) (* 281 S3)))
 (= X30 (+ (* 281 S2) (* 379 S3)))
 (= X30 (- (* 281 S2) (* 379 S3)))
 (= X30 (- (* 379 S2) (* 281 S3)))
 (= X30 (+ (* 281 S2) (* 577 S3)))
 (= X30 (- (* 281 S2) (* 577 S3)))
 (= X30 (- (* 577 S2) (* 281 S3)))
 (= X30 (+ (* 281 S2) (* 271 S3)))
 (= X30 (- (* 281 S2) (* 271 S3)))
 (= X30 (- (* 271 S2) (* 281 S3)))
 (= X30 (+ (* 281 S2) (* 653 S3)))
 (= X30 (- (* 281 S2) (* 653 S3)))
 (= X30 (- (* 653 S2) (* 281 S3)))
 (= X30 (+ (* 281 S2) (* 1395 S3)))
 (= X30 (- (* 281 S2) (* 1395 S3)))
 (= X30 (- (* 1395 S2) (* 281 S3)))
 (= X30 (+ (* 281 S2) (* 747 S3)))
 (= X30 (- (* 281 S2) (* 747 S3)))
 (= X30 (- (* 747 S2) (* 281 S3)))
 (= X30 (+ (* 281 S2) (* 1803 S3)))
 (= X30 (- (* 281 S2) (* 1803 S3)))
 (= X30 (- (* 1803 S2) (* 281 S3)))
 (= X30 (+ (* 281 S2) (* 933 S3)))
 (= X30 (- (* 281 S2) (* 933 S3)))
 (= X30 (- (* 933 S2) (* 281 S3)))
 (= X30 (+ (* 281 S2) (* 1041 S3)))
 (= X30 (- (* 281 S2) (* 1041 S3)))
 (= X30 (- (* 1041 S2) (* 281 S3)))
 (= X30 (+ (* 281 S2) (* X29 S3)))
 (= X30 (- (* 281 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 281 S3)))
 (= X30 (+ (* 1191 S2) S3))
 (= X30 (- (* 1191 S2) S3))
 (= X30 (- S2 (* 1191 S3)))
 (= X30 (+ (* 1191 S2) (* 1191 S3)))
 (= X30 (- (* 1191 S2) (* 1191 S3)))
 (= X30 (+ (* 1191 S2) (* 1945 S3)))
 (= X30 (- (* 1191 S2) (* 1945 S3)))
 (= X30 (- (* 1945 S2) (* 1191 S3)))
 (= X30 (+ (* 1191 S2) (* 775 S3)))
 (= X30 (- (* 1191 S2) (* 775 S3)))
 (= X30 (- (* 775 S2) (* 1191 S3)))
 (= X30 (+ (* 1191 S2) (* 1367 S3)))
 (= X30 (- (* 1191 S2) (* 1367 S3)))
 (= X30 (- (* 1367 S2) (* 1191 S3)))
 (= X30 (+ (* 1191 S2) (* 1015 S3)))
 (= X30 (- (* 1191 S2) (* 1015 S3)))
 (= X30 (- (* 1015 S2) (* 1191 S3)))
 (= X30 (+ (* 1191 S2) (* 173 S3)))
 (= X30 (- (* 1191 S2) (* 173 S3)))
 (= X30 (- (* 173 S2) (* 1191 S3)))
 (= X30 (+ (* 1191 S2) (* 1097 S3)))
 (= X30 (- (* 1191 S2) (* 1097 S3)))
 (= X30 (- (* 1097 S2) (* 1191 S3)))
 (= X30 (+ (* 1191 S2) (* 973 S3)))
 (= X30 (- (* 1191 S2) (* 973 S3)))
 (= X30 (- (* 973 S2) (* 1191 S3)))
 (= X30 (+ (* 1191 S2) (* 1517 S3)))
 (= X30 (- (* 1191 S2) (* 1517 S3)))
 (= X30 (- (* 1517 S2) (* 1191 S3)))
 (= X30 (+ (* 1191 S2) (* 493 S3)))
 (= X30 (- (* 1191 S2) (* 493 S3)))
 (= X30 (- (* 493 S2) (* 1191 S3)))
 (= X30 (+ (* 1191 S2) (* 379 S3)))
 (= X30 (- (* 1191 S2) (* 379 S3)))
 (= X30 (- (* 379 S2) (* 1191 S3)))
 (= X30 (+ (* 1191 S2) (* 577 S3)))
 (= X30 (- (* 1191 S2) (* 577 S3)))
 (= X30 (- (* 577 S2) (* 1191 S3)))
 (= X30 (+ (* 1191 S2) (* 271 S3)))
 (= X30 (- (* 1191 S2) (* 271 S3)))
 (= X30 (- (* 271 S2) (* 1191 S3)))
 (= X30 (+ (* 1191 S2) (* 653 S3)))
 (= X30 (- (* 1191 S2) (* 653 S3)))
 (= X30 (- (* 653 S2) (* 1191 S3)))
 (= X30 (+ (* 1191 S2) (* 1395 S3)))
 (= X30 (- (* 1191 S2) (* 1395 S3)))
 (= X30 (- (* 1395 S2) (* 1191 S3)))
 (= X30 (+ (* 1191 S2) (* 747 S3)))
 (= X30 (- (* 1191 S2) (* 747 S3)))
 (= X30 (- (* 747 S2) (* 1191 S3)))
 (= X30 (+ (* 1191 S2) (* 1803 S3)))
 (= X30 (- (* 1191 S2) (* 1803 S3)))
 (= X30 (- (* 1803 S2) (* 1191 S3)))
 (= X30 (+ (* 1191 S2) (* 933 S3)))
 (= X30 (- (* 1191 S2) (* 933 S3)))
 (= X30 (- (* 933 S2) (* 1191 S3)))
 (= X30 (+ (* 1191 S2) (* 1041 S3)))
 (= X30 (- (* 1191 S2) (* 1041 S3)))
 (= X30 (- (* 1041 S2) (* 1191 S3)))
 (= X30 (+ (* 1191 S2) (* X29 S3)))
 (= X30 (- (* 1191 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 1191 S3)))
 (= X30 (+ (* 1945 S2) S3))
 (= X30 (- (* 1945 S2) S3))
 (= X30 (- S2 (* 1945 S3)))
 (= X30 (+ (* 1945 S2) (* 1945 S3)))
 (= X30 (- (* 1945 S2) (* 1945 S3)))
 (= X30 (+ (* 1945 S2) (* 775 S3)))
 (= X30 (- (* 1945 S2) (* 775 S3)))
 (= X30 (- (* 775 S2) (* 1945 S3)))
 (= X30 (+ (* 1945 S2) (* 1367 S3)))
 (= X30 (- (* 1945 S2) (* 1367 S3)))
 (= X30 (- (* 1367 S2) (* 1945 S3)))
 (= X30 (+ (* 1945 S2) (* 1015 S3)))
 (= X30 (- (* 1945 S2) (* 1015 S3)))
 (= X30 (- (* 1015 S2) (* 1945 S3)))
 (= X30 (+ (* 1945 S2) (* 173 S3)))
 (= X30 (- (* 1945 S2) (* 173 S3)))
 (= X30 (- (* 173 S2) (* 1945 S3)))
 (= X30 (+ (* 1945 S2) (* 1097 S3)))
 (= X30 (- (* 1945 S2) (* 1097 S3)))
 (= X30 (- (* 1097 S2) (* 1945 S3)))
 (= X30 (+ (* 1945 S2) (* 973 S3)))
 (= X30 (- (* 1945 S2) (* 973 S3)))
 (= X30 (- (* 973 S2) (* 1945 S3)))
 (= X30 (+ (* 1945 S2) (* 1517 S3)))
 (= X30 (- (* 1945 S2) (* 1517 S3)))
 (= X30 (- (* 1517 S2) (* 1945 S3)))
 (= X30 (+ (* 1945 S2) (* 493 S3)))
 (= X30 (- (* 1945 S2) (* 493 S3)))
 (= X30 (- (* 493 S2) (* 1945 S3)))
 (= X30 (+ (* 1945 S2) (* 379 S3)))
 (= X30 (- (* 1945 S2) (* 379 S3)))
 (= X30 (- (* 379 S2) (* 1945 S3)))
 (= X30 (+ (* 1945 S2) (* 577 S3)))
 (= X30 (- (* 1945 S2) (* 577 S3)))
 (= X30 (- (* 577 S2) (* 1945 S3)))
 (= X30 (+ (* 1945 S2) (* 271 S3)))
 (= X30 (- (* 1945 S2) (* 271 S3)))
 (= X30 (- (* 271 S2) (* 1945 S3)))
 (= X30 (+ (* 1945 S2) (* 653 S3)))
 (= X30 (- (* 1945 S2) (* 653 S3)))
 (= X30 (- (* 653 S2) (* 1945 S3)))
 (= X30 (+ (* 1945 S2) (* 1395 S3)))
 (= X30 (- (* 1945 S2) (* 1395 S3)))
 (= X30 (- (* 1395 S2) (* 1945 S3)))
 (= X30 (+ (* 1945 S2) (* 747 S3)))
 (= X30 (- (* 1945 S2) (* 747 S3)))
 (= X30 (- (* 747 S2) (* 1945 S3)))
 (= X30 (+ (* 1945 S2) (* 1803 S3)))
 (= X30 (- (* 1945 S2) (* 1803 S3)))
 (= X30 (- (* 1803 S2) (* 1945 S3)))
 (= X30 (+ (* 1945 S2) (* 933 S3)))
 (= X30 (- (* 1945 S2) (* 933 S3)))
 (= X30 (- (* 933 S2) (* 1945 S3)))
 (= X30 (+ (* 1945 S2) (* 1041 S3)))
 (= X30 (- (* 1945 S2) (* 1041 S3)))
 (= X30 (- (* 1041 S2) (* 1945 S3)))
 (= X30 (+ (* 1945 S2) (* X29 S3)))
 (= X30 (- (* 1945 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 1945 S3)))
 (= X30 (+ (* 775 S2) S3))
 (= X30 (- (* 775 S2) S3))
 (= X30 (- S2 (* 775 S3)))
 (= X30 (+ (* 775 S2) (* 775 S3)))
 (= X30 (- (* 775 S2) (* 775 S3)))
 (= X30 (+ (* 775 S2) (* 1367 S3)))
 (= X30 (- (* 775 S2) (* 1367 S3)))
 (= X30 (- (* 1367 S2) (* 775 S3)))
 (= X30 (+ (* 775 S2) (* 1015 S3)))
 (= X30 (- (* 775 S2) (* 1015 S3)))
 (= X30 (- (* 1015 S2) (* 775 S3)))
 (= X30 (+ (* 775 S2) (* 173 S3)))
 (= X30 (- (* 775 S2) (* 173 S3)))
 (= X30 (- (* 173 S2) (* 775 S3)))
 (= X30 (+ (* 775 S2) (* 1097 S3)))
 (= X30 (- (* 775 S2) (* 1097 S3)))
 (= X30 (- (* 1097 S2) (* 775 S3)))
 (= X30 (+ (* 775 S2) (* 973 S3)))
 (= X30 (- (* 775 S2) (* 973 S3)))
 (= X30 (- (* 973 S2) (* 775 S3)))
 (= X30 (+ (* 775 S2) (* 1517 S3)))
 (= X30 (- (* 775 S2) (* 1517 S3)))
 (= X30 (- (* 1517 S2) (* 775 S3)))
 (= X30 (+ (* 775 S2) (* 493 S3)))
 (= X30 (- (* 775 S2) (* 493 S3)))
 (= X30 (- (* 493 S2) (* 775 S3)))
 (= X30 (+ (* 775 S2) (* 379 S3)))
 (= X30 (- (* 775 S2) (* 379 S3)))
 (= X30 (- (* 379 S2) (* 775 S3)))
 (= X30 (+ (* 775 S2) (* 577 S3)))
 (= X30 (- (* 775 S2) (* 577 S3)))
 (= X30 (- (* 577 S2) (* 775 S3)))
 (= X30 (+ (* 775 S2) (* 271 S3)))
 (= X30 (- (* 775 S2) (* 271 S3)))
 (= X30 (- (* 271 S2) (* 775 S3)))
 (= X30 (+ (* 775 S2) (* 653 S3)))
 (= X30 (- (* 775 S2) (* 653 S3)))
 (= X30 (- (* 653 S2) (* 775 S3)))
 (= X30 (+ (* 775 S2) (* 1395 S3)))
 (= X30 (- (* 775 S2) (* 1395 S3)))
 (= X30 (- (* 1395 S2) (* 775 S3)))
 (= X30 (+ (* 775 S2) (* 747 S3)))
 (= X30 (- (* 775 S2) (* 747 S3)))
 (= X30 (- (* 747 S2) (* 775 S3)))
 (= X30 (+ (* 775 S2) (* 1803 S3)))
 (= X30 (- (* 775 S2) (* 1803 S3)))
 (= X30 (- (* 1803 S2) (* 775 S3)))
 (= X30 (+ (* 775 S2) (* 933 S3)))
 (= X30 (- (* 775 S2) (* 933 S3)))
 (= X30 (- (* 933 S2) (* 775 S3)))
 (= X30 (+ (* 775 S2) (* 1041 S3)))
 (= X30 (- (* 775 S2) (* 1041 S3)))
 (= X30 (- (* 1041 S2) (* 775 S3)))
 (= X30 (+ (* 775 S2) (* X29 S3)))
 (= X30 (- (* 775 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 775 S3)))
 (= X30 (+ (* 1367 S2) S3))
 (= X30 (- (* 1367 S2) S3))
 (= X30 (- S2 (* 1367 S3)))
 (= X30 (+ (* 1367 S2) (* 1367 S3)))
 (= X30 (- (* 1367 S2) (* 1367 S3)))
 (= X30 (+ (* 1367 S2) (* 1015 S3)))
 (= X30 (- (* 1367 S2) (* 1015 S3)))
 (= X30 (- (* 1015 S2) (* 1367 S3)))
 (= X30 (+ (* 1367 S2) (* 173 S3)))
 (= X30 (- (* 1367 S2) (* 173 S3)))
 (= X30 (- (* 173 S2) (* 1367 S3)))
 (= X30 (+ (* 1367 S2) (* 1097 S3)))
 (= X30 (- (* 1367 S2) (* 1097 S3)))
 (= X30 (- (* 1097 S2) (* 1367 S3)))
 (= X30 (+ (* 1367 S2) (* 973 S3)))
 (= X30 (- (* 1367 S2) (* 973 S3)))
 (= X30 (- (* 973 S2) (* 1367 S3)))
 (= X30 (+ (* 1367 S2) (* 1517 S3)))
 (= X30 (- (* 1367 S2) (* 1517 S3)))
 (= X30 (- (* 1517 S2) (* 1367 S3)))
 (= X30 (+ (* 1367 S2) (* 493 S3)))
 (= X30 (- (* 1367 S2) (* 493 S3)))
 (= X30 (- (* 493 S2) (* 1367 S3)))
 (= X30 (+ (* 1367 S2) (* 379 S3)))
 (= X30 (- (* 1367 S2) (* 379 S3)))
 (= X30 (- (* 379 S2) (* 1367 S3)))
 (= X30 (+ (* 1367 S2) (* 577 S3)))
 (= X30 (- (* 1367 S2) (* 577 S3)))
 (= X30 (- (* 577 S2) (* 1367 S3)))
 (= X30 (+ (* 1367 S2) (* 271 S3)))
 (= X30 (- (* 1367 S2) (* 271 S3)))
 (= X30 (- (* 271 S2) (* 1367 S3)))
 (= X30 (+ (* 1367 S2) (* 653 S3)))
 (= X30 (- (* 1367 S2) (* 653 S3)))
 (= X30 (- (* 653 S2) (* 1367 S3)))
 (= X30 (+ (* 1367 S2) (* 1395 S3)))
 (= X30 (- (* 1367 S2) (* 1395 S3)))
 (= X30 (- (* 1395 S2) (* 1367 S3)))
 (= X30 (+ (* 1367 S2) (* 747 S3)))
 (= X30 (- (* 1367 S2) (* 747 S3)))
 (= X30 (- (* 747 S2) (* 1367 S3)))
 (= X30 (+ (* 1367 S2) (* 1803 S3)))
 (= X30 (- (* 1367 S2) (* 1803 S3)))
 (= X30 (- (* 1803 S2) (* 1367 S3)))
 (= X30 (+ (* 1367 S2) (* 933 S3)))
 (= X30 (- (* 1367 S2) (* 933 S3)))
 (= X30 (- (* 933 S2) (* 1367 S3)))
 (= X30 (+ (* 1367 S2) (* 1041 S3)))
 (= X30 (- (* 1367 S2) (* 1041 S3)))
 (= X30 (- (* 1041 S2) (* 1367 S3)))
 (= X30 (+ (* 1367 S2) (* X29 S3)))
 (= X30 (- (* 1367 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 1367 S3)))
 (= X30 (+ (* 1015 S2) S3))
 (= X30 (- (* 1015 S2) S3))
 (= X30 (- S2 (* 1015 S3)))
 (= X30 (+ (* 1015 S2) (* 1015 S3)))
 (= X30 (- (* 1015 S2) (* 1015 S3)))
 (= X30 (+ (* 1015 S2) (* 173 S3)))
 (= X30 (- (* 1015 S2) (* 173 S3)))
 (= X30 (- (* 173 S2) (* 1015 S3)))
 (= X30 (+ (* 1015 S2) (* 1097 S3)))
 (= X30 (- (* 1015 S2) (* 1097 S3)))
 (= X30 (- (* 1097 S2) (* 1015 S3)))
 (= X30 (+ (* 1015 S2) (* 973 S3)))
 (= X30 (- (* 1015 S2) (* 973 S3)))
 (= X30 (- (* 973 S2) (* 1015 S3)))
 (= X30 (+ (* 1015 S2) (* 1517 S3)))
 (= X30 (- (* 1015 S2) (* 1517 S3)))
 (= X30 (- (* 1517 S2) (* 1015 S3)))
 (= X30 (+ (* 1015 S2) (* 493 S3)))
 (= X30 (- (* 1015 S2) (* 493 S3)))
 (= X30 (- (* 493 S2) (* 1015 S3)))
 (= X30 (+ (* 1015 S2) (* 379 S3)))
 (= X30 (- (* 1015 S2) (* 379 S3)))
 (= X30 (- (* 379 S2) (* 1015 S3)))
 (= X30 (+ (* 1015 S2) (* 577 S3)))
 (= X30 (- (* 1015 S2) (* 577 S3)))
 (= X30 (- (* 577 S2) (* 1015 S3)))
 (= X30 (+ (* 1015 S2) (* 271 S3)))
 (= X30 (- (* 1015 S2) (* 271 S3)))
 (= X30 (- (* 271 S2) (* 1015 S3)))
 (= X30 (+ (* 1015 S2) (* 653 S3)))
 (= X30 (- (* 1015 S2) (* 653 S3)))
 (= X30 (- (* 653 S2) (* 1015 S3)))
 (= X30 (+ (* 1015 S2) (* 1395 S3)))
 (= X30 (- (* 1015 S2) (* 1395 S3)))
 (= X30 (- (* 1395 S2) (* 1015 S3)))
 (= X30 (+ (* 1015 S2) (* 747 S3)))
 (= X30 (- (* 1015 S2) (* 747 S3)))
 (= X30 (- (* 747 S2) (* 1015 S3)))
 (= X30 (+ (* 1015 S2) (* 1803 S3)))
 (= X30 (- (* 1015 S2) (* 1803 S3)))
 (= X30 (- (* 1803 S2) (* 1015 S3)))
 (= X30 (+ (* 1015 S2) (* 933 S3)))
 (= X30 (- (* 1015 S2) (* 933 S3)))
 (= X30 (- (* 933 S2) (* 1015 S3)))
 (= X30 (+ (* 1015 S2) (* 1041 S3)))
 (= X30 (- (* 1015 S2) (* 1041 S3)))
 (= X30 (- (* 1041 S2) (* 1015 S3)))
 (= X30 (+ (* 1015 S2) (* X29 S3)))
 (= X30 (- (* 1015 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 1015 S3)))
 (= X30 (+ (* 173 S2) S3))
 (= X30 (- (* 173 S2) S3))
 (= X30 (- S2 (* 173 S3)))
 (= X30 (+ (* 173 S2) (* 173 S3)))
 (= X30 (- (* 173 S2) (* 173 S3)))
 (= X30 (+ (* 173 S2) (* 1097 S3)))
 (= X30 (- (* 173 S2) (* 1097 S3)))
 (= X30 (- (* 1097 S2) (* 173 S3)))
 (= X30 (+ (* 173 S2) (* 973 S3)))
 (= X30 (- (* 173 S2) (* 973 S3)))
 (= X30 (- (* 973 S2) (* 173 S3)))
 (= X30 (+ (* 173 S2) (* 1517 S3)))
 (= X30 (- (* 173 S2) (* 1517 S3)))
 (= X30 (- (* 1517 S2) (* 173 S3)))
 (= X30 (+ (* 173 S2) (* 493 S3)))
 (= X30 (- (* 173 S2) (* 493 S3)))
 (= X30 (- (* 493 S2) (* 173 S3)))
 (= X30 (+ (* 173 S2) (* 379 S3)))
 (= X30 (- (* 173 S2) (* 379 S3)))
 (= X30 (- (* 379 S2) (* 173 S3)))
 (= X30 (+ (* 173 S2) (* 577 S3)))
 (= X30 (- (* 173 S2) (* 577 S3)))
 (= X30 (- (* 577 S2) (* 173 S3)))
 (= X30 (+ (* 173 S2) (* 271 S3)))
 (= X30 (- (* 173 S2) (* 271 S3)))
 (= X30 (- (* 271 S2) (* 173 S3)))
 (= X30 (+ (* 173 S2) (* 653 S3)))
 (= X30 (- (* 173 S2) (* 653 S3)))
 (= X30 (- (* 653 S2) (* 173 S3)))
 (= X30 (+ (* 173 S2) (* 1395 S3)))
 (= X30 (- (* 173 S2) (* 1395 S3)))
 (= X30 (- (* 1395 S2) (* 173 S3)))
 (= X30 (+ (* 173 S2) (* 747 S3)))
 (= X30 (- (* 173 S2) (* 747 S3)))
 (= X30 (- (* 747 S2) (* 173 S3)))
 (= X30 (+ (* 173 S2) (* 1803 S3)))
 (= X30 (- (* 173 S2) (* 1803 S3)))
 (= X30 (- (* 1803 S2) (* 173 S3)))
 (= X30 (+ (* 173 S2) (* 933 S3)))
 (= X30 (- (* 173 S2) (* 933 S3)))
 (= X30 (- (* 933 S2) (* 173 S3)))
 (= X30 (+ (* 173 S2) (* 1041 S3)))
 (= X30 (- (* 173 S2) (* 1041 S3)))
 (= X30 (- (* 1041 S2) (* 173 S3)))
 (= X30 (+ (* 173 S2) (* X29 S3)))
 (= X30 (- (* 173 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 173 S3)))
 (= X30 (+ (* 1097 S2) S3))
 (= X30 (- (* 1097 S2) S3))
 (= X30 (- S2 (* 1097 S3)))
 (= X30 (+ (* 1097 S2) (* 1097 S3)))
 (= X30 (- (* 1097 S2) (* 1097 S3)))
 (= X30 (+ (* 1097 S2) (* 973 S3)))
 (= X30 (- (* 1097 S2) (* 973 S3)))
 (= X30 (- (* 973 S2) (* 1097 S3)))
 (= X30 (+ (* 1097 S2) (* 1517 S3)))
 (= X30 (- (* 1097 S2) (* 1517 S3)))
 (= X30 (- (* 1517 S2) (* 1097 S3)))
 (= X30 (+ (* 1097 S2) (* 493 S3)))
 (= X30 (- (* 1097 S2) (* 493 S3)))
 (= X30 (- (* 493 S2) (* 1097 S3)))
 (= X30 (+ (* 1097 S2) (* 379 S3)))
 (= X30 (- (* 1097 S2) (* 379 S3)))
 (= X30 (- (* 379 S2) (* 1097 S3)))
 (= X30 (+ (* 1097 S2) (* 577 S3)))
 (= X30 (- (* 1097 S2) (* 577 S3)))
 (= X30 (- (* 577 S2) (* 1097 S3)))
 (= X30 (+ (* 1097 S2) (* 271 S3)))
 (= X30 (- (* 1097 S2) (* 271 S3)))
 (= X30 (- (* 271 S2) (* 1097 S3)))
 (= X30 (+ (* 1097 S2) (* 653 S3)))
 (= X30 (- (* 1097 S2) (* 653 S3)))
 (= X30 (- (* 653 S2) (* 1097 S3)))
 (= X30 (+ (* 1097 S2) (* 1395 S3)))
 (= X30 (- (* 1097 S2) (* 1395 S3)))
 (= X30 (- (* 1395 S2) (* 1097 S3)))
 (= X30 (+ (* 1097 S2) (* 747 S3)))
 (= X30 (- (* 1097 S2) (* 747 S3)))
 (= X30 (- (* 747 S2) (* 1097 S3)))
 (= X30 (+ (* 1097 S2) (* 1803 S3)))
 (= X30 (- (* 1097 S2) (* 1803 S3)))
 (= X30 (- (* 1803 S2) (* 1097 S3)))
 (= X30 (+ (* 1097 S2) (* 933 S3)))
 (= X30 (- (* 1097 S2) (* 933 S3)))
 (= X30 (- (* 933 S2) (* 1097 S3)))
 (= X30 (+ (* 1097 S2) (* 1041 S3)))
 (= X30 (- (* 1097 S2) (* 1041 S3)))
 (= X30 (- (* 1041 S2) (* 1097 S3)))
 (= X30 (+ (* 1097 S2) (* X29 S3)))
 (= X30 (- (* 1097 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 1097 S3)))
 (= X30 (+ (* 973 S2) S3))
 (= X30 (- (* 973 S2) S3))
 (= X30 (- S2 (* 973 S3)))
 (= X30 (+ (* 973 S2) (* 973 S3)))
 (= X30 (- (* 973 S2) (* 973 S3)))
 (= X30 (+ (* 973 S2) (* 1517 S3)))
 (= X30 (- (* 973 S2) (* 1517 S3)))
 (= X30 (- (* 1517 S2) (* 973 S3)))
 (= X30 (+ (* 973 S2) (* 493 S3)))
 (= X30 (- (* 973 S2) (* 493 S3)))
 (= X30 (- (* 493 S2) (* 973 S3)))
 (= X30 (+ (* 973 S2) (* 379 S3)))
 (= X30 (- (* 973 S2) (* 379 S3)))
 (= X30 (- (* 379 S2) (* 973 S3)))
 (= X30 (+ (* 973 S2) (* 577 S3)))
 (= X30 (- (* 973 S2) (* 577 S3)))
 (= X30 (- (* 577 S2) (* 973 S3)))
 (= X30 (+ (* 973 S2) (* 271 S3)))
 (= X30 (- (* 973 S2) (* 271 S3)))
 (= X30 (- (* 271 S2) (* 973 S3)))
 (= X30 (+ (* 973 S2) (* 653 S3)))
 (= X30 (- (* 973 S2) (* 653 S3)))
 (= X30 (- (* 653 S2) (* 973 S3)))
 (= X30 (+ (* 973 S2) (* 1395 S3)))
 (= X30 (- (* 973 S2) (* 1395 S3)))
 (= X30 (- (* 1395 S2) (* 973 S3)))
 (= X30 (+ (* 973 S2) (* 747 S3)))
 (= X30 (- (* 973 S2) (* 747 S3)))
 (= X30 (- (* 747 S2) (* 973 S3)))
 (= X30 (+ (* 973 S2) (* 1803 S3)))
 (= X30 (- (* 973 S2) (* 1803 S3)))
 (= X30 (- (* 1803 S2) (* 973 S3)))
 (= X30 (+ (* 973 S2) (* 933 S3)))
 (= X30 (- (* 973 S2) (* 933 S3)))
 (= X30 (- (* 933 S2) (* 973 S3)))
 (= X30 (+ (* 973 S2) (* 1041 S3)))
 (= X30 (- (* 973 S2) (* 1041 S3)))
 (= X30 (- (* 1041 S2) (* 973 S3)))
 (= X30 (+ (* 973 S2) (* X29 S3)))
 (= X30 (- (* 973 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 973 S3)))
 (= X30 (+ (* 1517 S2) S3))
 (= X30 (- (* 1517 S2) S3))
 (= X30 (- S2 (* 1517 S3)))
 (= X30 (+ (* 1517 S2) (* 1517 S3)))
 (= X30 (- (* 1517 S2) (* 1517 S3)))
 (= X30 (+ (* 1517 S2) (* 493 S3)))
 (= X30 (- (* 1517 S2) (* 493 S3)))
 (= X30 (- (* 493 S2) (* 1517 S3)))
 (= X30 (+ (* 1517 S2) (* 379 S3)))
 (= X30 (- (* 1517 S2) (* 379 S3)))
 (= X30 (- (* 379 S2) (* 1517 S3)))
 (= X30 (+ (* 1517 S2) (* 577 S3)))
 (= X30 (- (* 1517 S2) (* 577 S3)))
 (= X30 (- (* 577 S2) (* 1517 S3)))
 (= X30 (+ (* 1517 S2) (* 271 S3)))
 (= X30 (- (* 1517 S2) (* 271 S3)))
 (= X30 (- (* 271 S2) (* 1517 S3)))
 (= X30 (+ (* 1517 S2) (* 653 S3)))
 (= X30 (- (* 1517 S2) (* 653 S3)))
 (= X30 (- (* 653 S2) (* 1517 S3)))
 (= X30 (+ (* 1517 S2) (* 1395 S3)))
 (= X30 (- (* 1517 S2) (* 1395 S3)))
 (= X30 (- (* 1395 S2) (* 1517 S3)))
 (= X30 (+ (* 1517 S2) (* 747 S3)))
 (= X30 (- (* 1517 S2) (* 747 S3)))
 (= X30 (- (* 747 S2) (* 1517 S3)))
 (= X30 (+ (* 1517 S2) (* 1803 S3)))
 (= X30 (- (* 1517 S2) (* 1803 S3)))
 (= X30 (- (* 1803 S2) (* 1517 S3)))
 (= X30 (+ (* 1517 S2) (* 933 S3)))
 (= X30 (- (* 1517 S2) (* 933 S3)))
 (= X30 (- (* 933 S2) (* 1517 S3)))
 (= X30 (+ (* 1517 S2) (* 1041 S3)))
 (= X30 (- (* 1517 S2) (* 1041 S3)))
 (= X30 (- (* 1041 S2) (* 1517 S3)))
 (= X30 (+ (* 1517 S2) (* X29 S3)))
 (= X30 (- (* 1517 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 1517 S3)))
 (= X30 (+ (* 493 S2) S3))
 (= X30 (- (* 493 S2) S3))
 (= X30 (- S2 (* 493 S3)))
 (= X30 (+ (* 493 S2) (* 493 S3)))
 (= X30 (- (* 493 S2) (* 493 S3)))
 (= X30 (+ (* 493 S2) (* 379 S3)))
 (= X30 (- (* 493 S2) (* 379 S3)))
 (= X30 (- (* 379 S2) (* 493 S3)))
 (= X30 (+ (* 493 S2) (* 577 S3)))
 (= X30 (- (* 493 S2) (* 577 S3)))
 (= X30 (- (* 577 S2) (* 493 S3)))
 (= X30 (+ (* 493 S2) (* 271 S3)))
 (= X30 (- (* 493 S2) (* 271 S3)))
 (= X30 (- (* 271 S2) (* 493 S3)))
 (= X30 (+ (* 493 S2) (* 653 S3)))
 (= X30 (- (* 493 S2) (* 653 S3)))
 (= X30 (- (* 653 S2) (* 493 S3)))
 (= X30 (+ (* 493 S2) (* 1395 S3)))
 (= X30 (- (* 493 S2) (* 1395 S3)))
 (= X30 (- (* 1395 S2) (* 493 S3)))
 (= X30 (+ (* 493 S2) (* 747 S3)))
 (= X30 (- (* 493 S2) (* 747 S3)))
 (= X30 (- (* 747 S2) (* 493 S3)))
 (= X30 (+ (* 493 S2) (* 1803 S3)))
 (= X30 (- (* 493 S2) (* 1803 S3)))
 (= X30 (- (* 1803 S2) (* 493 S3)))
 (= X30 (+ (* 493 S2) (* 933 S3)))
 (= X30 (- (* 493 S2) (* 933 S3)))
 (= X30 (- (* 933 S2) (* 493 S3)))
 (= X30 (+ (* 493 S2) (* 1041 S3)))
 (= X30 (- (* 493 S2) (* 1041 S3)))
 (= X30 (- (* 1041 S2) (* 493 S3)))
 (= X30 (+ (* 493 S2) (* X29 S3)))
 (= X30 (- (* 493 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 493 S3)))
 (= X30 (+ (* 379 S2) S3))
 (= X30 (- (* 379 S2) S3))
 (= X30 (- S2 (* 379 S3)))
 (= X30 (+ (* 379 S2) (* 379 S3)))
 (= X30 (- (* 379 S2) (* 379 S3)))
 (= X30 (+ (* 379 S2) (* 577 S3)))
 (= X30 (- (* 379 S2) (* 577 S3)))
 (= X30 (- (* 577 S2) (* 379 S3)))
 (= X30 (+ (* 379 S2) (* 271 S3)))
 (= X30 (- (* 379 S2) (* 271 S3)))
 (= X30 (- (* 271 S2) (* 379 S3)))
 (= X30 (+ (* 379 S2) (* 653 S3)))
 (= X30 (- (* 379 S2) (* 653 S3)))
 (= X30 (- (* 653 S2) (* 379 S3)))
 (= X30 (+ (* 379 S2) (* 1395 S3)))
 (= X30 (- (* 379 S2) (* 1395 S3)))
 (= X30 (- (* 1395 S2) (* 379 S3)))
 (= X30 (+ (* 379 S2) (* 747 S3)))
 (= X30 (- (* 379 S2) (* 747 S3)))
 (= X30 (- (* 747 S2) (* 379 S3)))
 (= X30 (+ (* 379 S2) (* 1803 S3)))
 (= X30 (- (* 379 S2) (* 1803 S3)))
 (= X30 (- (* 1803 S2) (* 379 S3)))
 (= X30 (+ (* 379 S2) (* 933 S3)))
 (= X30 (- (* 379 S2) (* 933 S3)))
 (= X30 (- (* 933 S2) (* 379 S3)))
 (= X30 (+ (* 379 S2) (* 1041 S3)))
 (= X30 (- (* 379 S2) (* 1041 S3)))
 (= X30 (- (* 1041 S2) (* 379 S3)))
 (= X30 (+ (* 379 S2) (* X29 S3)))
 (= X30 (- (* 379 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 379 S3)))
 (= X30 (+ (* 577 S2) S3))
 (= X30 (- (* 577 S2) S3))
 (= X30 (- S2 (* 577 S3)))
 (= X30 (+ (* 577 S2) (* 577 S3)))
 (= X30 (- (* 577 S2) (* 577 S3)))
 (= X30 (+ (* 577 S2) (* 271 S3)))
 (= X30 (- (* 577 S2) (* 271 S3)))
 (= X30 (- (* 271 S2) (* 577 S3)))
 (= X30 (+ (* 577 S2) (* 653 S3)))
 (= X30 (- (* 577 S2) (* 653 S3)))
 (= X30 (- (* 653 S2) (* 577 S3)))
 (= X30 (+ (* 577 S2) (* 1395 S3)))
 (= X30 (- (* 577 S2) (* 1395 S3)))
 (= X30 (- (* 1395 S2) (* 577 S3)))
 (= X30 (+ (* 577 S2) (* 747 S3)))
 (= X30 (- (* 577 S2) (* 747 S3)))
 (= X30 (- (* 747 S2) (* 577 S3)))
 (= X30 (+ (* 577 S2) (* 1803 S3)))
 (= X30 (- (* 577 S2) (* 1803 S3)))
 (= X30 (- (* 1803 S2) (* 577 S3)))
 (= X30 (+ (* 577 S2) (* 933 S3)))
 (= X30 (- (* 577 S2) (* 933 S3)))
 (= X30 (- (* 933 S2) (* 577 S3)))
 (= X30 (+ (* 577 S2) (* 1041 S3)))
 (= X30 (- (* 577 S2) (* 1041 S3)))
 (= X30 (- (* 1041 S2) (* 577 S3)))
 (= X30 (+ (* 577 S2) (* X29 S3)))
 (= X30 (- (* 577 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 577 S3)))
 (= X30 (+ (* 271 S2) S3))
 (= X30 (- (* 271 S2) S3))
 (= X30 (- S2 (* 271 S3)))
 (= X30 (+ (* 271 S2) (* 271 S3)))
 (= X30 (- (* 271 S2) (* 271 S3)))
 (= X30 (+ (* 271 S2) (* 653 S3)))
 (= X30 (- (* 271 S2) (* 653 S3)))
 (= X30 (- (* 653 S2) (* 271 S3)))
 (= X30 (+ (* 271 S2) (* 1395 S3)))
 (= X30 (- (* 271 S2) (* 1395 S3)))
 (= X30 (- (* 1395 S2) (* 271 S3)))
 (= X30 (+ (* 271 S2) (* 747 S3)))
 (= X30 (- (* 271 S2) (* 747 S3)))
 (= X30 (- (* 747 S2) (* 271 S3)))
 (= X30 (+ (* 271 S2) (* 1803 S3)))
 (= X30 (- (* 271 S2) (* 1803 S3)))
 (= X30 (- (* 1803 S2) (* 271 S3)))
 (= X30 (+ (* 271 S2) (* 933 S3)))
 (= X30 (- (* 271 S2) (* 933 S3)))
 (= X30 (- (* 933 S2) (* 271 S3)))
 (= X30 (+ (* 271 S2) (* 1041 S3)))
 (= X30 (- (* 271 S2) (* 1041 S3)))
 (= X30 (- (* 1041 S2) (* 271 S3)))
 (= X30 (+ (* 271 S2) (* X29 S3)))
 (= X30 (- (* 271 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 271 S3)))
 (= X30 (+ (* 653 S2) S3))
 (= X30 (- (* 653 S2) S3))
 (= X30 (- S2 (* 653 S3)))
 (= X30 (+ (* 653 S2) (* 653 S3)))
 (= X30 (- (* 653 S2) (* 653 S3)))
 (= X30 (+ (* 653 S2) (* 1395 S3)))
 (= X30 (- (* 653 S2) (* 1395 S3)))
 (= X30 (- (* 1395 S2) (* 653 S3)))
 (= X30 (+ (* 653 S2) (* 747 S3)))
 (= X30 (- (* 653 S2) (* 747 S3)))
 (= X30 (- (* 747 S2) (* 653 S3)))
 (= X30 (+ (* 653 S2) (* 1803 S3)))
 (= X30 (- (* 653 S2) (* 1803 S3)))
 (= X30 (- (* 1803 S2) (* 653 S3)))
 (= X30 (+ (* 653 S2) (* 933 S3)))
 (= X30 (- (* 653 S2) (* 933 S3)))
 (= X30 (- (* 933 S2) (* 653 S3)))
 (= X30 (+ (* 653 S2) (* 1041 S3)))
 (= X30 (- (* 653 S2) (* 1041 S3)))
 (= X30 (- (* 1041 S2) (* 653 S3)))
 (= X30 (+ (* 653 S2) (* X29 S3)))
 (= X30 (- (* 653 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 653 S3)))
 (= X30 (+ (* 1395 S2) S3))
 (= X30 (- (* 1395 S2) S3))
 (= X30 (- S2 (* 1395 S3)))
 (= X30 (+ (* 1395 S2) (* 1395 S3)))
 (= X30 (- (* 1395 S2) (* 1395 S3)))
 (= X30 (+ (* 1395 S2) (* 747 S3)))
 (= X30 (- (* 1395 S2) (* 747 S3)))
 (= X30 (- (* 747 S2) (* 1395 S3)))
 (= X30 (+ (* 1395 S2) (* 1803 S3)))
 (= X30 (- (* 1395 S2) (* 1803 S3)))
 (= X30 (- (* 1803 S2) (* 1395 S3)))
 (= X30 (+ (* 1395 S2) (* 933 S3)))
 (= X30 (- (* 1395 S2) (* 933 S3)))
 (= X30 (- (* 933 S2) (* 1395 S3)))
 (= X30 (+ (* 1395 S2) (* 1041 S3)))
 (= X30 (- (* 1395 S2) (* 1041 S3)))
 (= X30 (- (* 1041 S2) (* 1395 S3)))
 (= X30 (+ (* 1395 S2) (* X29 S3)))
 (= X30 (- (* 1395 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 1395 S3)))
 (= X30 (+ (* 747 S2) S3))
 (= X30 (- (* 747 S2) S3))
 (= X30 (- S2 (* 747 S3)))
 (= X30 (+ (* 747 S2) (* 747 S3)))
 (= X30 (- (* 747 S2) (* 747 S3)))
 (= X30 (+ (* 747 S2) (* 1803 S3)))
 (= X30 (- (* 747 S2) (* 1803 S3)))
 (= X30 (- (* 1803 S2) (* 747 S3)))
 (= X30 (+ (* 747 S2) (* 933 S3)))
 (= X30 (- (* 747 S2) (* 933 S3)))
 (= X30 (- (* 933 S2) (* 747 S3)))
 (= X30 (+ (* 747 S2) (* 1041 S3)))
 (= X30 (- (* 747 S2) (* 1041 S3)))
 (= X30 (- (* 1041 S2) (* 747 S3)))
 (= X30 (+ (* 747 S2) (* X29 S3)))
 (= X30 (- (* 747 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 747 S3)))
 (= X30 (+ (* 1803 S2) S3))
 (= X30 (- (* 1803 S2) S3))
 (= X30 (- S2 (* 1803 S3)))
 (= X30 (+ (* 1803 S2) (* 1803 S3)))
 (= X30 (- (* 1803 S2) (* 1803 S3)))
 (= X30 (+ (* 1803 S2) (* 933 S3)))
 (= X30 (- (* 1803 S2) (* 933 S3)))
 (= X30 (- (* 933 S2) (* 1803 S3)))
 (= X30 (+ (* 1803 S2) (* 1041 S3)))
 (= X30 (- (* 1803 S2) (* 1041 S3)))
 (= X30 (- (* 1041 S2) (* 1803 S3)))
 (= X30 (+ (* 1803 S2) (* X29 S3)))
 (= X30 (- (* 1803 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 1803 S3)))
 (= X30 (+ (* 933 S2) S3))
 (= X30 (- (* 933 S2) S3))
 (= X30 (- S2 (* 933 S3)))
 (= X30 (+ (* 933 S2) (* 933 S3)))
 (= X30 (- (* 933 S2) (* 933 S3)))
 (= X30 (+ (* 933 S2) (* 1041 S3)))
 (= X30 (- (* 933 S2) (* 1041 S3)))
 (= X30 (- (* 1041 S2) (* 933 S3)))
 (= X30 (+ (* 933 S2) (* X29 S3)))
 (= X30 (- (* 933 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 933 S3)))
 (= X30 (+ (* 1041 S2) S3))
 (= X30 (- (* 1041 S2) S3))
 (= X30 (- S2 (* 1041 S3)))
 (= X30 (+ (* 1041 S2) (* 1041 S3)))
 (= X30 (- (* 1041 S2) (* 1041 S3)))
 (= X30 (+ (* 1041 S2) (* X29 S3)))
 (= X30 (- (* 1041 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 1041 S3)))
 (= X30 (+ (* X29 S2) S3))
 (= X30 (- (* X29 S2) S3))
 (= X30 (- S2 (* X29 S3)))
 (= X30 (+ (* X29 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* X29 S3)))
))
(assert (and (> X30 0) (< X30 4096) (power2 S2) (power2 S3)))
(assert
 (= X30 1751)
)
(check-sat)
(exit)
