(set-logic QF_NIA)
(set-info :source |
 more info in 'N. P. Lopes, L. Aksoy, V. Manquinho, J. Monteiro.
 Optimally Solving the MCM Problem Using Pseudo-Boolean Satisfiability.
 Technical Report RT/43/2010, INESC-ID, Nov. 2010'. |)
(set-info :smt-lib-version 2.0)
(set-info :category "industrial")
(set-info :status unknown)
(declare-fun X29 () Int)
(declare-fun X30 () Int)
(declare-fun S0 () Int)
(declare-fun S1 () Int)
(declare-fun S2 () Int)
(declare-fun S3 () Int)
(define-fun power2 ((x Int)) Bool
  (or (= x 2048) (= x 1024) (= x 512) (= x 256) (= x 128) (= x 64) (= x 32) (= x 16) (= x 8) (= x 4) (= x 2) (= x 1)))
(assert (or
 (= X29 (+ S0 S1))
 (= X29 (- S0 S1))
 (= X29 (+ (* 5 S0) S1))
 (= X29 (- (* 5 S0) S1))
 (= X29 (- S0 (* 5 S1)))
 (= X29 (+ (* 5 S0) (* 5 S1)))
 (= X29 (- (* 5 S0) (* 5 S1)))
 (= X29 (+ (* 5 S0) (* 31 S1)))
 (= X29 (- (* 5 S0) (* 31 S1)))
 (= X29 (- (* 31 S0) (* 5 S1)))
 (= X29 (+ (* 5 S0) (* 161 S1)))
 (= X29 (- (* 5 S0) (* 161 S1)))
 (= X29 (- (* 161 S0) (* 5 S1)))
 (= X29 (+ (* 5 S0) (* 287 S1)))
 (= X29 (- (* 5 S0) (* 287 S1)))
 (= X29 (- (* 287 S0) (* 5 S1)))
 (= X29 (+ (* 5 S0) (* 45 S1)))
 (= X29 (- (* 5 S0) (* 45 S1)))
 (= X29 (- (* 45 S0) (* 5 S1)))
 (= X29 (+ (* 5 S0) (* 89 S1)))
 (= X29 (- (* 5 S0) (* 89 S1)))
 (= X29 (- (* 89 S0) (* 5 S1)))
 (= X29 (+ (* 5 S0) (* 87 S1)))
 (= X29 (- (* 5 S0) (* 87 S1)))
 (= X29 (- (* 87 S0) (* 5 S1)))
 (= X29 (+ (* 5 S0) (* 253 S1)))
 (= X29 (- (* 5 S0) (* 253 S1)))
 (= X29 (- (* 253 S0) (* 5 S1)))
 (= X29 (+ (* 5 S0) (* 595 S1)))
 (= X29 (- (* 5 S0) (* 595 S1)))
 (= X29 (- (* 595 S0) (* 5 S1)))
 (= X29 (+ (* 5 S0) (* 659 S1)))
 (= X29 (- (* 5 S0) (* 659 S1)))
 (= X29 (- (* 659 S0) (* 5 S1)))
 (= X29 (+ (* 5 S0) (* 403 S1)))
 (= X29 (- (* 5 S0) (* 403 S1)))
 (= X29 (- (* 403 S0) (* 5 S1)))
 (= X29 (+ (* 5 S0) (* 401 S1)))
 (= X29 (- (* 5 S0) (* 401 S1)))
 (= X29 (- (* 401 S0) (* 5 S1)))
 (= X29 (+ (* 5 S0) (* 893 S1)))
 (= X29 (- (* 5 S0) (* 893 S1)))
 (= X29 (- (* 893 S0) (* 5 S1)))
 (= X29 (+ (* 5 S0) (* 421 S1)))
 (= X29 (- (* 5 S0) (* 421 S1)))
 (= X29 (- (* 421 S0) (* 5 S1)))
 (= X29 (+ (* 5 S0) (* 453 S1)))
 (= X29 (- (* 5 S0) (* 453 S1)))
 (= X29 (- (* 453 S0) (* 5 S1)))
 (= X29 (+ (* 5 S0) (* 827 S1)))
 (= X29 (- (* 5 S0) (* 827 S1)))
 (= X29 (- (* 827 S0) (* 5 S1)))
 (= X29 (+ (* 5 S0) (* 961 S1)))
 (= X29 (- (* 5 S0) (* 961 S1)))
 (= X29 (- (* 961 S0) (* 5 S1)))
 (= X29 (+ (* 5 S0) (* 945 S1)))
 (= X29 (- (* 5 S0) (* 945 S1)))
 (= X29 (- (* 945 S0) (* 5 S1)))
 (= X29 (+ (* 5 S0) (* 947 S1)))
 (= X29 (- (* 5 S0) (* 947 S1)))
 (= X29 (- (* 947 S0) (* 5 S1)))
 (= X29 (+ (* 5 S0) (* 939 S1)))
 (= X29 (- (* 5 S0) (* 939 S1)))
 (= X29 (- (* 939 S0) (* 5 S1)))
 (= X29 (+ (* 5 S0) (* 527 S1)))
 (= X29 (- (* 5 S0) (* 527 S1)))
 (= X29 (- (* 527 S0) (* 5 S1)))
 (= X29 (+ (* 5 S0) (* 1953 S1)))
 (= X29 (- (* 5 S0) (* 1953 S1)))
 (= X29 (- (* 1953 S0) (* 5 S1)))
 (= X29 (+ (* 5 S0) (* 1245 S1)))
 (= X29 (- (* 5 S0) (* 1245 S1)))
 (= X29 (- (* 1245 S0) (* 5 S1)))
 (= X29 (+ (* 5 S0) (* 471 S1)))
 (= X29 (- (* 5 S0) (* 471 S1)))
 (= X29 (- (* 471 S0) (* 5 S1)))
 (= X29 (+ (* 5 S0) (* 1263 S1)))
 (= X29 (- (* 5 S0) (* 1263 S1)))
 (= X29 (- (* 1263 S0) (* 5 S1)))
 (= X29 (+ (* 5 S0) (* 235 S1)))
 (= X29 (- (* 5 S0) (* 235 S1)))
 (= X29 (- (* 235 S0) (* 5 S1)))
 (= X29 (+ (* 5 S0) (* 999 S1)))
 (= X29 (- (* 5 S0) (* 999 S1)))
 (= X29 (- (* 999 S0) (* 5 S1)))
 (= X29 (+ (* 5 S0) (* 1251 S1)))
 (= X29 (- (* 5 S0) (* 1251 S1)))
 (= X29 (- (* 1251 S0) (* 5 S1)))
 (= X29 (+ (* 5 S0) (* 1385 S1)))
 (= X29 (- (* 5 S0) (* 1385 S1)))
 (= X29 (- (* 1385 S0) (* 5 S1)))
 (= X29 (+ (* 31 S0) S1))
 (= X29 (- (* 31 S0) S1))
 (= X29 (- S0 (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 31 S1)))
 (= X29 (- (* 31 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 161 S1)))
 (= X29 (- (* 31 S0) (* 161 S1)))
 (= X29 (- (* 161 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 287 S1)))
 (= X29 (- (* 31 S0) (* 287 S1)))
 (= X29 (- (* 287 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 45 S1)))
 (= X29 (- (* 31 S0) (* 45 S1)))
 (= X29 (- (* 45 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 89 S1)))
 (= X29 (- (* 31 S0) (* 89 S1)))
 (= X29 (- (* 89 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 87 S1)))
 (= X29 (- (* 31 S0) (* 87 S1)))
 (= X29 (- (* 87 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 253 S1)))
 (= X29 (- (* 31 S0) (* 253 S1)))
 (= X29 (- (* 253 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 595 S1)))
 (= X29 (- (* 31 S0) (* 595 S1)))
 (= X29 (- (* 595 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 659 S1)))
 (= X29 (- (* 31 S0) (* 659 S1)))
 (= X29 (- (* 659 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 403 S1)))
 (= X29 (- (* 31 S0) (* 403 S1)))
 (= X29 (- (* 403 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 401 S1)))
 (= X29 (- (* 31 S0) (* 401 S1)))
 (= X29 (- (* 401 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 893 S1)))
 (= X29 (- (* 31 S0) (* 893 S1)))
 (= X29 (- (* 893 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 421 S1)))
 (= X29 (- (* 31 S0) (* 421 S1)))
 (= X29 (- (* 421 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 453 S1)))
 (= X29 (- (* 31 S0) (* 453 S1)))
 (= X29 (- (* 453 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 827 S1)))
 (= X29 (- (* 31 S0) (* 827 S1)))
 (= X29 (- (* 827 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 961 S1)))
 (= X29 (- (* 31 S0) (* 961 S1)))
 (= X29 (- (* 961 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 945 S1)))
 (= X29 (- (* 31 S0) (* 945 S1)))
 (= X29 (- (* 945 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 947 S1)))
 (= X29 (- (* 31 S0) (* 947 S1)))
 (= X29 (- (* 947 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 939 S1)))
 (= X29 (- (* 31 S0) (* 939 S1)))
 (= X29 (- (* 939 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 527 S1)))
 (= X29 (- (* 31 S0) (* 527 S1)))
 (= X29 (- (* 527 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 1953 S1)))
 (= X29 (- (* 31 S0) (* 1953 S1)))
 (= X29 (- (* 1953 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 1245 S1)))
 (= X29 (- (* 31 S0) (* 1245 S1)))
 (= X29 (- (* 1245 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 471 S1)))
 (= X29 (- (* 31 S0) (* 471 S1)))
 (= X29 (- (* 471 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 1263 S1)))
 (= X29 (- (* 31 S0) (* 1263 S1)))
 (= X29 (- (* 1263 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 235 S1)))
 (= X29 (- (* 31 S0) (* 235 S1)))
 (= X29 (- (* 235 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 999 S1)))
 (= X29 (- (* 31 S0) (* 999 S1)))
 (= X29 (- (* 999 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 1251 S1)))
 (= X29 (- (* 31 S0) (* 1251 S1)))
 (= X29 (- (* 1251 S0) (* 31 S1)))
 (= X29 (+ (* 31 S0) (* 1385 S1)))
 (= X29 (- (* 31 S0) (* 1385 S1)))
 (= X29 (- (* 1385 S0) (* 31 S1)))
 (= X29 (+ (* 161 S0) S1))
 (= X29 (- (* 161 S0) S1))
 (= X29 (- S0 (* 161 S1)))
 (= X29 (+ (* 161 S0) (* 161 S1)))
 (= X29 (- (* 161 S0) (* 161 S1)))
 (= X29 (+ (* 161 S0) (* 287 S1)))
 (= X29 (- (* 161 S0) (* 287 S1)))
 (= X29 (- (* 287 S0) (* 161 S1)))
 (= X29 (+ (* 161 S0) (* 45 S1)))
 (= X29 (- (* 161 S0) (* 45 S1)))
 (= X29 (- (* 45 S0) (* 161 S1)))
 (= X29 (+ (* 161 S0) (* 89 S1)))
 (= X29 (- (* 161 S0) (* 89 S1)))
 (= X29 (- (* 89 S0) (* 161 S1)))
 (= X29 (+ (* 161 S0) (* 87 S1)))
 (= X29 (- (* 161 S0) (* 87 S1)))
 (= X29 (- (* 87 S0) (* 161 S1)))
 (= X29 (+ (* 161 S0) (* 253 S1)))
 (= X29 (- (* 161 S0) (* 253 S1)))
 (= X29 (- (* 253 S0) (* 161 S1)))
 (= X29 (+ (* 161 S0) (* 595 S1)))
 (= X29 (- (* 161 S0) (* 595 S1)))
 (= X29 (- (* 595 S0) (* 161 S1)))
 (= X29 (+ (* 161 S0) (* 659 S1)))
 (= X29 (- (* 161 S0) (* 659 S1)))
 (= X29 (- (* 659 S0) (* 161 S1)))
 (= X29 (+ (* 161 S0) (* 403 S1)))
 (= X29 (- (* 161 S0) (* 403 S1)))
 (= X29 (- (* 403 S0) (* 161 S1)))
 (= X29 (+ (* 161 S0) (* 401 S1)))
 (= X29 (- (* 161 S0) (* 401 S1)))
 (= X29 (- (* 401 S0) (* 161 S1)))
 (= X29 (+ (* 161 S0) (* 893 S1)))
 (= X29 (- (* 161 S0) (* 893 S1)))
 (= X29 (- (* 893 S0) (* 161 S1)))
 (= X29 (+ (* 161 S0) (* 421 S1)))
 (= X29 (- (* 161 S0) (* 421 S1)))
 (= X29 (- (* 421 S0) (* 161 S1)))
 (= X29 (+ (* 161 S0) (* 453 S1)))
 (= X29 (- (* 161 S0) (* 453 S1)))
 (= X29 (- (* 453 S0) (* 161 S1)))
 (= X29 (+ (* 161 S0) (* 827 S1)))
 (= X29 (- (* 161 S0) (* 827 S1)))
 (= X29 (- (* 827 S0) (* 161 S1)))
 (= X29 (+ (* 161 S0) (* 961 S1)))
 (= X29 (- (* 161 S0) (* 961 S1)))
 (= X29 (- (* 961 S0) (* 161 S1)))
 (= X29 (+ (* 161 S0) (* 945 S1)))
 (= X29 (- (* 161 S0) (* 945 S1)))
 (= X29 (- (* 945 S0) (* 161 S1)))
 (= X29 (+ (* 161 S0) (* 947 S1)))
 (= X29 (- (* 161 S0) (* 947 S1)))
 (= X29 (- (* 947 S0) (* 161 S1)))
 (= X29 (+ (* 161 S0) (* 939 S1)))
 (= X29 (- (* 161 S0) (* 939 S1)))
 (= X29 (- (* 939 S0) (* 161 S1)))
 (= X29 (+ (* 161 S0) (* 527 S1)))
 (= X29 (- (* 161 S0) (* 527 S1)))
 (= X29 (- (* 527 S0) (* 161 S1)))
 (= X29 (+ (* 161 S0) (* 1953 S1)))
 (= X29 (- (* 161 S0) (* 1953 S1)))
 (= X29 (- (* 1953 S0) (* 161 S1)))
 (= X29 (+ (* 161 S0) (* 1245 S1)))
 (= X29 (- (* 161 S0) (* 1245 S1)))
 (= X29 (- (* 1245 S0) (* 161 S1)))
 (= X29 (+ (* 161 S0) (* 471 S1)))
 (= X29 (- (* 161 S0) (* 471 S1)))
 (= X29 (- (* 471 S0) (* 161 S1)))
 (= X29 (+ (* 161 S0) (* 1263 S1)))
 (= X29 (- (* 161 S0) (* 1263 S1)))
 (= X29 (- (* 1263 S0) (* 161 S1)))
 (= X29 (+ (* 161 S0) (* 235 S1)))
 (= X29 (- (* 161 S0) (* 235 S1)))
 (= X29 (- (* 235 S0) (* 161 S1)))
 (= X29 (+ (* 161 S0) (* 999 S1)))
 (= X29 (- (* 161 S0) (* 999 S1)))
 (= X29 (- (* 999 S0) (* 161 S1)))
 (= X29 (+ (* 161 S0) (* 1251 S1)))
 (= X29 (- (* 161 S0) (* 1251 S1)))
 (= X29 (- (* 1251 S0) (* 161 S1)))
 (= X29 (+ (* 161 S0) (* 1385 S1)))
 (= X29 (- (* 161 S0) (* 1385 S1)))
 (= X29 (- (* 1385 S0) (* 161 S1)))
 (= X29 (+ (* 287 S0) S1))
 (= X29 (- (* 287 S0) S1))
 (= X29 (- S0 (* 287 S1)))
 (= X29 (+ (* 287 S0) (* 287 S1)))
 (= X29 (- (* 287 S0) (* 287 S1)))
 (= X29 (+ (* 287 S0) (* 45 S1)))
 (= X29 (- (* 287 S0) (* 45 S1)))
 (= X29 (- (* 45 S0) (* 287 S1)))
 (= X29 (+ (* 287 S0) (* 89 S1)))
 (= X29 (- (* 287 S0) (* 89 S1)))
 (= X29 (- (* 89 S0) (* 287 S1)))
 (= X29 (+ (* 287 S0) (* 87 S1)))
 (= X29 (- (* 287 S0) (* 87 S1)))
 (= X29 (- (* 87 S0) (* 287 S1)))
 (= X29 (+ (* 287 S0) (* 253 S1)))
 (= X29 (- (* 287 S0) (* 253 S1)))
 (= X29 (- (* 253 S0) (* 287 S1)))
 (= X29 (+ (* 287 S0) (* 595 S1)))
 (= X29 (- (* 287 S0) (* 595 S1)))
 (= X29 (- (* 595 S0) (* 287 S1)))
 (= X29 (+ (* 287 S0) (* 659 S1)))
 (= X29 (- (* 287 S0) (* 659 S1)))
 (= X29 (- (* 659 S0) (* 287 S1)))
 (= X29 (+ (* 287 S0) (* 403 S1)))
 (= X29 (- (* 287 S0) (* 403 S1)))
 (= X29 (- (* 403 S0) (* 287 S1)))
 (= X29 (+ (* 287 S0) (* 401 S1)))
 (= X29 (- (* 287 S0) (* 401 S1)))
 (= X29 (- (* 401 S0) (* 287 S1)))
 (= X29 (+ (* 287 S0) (* 893 S1)))
 (= X29 (- (* 287 S0) (* 893 S1)))
 (= X29 (- (* 893 S0) (* 287 S1)))
 (= X29 (+ (* 287 S0) (* 421 S1)))
 (= X29 (- (* 287 S0) (* 421 S1)))
 (= X29 (- (* 421 S0) (* 287 S1)))
 (= X29 (+ (* 287 S0) (* 453 S1)))
 (= X29 (- (* 287 S0) (* 453 S1)))
 (= X29 (- (* 453 S0) (* 287 S1)))
 (= X29 (+ (* 287 S0) (* 827 S1)))
 (= X29 (- (* 287 S0) (* 827 S1)))
 (= X29 (- (* 827 S0) (* 287 S1)))
 (= X29 (+ (* 287 S0) (* 961 S1)))
 (= X29 (- (* 287 S0) (* 961 S1)))
 (= X29 (- (* 961 S0) (* 287 S1)))
 (= X29 (+ (* 287 S0) (* 945 S1)))
 (= X29 (- (* 287 S0) (* 945 S1)))
 (= X29 (- (* 945 S0) (* 287 S1)))
 (= X29 (+ (* 287 S0) (* 947 S1)))
 (= X29 (- (* 287 S0) (* 947 S1)))
 (= X29 (- (* 947 S0) (* 287 S1)))
 (= X29 (+ (* 287 S0) (* 939 S1)))
 (= X29 (- (* 287 S0) (* 939 S1)))
 (= X29 (- (* 939 S0) (* 287 S1)))
 (= X29 (+ (* 287 S0) (* 527 S1)))
 (= X29 (- (* 287 S0) (* 527 S1)))
 (= X29 (- (* 527 S0) (* 287 S1)))
 (= X29 (+ (* 287 S0) (* 1953 S1)))
 (= X29 (- (* 287 S0) (* 1953 S1)))
 (= X29 (- (* 1953 S0) (* 287 S1)))
 (= X29 (+ (* 287 S0) (* 1245 S1)))
 (= X29 (- (* 287 S0) (* 1245 S1)))
 (= X29 (- (* 1245 S0) (* 287 S1)))
 (= X29 (+ (* 287 S0) (* 471 S1)))
 (= X29 (- (* 287 S0) (* 471 S1)))
 (= X29 (- (* 471 S0) (* 287 S1)))
 (= X29 (+ (* 287 S0) (* 1263 S1)))
 (= X29 (- (* 287 S0) (* 1263 S1)))
 (= X29 (- (* 1263 S0) (* 287 S1)))
 (= X29 (+ (* 287 S0) (* 235 S1)))
 (= X29 (- (* 287 S0) (* 235 S1)))
 (= X29 (- (* 235 S0) (* 287 S1)))
 (= X29 (+ (* 287 S0) (* 999 S1)))
 (= X29 (- (* 287 S0) (* 999 S1)))
 (= X29 (- (* 999 S0) (* 287 S1)))
 (= X29 (+ (* 287 S0) (* 1251 S1)))
 (= X29 (- (* 287 S0) (* 1251 S1)))
 (= X29 (- (* 1251 S0) (* 287 S1)))
 (= X29 (+ (* 287 S0) (* 1385 S1)))
 (= X29 (- (* 287 S0) (* 1385 S1)))
 (= X29 (- (* 1385 S0) (* 287 S1)))
 (= X29 (+ (* 45 S0) S1))
 (= X29 (- (* 45 S0) S1))
 (= X29 (- S0 (* 45 S1)))
 (= X29 (+ (* 45 S0) (* 45 S1)))
 (= X29 (- (* 45 S0) (* 45 S1)))
 (= X29 (+ (* 45 S0) (* 89 S1)))
 (= X29 (- (* 45 S0) (* 89 S1)))
 (= X29 (- (* 89 S0) (* 45 S1)))
 (= X29 (+ (* 45 S0) (* 87 S1)))
 (= X29 (- (* 45 S0) (* 87 S1)))
 (= X29 (- (* 87 S0) (* 45 S1)))
 (= X29 (+ (* 45 S0) (* 253 S1)))
 (= X29 (- (* 45 S0) (* 253 S1)))
 (= X29 (- (* 253 S0) (* 45 S1)))
 (= X29 (+ (* 45 S0) (* 595 S1)))
 (= X29 (- (* 45 S0) (* 595 S1)))
 (= X29 (- (* 595 S0) (* 45 S1)))
 (= X29 (+ (* 45 S0) (* 659 S1)))
 (= X29 (- (* 45 S0) (* 659 S1)))
 (= X29 (- (* 659 S0) (* 45 S1)))
 (= X29 (+ (* 45 S0) (* 403 S1)))
 (= X29 (- (* 45 S0) (* 403 S1)))
 (= X29 (- (* 403 S0) (* 45 S1)))
 (= X29 (+ (* 45 S0) (* 401 S1)))
 (= X29 (- (* 45 S0) (* 401 S1)))
 (= X29 (- (* 401 S0) (* 45 S1)))
 (= X29 (+ (* 45 S0) (* 893 S1)))
 (= X29 (- (* 45 S0) (* 893 S1)))
 (= X29 (- (* 893 S0) (* 45 S1)))
 (= X29 (+ (* 45 S0) (* 421 S1)))
 (= X29 (- (* 45 S0) (* 421 S1)))
 (= X29 (- (* 421 S0) (* 45 S1)))
 (= X29 (+ (* 45 S0) (* 453 S1)))
 (= X29 (- (* 45 S0) (* 453 S1)))
 (= X29 (- (* 453 S0) (* 45 S1)))
 (= X29 (+ (* 45 S0) (* 827 S1)))
 (= X29 (- (* 45 S0) (* 827 S1)))
 (= X29 (- (* 827 S0) (* 45 S1)))
 (= X29 (+ (* 45 S0) (* 961 S1)))
 (= X29 (- (* 45 S0) (* 961 S1)))
 (= X29 (- (* 961 S0) (* 45 S1)))
 (= X29 (+ (* 45 S0) (* 945 S1)))
 (= X29 (- (* 45 S0) (* 945 S1)))
 (= X29 (- (* 945 S0) (* 45 S1)))
 (= X29 (+ (* 45 S0) (* 947 S1)))
 (= X29 (- (* 45 S0) (* 947 S1)))
 (= X29 (- (* 947 S0) (* 45 S1)))
 (= X29 (+ (* 45 S0) (* 939 S1)))
 (= X29 (- (* 45 S0) (* 939 S1)))
 (= X29 (- (* 939 S0) (* 45 S1)))
 (= X29 (+ (* 45 S0) (* 527 S1)))
 (= X29 (- (* 45 S0) (* 527 S1)))
 (= X29 (- (* 527 S0) (* 45 S1)))
 (= X29 (+ (* 45 S0) (* 1953 S1)))
 (= X29 (- (* 45 S0) (* 1953 S1)))
 (= X29 (- (* 1953 S0) (* 45 S1)))
 (= X29 (+ (* 45 S0) (* 1245 S1)))
 (= X29 (- (* 45 S0) (* 1245 S1)))
 (= X29 (- (* 1245 S0) (* 45 S1)))
 (= X29 (+ (* 45 S0) (* 471 S1)))
 (= X29 (- (* 45 S0) (* 471 S1)))
 (= X29 (- (* 471 S0) (* 45 S1)))
 (= X29 (+ (* 45 S0) (* 1263 S1)))
 (= X29 (- (* 45 S0) (* 1263 S1)))
 (= X29 (- (* 1263 S0) (* 45 S1)))
 (= X29 (+ (* 45 S0) (* 235 S1)))
 (= X29 (- (* 45 S0) (* 235 S1)))
 (= X29 (- (* 235 S0) (* 45 S1)))
 (= X29 (+ (* 45 S0) (* 999 S1)))
 (= X29 (- (* 45 S0) (* 999 S1)))
 (= X29 (- (* 999 S0) (* 45 S1)))
 (= X29 (+ (* 45 S0) (* 1251 S1)))
 (= X29 (- (* 45 S0) (* 1251 S1)))
 (= X29 (- (* 1251 S0) (* 45 S1)))
 (= X29 (+ (* 45 S0) (* 1385 S1)))
 (= X29 (- (* 45 S0) (* 1385 S1)))
 (= X29 (- (* 1385 S0) (* 45 S1)))
 (= X29 (+ (* 89 S0) S1))
 (= X29 (- (* 89 S0) S1))
 (= X29 (- S0 (* 89 S1)))
 (= X29 (+ (* 89 S0) (* 89 S1)))
 (= X29 (- (* 89 S0) (* 89 S1)))
 (= X29 (+ (* 89 S0) (* 87 S1)))
 (= X29 (- (* 89 S0) (* 87 S1)))
 (= X29 (- (* 87 S0) (* 89 S1)))
 (= X29 (+ (* 89 S0) (* 253 S1)))
 (= X29 (- (* 89 S0) (* 253 S1)))
 (= X29 (- (* 253 S0) (* 89 S1)))
 (= X29 (+ (* 89 S0) (* 595 S1)))
 (= X29 (- (* 89 S0) (* 595 S1)))
 (= X29 (- (* 595 S0) (* 89 S1)))
 (= X29 (+ (* 89 S0) (* 659 S1)))
 (= X29 (- (* 89 S0) (* 659 S1)))
 (= X29 (- (* 659 S0) (* 89 S1)))
 (= X29 (+ (* 89 S0) (* 403 S1)))
 (= X29 (- (* 89 S0) (* 403 S1)))
 (= X29 (- (* 403 S0) (* 89 S1)))
 (= X29 (+ (* 89 S0) (* 401 S1)))
 (= X29 (- (* 89 S0) (* 401 S1)))
 (= X29 (- (* 401 S0) (* 89 S1)))
 (= X29 (+ (* 89 S0) (* 893 S1)))
 (= X29 (- (* 89 S0) (* 893 S1)))
 (= X29 (- (* 893 S0) (* 89 S1)))
 (= X29 (+ (* 89 S0) (* 421 S1)))
 (= X29 (- (* 89 S0) (* 421 S1)))
 (= X29 (- (* 421 S0) (* 89 S1)))
 (= X29 (+ (* 89 S0) (* 453 S1)))
 (= X29 (- (* 89 S0) (* 453 S1)))
 (= X29 (- (* 453 S0) (* 89 S1)))
 (= X29 (+ (* 89 S0) (* 827 S1)))
 (= X29 (- (* 89 S0) (* 827 S1)))
 (= X29 (- (* 827 S0) (* 89 S1)))
 (= X29 (+ (* 89 S0) (* 961 S1)))
 (= X29 (- (* 89 S0) (* 961 S1)))
 (= X29 (- (* 961 S0) (* 89 S1)))
 (= X29 (+ (* 89 S0) (* 945 S1)))
 (= X29 (- (* 89 S0) (* 945 S1)))
 (= X29 (- (* 945 S0) (* 89 S1)))
 (= X29 (+ (* 89 S0) (* 947 S1)))
 (= X29 (- (* 89 S0) (* 947 S1)))
 (= X29 (- (* 947 S0) (* 89 S1)))
 (= X29 (+ (* 89 S0) (* 939 S1)))
 (= X29 (- (* 89 S0) (* 939 S1)))
 (= X29 (- (* 939 S0) (* 89 S1)))
 (= X29 (+ (* 89 S0) (* 527 S1)))
 (= X29 (- (* 89 S0) (* 527 S1)))
 (= X29 (- (* 527 S0) (* 89 S1)))
 (= X29 (+ (* 89 S0) (* 1953 S1)))
 (= X29 (- (* 89 S0) (* 1953 S1)))
 (= X29 (- (* 1953 S0) (* 89 S1)))
 (= X29 (+ (* 89 S0) (* 1245 S1)))
 (= X29 (- (* 89 S0) (* 1245 S1)))
 (= X29 (- (* 1245 S0) (* 89 S1)))
 (= X29 (+ (* 89 S0) (* 471 S1)))
 (= X29 (- (* 89 S0) (* 471 S1)))
 (= X29 (- (* 471 S0) (* 89 S1)))
 (= X29 (+ (* 89 S0) (* 1263 S1)))
 (= X29 (- (* 89 S0) (* 1263 S1)))
 (= X29 (- (* 1263 S0) (* 89 S1)))
 (= X29 (+ (* 89 S0) (* 235 S1)))
 (= X29 (- (* 89 S0) (* 235 S1)))
 (= X29 (- (* 235 S0) (* 89 S1)))
 (= X29 (+ (* 89 S0) (* 999 S1)))
 (= X29 (- (* 89 S0) (* 999 S1)))
 (= X29 (- (* 999 S0) (* 89 S1)))
 (= X29 (+ (* 89 S0) (* 1251 S1)))
 (= X29 (- (* 89 S0) (* 1251 S1)))
 (= X29 (- (* 1251 S0) (* 89 S1)))
 (= X29 (+ (* 89 S0) (* 1385 S1)))
 (= X29 (- (* 89 S0) (* 1385 S1)))
 (= X29 (- (* 1385 S0) (* 89 S1)))
 (= X29 (+ (* 87 S0) S1))
 (= X29 (- (* 87 S0) S1))
 (= X29 (- S0 (* 87 S1)))
 (= X29 (+ (* 87 S0) (* 87 S1)))
 (= X29 (- (* 87 S0) (* 87 S1)))
 (= X29 (+ (* 87 S0) (* 253 S1)))
 (= X29 (- (* 87 S0) (* 253 S1)))
 (= X29 (- (* 253 S0) (* 87 S1)))
 (= X29 (+ (* 87 S0) (* 595 S1)))
 (= X29 (- (* 87 S0) (* 595 S1)))
 (= X29 (- (* 595 S0) (* 87 S1)))
 (= X29 (+ (* 87 S0) (* 659 S1)))
 (= X29 (- (* 87 S0) (* 659 S1)))
 (= X29 (- (* 659 S0) (* 87 S1)))
 (= X29 (+ (* 87 S0) (* 403 S1)))
 (= X29 (- (* 87 S0) (* 403 S1)))
 (= X29 (- (* 403 S0) (* 87 S1)))
 (= X29 (+ (* 87 S0) (* 401 S1)))
 (= X29 (- (* 87 S0) (* 401 S1)))
 (= X29 (- (* 401 S0) (* 87 S1)))
 (= X29 (+ (* 87 S0) (* 893 S1)))
 (= X29 (- (* 87 S0) (* 893 S1)))
 (= X29 (- (* 893 S0) (* 87 S1)))
 (= X29 (+ (* 87 S0) (* 421 S1)))
 (= X29 (- (* 87 S0) (* 421 S1)))
 (= X29 (- (* 421 S0) (* 87 S1)))
 (= X29 (+ (* 87 S0) (* 453 S1)))
 (= X29 (- (* 87 S0) (* 453 S1)))
 (= X29 (- (* 453 S0) (* 87 S1)))
 (= X29 (+ (* 87 S0) (* 827 S1)))
 (= X29 (- (* 87 S0) (* 827 S1)))
 (= X29 (- (* 827 S0) (* 87 S1)))
 (= X29 (+ (* 87 S0) (* 961 S1)))
 (= X29 (- (* 87 S0) (* 961 S1)))
 (= X29 (- (* 961 S0) (* 87 S1)))
 (= X29 (+ (* 87 S0) (* 945 S1)))
 (= X29 (- (* 87 S0) (* 945 S1)))
 (= X29 (- (* 945 S0) (* 87 S1)))
 (= X29 (+ (* 87 S0) (* 947 S1)))
 (= X29 (- (* 87 S0) (* 947 S1)))
 (= X29 (- (* 947 S0) (* 87 S1)))
 (= X29 (+ (* 87 S0) (* 939 S1)))
 (= X29 (- (* 87 S0) (* 939 S1)))
 (= X29 (- (* 939 S0) (* 87 S1)))
 (= X29 (+ (* 87 S0) (* 527 S1)))
 (= X29 (- (* 87 S0) (* 527 S1)))
 (= X29 (- (* 527 S0) (* 87 S1)))
 (= X29 (+ (* 87 S0) (* 1953 S1)))
 (= X29 (- (* 87 S0) (* 1953 S1)))
 (= X29 (- (* 1953 S0) (* 87 S1)))
 (= X29 (+ (* 87 S0) (* 1245 S1)))
 (= X29 (- (* 87 S0) (* 1245 S1)))
 (= X29 (- (* 1245 S0) (* 87 S1)))
 (= X29 (+ (* 87 S0) (* 471 S1)))
 (= X29 (- (* 87 S0) (* 471 S1)))
 (= X29 (- (* 471 S0) (* 87 S1)))
 (= X29 (+ (* 87 S0) (* 1263 S1)))
 (= X29 (- (* 87 S0) (* 1263 S1)))
 (= X29 (- (* 1263 S0) (* 87 S1)))
 (= X29 (+ (* 87 S0) (* 235 S1)))
 (= X29 (- (* 87 S0) (* 235 S1)))
 (= X29 (- (* 235 S0) (* 87 S1)))
 (= X29 (+ (* 87 S0) (* 999 S1)))
 (= X29 (- (* 87 S0) (* 999 S1)))
 (= X29 (- (* 999 S0) (* 87 S1)))
 (= X29 (+ (* 87 S0) (* 1251 S1)))
 (= X29 (- (* 87 S0) (* 1251 S1)))
 (= X29 (- (* 1251 S0) (* 87 S1)))
 (= X29 (+ (* 87 S0) (* 1385 S1)))
 (= X29 (- (* 87 S0) (* 1385 S1)))
 (= X29 (- (* 1385 S0) (* 87 S1)))
 (= X29 (+ (* 253 S0) S1))
 (= X29 (- (* 253 S0) S1))
 (= X29 (- S0 (* 253 S1)))
 (= X29 (+ (* 253 S0) (* 253 S1)))
 (= X29 (- (* 253 S0) (* 253 S1)))
 (= X29 (+ (* 253 S0) (* 595 S1)))
 (= X29 (- (* 253 S0) (* 595 S1)))
 (= X29 (- (* 595 S0) (* 253 S1)))
 (= X29 (+ (* 253 S0) (* 659 S1)))
 (= X29 (- (* 253 S0) (* 659 S1)))
 (= X29 (- (* 659 S0) (* 253 S1)))
 (= X29 (+ (* 253 S0) (* 403 S1)))
 (= X29 (- (* 253 S0) (* 403 S1)))
 (= X29 (- (* 403 S0) (* 253 S1)))
 (= X29 (+ (* 253 S0) (* 401 S1)))
 (= X29 (- (* 253 S0) (* 401 S1)))
 (= X29 (- (* 401 S0) (* 253 S1)))
 (= X29 (+ (* 253 S0) (* 893 S1)))
 (= X29 (- (* 253 S0) (* 893 S1)))
 (= X29 (- (* 893 S0) (* 253 S1)))
 (= X29 (+ (* 253 S0) (* 421 S1)))
 (= X29 (- (* 253 S0) (* 421 S1)))
 (= X29 (- (* 421 S0) (* 253 S1)))
 (= X29 (+ (* 253 S0) (* 453 S1)))
 (= X29 (- (* 253 S0) (* 453 S1)))
 (= X29 (- (* 453 S0) (* 253 S1)))
 (= X29 (+ (* 253 S0) (* 827 S1)))
 (= X29 (- (* 253 S0) (* 827 S1)))
 (= X29 (- (* 827 S0) (* 253 S1)))
 (= X29 (+ (* 253 S0) (* 961 S1)))
 (= X29 (- (* 253 S0) (* 961 S1)))
 (= X29 (- (* 961 S0) (* 253 S1)))
 (= X29 (+ (* 253 S0) (* 945 S1)))
 (= X29 (- (* 253 S0) (* 945 S1)))
 (= X29 (- (* 945 S0) (* 253 S1)))
 (= X29 (+ (* 253 S0) (* 947 S1)))
 (= X29 (- (* 253 S0) (* 947 S1)))
 (= X29 (- (* 947 S0) (* 253 S1)))
 (= X29 (+ (* 253 S0) (* 939 S1)))
 (= X29 (- (* 253 S0) (* 939 S1)))
 (= X29 (- (* 939 S0) (* 253 S1)))
 (= X29 (+ (* 253 S0) (* 527 S1)))
 (= X29 (- (* 253 S0) (* 527 S1)))
 (= X29 (- (* 527 S0) (* 253 S1)))
 (= X29 (+ (* 253 S0) (* 1953 S1)))
 (= X29 (- (* 253 S0) (* 1953 S1)))
 (= X29 (- (* 1953 S0) (* 253 S1)))
 (= X29 (+ (* 253 S0) (* 1245 S1)))
 (= X29 (- (* 253 S0) (* 1245 S1)))
 (= X29 (- (* 1245 S0) (* 253 S1)))
 (= X29 (+ (* 253 S0) (* 471 S1)))
 (= X29 (- (* 253 S0) (* 471 S1)))
 (= X29 (- (* 471 S0) (* 253 S1)))
 (= X29 (+ (* 253 S0) (* 1263 S1)))
 (= X29 (- (* 253 S0) (* 1263 S1)))
 (= X29 (- (* 1263 S0) (* 253 S1)))
 (= X29 (+ (* 253 S0) (* 235 S1)))
 (= X29 (- (* 253 S0) (* 235 S1)))
 (= X29 (- (* 235 S0) (* 253 S1)))
 (= X29 (+ (* 253 S0) (* 999 S1)))
 (= X29 (- (* 253 S0) (* 999 S1)))
 (= X29 (- (* 999 S0) (* 253 S1)))
 (= X29 (+ (* 253 S0) (* 1251 S1)))
 (= X29 (- (* 253 S0) (* 1251 S1)))
 (= X29 (- (* 1251 S0) (* 253 S1)))
 (= X29 (+ (* 253 S0) (* 1385 S1)))
 (= X29 (- (* 253 S0) (* 1385 S1)))
 (= X29 (- (* 1385 S0) (* 253 S1)))
 (= X29 (+ (* 595 S0) S1))
 (= X29 (- (* 595 S0) S1))
 (= X29 (- S0 (* 595 S1)))
 (= X29 (+ (* 595 S0) (* 595 S1)))
 (= X29 (- (* 595 S0) (* 595 S1)))
 (= X29 (+ (* 595 S0) (* 659 S1)))
 (= X29 (- (* 595 S0) (* 659 S1)))
 (= X29 (- (* 659 S0) (* 595 S1)))
 (= X29 (+ (* 595 S0) (* 403 S1)))
 (= X29 (- (* 595 S0) (* 403 S1)))
 (= X29 (- (* 403 S0) (* 595 S1)))
 (= X29 (+ (* 595 S0) (* 401 S1)))
 (= X29 (- (* 595 S0) (* 401 S1)))
 (= X29 (- (* 401 S0) (* 595 S1)))
 (= X29 (+ (* 595 S0) (* 893 S1)))
 (= X29 (- (* 595 S0) (* 893 S1)))
 (= X29 (- (* 893 S0) (* 595 S1)))
 (= X29 (+ (* 595 S0) (* 421 S1)))
 (= X29 (- (* 595 S0) (* 421 S1)))
 (= X29 (- (* 421 S0) (* 595 S1)))
 (= X29 (+ (* 595 S0) (* 453 S1)))
 (= X29 (- (* 595 S0) (* 453 S1)))
 (= X29 (- (* 453 S0) (* 595 S1)))
 (= X29 (+ (* 595 S0) (* 827 S1)))
 (= X29 (- (* 595 S0) (* 827 S1)))
 (= X29 (- (* 827 S0) (* 595 S1)))
 (= X29 (+ (* 595 S0) (* 961 S1)))
 (= X29 (- (* 595 S0) (* 961 S1)))
 (= X29 (- (* 961 S0) (* 595 S1)))
 (= X29 (+ (* 595 S0) (* 945 S1)))
 (= X29 (- (* 595 S0) (* 945 S1)))
 (= X29 (- (* 945 S0) (* 595 S1)))
 (= X29 (+ (* 595 S0) (* 947 S1)))
 (= X29 (- (* 595 S0) (* 947 S1)))
 (= X29 (- (* 947 S0) (* 595 S1)))
 (= X29 (+ (* 595 S0) (* 939 S1)))
 (= X29 (- (* 595 S0) (* 939 S1)))
 (= X29 (- (* 939 S0) (* 595 S1)))
 (= X29 (+ (* 595 S0) (* 527 S1)))
 (= X29 (- (* 595 S0) (* 527 S1)))
 (= X29 (- (* 527 S0) (* 595 S1)))
 (= X29 (+ (* 595 S0) (* 1953 S1)))
 (= X29 (- (* 595 S0) (* 1953 S1)))
 (= X29 (- (* 1953 S0) (* 595 S1)))
 (= X29 (+ (* 595 S0) (* 1245 S1)))
 (= X29 (- (* 595 S0) (* 1245 S1)))
 (= X29 (- (* 1245 S0) (* 595 S1)))
 (= X29 (+ (* 595 S0) (* 471 S1)))
 (= X29 (- (* 595 S0) (* 471 S1)))
 (= X29 (- (* 471 S0) (* 595 S1)))
 (= X29 (+ (* 595 S0) (* 1263 S1)))
 (= X29 (- (* 595 S0) (* 1263 S1)))
 (= X29 (- (* 1263 S0) (* 595 S1)))
 (= X29 (+ (* 595 S0) (* 235 S1)))
 (= X29 (- (* 595 S0) (* 235 S1)))
 (= X29 (- (* 235 S0) (* 595 S1)))
 (= X29 (+ (* 595 S0) (* 999 S1)))
 (= X29 (- (* 595 S0) (* 999 S1)))
 (= X29 (- (* 999 S0) (* 595 S1)))
 (= X29 (+ (* 595 S0) (* 1251 S1)))
 (= X29 (- (* 595 S0) (* 1251 S1)))
 (= X29 (- (* 1251 S0) (* 595 S1)))
 (= X29 (+ (* 595 S0) (* 1385 S1)))
 (= X29 (- (* 595 S0) (* 1385 S1)))
 (= X29 (- (* 1385 S0) (* 595 S1)))
 (= X29 (+ (* 659 S0) S1))
 (= X29 (- (* 659 S0) S1))
 (= X29 (- S0 (* 659 S1)))
 (= X29 (+ (* 659 S0) (* 659 S1)))
 (= X29 (- (* 659 S0) (* 659 S1)))
 (= X29 (+ (* 659 S0) (* 403 S1)))
 (= X29 (- (* 659 S0) (* 403 S1)))
 (= X29 (- (* 403 S0) (* 659 S1)))
 (= X29 (+ (* 659 S0) (* 401 S1)))
 (= X29 (- (* 659 S0) (* 401 S1)))
 (= X29 (- (* 401 S0) (* 659 S1)))
 (= X29 (+ (* 659 S0) (* 893 S1)))
 (= X29 (- (* 659 S0) (* 893 S1)))
 (= X29 (- (* 893 S0) (* 659 S1)))
 (= X29 (+ (* 659 S0) (* 421 S1)))
 (= X29 (- (* 659 S0) (* 421 S1)))
 (= X29 (- (* 421 S0) (* 659 S1)))
 (= X29 (+ (* 659 S0) (* 453 S1)))
 (= X29 (- (* 659 S0) (* 453 S1)))
 (= X29 (- (* 453 S0) (* 659 S1)))
 (= X29 (+ (* 659 S0) (* 827 S1)))
 (= X29 (- (* 659 S0) (* 827 S1)))
 (= X29 (- (* 827 S0) (* 659 S1)))
 (= X29 (+ (* 659 S0) (* 961 S1)))
 (= X29 (- (* 659 S0) (* 961 S1)))
 (= X29 (- (* 961 S0) (* 659 S1)))
 (= X29 (+ (* 659 S0) (* 945 S1)))
 (= X29 (- (* 659 S0) (* 945 S1)))
 (= X29 (- (* 945 S0) (* 659 S1)))
 (= X29 (+ (* 659 S0) (* 947 S1)))
 (= X29 (- (* 659 S0) (* 947 S1)))
 (= X29 (- (* 947 S0) (* 659 S1)))
 (= X29 (+ (* 659 S0) (* 939 S1)))
 (= X29 (- (* 659 S0) (* 939 S1)))
 (= X29 (- (* 939 S0) (* 659 S1)))
 (= X29 (+ (* 659 S0) (* 527 S1)))
 (= X29 (- (* 659 S0) (* 527 S1)))
 (= X29 (- (* 527 S0) (* 659 S1)))
 (= X29 (+ (* 659 S0) (* 1953 S1)))
 (= X29 (- (* 659 S0) (* 1953 S1)))
 (= X29 (- (* 1953 S0) (* 659 S1)))
 (= X29 (+ (* 659 S0) (* 1245 S1)))
 (= X29 (- (* 659 S0) (* 1245 S1)))
 (= X29 (- (* 1245 S0) (* 659 S1)))
 (= X29 (+ (* 659 S0) (* 471 S1)))
 (= X29 (- (* 659 S0) (* 471 S1)))
 (= X29 (- (* 471 S0) (* 659 S1)))
 (= X29 (+ (* 659 S0) (* 1263 S1)))
 (= X29 (- (* 659 S0) (* 1263 S1)))
 (= X29 (- (* 1263 S0) (* 659 S1)))
 (= X29 (+ (* 659 S0) (* 235 S1)))
 (= X29 (- (* 659 S0) (* 235 S1)))
 (= X29 (- (* 235 S0) (* 659 S1)))
 (= X29 (+ (* 659 S0) (* 999 S1)))
 (= X29 (- (* 659 S0) (* 999 S1)))
 (= X29 (- (* 999 S0) (* 659 S1)))
 (= X29 (+ (* 659 S0) (* 1251 S1)))
 (= X29 (- (* 659 S0) (* 1251 S1)))
 (= X29 (- (* 1251 S0) (* 659 S1)))
 (= X29 (+ (* 659 S0) (* 1385 S1)))
 (= X29 (- (* 659 S0) (* 1385 S1)))
 (= X29 (- (* 1385 S0) (* 659 S1)))
 (= X29 (+ (* 403 S0) S1))
 (= X29 (- (* 403 S0) S1))
 (= X29 (- S0 (* 403 S1)))
 (= X29 (+ (* 403 S0) (* 403 S1)))
 (= X29 (- (* 403 S0) (* 403 S1)))
 (= X29 (+ (* 403 S0) (* 401 S1)))
 (= X29 (- (* 403 S0) (* 401 S1)))
 (= X29 (- (* 401 S0) (* 403 S1)))
 (= X29 (+ (* 403 S0) (* 893 S1)))
 (= X29 (- (* 403 S0) (* 893 S1)))
 (= X29 (- (* 893 S0) (* 403 S1)))
 (= X29 (+ (* 403 S0) (* 421 S1)))
 (= X29 (- (* 403 S0) (* 421 S1)))
 (= X29 (- (* 421 S0) (* 403 S1)))
 (= X29 (+ (* 403 S0) (* 453 S1)))
 (= X29 (- (* 403 S0) (* 453 S1)))
 (= X29 (- (* 453 S0) (* 403 S1)))
 (= X29 (+ (* 403 S0) (* 827 S1)))
 (= X29 (- (* 403 S0) (* 827 S1)))
 (= X29 (- (* 827 S0) (* 403 S1)))
 (= X29 (+ (* 403 S0) (* 961 S1)))
 (= X29 (- (* 403 S0) (* 961 S1)))
 (= X29 (- (* 961 S0) (* 403 S1)))
 (= X29 (+ (* 403 S0) (* 945 S1)))
 (= X29 (- (* 403 S0) (* 945 S1)))
 (= X29 (- (* 945 S0) (* 403 S1)))
 (= X29 (+ (* 403 S0) (* 947 S1)))
 (= X29 (- (* 403 S0) (* 947 S1)))
 (= X29 (- (* 947 S0) (* 403 S1)))
 (= X29 (+ (* 403 S0) (* 939 S1)))
 (= X29 (- (* 403 S0) (* 939 S1)))
 (= X29 (- (* 939 S0) (* 403 S1)))
 (= X29 (+ (* 403 S0) (* 527 S1)))
 (= X29 (- (* 403 S0) (* 527 S1)))
 (= X29 (- (* 527 S0) (* 403 S1)))
 (= X29 (+ (* 403 S0) (* 1953 S1)))
 (= X29 (- (* 403 S0) (* 1953 S1)))
 (= X29 (- (* 1953 S0) (* 403 S1)))
 (= X29 (+ (* 403 S0) (* 1245 S1)))
 (= X29 (- (* 403 S0) (* 1245 S1)))
 (= X29 (- (* 1245 S0) (* 403 S1)))
 (= X29 (+ (* 403 S0) (* 471 S1)))
 (= X29 (- (* 403 S0) (* 471 S1)))
 (= X29 (- (* 471 S0) (* 403 S1)))
 (= X29 (+ (* 403 S0) (* 1263 S1)))
 (= X29 (- (* 403 S0) (* 1263 S1)))
 (= X29 (- (* 1263 S0) (* 403 S1)))
 (= X29 (+ (* 403 S0) (* 235 S1)))
 (= X29 (- (* 403 S0) (* 235 S1)))
 (= X29 (- (* 235 S0) (* 403 S1)))
 (= X29 (+ (* 403 S0) (* 999 S1)))
 (= X29 (- (* 403 S0) (* 999 S1)))
 (= X29 (- (* 999 S0) (* 403 S1)))
 (= X29 (+ (* 403 S0) (* 1251 S1)))
 (= X29 (- (* 403 S0) (* 1251 S1)))
 (= X29 (- (* 1251 S0) (* 403 S1)))
 (= X29 (+ (* 403 S0) (* 1385 S1)))
 (= X29 (- (* 403 S0) (* 1385 S1)))
 (= X29 (- (* 1385 S0) (* 403 S1)))
 (= X29 (+ (* 401 S0) S1))
 (= X29 (- (* 401 S0) S1))
 (= X29 (- S0 (* 401 S1)))
 (= X29 (+ (* 401 S0) (* 401 S1)))
 (= X29 (- (* 401 S0) (* 401 S1)))
 (= X29 (+ (* 401 S0) (* 893 S1)))
 (= X29 (- (* 401 S0) (* 893 S1)))
 (= X29 (- (* 893 S0) (* 401 S1)))
 (= X29 (+ (* 401 S0) (* 421 S1)))
 (= X29 (- (* 401 S0) (* 421 S1)))
 (= X29 (- (* 421 S0) (* 401 S1)))
 (= X29 (+ (* 401 S0) (* 453 S1)))
 (= X29 (- (* 401 S0) (* 453 S1)))
 (= X29 (- (* 453 S0) (* 401 S1)))
 (= X29 (+ (* 401 S0) (* 827 S1)))
 (= X29 (- (* 401 S0) (* 827 S1)))
 (= X29 (- (* 827 S0) (* 401 S1)))
 (= X29 (+ (* 401 S0) (* 961 S1)))
 (= X29 (- (* 401 S0) (* 961 S1)))
 (= X29 (- (* 961 S0) (* 401 S1)))
 (= X29 (+ (* 401 S0) (* 945 S1)))
 (= X29 (- (* 401 S0) (* 945 S1)))
 (= X29 (- (* 945 S0) (* 401 S1)))
 (= X29 (+ (* 401 S0) (* 947 S1)))
 (= X29 (- (* 401 S0) (* 947 S1)))
 (= X29 (- (* 947 S0) (* 401 S1)))
 (= X29 (+ (* 401 S0) (* 939 S1)))
 (= X29 (- (* 401 S0) (* 939 S1)))
 (= X29 (- (* 939 S0) (* 401 S1)))
 (= X29 (+ (* 401 S0) (* 527 S1)))
 (= X29 (- (* 401 S0) (* 527 S1)))
 (= X29 (- (* 527 S0) (* 401 S1)))
 (= X29 (+ (* 401 S0) (* 1953 S1)))
 (= X29 (- (* 401 S0) (* 1953 S1)))
 (= X29 (- (* 1953 S0) (* 401 S1)))
 (= X29 (+ (* 401 S0) (* 1245 S1)))
 (= X29 (- (* 401 S0) (* 1245 S1)))
 (= X29 (- (* 1245 S0) (* 401 S1)))
 (= X29 (+ (* 401 S0) (* 471 S1)))
 (= X29 (- (* 401 S0) (* 471 S1)))
 (= X29 (- (* 471 S0) (* 401 S1)))
 (= X29 (+ (* 401 S0) (* 1263 S1)))
 (= X29 (- (* 401 S0) (* 1263 S1)))
 (= X29 (- (* 1263 S0) (* 401 S1)))
 (= X29 (+ (* 401 S0) (* 235 S1)))
 (= X29 (- (* 401 S0) (* 235 S1)))
 (= X29 (- (* 235 S0) (* 401 S1)))
 (= X29 (+ (* 401 S0) (* 999 S1)))
 (= X29 (- (* 401 S0) (* 999 S1)))
 (= X29 (- (* 999 S0) (* 401 S1)))
 (= X29 (+ (* 401 S0) (* 1251 S1)))
 (= X29 (- (* 401 S0) (* 1251 S1)))
 (= X29 (- (* 1251 S0) (* 401 S1)))
 (= X29 (+ (* 401 S0) (* 1385 S1)))
 (= X29 (- (* 401 S0) (* 1385 S1)))
 (= X29 (- (* 1385 S0) (* 401 S1)))
 (= X29 (+ (* 893 S0) S1))
 (= X29 (- (* 893 S0) S1))
 (= X29 (- S0 (* 893 S1)))
 (= X29 (+ (* 893 S0) (* 893 S1)))
 (= X29 (- (* 893 S0) (* 893 S1)))
 (= X29 (+ (* 893 S0) (* 421 S1)))
 (= X29 (- (* 893 S0) (* 421 S1)))
 (= X29 (- (* 421 S0) (* 893 S1)))
 (= X29 (+ (* 893 S0) (* 453 S1)))
 (= X29 (- (* 893 S0) (* 453 S1)))
 (= X29 (- (* 453 S0) (* 893 S1)))
 (= X29 (+ (* 893 S0) (* 827 S1)))
 (= X29 (- (* 893 S0) (* 827 S1)))
 (= X29 (- (* 827 S0) (* 893 S1)))
 (= X29 (+ (* 893 S0) (* 961 S1)))
 (= X29 (- (* 893 S0) (* 961 S1)))
 (= X29 (- (* 961 S0) (* 893 S1)))
 (= X29 (+ (* 893 S0) (* 945 S1)))
 (= X29 (- (* 893 S0) (* 945 S1)))
 (= X29 (- (* 945 S0) (* 893 S1)))
 (= X29 (+ (* 893 S0) (* 947 S1)))
 (= X29 (- (* 893 S0) (* 947 S1)))
 (= X29 (- (* 947 S0) (* 893 S1)))
 (= X29 (+ (* 893 S0) (* 939 S1)))
 (= X29 (- (* 893 S0) (* 939 S1)))
 (= X29 (- (* 939 S0) (* 893 S1)))
 (= X29 (+ (* 893 S0) (* 527 S1)))
 (= X29 (- (* 893 S0) (* 527 S1)))
 (= X29 (- (* 527 S0) (* 893 S1)))
 (= X29 (+ (* 893 S0) (* 1953 S1)))
 (= X29 (- (* 893 S0) (* 1953 S1)))
 (= X29 (- (* 1953 S0) (* 893 S1)))
 (= X29 (+ (* 893 S0) (* 1245 S1)))
 (= X29 (- (* 893 S0) (* 1245 S1)))
 (= X29 (- (* 1245 S0) (* 893 S1)))
 (= X29 (+ (* 893 S0) (* 471 S1)))
 (= X29 (- (* 893 S0) (* 471 S1)))
 (= X29 (- (* 471 S0) (* 893 S1)))
 (= X29 (+ (* 893 S0) (* 1263 S1)))
 (= X29 (- (* 893 S0) (* 1263 S1)))
 (= X29 (- (* 1263 S0) (* 893 S1)))
 (= X29 (+ (* 893 S0) (* 235 S1)))
 (= X29 (- (* 893 S0) (* 235 S1)))
 (= X29 (- (* 235 S0) (* 893 S1)))
 (= X29 (+ (* 893 S0) (* 999 S1)))
 (= X29 (- (* 893 S0) (* 999 S1)))
 (= X29 (- (* 999 S0) (* 893 S1)))
 (= X29 (+ (* 893 S0) (* 1251 S1)))
 (= X29 (- (* 893 S0) (* 1251 S1)))
 (= X29 (- (* 1251 S0) (* 893 S1)))
 (= X29 (+ (* 893 S0) (* 1385 S1)))
 (= X29 (- (* 893 S0) (* 1385 S1)))
 (= X29 (- (* 1385 S0) (* 893 S1)))
 (= X29 (+ (* 421 S0) S1))
 (= X29 (- (* 421 S0) S1))
 (= X29 (- S0 (* 421 S1)))
 (= X29 (+ (* 421 S0) (* 421 S1)))
 (= X29 (- (* 421 S0) (* 421 S1)))
 (= X29 (+ (* 421 S0) (* 453 S1)))
 (= X29 (- (* 421 S0) (* 453 S1)))
 (= X29 (- (* 453 S0) (* 421 S1)))
 (= X29 (+ (* 421 S0) (* 827 S1)))
 (= X29 (- (* 421 S0) (* 827 S1)))
 (= X29 (- (* 827 S0) (* 421 S1)))
 (= X29 (+ (* 421 S0) (* 961 S1)))
 (= X29 (- (* 421 S0) (* 961 S1)))
 (= X29 (- (* 961 S0) (* 421 S1)))
 (= X29 (+ (* 421 S0) (* 945 S1)))
 (= X29 (- (* 421 S0) (* 945 S1)))
 (= X29 (- (* 945 S0) (* 421 S1)))
 (= X29 (+ (* 421 S0) (* 947 S1)))
 (= X29 (- (* 421 S0) (* 947 S1)))
 (= X29 (- (* 947 S0) (* 421 S1)))
 (= X29 (+ (* 421 S0) (* 939 S1)))
 (= X29 (- (* 421 S0) (* 939 S1)))
 (= X29 (- (* 939 S0) (* 421 S1)))
 (= X29 (+ (* 421 S0) (* 527 S1)))
 (= X29 (- (* 421 S0) (* 527 S1)))
 (= X29 (- (* 527 S0) (* 421 S1)))
 (= X29 (+ (* 421 S0) (* 1953 S1)))
 (= X29 (- (* 421 S0) (* 1953 S1)))
 (= X29 (- (* 1953 S0) (* 421 S1)))
 (= X29 (+ (* 421 S0) (* 1245 S1)))
 (= X29 (- (* 421 S0) (* 1245 S1)))
 (= X29 (- (* 1245 S0) (* 421 S1)))
 (= X29 (+ (* 421 S0) (* 471 S1)))
 (= X29 (- (* 421 S0) (* 471 S1)))
 (= X29 (- (* 471 S0) (* 421 S1)))
 (= X29 (+ (* 421 S0) (* 1263 S1)))
 (= X29 (- (* 421 S0) (* 1263 S1)))
 (= X29 (- (* 1263 S0) (* 421 S1)))
 (= X29 (+ (* 421 S0) (* 235 S1)))
 (= X29 (- (* 421 S0) (* 235 S1)))
 (= X29 (- (* 235 S0) (* 421 S1)))
 (= X29 (+ (* 421 S0) (* 999 S1)))
 (= X29 (- (* 421 S0) (* 999 S1)))
 (= X29 (- (* 999 S0) (* 421 S1)))
 (= X29 (+ (* 421 S0) (* 1251 S1)))
 (= X29 (- (* 421 S0) (* 1251 S1)))
 (= X29 (- (* 1251 S0) (* 421 S1)))
 (= X29 (+ (* 421 S0) (* 1385 S1)))
 (= X29 (- (* 421 S0) (* 1385 S1)))
 (= X29 (- (* 1385 S0) (* 421 S1)))
 (= X29 (+ (* 453 S0) S1))
 (= X29 (- (* 453 S0) S1))
 (= X29 (- S0 (* 453 S1)))
 (= X29 (+ (* 453 S0) (* 453 S1)))
 (= X29 (- (* 453 S0) (* 453 S1)))
 (= X29 (+ (* 453 S0) (* 827 S1)))
 (= X29 (- (* 453 S0) (* 827 S1)))
 (= X29 (- (* 827 S0) (* 453 S1)))
 (= X29 (+ (* 453 S0) (* 961 S1)))
 (= X29 (- (* 453 S0) (* 961 S1)))
 (= X29 (- (* 961 S0) (* 453 S1)))
 (= X29 (+ (* 453 S0) (* 945 S1)))
 (= X29 (- (* 453 S0) (* 945 S1)))
 (= X29 (- (* 945 S0) (* 453 S1)))
 (= X29 (+ (* 453 S0) (* 947 S1)))
 (= X29 (- (* 453 S0) (* 947 S1)))
 (= X29 (- (* 947 S0) (* 453 S1)))
 (= X29 (+ (* 453 S0) (* 939 S1)))
 (= X29 (- (* 453 S0) (* 939 S1)))
 (= X29 (- (* 939 S0) (* 453 S1)))
 (= X29 (+ (* 453 S0) (* 527 S1)))
 (= X29 (- (* 453 S0) (* 527 S1)))
 (= X29 (- (* 527 S0) (* 453 S1)))
 (= X29 (+ (* 453 S0) (* 1953 S1)))
 (= X29 (- (* 453 S0) (* 1953 S1)))
 (= X29 (- (* 1953 S0) (* 453 S1)))
 (= X29 (+ (* 453 S0) (* 1245 S1)))
 (= X29 (- (* 453 S0) (* 1245 S1)))
 (= X29 (- (* 1245 S0) (* 453 S1)))
 (= X29 (+ (* 453 S0) (* 471 S1)))
 (= X29 (- (* 453 S0) (* 471 S1)))
 (= X29 (- (* 471 S0) (* 453 S1)))
 (= X29 (+ (* 453 S0) (* 1263 S1)))
 (= X29 (- (* 453 S0) (* 1263 S1)))
 (= X29 (- (* 1263 S0) (* 453 S1)))
 (= X29 (+ (* 453 S0) (* 235 S1)))
 (= X29 (- (* 453 S0) (* 235 S1)))
 (= X29 (- (* 235 S0) (* 453 S1)))
 (= X29 (+ (* 453 S0) (* 999 S1)))
 (= X29 (- (* 453 S0) (* 999 S1)))
 (= X29 (- (* 999 S0) (* 453 S1)))
 (= X29 (+ (* 453 S0) (* 1251 S1)))
 (= X29 (- (* 453 S0) (* 1251 S1)))
 (= X29 (- (* 1251 S0) (* 453 S1)))
 (= X29 (+ (* 453 S0) (* 1385 S1)))
 (= X29 (- (* 453 S0) (* 1385 S1)))
 (= X29 (- (* 1385 S0) (* 453 S1)))
 (= X29 (+ (* 827 S0) S1))
 (= X29 (- (* 827 S0) S1))
 (= X29 (- S0 (* 827 S1)))
 (= X29 (+ (* 827 S0) (* 827 S1)))
 (= X29 (- (* 827 S0) (* 827 S1)))
 (= X29 (+ (* 827 S0) (* 961 S1)))
 (= X29 (- (* 827 S0) (* 961 S1)))
 (= X29 (- (* 961 S0) (* 827 S1)))
 (= X29 (+ (* 827 S0) (* 945 S1)))
 (= X29 (- (* 827 S0) (* 945 S1)))
 (= X29 (- (* 945 S0) (* 827 S1)))
 (= X29 (+ (* 827 S0) (* 947 S1)))
 (= X29 (- (* 827 S0) (* 947 S1)))
 (= X29 (- (* 947 S0) (* 827 S1)))
 (= X29 (+ (* 827 S0) (* 939 S1)))
 (= X29 (- (* 827 S0) (* 939 S1)))
 (= X29 (- (* 939 S0) (* 827 S1)))
 (= X29 (+ (* 827 S0) (* 527 S1)))
 (= X29 (- (* 827 S0) (* 527 S1)))
 (= X29 (- (* 527 S0) (* 827 S1)))
 (= X29 (+ (* 827 S0) (* 1953 S1)))
 (= X29 (- (* 827 S0) (* 1953 S1)))
 (= X29 (- (* 1953 S0) (* 827 S1)))
 (= X29 (+ (* 827 S0) (* 1245 S1)))
 (= X29 (- (* 827 S0) (* 1245 S1)))
 (= X29 (- (* 1245 S0) (* 827 S1)))
 (= X29 (+ (* 827 S0) (* 471 S1)))
 (= X29 (- (* 827 S0) (* 471 S1)))
 (= X29 (- (* 471 S0) (* 827 S1)))
 (= X29 (+ (* 827 S0) (* 1263 S1)))
 (= X29 (- (* 827 S0) (* 1263 S1)))
 (= X29 (- (* 1263 S0) (* 827 S1)))
 (= X29 (+ (* 827 S0) (* 235 S1)))
 (= X29 (- (* 827 S0) (* 235 S1)))
 (= X29 (- (* 235 S0) (* 827 S1)))
 (= X29 (+ (* 827 S0) (* 999 S1)))
 (= X29 (- (* 827 S0) (* 999 S1)))
 (= X29 (- (* 999 S0) (* 827 S1)))
 (= X29 (+ (* 827 S0) (* 1251 S1)))
 (= X29 (- (* 827 S0) (* 1251 S1)))
 (= X29 (- (* 1251 S0) (* 827 S1)))
 (= X29 (+ (* 827 S0) (* 1385 S1)))
 (= X29 (- (* 827 S0) (* 1385 S1)))
 (= X29 (- (* 1385 S0) (* 827 S1)))
 (= X29 (+ (* 961 S0) S1))
 (= X29 (- (* 961 S0) S1))
 (= X29 (- S0 (* 961 S1)))
 (= X29 (+ (* 961 S0) (* 961 S1)))
 (= X29 (- (* 961 S0) (* 961 S1)))
 (= X29 (+ (* 961 S0) (* 945 S1)))
 (= X29 (- (* 961 S0) (* 945 S1)))
 (= X29 (- (* 945 S0) (* 961 S1)))
 (= X29 (+ (* 961 S0) (* 947 S1)))
 (= X29 (- (* 961 S0) (* 947 S1)))
 (= X29 (- (* 947 S0) (* 961 S1)))
 (= X29 (+ (* 961 S0) (* 939 S1)))
 (= X29 (- (* 961 S0) (* 939 S1)))
 (= X29 (- (* 939 S0) (* 961 S1)))
 (= X29 (+ (* 961 S0) (* 527 S1)))
 (= X29 (- (* 961 S0) (* 527 S1)))
 (= X29 (- (* 527 S0) (* 961 S1)))
 (= X29 (+ (* 961 S0) (* 1953 S1)))
 (= X29 (- (* 961 S0) (* 1953 S1)))
 (= X29 (- (* 1953 S0) (* 961 S1)))
 (= X29 (+ (* 961 S0) (* 1245 S1)))
 (= X29 (- (* 961 S0) (* 1245 S1)))
 (= X29 (- (* 1245 S0) (* 961 S1)))
 (= X29 (+ (* 961 S0) (* 471 S1)))
 (= X29 (- (* 961 S0) (* 471 S1)))
 (= X29 (- (* 471 S0) (* 961 S1)))
 (= X29 (+ (* 961 S0) (* 1263 S1)))
 (= X29 (- (* 961 S0) (* 1263 S1)))
 (= X29 (- (* 1263 S0) (* 961 S1)))
 (= X29 (+ (* 961 S0) (* 235 S1)))
 (= X29 (- (* 961 S0) (* 235 S1)))
 (= X29 (- (* 235 S0) (* 961 S1)))
 (= X29 (+ (* 961 S0) (* 999 S1)))
 (= X29 (- (* 961 S0) (* 999 S1)))
 (= X29 (- (* 999 S0) (* 961 S1)))
 (= X29 (+ (* 961 S0) (* 1251 S1)))
 (= X29 (- (* 961 S0) (* 1251 S1)))
 (= X29 (- (* 1251 S0) (* 961 S1)))
 (= X29 (+ (* 961 S0) (* 1385 S1)))
 (= X29 (- (* 961 S0) (* 1385 S1)))
 (= X29 (- (* 1385 S0) (* 961 S1)))
 (= X29 (+ (* 945 S0) S1))
 (= X29 (- (* 945 S0) S1))
 (= X29 (- S0 (* 945 S1)))
 (= X29 (+ (* 945 S0) (* 945 S1)))
 (= X29 (- (* 945 S0) (* 945 S1)))
 (= X29 (+ (* 945 S0) (* 947 S1)))
 (= X29 (- (* 945 S0) (* 947 S1)))
 (= X29 (- (* 947 S0) (* 945 S1)))
 (= X29 (+ (* 945 S0) (* 939 S1)))
 (= X29 (- (* 945 S0) (* 939 S1)))
 (= X29 (- (* 939 S0) (* 945 S1)))
 (= X29 (+ (* 945 S0) (* 527 S1)))
 (= X29 (- (* 945 S0) (* 527 S1)))
 (= X29 (- (* 527 S0) (* 945 S1)))
 (= X29 (+ (* 945 S0) (* 1953 S1)))
 (= X29 (- (* 945 S0) (* 1953 S1)))
 (= X29 (- (* 1953 S0) (* 945 S1)))
 (= X29 (+ (* 945 S0) (* 1245 S1)))
 (= X29 (- (* 945 S0) (* 1245 S1)))
 (= X29 (- (* 1245 S0) (* 945 S1)))
 (= X29 (+ (* 945 S0) (* 471 S1)))
 (= X29 (- (* 945 S0) (* 471 S1)))
 (= X29 (- (* 471 S0) (* 945 S1)))
 (= X29 (+ (* 945 S0) (* 1263 S1)))
 (= X29 (- (* 945 S0) (* 1263 S1)))
 (= X29 (- (* 1263 S0) (* 945 S1)))
 (= X29 (+ (* 945 S0) (* 235 S1)))
 (= X29 (- (* 945 S0) (* 235 S1)))
 (= X29 (- (* 235 S0) (* 945 S1)))
 (= X29 (+ (* 945 S0) (* 999 S1)))
 (= X29 (- (* 945 S0) (* 999 S1)))
 (= X29 (- (* 999 S0) (* 945 S1)))
 (= X29 (+ (* 945 S0) (* 1251 S1)))
 (= X29 (- (* 945 S0) (* 1251 S1)))
 (= X29 (- (* 1251 S0) (* 945 S1)))
 (= X29 (+ (* 945 S0) (* 1385 S1)))
 (= X29 (- (* 945 S0) (* 1385 S1)))
 (= X29 (- (* 1385 S0) (* 945 S1)))
 (= X29 (+ (* 947 S0) S1))
 (= X29 (- (* 947 S0) S1))
 (= X29 (- S0 (* 947 S1)))
 (= X29 (+ (* 947 S0) (* 947 S1)))
 (= X29 (- (* 947 S0) (* 947 S1)))
 (= X29 (+ (* 947 S0) (* 939 S1)))
 (= X29 (- (* 947 S0) (* 939 S1)))
 (= X29 (- (* 939 S0) (* 947 S1)))
 (= X29 (+ (* 947 S0) (* 527 S1)))
 (= X29 (- (* 947 S0) (* 527 S1)))
 (= X29 (- (* 527 S0) (* 947 S1)))
 (= X29 (+ (* 947 S0) (* 1953 S1)))
 (= X29 (- (* 947 S0) (* 1953 S1)))
 (= X29 (- (* 1953 S0) (* 947 S1)))
 (= X29 (+ (* 947 S0) (* 1245 S1)))
 (= X29 (- (* 947 S0) (* 1245 S1)))
 (= X29 (- (* 1245 S0) (* 947 S1)))
 (= X29 (+ (* 947 S0) (* 471 S1)))
 (= X29 (- (* 947 S0) (* 471 S1)))
 (= X29 (- (* 471 S0) (* 947 S1)))
 (= X29 (+ (* 947 S0) (* 1263 S1)))
 (= X29 (- (* 947 S0) (* 1263 S1)))
 (= X29 (- (* 1263 S0) (* 947 S1)))
 (= X29 (+ (* 947 S0) (* 235 S1)))
 (= X29 (- (* 947 S0) (* 235 S1)))
 (= X29 (- (* 235 S0) (* 947 S1)))
 (= X29 (+ (* 947 S0) (* 999 S1)))
 (= X29 (- (* 947 S0) (* 999 S1)))
 (= X29 (- (* 999 S0) (* 947 S1)))
 (= X29 (+ (* 947 S0) (* 1251 S1)))
 (= X29 (- (* 947 S0) (* 1251 S1)))
 (= X29 (- (* 1251 S0) (* 947 S1)))
 (= X29 (+ (* 947 S0) (* 1385 S1)))
 (= X29 (- (* 947 S0) (* 1385 S1)))
 (= X29 (- (* 1385 S0) (* 947 S1)))
 (= X29 (+ (* 939 S0) S1))
 (= X29 (- (* 939 S0) S1))
 (= X29 (- S0 (* 939 S1)))
 (= X29 (+ (* 939 S0) (* 939 S1)))
 (= X29 (- (* 939 S0) (* 939 S1)))
 (= X29 (+ (* 939 S0) (* 527 S1)))
 (= X29 (- (* 939 S0) (* 527 S1)))
 (= X29 (- (* 527 S0) (* 939 S1)))
 (= X29 (+ (* 939 S0) (* 1953 S1)))
 (= X29 (- (* 939 S0) (* 1953 S1)))
 (= X29 (- (* 1953 S0) (* 939 S1)))
 (= X29 (+ (* 939 S0) (* 1245 S1)))
 (= X29 (- (* 939 S0) (* 1245 S1)))
 (= X29 (- (* 1245 S0) (* 939 S1)))
 (= X29 (+ (* 939 S0) (* 471 S1)))
 (= X29 (- (* 939 S0) (* 471 S1)))
 (= X29 (- (* 471 S0) (* 939 S1)))
 (= X29 (+ (* 939 S0) (* 1263 S1)))
 (= X29 (- (* 939 S0) (* 1263 S1)))
 (= X29 (- (* 1263 S0) (* 939 S1)))
 (= X29 (+ (* 939 S0) (* 235 S1)))
 (= X29 (- (* 939 S0) (* 235 S1)))
 (= X29 (- (* 235 S0) (* 939 S1)))
 (= X29 (+ (* 939 S0) (* 999 S1)))
 (= X29 (- (* 939 S0) (* 999 S1)))
 (= X29 (- (* 999 S0) (* 939 S1)))
 (= X29 (+ (* 939 S0) (* 1251 S1)))
 (= X29 (- (* 939 S0) (* 1251 S1)))
 (= X29 (- (* 1251 S0) (* 939 S1)))
 (= X29 (+ (* 939 S0) (* 1385 S1)))
 (= X29 (- (* 939 S0) (* 1385 S1)))
 (= X29 (- (* 1385 S0) (* 939 S1)))
 (= X29 (+ (* 527 S0) S1))
 (= X29 (- (* 527 S0) S1))
 (= X29 (- S0 (* 527 S1)))
 (= X29 (+ (* 527 S0) (* 527 S1)))
 (= X29 (- (* 527 S0) (* 527 S1)))
 (= X29 (+ (* 527 S0) (* 1953 S1)))
 (= X29 (- (* 527 S0) (* 1953 S1)))
 (= X29 (- (* 1953 S0) (* 527 S1)))
 (= X29 (+ (* 527 S0) (* 1245 S1)))
 (= X29 (- (* 527 S0) (* 1245 S1)))
 (= X29 (- (* 1245 S0) (* 527 S1)))
 (= X29 (+ (* 527 S0) (* 471 S1)))
 (= X29 (- (* 527 S0) (* 471 S1)))
 (= X29 (- (* 471 S0) (* 527 S1)))
 (= X29 (+ (* 527 S0) (* 1263 S1)))
 (= X29 (- (* 527 S0) (* 1263 S1)))
 (= X29 (- (* 1263 S0) (* 527 S1)))
 (= X29 (+ (* 527 S0) (* 235 S1)))
 (= X29 (- (* 527 S0) (* 235 S1)))
 (= X29 (- (* 235 S0) (* 527 S1)))
 (= X29 (+ (* 527 S0) (* 999 S1)))
 (= X29 (- (* 527 S0) (* 999 S1)))
 (= X29 (- (* 999 S0) (* 527 S1)))
 (= X29 (+ (* 527 S0) (* 1251 S1)))
 (= X29 (- (* 527 S0) (* 1251 S1)))
 (= X29 (- (* 1251 S0) (* 527 S1)))
 (= X29 (+ (* 527 S0) (* 1385 S1)))
 (= X29 (- (* 527 S0) (* 1385 S1)))
 (= X29 (- (* 1385 S0) (* 527 S1)))
 (= X29 (+ (* 1953 S0) S1))
 (= X29 (- (* 1953 S0) S1))
 (= X29 (- S0 (* 1953 S1)))
 (= X29 (+ (* 1953 S0) (* 1953 S1)))
 (= X29 (- (* 1953 S0) (* 1953 S1)))
 (= X29 (+ (* 1953 S0) (* 1245 S1)))
 (= X29 (- (* 1953 S0) (* 1245 S1)))
 (= X29 (- (* 1245 S0) (* 1953 S1)))
 (= X29 (+ (* 1953 S0) (* 471 S1)))
 (= X29 (- (* 1953 S0) (* 471 S1)))
 (= X29 (- (* 471 S0) (* 1953 S1)))
 (= X29 (+ (* 1953 S0) (* 1263 S1)))
 (= X29 (- (* 1953 S0) (* 1263 S1)))
 (= X29 (- (* 1263 S0) (* 1953 S1)))
 (= X29 (+ (* 1953 S0) (* 235 S1)))
 (= X29 (- (* 1953 S0) (* 235 S1)))
 (= X29 (- (* 235 S0) (* 1953 S1)))
 (= X29 (+ (* 1953 S0) (* 999 S1)))
 (= X29 (- (* 1953 S0) (* 999 S1)))
 (= X29 (- (* 999 S0) (* 1953 S1)))
 (= X29 (+ (* 1953 S0) (* 1251 S1)))
 (= X29 (- (* 1953 S0) (* 1251 S1)))
 (= X29 (- (* 1251 S0) (* 1953 S1)))
 (= X29 (+ (* 1953 S0) (* 1385 S1)))
 (= X29 (- (* 1953 S0) (* 1385 S1)))
 (= X29 (- (* 1385 S0) (* 1953 S1)))
 (= X29 (+ (* 1245 S0) S1))
 (= X29 (- (* 1245 S0) S1))
 (= X29 (- S0 (* 1245 S1)))
 (= X29 (+ (* 1245 S0) (* 1245 S1)))
 (= X29 (- (* 1245 S0) (* 1245 S1)))
 (= X29 (+ (* 1245 S0) (* 471 S1)))
 (= X29 (- (* 1245 S0) (* 471 S1)))
 (= X29 (- (* 471 S0) (* 1245 S1)))
 (= X29 (+ (* 1245 S0) (* 1263 S1)))
 (= X29 (- (* 1245 S0) (* 1263 S1)))
 (= X29 (- (* 1263 S0) (* 1245 S1)))
 (= X29 (+ (* 1245 S0) (* 235 S1)))
 (= X29 (- (* 1245 S0) (* 235 S1)))
 (= X29 (- (* 235 S0) (* 1245 S1)))
 (= X29 (+ (* 1245 S0) (* 999 S1)))
 (= X29 (- (* 1245 S0) (* 999 S1)))
 (= X29 (- (* 999 S0) (* 1245 S1)))
 (= X29 (+ (* 1245 S0) (* 1251 S1)))
 (= X29 (- (* 1245 S0) (* 1251 S1)))
 (= X29 (- (* 1251 S0) (* 1245 S1)))
 (= X29 (+ (* 1245 S0) (* 1385 S1)))
 (= X29 (- (* 1245 S0) (* 1385 S1)))
 (= X29 (- (* 1385 S0) (* 1245 S1)))
 (= X29 (+ (* 471 S0) S1))
 (= X29 (- (* 471 S0) S1))
 (= X29 (- S0 (* 471 S1)))
 (= X29 (+ (* 471 S0) (* 471 S1)))
 (= X29 (- (* 471 S0) (* 471 S1)))
 (= X29 (+ (* 471 S0) (* 1263 S1)))
 (= X29 (- (* 471 S0) (* 1263 S1)))
 (= X29 (- (* 1263 S0) (* 471 S1)))
 (= X29 (+ (* 471 S0) (* 235 S1)))
 (= X29 (- (* 471 S0) (* 235 S1)))
 (= X29 (- (* 235 S0) (* 471 S1)))
 (= X29 (+ (* 471 S0) (* 999 S1)))
 (= X29 (- (* 471 S0) (* 999 S1)))
 (= X29 (- (* 999 S0) (* 471 S1)))
 (= X29 (+ (* 471 S0) (* 1251 S1)))
 (= X29 (- (* 471 S0) (* 1251 S1)))
 (= X29 (- (* 1251 S0) (* 471 S1)))
 (= X29 (+ (* 471 S0) (* 1385 S1)))
 (= X29 (- (* 471 S0) (* 1385 S1)))
 (= X29 (- (* 1385 S0) (* 471 S1)))
 (= X29 (+ (* 1263 S0) S1))
 (= X29 (- (* 1263 S0) S1))
 (= X29 (- S0 (* 1263 S1)))
 (= X29 (+ (* 1263 S0) (* 1263 S1)))
 (= X29 (- (* 1263 S0) (* 1263 S1)))
 (= X29 (+ (* 1263 S0) (* 235 S1)))
 (= X29 (- (* 1263 S0) (* 235 S1)))
 (= X29 (- (* 235 S0) (* 1263 S1)))
 (= X29 (+ (* 1263 S0) (* 999 S1)))
 (= X29 (- (* 1263 S0) (* 999 S1)))
 (= X29 (- (* 999 S0) (* 1263 S1)))
 (= X29 (+ (* 1263 S0) (* 1251 S1)))
 (= X29 (- (* 1263 S0) (* 1251 S1)))
 (= X29 (- (* 1251 S0) (* 1263 S1)))
 (= X29 (+ (* 1263 S0) (* 1385 S1)))
 (= X29 (- (* 1263 S0) (* 1385 S1)))
 (= X29 (- (* 1385 S0) (* 1263 S1)))
 (= X29 (+ (* 235 S0) S1))
 (= X29 (- (* 235 S0) S1))
 (= X29 (- S0 (* 235 S1)))
 (= X29 (+ (* 235 S0) (* 235 S1)))
 (= X29 (- (* 235 S0) (* 235 S1)))
 (= X29 (+ (* 235 S0) (* 999 S1)))
 (= X29 (- (* 235 S0) (* 999 S1)))
 (= X29 (- (* 999 S0) (* 235 S1)))
 (= X29 (+ (* 235 S0) (* 1251 S1)))
 (= X29 (- (* 235 S0) (* 1251 S1)))
 (= X29 (- (* 1251 S0) (* 235 S1)))
 (= X29 (+ (* 235 S0) (* 1385 S1)))
 (= X29 (- (* 235 S0) (* 1385 S1)))
 (= X29 (- (* 1385 S0) (* 235 S1)))
 (= X29 (+ (* 999 S0) S1))
 (= X29 (- (* 999 S0) S1))
 (= X29 (- S0 (* 999 S1)))
 (= X29 (+ (* 999 S0) (* 999 S1)))
 (= X29 (- (* 999 S0) (* 999 S1)))
 (= X29 (+ (* 999 S0) (* 1251 S1)))
 (= X29 (- (* 999 S0) (* 1251 S1)))
 (= X29 (- (* 1251 S0) (* 999 S1)))
 (= X29 (+ (* 999 S0) (* 1385 S1)))
 (= X29 (- (* 999 S0) (* 1385 S1)))
 (= X29 (- (* 1385 S0) (* 999 S1)))
 (= X29 (+ (* 1251 S0) S1))
 (= X29 (- (* 1251 S0) S1))
 (= X29 (- S0 (* 1251 S1)))
 (= X29 (+ (* 1251 S0) (* 1251 S1)))
 (= X29 (- (* 1251 S0) (* 1251 S1)))
 (= X29 (+ (* 1251 S0) (* 1385 S1)))
 (= X29 (- (* 1251 S0) (* 1385 S1)))
 (= X29 (- (* 1385 S0) (* 1251 S1)))
 (= X29 (+ (* 1385 S0) S1))
 (= X29 (- (* 1385 S0) S1))
 (= X29 (- S0 (* 1385 S1)))
 (= X29 (+ (* 1385 S0) (* 1385 S1)))
 (= X29 (- (* 1385 S0) (* 1385 S1)))
))
(assert (and (> X29 0) (< X29 4096) (power2 S0) (power2 S1)))
(assert (or
 (= X30 (+ (* 5 S2) S3))
 (= X30 (- (* 5 S2) S3))
 (= X30 (- S2 (* 5 S3)))
 (= X30 (+ (* 5 S2) (* 5 S3)))
 (= X30 (- (* 5 S2) (* 5 S3)))
 (= X30 (+ (* 5 S2) (* 31 S3)))
 (= X30 (- (* 5 S2) (* 31 S3)))
 (= X30 (- (* 31 S2) (* 5 S3)))
 (= X30 (+ (* 5 S2) (* 161 S3)))
 (= X30 (- (* 5 S2) (* 161 S3)))
 (= X30 (- (* 161 S2) (* 5 S3)))
 (= X30 (+ (* 5 S2) (* 287 S3)))
 (= X30 (- (* 5 S2) (* 287 S3)))
 (= X30 (- (* 287 S2) (* 5 S3)))
 (= X30 (+ (* 5 S2) (* 45 S3)))
 (= X30 (- (* 5 S2) (* 45 S3)))
 (= X30 (- (* 45 S2) (* 5 S3)))
 (= X30 (+ (* 5 S2) (* 89 S3)))
 (= X30 (- (* 5 S2) (* 89 S3)))
 (= X30 (- (* 89 S2) (* 5 S3)))
 (= X30 (+ (* 5 S2) (* 87 S3)))
 (= X30 (- (* 5 S2) (* 87 S3)))
 (= X30 (- (* 87 S2) (* 5 S3)))
 (= X30 (+ (* 5 S2) (* 253 S3)))
 (= X30 (- (* 5 S2) (* 253 S3)))
 (= X30 (- (* 253 S2) (* 5 S3)))
 (= X30 (+ (* 5 S2) (* 595 S3)))
 (= X30 (- (* 5 S2) (* 595 S3)))
 (= X30 (- (* 595 S2) (* 5 S3)))
 (= X30 (+ (* 5 S2) (* 659 S3)))
 (= X30 (- (* 5 S2) (* 659 S3)))
 (= X30 (- (* 659 S2) (* 5 S3)))
 (= X30 (+ (* 5 S2) (* 403 S3)))
 (= X30 (- (* 5 S2) (* 403 S3)))
 (= X30 (- (* 403 S2) (* 5 S3)))
 (= X30 (+ (* 5 S2) (* 401 S3)))
 (= X30 (- (* 5 S2) (* 401 S3)))
 (= X30 (- (* 401 S2) (* 5 S3)))
 (= X30 (+ (* 5 S2) (* 893 S3)))
 (= X30 (- (* 5 S2) (* 893 S3)))
 (= X30 (- (* 893 S2) (* 5 S3)))
 (= X30 (+ (* 5 S2) (* 421 S3)))
 (= X30 (- (* 5 S2) (* 421 S3)))
 (= X30 (- (* 421 S2) (* 5 S3)))
 (= X30 (+ (* 5 S2) (* 453 S3)))
 (= X30 (- (* 5 S2) (* 453 S3)))
 (= X30 (- (* 453 S2) (* 5 S3)))
 (= X30 (+ (* 5 S2) (* 827 S3)))
 (= X30 (- (* 5 S2) (* 827 S3)))
 (= X30 (- (* 827 S2) (* 5 S3)))
 (= X30 (+ (* 5 S2) (* 961 S3)))
 (= X30 (- (* 5 S2) (* 961 S3)))
 (= X30 (- (* 961 S2) (* 5 S3)))
 (= X30 (+ (* 5 S2) (* 945 S3)))
 (= X30 (- (* 5 S2) (* 945 S3)))
 (= X30 (- (* 945 S2) (* 5 S3)))
 (= X30 (+ (* 5 S2) (* 947 S3)))
 (= X30 (- (* 5 S2) (* 947 S3)))
 (= X30 (- (* 947 S2) (* 5 S3)))
 (= X30 (+ (* 5 S2) (* 939 S3)))
 (= X30 (- (* 5 S2) (* 939 S3)))
 (= X30 (- (* 939 S2) (* 5 S3)))
 (= X30 (+ (* 5 S2) (* 527 S3)))
 (= X30 (- (* 5 S2) (* 527 S3)))
 (= X30 (- (* 527 S2) (* 5 S3)))
 (= X30 (+ (* 5 S2) (* 1953 S3)))
 (= X30 (- (* 5 S2) (* 1953 S3)))
 (= X30 (- (* 1953 S2) (* 5 S3)))
 (= X30 (+ (* 5 S2) (* 1245 S3)))
 (= X30 (- (* 5 S2) (* 1245 S3)))
 (= X30 (- (* 1245 S2) (* 5 S3)))
 (= X30 (+ (* 5 S2) (* 471 S3)))
 (= X30 (- (* 5 S2) (* 471 S3)))
 (= X30 (- (* 471 S2) (* 5 S3)))
 (= X30 (+ (* 5 S2) (* 1263 S3)))
 (= X30 (- (* 5 S2) (* 1263 S3)))
 (= X30 (- (* 1263 S2) (* 5 S3)))
 (= X30 (+ (* 5 S2) (* 235 S3)))
 (= X30 (- (* 5 S2) (* 235 S3)))
 (= X30 (- (* 235 S2) (* 5 S3)))
 (= X30 (+ (* 5 S2) (* 999 S3)))
 (= X30 (- (* 5 S2) (* 999 S3)))
 (= X30 (- (* 999 S2) (* 5 S3)))
 (= X30 (+ (* 5 S2) (* 1251 S3)))
 (= X30 (- (* 5 S2) (* 1251 S3)))
 (= X30 (- (* 1251 S2) (* 5 S3)))
 (= X30 (+ (* 5 S2) (* 1385 S3)))
 (= X30 (- (* 5 S2) (* 1385 S3)))
 (= X30 (- (* 1385 S2) (* 5 S3)))
 (= X30 (+ (* 5 S2) (* X29 S3)))
 (= X30 (- (* 5 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 5 S3)))
 (= X30 (+ (* 31 S2) S3))
 (= X30 (- (* 31 S2) S3))
 (= X30 (- S2 (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 31 S3)))
 (= X30 (- (* 31 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 161 S3)))
 (= X30 (- (* 31 S2) (* 161 S3)))
 (= X30 (- (* 161 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 287 S3)))
 (= X30 (- (* 31 S2) (* 287 S3)))
 (= X30 (- (* 287 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 45 S3)))
 (= X30 (- (* 31 S2) (* 45 S3)))
 (= X30 (- (* 45 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 89 S3)))
 (= X30 (- (* 31 S2) (* 89 S3)))
 (= X30 (- (* 89 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 87 S3)))
 (= X30 (- (* 31 S2) (* 87 S3)))
 (= X30 (- (* 87 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 253 S3)))
 (= X30 (- (* 31 S2) (* 253 S3)))
 (= X30 (- (* 253 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 595 S3)))
 (= X30 (- (* 31 S2) (* 595 S3)))
 (= X30 (- (* 595 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 659 S3)))
 (= X30 (- (* 31 S2) (* 659 S3)))
 (= X30 (- (* 659 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 403 S3)))
 (= X30 (- (* 31 S2) (* 403 S3)))
 (= X30 (- (* 403 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 401 S3)))
 (= X30 (- (* 31 S2) (* 401 S3)))
 (= X30 (- (* 401 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 893 S3)))
 (= X30 (- (* 31 S2) (* 893 S3)))
 (= X30 (- (* 893 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 421 S3)))
 (= X30 (- (* 31 S2) (* 421 S3)))
 (= X30 (- (* 421 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 453 S3)))
 (= X30 (- (* 31 S2) (* 453 S3)))
 (= X30 (- (* 453 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 827 S3)))
 (= X30 (- (* 31 S2) (* 827 S3)))
 (= X30 (- (* 827 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 961 S3)))
 (= X30 (- (* 31 S2) (* 961 S3)))
 (= X30 (- (* 961 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 945 S3)))
 (= X30 (- (* 31 S2) (* 945 S3)))
 (= X30 (- (* 945 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 947 S3)))
 (= X30 (- (* 31 S2) (* 947 S3)))
 (= X30 (- (* 947 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 939 S3)))
 (= X30 (- (* 31 S2) (* 939 S3)))
 (= X30 (- (* 939 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 527 S3)))
 (= X30 (- (* 31 S2) (* 527 S3)))
 (= X30 (- (* 527 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 1953 S3)))
 (= X30 (- (* 31 S2) (* 1953 S3)))
 (= X30 (- (* 1953 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 1245 S3)))
 (= X30 (- (* 31 S2) (* 1245 S3)))
 (= X30 (- (* 1245 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 471 S3)))
 (= X30 (- (* 31 S2) (* 471 S3)))
 (= X30 (- (* 471 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 1263 S3)))
 (= X30 (- (* 31 S2) (* 1263 S3)))
 (= X30 (- (* 1263 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 235 S3)))
 (= X30 (- (* 31 S2) (* 235 S3)))
 (= X30 (- (* 235 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 999 S3)))
 (= X30 (- (* 31 S2) (* 999 S3)))
 (= X30 (- (* 999 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 1251 S3)))
 (= X30 (- (* 31 S2) (* 1251 S3)))
 (= X30 (- (* 1251 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* 1385 S3)))
 (= X30 (- (* 31 S2) (* 1385 S3)))
 (= X30 (- (* 1385 S2) (* 31 S3)))
 (= X30 (+ (* 31 S2) (* X29 S3)))
 (= X30 (- (* 31 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 31 S3)))
 (= X30 (+ (* 161 S2) S3))
 (= X30 (- (* 161 S2) S3))
 (= X30 (- S2 (* 161 S3)))
 (= X30 (+ (* 161 S2) (* 161 S3)))
 (= X30 (- (* 161 S2) (* 161 S3)))
 (= X30 (+ (* 161 S2) (* 287 S3)))
 (= X30 (- (* 161 S2) (* 287 S3)))
 (= X30 (- (* 287 S2) (* 161 S3)))
 (= X30 (+ (* 161 S2) (* 45 S3)))
 (= X30 (- (* 161 S2) (* 45 S3)))
 (= X30 (- (* 45 S2) (* 161 S3)))
 (= X30 (+ (* 161 S2) (* 89 S3)))
 (= X30 (- (* 161 S2) (* 89 S3)))
 (= X30 (- (* 89 S2) (* 161 S3)))
 (= X30 (+ (* 161 S2) (* 87 S3)))
 (= X30 (- (* 161 S2) (* 87 S3)))
 (= X30 (- (* 87 S2) (* 161 S3)))
 (= X30 (+ (* 161 S2) (* 253 S3)))
 (= X30 (- (* 161 S2) (* 253 S3)))
 (= X30 (- (* 253 S2) (* 161 S3)))
 (= X30 (+ (* 161 S2) (* 595 S3)))
 (= X30 (- (* 161 S2) (* 595 S3)))
 (= X30 (- (* 595 S2) (* 161 S3)))
 (= X30 (+ (* 161 S2) (* 659 S3)))
 (= X30 (- (* 161 S2) (* 659 S3)))
 (= X30 (- (* 659 S2) (* 161 S3)))
 (= X30 (+ (* 161 S2) (* 403 S3)))
 (= X30 (- (* 161 S2) (* 403 S3)))
 (= X30 (- (* 403 S2) (* 161 S3)))
 (= X30 (+ (* 161 S2) (* 401 S3)))
 (= X30 (- (* 161 S2) (* 401 S3)))
 (= X30 (- (* 401 S2) (* 161 S3)))
 (= X30 (+ (* 161 S2) (* 893 S3)))
 (= X30 (- (* 161 S2) (* 893 S3)))
 (= X30 (- (* 893 S2) (* 161 S3)))
 (= X30 (+ (* 161 S2) (* 421 S3)))
 (= X30 (- (* 161 S2) (* 421 S3)))
 (= X30 (- (* 421 S2) (* 161 S3)))
 (= X30 (+ (* 161 S2) (* 453 S3)))
 (= X30 (- (* 161 S2) (* 453 S3)))
 (= X30 (- (* 453 S2) (* 161 S3)))
 (= X30 (+ (* 161 S2) (* 827 S3)))
 (= X30 (- (* 161 S2) (* 827 S3)))
 (= X30 (- (* 827 S2) (* 161 S3)))
 (= X30 (+ (* 161 S2) (* 961 S3)))
 (= X30 (- (* 161 S2) (* 961 S3)))
 (= X30 (- (* 961 S2) (* 161 S3)))
 (= X30 (+ (* 161 S2) (* 945 S3)))
 (= X30 (- (* 161 S2) (* 945 S3)))
 (= X30 (- (* 945 S2) (* 161 S3)))
 (= X30 (+ (* 161 S2) (* 947 S3)))
 (= X30 (- (* 161 S2) (* 947 S3)))
 (= X30 (- (* 947 S2) (* 161 S3)))
 (= X30 (+ (* 161 S2) (* 939 S3)))
 (= X30 (- (* 161 S2) (* 939 S3)))
 (= X30 (- (* 939 S2) (* 161 S3)))
 (= X30 (+ (* 161 S2) (* 527 S3)))
 (= X30 (- (* 161 S2) (* 527 S3)))
 (= X30 (- (* 527 S2) (* 161 S3)))
 (= X30 (+ (* 161 S2) (* 1953 S3)))
 (= X30 (- (* 161 S2) (* 1953 S3)))
 (= X30 (- (* 1953 S2) (* 161 S3)))
 (= X30 (+ (* 161 S2) (* 1245 S3)))
 (= X30 (- (* 161 S2) (* 1245 S3)))
 (= X30 (- (* 1245 S2) (* 161 S3)))
 (= X30 (+ (* 161 S2) (* 471 S3)))
 (= X30 (- (* 161 S2) (* 471 S3)))
 (= X30 (- (* 471 S2) (* 161 S3)))
 (= X30 (+ (* 161 S2) (* 1263 S3)))
 (= X30 (- (* 161 S2) (* 1263 S3)))
 (= X30 (- (* 1263 S2) (* 161 S3)))
 (= X30 (+ (* 161 S2) (* 235 S3)))
 (= X30 (- (* 161 S2) (* 235 S3)))
 (= X30 (- (* 235 S2) (* 161 S3)))
 (= X30 (+ (* 161 S2) (* 999 S3)))
 (= X30 (- (* 161 S2) (* 999 S3)))
 (= X30 (- (* 999 S2) (* 161 S3)))
 (= X30 (+ (* 161 S2) (* 1251 S3)))
 (= X30 (- (* 161 S2) (* 1251 S3)))
 (= X30 (- (* 1251 S2) (* 161 S3)))
 (= X30 (+ (* 161 S2) (* 1385 S3)))
 (= X30 (- (* 161 S2) (* 1385 S3)))
 (= X30 (- (* 1385 S2) (* 161 S3)))
 (= X30 (+ (* 161 S2) (* X29 S3)))
 (= X30 (- (* 161 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 161 S3)))
 (= X30 (+ (* 287 S2) S3))
 (= X30 (- (* 287 S2) S3))
 (= X30 (- S2 (* 287 S3)))
 (= X30 (+ (* 287 S2) (* 287 S3)))
 (= X30 (- (* 287 S2) (* 287 S3)))
 (= X30 (+ (* 287 S2) (* 45 S3)))
 (= X30 (- (* 287 S2) (* 45 S3)))
 (= X30 (- (* 45 S2) (* 287 S3)))
 (= X30 (+ (* 287 S2) (* 89 S3)))
 (= X30 (- (* 287 S2) (* 89 S3)))
 (= X30 (- (* 89 S2) (* 287 S3)))
 (= X30 (+ (* 287 S2) (* 87 S3)))
 (= X30 (- (* 287 S2) (* 87 S3)))
 (= X30 (- (* 87 S2) (* 287 S3)))
 (= X30 (+ (* 287 S2) (* 253 S3)))
 (= X30 (- (* 287 S2) (* 253 S3)))
 (= X30 (- (* 253 S2) (* 287 S3)))
 (= X30 (+ (* 287 S2) (* 595 S3)))
 (= X30 (- (* 287 S2) (* 595 S3)))
 (= X30 (- (* 595 S2) (* 287 S3)))
 (= X30 (+ (* 287 S2) (* 659 S3)))
 (= X30 (- (* 287 S2) (* 659 S3)))
 (= X30 (- (* 659 S2) (* 287 S3)))
 (= X30 (+ (* 287 S2) (* 403 S3)))
 (= X30 (- (* 287 S2) (* 403 S3)))
 (= X30 (- (* 403 S2) (* 287 S3)))
 (= X30 (+ (* 287 S2) (* 401 S3)))
 (= X30 (- (* 287 S2) (* 401 S3)))
 (= X30 (- (* 401 S2) (* 287 S3)))
 (= X30 (+ (* 287 S2) (* 893 S3)))
 (= X30 (- (* 287 S2) (* 893 S3)))
 (= X30 (- (* 893 S2) (* 287 S3)))
 (= X30 (+ (* 287 S2) (* 421 S3)))
 (= X30 (- (* 287 S2) (* 421 S3)))
 (= X30 (- (* 421 S2) (* 287 S3)))
 (= X30 (+ (* 287 S2) (* 453 S3)))
 (= X30 (- (* 287 S2) (* 453 S3)))
 (= X30 (- (* 453 S2) (* 287 S3)))
 (= X30 (+ (* 287 S2) (* 827 S3)))
 (= X30 (- (* 287 S2) (* 827 S3)))
 (= X30 (- (* 827 S2) (* 287 S3)))
 (= X30 (+ (* 287 S2) (* 961 S3)))
 (= X30 (- (* 287 S2) (* 961 S3)))
 (= X30 (- (* 961 S2) (* 287 S3)))
 (= X30 (+ (* 287 S2) (* 945 S3)))
 (= X30 (- (* 287 S2) (* 945 S3)))
 (= X30 (- (* 945 S2) (* 287 S3)))
 (= X30 (+ (* 287 S2) (* 947 S3)))
 (= X30 (- (* 287 S2) (* 947 S3)))
 (= X30 (- (* 947 S2) (* 287 S3)))
 (= X30 (+ (* 287 S2) (* 939 S3)))
 (= X30 (- (* 287 S2) (* 939 S3)))
 (= X30 (- (* 939 S2) (* 287 S3)))
 (= X30 (+ (* 287 S2) (* 527 S3)))
 (= X30 (- (* 287 S2) (* 527 S3)))
 (= X30 (- (* 527 S2) (* 287 S3)))
 (= X30 (+ (* 287 S2) (* 1953 S3)))
 (= X30 (- (* 287 S2) (* 1953 S3)))
 (= X30 (- (* 1953 S2) (* 287 S3)))
 (= X30 (+ (* 287 S2) (* 1245 S3)))
 (= X30 (- (* 287 S2) (* 1245 S3)))
 (= X30 (- (* 1245 S2) (* 287 S3)))
 (= X30 (+ (* 287 S2) (* 471 S3)))
 (= X30 (- (* 287 S2) (* 471 S3)))
 (= X30 (- (* 471 S2) (* 287 S3)))
 (= X30 (+ (* 287 S2) (* 1263 S3)))
 (= X30 (- (* 287 S2) (* 1263 S3)))
 (= X30 (- (* 1263 S2) (* 287 S3)))
 (= X30 (+ (* 287 S2) (* 235 S3)))
 (= X30 (- (* 287 S2) (* 235 S3)))
 (= X30 (- (* 235 S2) (* 287 S3)))
 (= X30 (+ (* 287 S2) (* 999 S3)))
 (= X30 (- (* 287 S2) (* 999 S3)))
 (= X30 (- (* 999 S2) (* 287 S3)))
 (= X30 (+ (* 287 S2) (* 1251 S3)))
 (= X30 (- (* 287 S2) (* 1251 S3)))
 (= X30 (- (* 1251 S2) (* 287 S3)))
 (= X30 (+ (* 287 S2) (* 1385 S3)))
 (= X30 (- (* 287 S2) (* 1385 S3)))
 (= X30 (- (* 1385 S2) (* 287 S3)))
 (= X30 (+ (* 287 S2) (* X29 S3)))
 (= X30 (- (* 287 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 287 S3)))
 (= X30 (+ (* 45 S2) S3))
 (= X30 (- (* 45 S2) S3))
 (= X30 (- S2 (* 45 S3)))
 (= X30 (+ (* 45 S2) (* 45 S3)))
 (= X30 (- (* 45 S2) (* 45 S3)))
 (= X30 (+ (* 45 S2) (* 89 S3)))
 (= X30 (- (* 45 S2) (* 89 S3)))
 (= X30 (- (* 89 S2) (* 45 S3)))
 (= X30 (+ (* 45 S2) (* 87 S3)))
 (= X30 (- (* 45 S2) (* 87 S3)))
 (= X30 (- (* 87 S2) (* 45 S3)))
 (= X30 (+ (* 45 S2) (* 253 S3)))
 (= X30 (- (* 45 S2) (* 253 S3)))
 (= X30 (- (* 253 S2) (* 45 S3)))
 (= X30 (+ (* 45 S2) (* 595 S3)))
 (= X30 (- (* 45 S2) (* 595 S3)))
 (= X30 (- (* 595 S2) (* 45 S3)))
 (= X30 (+ (* 45 S2) (* 659 S3)))
 (= X30 (- (* 45 S2) (* 659 S3)))
 (= X30 (- (* 659 S2) (* 45 S3)))
 (= X30 (+ (* 45 S2) (* 403 S3)))
 (= X30 (- (* 45 S2) (* 403 S3)))
 (= X30 (- (* 403 S2) (* 45 S3)))
 (= X30 (+ (* 45 S2) (* 401 S3)))
 (= X30 (- (* 45 S2) (* 401 S3)))
 (= X30 (- (* 401 S2) (* 45 S3)))
 (= X30 (+ (* 45 S2) (* 893 S3)))
 (= X30 (- (* 45 S2) (* 893 S3)))
 (= X30 (- (* 893 S2) (* 45 S3)))
 (= X30 (+ (* 45 S2) (* 421 S3)))
 (= X30 (- (* 45 S2) (* 421 S3)))
 (= X30 (- (* 421 S2) (* 45 S3)))
 (= X30 (+ (* 45 S2) (* 453 S3)))
 (= X30 (- (* 45 S2) (* 453 S3)))
 (= X30 (- (* 453 S2) (* 45 S3)))
 (= X30 (+ (* 45 S2) (* 827 S3)))
 (= X30 (- (* 45 S2) (* 827 S3)))
 (= X30 (- (* 827 S2) (* 45 S3)))
 (= X30 (+ (* 45 S2) (* 961 S3)))
 (= X30 (- (* 45 S2) (* 961 S3)))
 (= X30 (- (* 961 S2) (* 45 S3)))
 (= X30 (+ (* 45 S2) (* 945 S3)))
 (= X30 (- (* 45 S2) (* 945 S3)))
 (= X30 (- (* 945 S2) (* 45 S3)))
 (= X30 (+ (* 45 S2) (* 947 S3)))
 (= X30 (- (* 45 S2) (* 947 S3)))
 (= X30 (- (* 947 S2) (* 45 S3)))
 (= X30 (+ (* 45 S2) (* 939 S3)))
 (= X30 (- (* 45 S2) (* 939 S3)))
 (= X30 (- (* 939 S2) (* 45 S3)))
 (= X30 (+ (* 45 S2) (* 527 S3)))
 (= X30 (- (* 45 S2) (* 527 S3)))
 (= X30 (- (* 527 S2) (* 45 S3)))
 (= X30 (+ (* 45 S2) (* 1953 S3)))
 (= X30 (- (* 45 S2) (* 1953 S3)))
 (= X30 (- (* 1953 S2) (* 45 S3)))
 (= X30 (+ (* 45 S2) (* 1245 S3)))
 (= X30 (- (* 45 S2) (* 1245 S3)))
 (= X30 (- (* 1245 S2) (* 45 S3)))
 (= X30 (+ (* 45 S2) (* 471 S3)))
 (= X30 (- (* 45 S2) (* 471 S3)))
 (= X30 (- (* 471 S2) (* 45 S3)))
 (= X30 (+ (* 45 S2) (* 1263 S3)))
 (= X30 (- (* 45 S2) (* 1263 S3)))
 (= X30 (- (* 1263 S2) (* 45 S3)))
 (= X30 (+ (* 45 S2) (* 235 S3)))
 (= X30 (- (* 45 S2) (* 235 S3)))
 (= X30 (- (* 235 S2) (* 45 S3)))
 (= X30 (+ (* 45 S2) (* 999 S3)))
 (= X30 (- (* 45 S2) (* 999 S3)))
 (= X30 (- (* 999 S2) (* 45 S3)))
 (= X30 (+ (* 45 S2) (* 1251 S3)))
 (= X30 (- (* 45 S2) (* 1251 S3)))
 (= X30 (- (* 1251 S2) (* 45 S3)))
 (= X30 (+ (* 45 S2) (* 1385 S3)))
 (= X30 (- (* 45 S2) (* 1385 S3)))
 (= X30 (- (* 1385 S2) (* 45 S3)))
 (= X30 (+ (* 45 S2) (* X29 S3)))
 (= X30 (- (* 45 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 45 S3)))
 (= X30 (+ (* 89 S2) S3))
 (= X30 (- (* 89 S2) S3))
 (= X30 (- S2 (* 89 S3)))
 (= X30 (+ (* 89 S2) (* 89 S3)))
 (= X30 (- (* 89 S2) (* 89 S3)))
 (= X30 (+ (* 89 S2) (* 87 S3)))
 (= X30 (- (* 89 S2) (* 87 S3)))
 (= X30 (- (* 87 S2) (* 89 S3)))
 (= X30 (+ (* 89 S2) (* 253 S3)))
 (= X30 (- (* 89 S2) (* 253 S3)))
 (= X30 (- (* 253 S2) (* 89 S3)))
 (= X30 (+ (* 89 S2) (* 595 S3)))
 (= X30 (- (* 89 S2) (* 595 S3)))
 (= X30 (- (* 595 S2) (* 89 S3)))
 (= X30 (+ (* 89 S2) (* 659 S3)))
 (= X30 (- (* 89 S2) (* 659 S3)))
 (= X30 (- (* 659 S2) (* 89 S3)))
 (= X30 (+ (* 89 S2) (* 403 S3)))
 (= X30 (- (* 89 S2) (* 403 S3)))
 (= X30 (- (* 403 S2) (* 89 S3)))
 (= X30 (+ (* 89 S2) (* 401 S3)))
 (= X30 (- (* 89 S2) (* 401 S3)))
 (= X30 (- (* 401 S2) (* 89 S3)))
 (= X30 (+ (* 89 S2) (* 893 S3)))
 (= X30 (- (* 89 S2) (* 893 S3)))
 (= X30 (- (* 893 S2) (* 89 S3)))
 (= X30 (+ (* 89 S2) (* 421 S3)))
 (= X30 (- (* 89 S2) (* 421 S3)))
 (= X30 (- (* 421 S2) (* 89 S3)))
 (= X30 (+ (* 89 S2) (* 453 S3)))
 (= X30 (- (* 89 S2) (* 453 S3)))
 (= X30 (- (* 453 S2) (* 89 S3)))
 (= X30 (+ (* 89 S2) (* 827 S3)))
 (= X30 (- (* 89 S2) (* 827 S3)))
 (= X30 (- (* 827 S2) (* 89 S3)))
 (= X30 (+ (* 89 S2) (* 961 S3)))
 (= X30 (- (* 89 S2) (* 961 S3)))
 (= X30 (- (* 961 S2) (* 89 S3)))
 (= X30 (+ (* 89 S2) (* 945 S3)))
 (= X30 (- (* 89 S2) (* 945 S3)))
 (= X30 (- (* 945 S2) (* 89 S3)))
 (= X30 (+ (* 89 S2) (* 947 S3)))
 (= X30 (- (* 89 S2) (* 947 S3)))
 (= X30 (- (* 947 S2) (* 89 S3)))
 (= X30 (+ (* 89 S2) (* 939 S3)))
 (= X30 (- (* 89 S2) (* 939 S3)))
 (= X30 (- (* 939 S2) (* 89 S3)))
 (= X30 (+ (* 89 S2) (* 527 S3)))
 (= X30 (- (* 89 S2) (* 527 S3)))
 (= X30 (- (* 527 S2) (* 89 S3)))
 (= X30 (+ (* 89 S2) (* 1953 S3)))
 (= X30 (- (* 89 S2) (* 1953 S3)))
 (= X30 (- (* 1953 S2) (* 89 S3)))
 (= X30 (+ (* 89 S2) (* 1245 S3)))
 (= X30 (- (* 89 S2) (* 1245 S3)))
 (= X30 (- (* 1245 S2) (* 89 S3)))
 (= X30 (+ (* 89 S2) (* 471 S3)))
 (= X30 (- (* 89 S2) (* 471 S3)))
 (= X30 (- (* 471 S2) (* 89 S3)))
 (= X30 (+ (* 89 S2) (* 1263 S3)))
 (= X30 (- (* 89 S2) (* 1263 S3)))
 (= X30 (- (* 1263 S2) (* 89 S3)))
 (= X30 (+ (* 89 S2) (* 235 S3)))
 (= X30 (- (* 89 S2) (* 235 S3)))
 (= X30 (- (* 235 S2) (* 89 S3)))
 (= X30 (+ (* 89 S2) (* 999 S3)))
 (= X30 (- (* 89 S2) (* 999 S3)))
 (= X30 (- (* 999 S2) (* 89 S3)))
 (= X30 (+ (* 89 S2) (* 1251 S3)))
 (= X30 (- (* 89 S2) (* 1251 S3)))
 (= X30 (- (* 1251 S2) (* 89 S3)))
 (= X30 (+ (* 89 S2) (* 1385 S3)))
 (= X30 (- (* 89 S2) (* 1385 S3)))
 (= X30 (- (* 1385 S2) (* 89 S3)))
 (= X30 (+ (* 89 S2) (* X29 S3)))
 (= X30 (- (* 89 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 89 S3)))
 (= X30 (+ (* 87 S2) S3))
 (= X30 (- (* 87 S2) S3))
 (= X30 (- S2 (* 87 S3)))
 (= X30 (+ (* 87 S2) (* 87 S3)))
 (= X30 (- (* 87 S2) (* 87 S3)))
 (= X30 (+ (* 87 S2) (* 253 S3)))
 (= X30 (- (* 87 S2) (* 253 S3)))
 (= X30 (- (* 253 S2) (* 87 S3)))
 (= X30 (+ (* 87 S2) (* 595 S3)))
 (= X30 (- (* 87 S2) (* 595 S3)))
 (= X30 (- (* 595 S2) (* 87 S3)))
 (= X30 (+ (* 87 S2) (* 659 S3)))
 (= X30 (- (* 87 S2) (* 659 S3)))
 (= X30 (- (* 659 S2) (* 87 S3)))
 (= X30 (+ (* 87 S2) (* 403 S3)))
 (= X30 (- (* 87 S2) (* 403 S3)))
 (= X30 (- (* 403 S2) (* 87 S3)))
 (= X30 (+ (* 87 S2) (* 401 S3)))
 (= X30 (- (* 87 S2) (* 401 S3)))
 (= X30 (- (* 401 S2) (* 87 S3)))
 (= X30 (+ (* 87 S2) (* 893 S3)))
 (= X30 (- (* 87 S2) (* 893 S3)))
 (= X30 (- (* 893 S2) (* 87 S3)))
 (= X30 (+ (* 87 S2) (* 421 S3)))
 (= X30 (- (* 87 S2) (* 421 S3)))
 (= X30 (- (* 421 S2) (* 87 S3)))
 (= X30 (+ (* 87 S2) (* 453 S3)))
 (= X30 (- (* 87 S2) (* 453 S3)))
 (= X30 (- (* 453 S2) (* 87 S3)))
 (= X30 (+ (* 87 S2) (* 827 S3)))
 (= X30 (- (* 87 S2) (* 827 S3)))
 (= X30 (- (* 827 S2) (* 87 S3)))
 (= X30 (+ (* 87 S2) (* 961 S3)))
 (= X30 (- (* 87 S2) (* 961 S3)))
 (= X30 (- (* 961 S2) (* 87 S3)))
 (= X30 (+ (* 87 S2) (* 945 S3)))
 (= X30 (- (* 87 S2) (* 945 S3)))
 (= X30 (- (* 945 S2) (* 87 S3)))
 (= X30 (+ (* 87 S2) (* 947 S3)))
 (= X30 (- (* 87 S2) (* 947 S3)))
 (= X30 (- (* 947 S2) (* 87 S3)))
 (= X30 (+ (* 87 S2) (* 939 S3)))
 (= X30 (- (* 87 S2) (* 939 S3)))
 (= X30 (- (* 939 S2) (* 87 S3)))
 (= X30 (+ (* 87 S2) (* 527 S3)))
 (= X30 (- (* 87 S2) (* 527 S3)))
 (= X30 (- (* 527 S2) (* 87 S3)))
 (= X30 (+ (* 87 S2) (* 1953 S3)))
 (= X30 (- (* 87 S2) (* 1953 S3)))
 (= X30 (- (* 1953 S2) (* 87 S3)))
 (= X30 (+ (* 87 S2) (* 1245 S3)))
 (= X30 (- (* 87 S2) (* 1245 S3)))
 (= X30 (- (* 1245 S2) (* 87 S3)))
 (= X30 (+ (* 87 S2) (* 471 S3)))
 (= X30 (- (* 87 S2) (* 471 S3)))
 (= X30 (- (* 471 S2) (* 87 S3)))
 (= X30 (+ (* 87 S2) (* 1263 S3)))
 (= X30 (- (* 87 S2) (* 1263 S3)))
 (= X30 (- (* 1263 S2) (* 87 S3)))
 (= X30 (+ (* 87 S2) (* 235 S3)))
 (= X30 (- (* 87 S2) (* 235 S3)))
 (= X30 (- (* 235 S2) (* 87 S3)))
 (= X30 (+ (* 87 S2) (* 999 S3)))
 (= X30 (- (* 87 S2) (* 999 S3)))
 (= X30 (- (* 999 S2) (* 87 S3)))
 (= X30 (+ (* 87 S2) (* 1251 S3)))
 (= X30 (- (* 87 S2) (* 1251 S3)))
 (= X30 (- (* 1251 S2) (* 87 S3)))
 (= X30 (+ (* 87 S2) (* 1385 S3)))
 (= X30 (- (* 87 S2) (* 1385 S3)))
 (= X30 (- (* 1385 S2) (* 87 S3)))
 (= X30 (+ (* 87 S2) (* X29 S3)))
 (= X30 (- (* 87 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 87 S3)))
 (= X30 (+ (* 253 S2) S3))
 (= X30 (- (* 253 S2) S3))
 (= X30 (- S2 (* 253 S3)))
 (= X30 (+ (* 253 S2) (* 253 S3)))
 (= X30 (- (* 253 S2) (* 253 S3)))
 (= X30 (+ (* 253 S2) (* 595 S3)))
 (= X30 (- (* 253 S2) (* 595 S3)))
 (= X30 (- (* 595 S2) (* 253 S3)))
 (= X30 (+ (* 253 S2) (* 659 S3)))
 (= X30 (- (* 253 S2) (* 659 S3)))
 (= X30 (- (* 659 S2) (* 253 S3)))
 (= X30 (+ (* 253 S2) (* 403 S3)))
 (= X30 (- (* 253 S2) (* 403 S3)))
 (= X30 (- (* 403 S2) (* 253 S3)))
 (= X30 (+ (* 253 S2) (* 401 S3)))
 (= X30 (- (* 253 S2) (* 401 S3)))
 (= X30 (- (* 401 S2) (* 253 S3)))
 (= X30 (+ (* 253 S2) (* 893 S3)))
 (= X30 (- (* 253 S2) (* 893 S3)))
 (= X30 (- (* 893 S2) (* 253 S3)))
 (= X30 (+ (* 253 S2) (* 421 S3)))
 (= X30 (- (* 253 S2) (* 421 S3)))
 (= X30 (- (* 421 S2) (* 253 S3)))
 (= X30 (+ (* 253 S2) (* 453 S3)))
 (= X30 (- (* 253 S2) (* 453 S3)))
 (= X30 (- (* 453 S2) (* 253 S3)))
 (= X30 (+ (* 253 S2) (* 827 S3)))
 (= X30 (- (* 253 S2) (* 827 S3)))
 (= X30 (- (* 827 S2) (* 253 S3)))
 (= X30 (+ (* 253 S2) (* 961 S3)))
 (= X30 (- (* 253 S2) (* 961 S3)))
 (= X30 (- (* 961 S2) (* 253 S3)))
 (= X30 (+ (* 253 S2) (* 945 S3)))
 (= X30 (- (* 253 S2) (* 945 S3)))
 (= X30 (- (* 945 S2) (* 253 S3)))
 (= X30 (+ (* 253 S2) (* 947 S3)))
 (= X30 (- (* 253 S2) (* 947 S3)))
 (= X30 (- (* 947 S2) (* 253 S3)))
 (= X30 (+ (* 253 S2) (* 939 S3)))
 (= X30 (- (* 253 S2) (* 939 S3)))
 (= X30 (- (* 939 S2) (* 253 S3)))
 (= X30 (+ (* 253 S2) (* 527 S3)))
 (= X30 (- (* 253 S2) (* 527 S3)))
 (= X30 (- (* 527 S2) (* 253 S3)))
 (= X30 (+ (* 253 S2) (* 1953 S3)))
 (= X30 (- (* 253 S2) (* 1953 S3)))
 (= X30 (- (* 1953 S2) (* 253 S3)))
 (= X30 (+ (* 253 S2) (* 1245 S3)))
 (= X30 (- (* 253 S2) (* 1245 S3)))
 (= X30 (- (* 1245 S2) (* 253 S3)))
 (= X30 (+ (* 253 S2) (* 471 S3)))
 (= X30 (- (* 253 S2) (* 471 S3)))
 (= X30 (- (* 471 S2) (* 253 S3)))
 (= X30 (+ (* 253 S2) (* 1263 S3)))
 (= X30 (- (* 253 S2) (* 1263 S3)))
 (= X30 (- (* 1263 S2) (* 253 S3)))
 (= X30 (+ (* 253 S2) (* 235 S3)))
 (= X30 (- (* 253 S2) (* 235 S3)))
 (= X30 (- (* 235 S2) (* 253 S3)))
 (= X30 (+ (* 253 S2) (* 999 S3)))
 (= X30 (- (* 253 S2) (* 999 S3)))
 (= X30 (- (* 999 S2) (* 253 S3)))
 (= X30 (+ (* 253 S2) (* 1251 S3)))
 (= X30 (- (* 253 S2) (* 1251 S3)))
 (= X30 (- (* 1251 S2) (* 253 S3)))
 (= X30 (+ (* 253 S2) (* 1385 S3)))
 (= X30 (- (* 253 S2) (* 1385 S3)))
 (= X30 (- (* 1385 S2) (* 253 S3)))
 (= X30 (+ (* 253 S2) (* X29 S3)))
 (= X30 (- (* 253 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 253 S3)))
 (= X30 (+ (* 595 S2) S3))
 (= X30 (- (* 595 S2) S3))
 (= X30 (- S2 (* 595 S3)))
 (= X30 (+ (* 595 S2) (* 595 S3)))
 (= X30 (- (* 595 S2) (* 595 S3)))
 (= X30 (+ (* 595 S2) (* 659 S3)))
 (= X30 (- (* 595 S2) (* 659 S3)))
 (= X30 (- (* 659 S2) (* 595 S3)))
 (= X30 (+ (* 595 S2) (* 403 S3)))
 (= X30 (- (* 595 S2) (* 403 S3)))
 (= X30 (- (* 403 S2) (* 595 S3)))
 (= X30 (+ (* 595 S2) (* 401 S3)))
 (= X30 (- (* 595 S2) (* 401 S3)))
 (= X30 (- (* 401 S2) (* 595 S3)))
 (= X30 (+ (* 595 S2) (* 893 S3)))
 (= X30 (- (* 595 S2) (* 893 S3)))
 (= X30 (- (* 893 S2) (* 595 S3)))
 (= X30 (+ (* 595 S2) (* 421 S3)))
 (= X30 (- (* 595 S2) (* 421 S3)))
 (= X30 (- (* 421 S2) (* 595 S3)))
 (= X30 (+ (* 595 S2) (* 453 S3)))
 (= X30 (- (* 595 S2) (* 453 S3)))
 (= X30 (- (* 453 S2) (* 595 S3)))
 (= X30 (+ (* 595 S2) (* 827 S3)))
 (= X30 (- (* 595 S2) (* 827 S3)))
 (= X30 (- (* 827 S2) (* 595 S3)))
 (= X30 (+ (* 595 S2) (* 961 S3)))
 (= X30 (- (* 595 S2) (* 961 S3)))
 (= X30 (- (* 961 S2) (* 595 S3)))
 (= X30 (+ (* 595 S2) (* 945 S3)))
 (= X30 (- (* 595 S2) (* 945 S3)))
 (= X30 (- (* 945 S2) (* 595 S3)))
 (= X30 (+ (* 595 S2) (* 947 S3)))
 (= X30 (- (* 595 S2) (* 947 S3)))
 (= X30 (- (* 947 S2) (* 595 S3)))
 (= X30 (+ (* 595 S2) (* 939 S3)))
 (= X30 (- (* 595 S2) (* 939 S3)))
 (= X30 (- (* 939 S2) (* 595 S3)))
 (= X30 (+ (* 595 S2) (* 527 S3)))
 (= X30 (- (* 595 S2) (* 527 S3)))
 (= X30 (- (* 527 S2) (* 595 S3)))
 (= X30 (+ (* 595 S2) (* 1953 S3)))
 (= X30 (- (* 595 S2) (* 1953 S3)))
 (= X30 (- (* 1953 S2) (* 595 S3)))
 (= X30 (+ (* 595 S2) (* 1245 S3)))
 (= X30 (- (* 595 S2) (* 1245 S3)))
 (= X30 (- (* 1245 S2) (* 595 S3)))
 (= X30 (+ (* 595 S2) (* 471 S3)))
 (= X30 (- (* 595 S2) (* 471 S3)))
 (= X30 (- (* 471 S2) (* 595 S3)))
 (= X30 (+ (* 595 S2) (* 1263 S3)))
 (= X30 (- (* 595 S2) (* 1263 S3)))
 (= X30 (- (* 1263 S2) (* 595 S3)))
 (= X30 (+ (* 595 S2) (* 235 S3)))
 (= X30 (- (* 595 S2) (* 235 S3)))
 (= X30 (- (* 235 S2) (* 595 S3)))
 (= X30 (+ (* 595 S2) (* 999 S3)))
 (= X30 (- (* 595 S2) (* 999 S3)))
 (= X30 (- (* 999 S2) (* 595 S3)))
 (= X30 (+ (* 595 S2) (* 1251 S3)))
 (= X30 (- (* 595 S2) (* 1251 S3)))
 (= X30 (- (* 1251 S2) (* 595 S3)))
 (= X30 (+ (* 595 S2) (* 1385 S3)))
 (= X30 (- (* 595 S2) (* 1385 S3)))
 (= X30 (- (* 1385 S2) (* 595 S3)))
 (= X30 (+ (* 595 S2) (* X29 S3)))
 (= X30 (- (* 595 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 595 S3)))
 (= X30 (+ (* 659 S2) S3))
 (= X30 (- (* 659 S2) S3))
 (= X30 (- S2 (* 659 S3)))
 (= X30 (+ (* 659 S2) (* 659 S3)))
 (= X30 (- (* 659 S2) (* 659 S3)))
 (= X30 (+ (* 659 S2) (* 403 S3)))
 (= X30 (- (* 659 S2) (* 403 S3)))
 (= X30 (- (* 403 S2) (* 659 S3)))
 (= X30 (+ (* 659 S2) (* 401 S3)))
 (= X30 (- (* 659 S2) (* 401 S3)))
 (= X30 (- (* 401 S2) (* 659 S3)))
 (= X30 (+ (* 659 S2) (* 893 S3)))
 (= X30 (- (* 659 S2) (* 893 S3)))
 (= X30 (- (* 893 S2) (* 659 S3)))
 (= X30 (+ (* 659 S2) (* 421 S3)))
 (= X30 (- (* 659 S2) (* 421 S3)))
 (= X30 (- (* 421 S2) (* 659 S3)))
 (= X30 (+ (* 659 S2) (* 453 S3)))
 (= X30 (- (* 659 S2) (* 453 S3)))
 (= X30 (- (* 453 S2) (* 659 S3)))
 (= X30 (+ (* 659 S2) (* 827 S3)))
 (= X30 (- (* 659 S2) (* 827 S3)))
 (= X30 (- (* 827 S2) (* 659 S3)))
 (= X30 (+ (* 659 S2) (* 961 S3)))
 (= X30 (- (* 659 S2) (* 961 S3)))
 (= X30 (- (* 961 S2) (* 659 S3)))
 (= X30 (+ (* 659 S2) (* 945 S3)))
 (= X30 (- (* 659 S2) (* 945 S3)))
 (= X30 (- (* 945 S2) (* 659 S3)))
 (= X30 (+ (* 659 S2) (* 947 S3)))
 (= X30 (- (* 659 S2) (* 947 S3)))
 (= X30 (- (* 947 S2) (* 659 S3)))
 (= X30 (+ (* 659 S2) (* 939 S3)))
 (= X30 (- (* 659 S2) (* 939 S3)))
 (= X30 (- (* 939 S2) (* 659 S3)))
 (= X30 (+ (* 659 S2) (* 527 S3)))
 (= X30 (- (* 659 S2) (* 527 S3)))
 (= X30 (- (* 527 S2) (* 659 S3)))
 (= X30 (+ (* 659 S2) (* 1953 S3)))
 (= X30 (- (* 659 S2) (* 1953 S3)))
 (= X30 (- (* 1953 S2) (* 659 S3)))
 (= X30 (+ (* 659 S2) (* 1245 S3)))
 (= X30 (- (* 659 S2) (* 1245 S3)))
 (= X30 (- (* 1245 S2) (* 659 S3)))
 (= X30 (+ (* 659 S2) (* 471 S3)))
 (= X30 (- (* 659 S2) (* 471 S3)))
 (= X30 (- (* 471 S2) (* 659 S3)))
 (= X30 (+ (* 659 S2) (* 1263 S3)))
 (= X30 (- (* 659 S2) (* 1263 S3)))
 (= X30 (- (* 1263 S2) (* 659 S3)))
 (= X30 (+ (* 659 S2) (* 235 S3)))
 (= X30 (- (* 659 S2) (* 235 S3)))
 (= X30 (- (* 235 S2) (* 659 S3)))
 (= X30 (+ (* 659 S2) (* 999 S3)))
 (= X30 (- (* 659 S2) (* 999 S3)))
 (= X30 (- (* 999 S2) (* 659 S3)))
 (= X30 (+ (* 659 S2) (* 1251 S3)))
 (= X30 (- (* 659 S2) (* 1251 S3)))
 (= X30 (- (* 1251 S2) (* 659 S3)))
 (= X30 (+ (* 659 S2) (* 1385 S3)))
 (= X30 (- (* 659 S2) (* 1385 S3)))
 (= X30 (- (* 1385 S2) (* 659 S3)))
 (= X30 (+ (* 659 S2) (* X29 S3)))
 (= X30 (- (* 659 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 659 S3)))
 (= X30 (+ (* 403 S2) S3))
 (= X30 (- (* 403 S2) S3))
 (= X30 (- S2 (* 403 S3)))
 (= X30 (+ (* 403 S2) (* 403 S3)))
 (= X30 (- (* 403 S2) (* 403 S3)))
 (= X30 (+ (* 403 S2) (* 401 S3)))
 (= X30 (- (* 403 S2) (* 401 S3)))
 (= X30 (- (* 401 S2) (* 403 S3)))
 (= X30 (+ (* 403 S2) (* 893 S3)))
 (= X30 (- (* 403 S2) (* 893 S3)))
 (= X30 (- (* 893 S2) (* 403 S3)))
 (= X30 (+ (* 403 S2) (* 421 S3)))
 (= X30 (- (* 403 S2) (* 421 S3)))
 (= X30 (- (* 421 S2) (* 403 S3)))
 (= X30 (+ (* 403 S2) (* 453 S3)))
 (= X30 (- (* 403 S2) (* 453 S3)))
 (= X30 (- (* 453 S2) (* 403 S3)))
 (= X30 (+ (* 403 S2) (* 827 S3)))
 (= X30 (- (* 403 S2) (* 827 S3)))
 (= X30 (- (* 827 S2) (* 403 S3)))
 (= X30 (+ (* 403 S2) (* 961 S3)))
 (= X30 (- (* 403 S2) (* 961 S3)))
 (= X30 (- (* 961 S2) (* 403 S3)))
 (= X30 (+ (* 403 S2) (* 945 S3)))
 (= X30 (- (* 403 S2) (* 945 S3)))
 (= X30 (- (* 945 S2) (* 403 S3)))
 (= X30 (+ (* 403 S2) (* 947 S3)))
 (= X30 (- (* 403 S2) (* 947 S3)))
 (= X30 (- (* 947 S2) (* 403 S3)))
 (= X30 (+ (* 403 S2) (* 939 S3)))
 (= X30 (- (* 403 S2) (* 939 S3)))
 (= X30 (- (* 939 S2) (* 403 S3)))
 (= X30 (+ (* 403 S2) (* 527 S3)))
 (= X30 (- (* 403 S2) (* 527 S3)))
 (= X30 (- (* 527 S2) (* 403 S3)))
 (= X30 (+ (* 403 S2) (* 1953 S3)))
 (= X30 (- (* 403 S2) (* 1953 S3)))
 (= X30 (- (* 1953 S2) (* 403 S3)))
 (= X30 (+ (* 403 S2) (* 1245 S3)))
 (= X30 (- (* 403 S2) (* 1245 S3)))
 (= X30 (- (* 1245 S2) (* 403 S3)))
 (= X30 (+ (* 403 S2) (* 471 S3)))
 (= X30 (- (* 403 S2) (* 471 S3)))
 (= X30 (- (* 471 S2) (* 403 S3)))
 (= X30 (+ (* 403 S2) (* 1263 S3)))
 (= X30 (- (* 403 S2) (* 1263 S3)))
 (= X30 (- (* 1263 S2) (* 403 S3)))
 (= X30 (+ (* 403 S2) (* 235 S3)))
 (= X30 (- (* 403 S2) (* 235 S3)))
 (= X30 (- (* 235 S2) (* 403 S3)))
 (= X30 (+ (* 403 S2) (* 999 S3)))
 (= X30 (- (* 403 S2) (* 999 S3)))
 (= X30 (- (* 999 S2) (* 403 S3)))
 (= X30 (+ (* 403 S2) (* 1251 S3)))
 (= X30 (- (* 403 S2) (* 1251 S3)))
 (= X30 (- (* 1251 S2) (* 403 S3)))
 (= X30 (+ (* 403 S2) (* 1385 S3)))
 (= X30 (- (* 403 S2) (* 1385 S3)))
 (= X30 (- (* 1385 S2) (* 403 S3)))
 (= X30 (+ (* 403 S2) (* X29 S3)))
 (= X30 (- (* 403 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 403 S3)))
 (= X30 (+ (* 401 S2) S3))
 (= X30 (- (* 401 S2) S3))
 (= X30 (- S2 (* 401 S3)))
 (= X30 (+ (* 401 S2) (* 401 S3)))
 (= X30 (- (* 401 S2) (* 401 S3)))
 (= X30 (+ (* 401 S2) (* 893 S3)))
 (= X30 (- (* 401 S2) (* 893 S3)))
 (= X30 (- (* 893 S2) (* 401 S3)))
 (= X30 (+ (* 401 S2) (* 421 S3)))
 (= X30 (- (* 401 S2) (* 421 S3)))
 (= X30 (- (* 421 S2) (* 401 S3)))
 (= X30 (+ (* 401 S2) (* 453 S3)))
 (= X30 (- (* 401 S2) (* 453 S3)))
 (= X30 (- (* 453 S2) (* 401 S3)))
 (= X30 (+ (* 401 S2) (* 827 S3)))
 (= X30 (- (* 401 S2) (* 827 S3)))
 (= X30 (- (* 827 S2) (* 401 S3)))
 (= X30 (+ (* 401 S2) (* 961 S3)))
 (= X30 (- (* 401 S2) (* 961 S3)))
 (= X30 (- (* 961 S2) (* 401 S3)))
 (= X30 (+ (* 401 S2) (* 945 S3)))
 (= X30 (- (* 401 S2) (* 945 S3)))
 (= X30 (- (* 945 S2) (* 401 S3)))
 (= X30 (+ (* 401 S2) (* 947 S3)))
 (= X30 (- (* 401 S2) (* 947 S3)))
 (= X30 (- (* 947 S2) (* 401 S3)))
 (= X30 (+ (* 401 S2) (* 939 S3)))
 (= X30 (- (* 401 S2) (* 939 S3)))
 (= X30 (- (* 939 S2) (* 401 S3)))
 (= X30 (+ (* 401 S2) (* 527 S3)))
 (= X30 (- (* 401 S2) (* 527 S3)))
 (= X30 (- (* 527 S2) (* 401 S3)))
 (= X30 (+ (* 401 S2) (* 1953 S3)))
 (= X30 (- (* 401 S2) (* 1953 S3)))
 (= X30 (- (* 1953 S2) (* 401 S3)))
 (= X30 (+ (* 401 S2) (* 1245 S3)))
 (= X30 (- (* 401 S2) (* 1245 S3)))
 (= X30 (- (* 1245 S2) (* 401 S3)))
 (= X30 (+ (* 401 S2) (* 471 S3)))
 (= X30 (- (* 401 S2) (* 471 S3)))
 (= X30 (- (* 471 S2) (* 401 S3)))
 (= X30 (+ (* 401 S2) (* 1263 S3)))
 (= X30 (- (* 401 S2) (* 1263 S3)))
 (= X30 (- (* 1263 S2) (* 401 S3)))
 (= X30 (+ (* 401 S2) (* 235 S3)))
 (= X30 (- (* 401 S2) (* 235 S3)))
 (= X30 (- (* 235 S2) (* 401 S3)))
 (= X30 (+ (* 401 S2) (* 999 S3)))
 (= X30 (- (* 401 S2) (* 999 S3)))
 (= X30 (- (* 999 S2) (* 401 S3)))
 (= X30 (+ (* 401 S2) (* 1251 S3)))
 (= X30 (- (* 401 S2) (* 1251 S3)))
 (= X30 (- (* 1251 S2) (* 401 S3)))
 (= X30 (+ (* 401 S2) (* 1385 S3)))
 (= X30 (- (* 401 S2) (* 1385 S3)))
 (= X30 (- (* 1385 S2) (* 401 S3)))
 (= X30 (+ (* 401 S2) (* X29 S3)))
 (= X30 (- (* 401 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 401 S3)))
 (= X30 (+ (* 893 S2) S3))
 (= X30 (- (* 893 S2) S3))
 (= X30 (- S2 (* 893 S3)))
 (= X30 (+ (* 893 S2) (* 893 S3)))
 (= X30 (- (* 893 S2) (* 893 S3)))
 (= X30 (+ (* 893 S2) (* 421 S3)))
 (= X30 (- (* 893 S2) (* 421 S3)))
 (= X30 (- (* 421 S2) (* 893 S3)))
 (= X30 (+ (* 893 S2) (* 453 S3)))
 (= X30 (- (* 893 S2) (* 453 S3)))
 (= X30 (- (* 453 S2) (* 893 S3)))
 (= X30 (+ (* 893 S2) (* 827 S3)))
 (= X30 (- (* 893 S2) (* 827 S3)))
 (= X30 (- (* 827 S2) (* 893 S3)))
 (= X30 (+ (* 893 S2) (* 961 S3)))
 (= X30 (- (* 893 S2) (* 961 S3)))
 (= X30 (- (* 961 S2) (* 893 S3)))
 (= X30 (+ (* 893 S2) (* 945 S3)))
 (= X30 (- (* 893 S2) (* 945 S3)))
 (= X30 (- (* 945 S2) (* 893 S3)))
 (= X30 (+ (* 893 S2) (* 947 S3)))
 (= X30 (- (* 893 S2) (* 947 S3)))
 (= X30 (- (* 947 S2) (* 893 S3)))
 (= X30 (+ (* 893 S2) (* 939 S3)))
 (= X30 (- (* 893 S2) (* 939 S3)))
 (= X30 (- (* 939 S2) (* 893 S3)))
 (= X30 (+ (* 893 S2) (* 527 S3)))
 (= X30 (- (* 893 S2) (* 527 S3)))
 (= X30 (- (* 527 S2) (* 893 S3)))
 (= X30 (+ (* 893 S2) (* 1953 S3)))
 (= X30 (- (* 893 S2) (* 1953 S3)))
 (= X30 (- (* 1953 S2) (* 893 S3)))
 (= X30 (+ (* 893 S2) (* 1245 S3)))
 (= X30 (- (* 893 S2) (* 1245 S3)))
 (= X30 (- (* 1245 S2) (* 893 S3)))
 (= X30 (+ (* 893 S2) (* 471 S3)))
 (= X30 (- (* 893 S2) (* 471 S3)))
 (= X30 (- (* 471 S2) (* 893 S3)))
 (= X30 (+ (* 893 S2) (* 1263 S3)))
 (= X30 (- (* 893 S2) (* 1263 S3)))
 (= X30 (- (* 1263 S2) (* 893 S3)))
 (= X30 (+ (* 893 S2) (* 235 S3)))
 (= X30 (- (* 893 S2) (* 235 S3)))
 (= X30 (- (* 235 S2) (* 893 S3)))
 (= X30 (+ (* 893 S2) (* 999 S3)))
 (= X30 (- (* 893 S2) (* 999 S3)))
 (= X30 (- (* 999 S2) (* 893 S3)))
 (= X30 (+ (* 893 S2) (* 1251 S3)))
 (= X30 (- (* 893 S2) (* 1251 S3)))
 (= X30 (- (* 1251 S2) (* 893 S3)))
 (= X30 (+ (* 893 S2) (* 1385 S3)))
 (= X30 (- (* 893 S2) (* 1385 S3)))
 (= X30 (- (* 1385 S2) (* 893 S3)))
 (= X30 (+ (* 893 S2) (* X29 S3)))
 (= X30 (- (* 893 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 893 S3)))
 (= X30 (+ (* 421 S2) S3))
 (= X30 (- (* 421 S2) S3))
 (= X30 (- S2 (* 421 S3)))
 (= X30 (+ (* 421 S2) (* 421 S3)))
 (= X30 (- (* 421 S2) (* 421 S3)))
 (= X30 (+ (* 421 S2) (* 453 S3)))
 (= X30 (- (* 421 S2) (* 453 S3)))
 (= X30 (- (* 453 S2) (* 421 S3)))
 (= X30 (+ (* 421 S2) (* 827 S3)))
 (= X30 (- (* 421 S2) (* 827 S3)))
 (= X30 (- (* 827 S2) (* 421 S3)))
 (= X30 (+ (* 421 S2) (* 961 S3)))
 (= X30 (- (* 421 S2) (* 961 S3)))
 (= X30 (- (* 961 S2) (* 421 S3)))
 (= X30 (+ (* 421 S2) (* 945 S3)))
 (= X30 (- (* 421 S2) (* 945 S3)))
 (= X30 (- (* 945 S2) (* 421 S3)))
 (= X30 (+ (* 421 S2) (* 947 S3)))
 (= X30 (- (* 421 S2) (* 947 S3)))
 (= X30 (- (* 947 S2) (* 421 S3)))
 (= X30 (+ (* 421 S2) (* 939 S3)))
 (= X30 (- (* 421 S2) (* 939 S3)))
 (= X30 (- (* 939 S2) (* 421 S3)))
 (= X30 (+ (* 421 S2) (* 527 S3)))
 (= X30 (- (* 421 S2) (* 527 S3)))
 (= X30 (- (* 527 S2) (* 421 S3)))
 (= X30 (+ (* 421 S2) (* 1953 S3)))
 (= X30 (- (* 421 S2) (* 1953 S3)))
 (= X30 (- (* 1953 S2) (* 421 S3)))
 (= X30 (+ (* 421 S2) (* 1245 S3)))
 (= X30 (- (* 421 S2) (* 1245 S3)))
 (= X30 (- (* 1245 S2) (* 421 S3)))
 (= X30 (+ (* 421 S2) (* 471 S3)))
 (= X30 (- (* 421 S2) (* 471 S3)))
 (= X30 (- (* 471 S2) (* 421 S3)))
 (= X30 (+ (* 421 S2) (* 1263 S3)))
 (= X30 (- (* 421 S2) (* 1263 S3)))
 (= X30 (- (* 1263 S2) (* 421 S3)))
 (= X30 (+ (* 421 S2) (* 235 S3)))
 (= X30 (- (* 421 S2) (* 235 S3)))
 (= X30 (- (* 235 S2) (* 421 S3)))
 (= X30 (+ (* 421 S2) (* 999 S3)))
 (= X30 (- (* 421 S2) (* 999 S3)))
 (= X30 (- (* 999 S2) (* 421 S3)))
 (= X30 (+ (* 421 S2) (* 1251 S3)))
 (= X30 (- (* 421 S2) (* 1251 S3)))
 (= X30 (- (* 1251 S2) (* 421 S3)))
 (= X30 (+ (* 421 S2) (* 1385 S3)))
 (= X30 (- (* 421 S2) (* 1385 S3)))
 (= X30 (- (* 1385 S2) (* 421 S3)))
 (= X30 (+ (* 421 S2) (* X29 S3)))
 (= X30 (- (* 421 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 421 S3)))
 (= X30 (+ (* 453 S2) S3))
 (= X30 (- (* 453 S2) S3))
 (= X30 (- S2 (* 453 S3)))
 (= X30 (+ (* 453 S2) (* 453 S3)))
 (= X30 (- (* 453 S2) (* 453 S3)))
 (= X30 (+ (* 453 S2) (* 827 S3)))
 (= X30 (- (* 453 S2) (* 827 S3)))
 (= X30 (- (* 827 S2) (* 453 S3)))
 (= X30 (+ (* 453 S2) (* 961 S3)))
 (= X30 (- (* 453 S2) (* 961 S3)))
 (= X30 (- (* 961 S2) (* 453 S3)))
 (= X30 (+ (* 453 S2) (* 945 S3)))
 (= X30 (- (* 453 S2) (* 945 S3)))
 (= X30 (- (* 945 S2) (* 453 S3)))
 (= X30 (+ (* 453 S2) (* 947 S3)))
 (= X30 (- (* 453 S2) (* 947 S3)))
 (= X30 (- (* 947 S2) (* 453 S3)))
 (= X30 (+ (* 453 S2) (* 939 S3)))
 (= X30 (- (* 453 S2) (* 939 S3)))
 (= X30 (- (* 939 S2) (* 453 S3)))
 (= X30 (+ (* 453 S2) (* 527 S3)))
 (= X30 (- (* 453 S2) (* 527 S3)))
 (= X30 (- (* 527 S2) (* 453 S3)))
 (= X30 (+ (* 453 S2) (* 1953 S3)))
 (= X30 (- (* 453 S2) (* 1953 S3)))
 (= X30 (- (* 1953 S2) (* 453 S3)))
 (= X30 (+ (* 453 S2) (* 1245 S3)))
 (= X30 (- (* 453 S2) (* 1245 S3)))
 (= X30 (- (* 1245 S2) (* 453 S3)))
 (= X30 (+ (* 453 S2) (* 471 S3)))
 (= X30 (- (* 453 S2) (* 471 S3)))
 (= X30 (- (* 471 S2) (* 453 S3)))
 (= X30 (+ (* 453 S2) (* 1263 S3)))
 (= X30 (- (* 453 S2) (* 1263 S3)))
 (= X30 (- (* 1263 S2) (* 453 S3)))
 (= X30 (+ (* 453 S2) (* 235 S3)))
 (= X30 (- (* 453 S2) (* 235 S3)))
 (= X30 (- (* 235 S2) (* 453 S3)))
 (= X30 (+ (* 453 S2) (* 999 S3)))
 (= X30 (- (* 453 S2) (* 999 S3)))
 (= X30 (- (* 999 S2) (* 453 S3)))
 (= X30 (+ (* 453 S2) (* 1251 S3)))
 (= X30 (- (* 453 S2) (* 1251 S3)))
 (= X30 (- (* 1251 S2) (* 453 S3)))
 (= X30 (+ (* 453 S2) (* 1385 S3)))
 (= X30 (- (* 453 S2) (* 1385 S3)))
 (= X30 (- (* 1385 S2) (* 453 S3)))
 (= X30 (+ (* 453 S2) (* X29 S3)))
 (= X30 (- (* 453 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 453 S3)))
 (= X30 (+ (* 827 S2) S3))
 (= X30 (- (* 827 S2) S3))
 (= X30 (- S2 (* 827 S3)))
 (= X30 (+ (* 827 S2) (* 827 S3)))
 (= X30 (- (* 827 S2) (* 827 S3)))
 (= X30 (+ (* 827 S2) (* 961 S3)))
 (= X30 (- (* 827 S2) (* 961 S3)))
 (= X30 (- (* 961 S2) (* 827 S3)))
 (= X30 (+ (* 827 S2) (* 945 S3)))
 (= X30 (- (* 827 S2) (* 945 S3)))
 (= X30 (- (* 945 S2) (* 827 S3)))
 (= X30 (+ (* 827 S2) (* 947 S3)))
 (= X30 (- (* 827 S2) (* 947 S3)))
 (= X30 (- (* 947 S2) (* 827 S3)))
 (= X30 (+ (* 827 S2) (* 939 S3)))
 (= X30 (- (* 827 S2) (* 939 S3)))
 (= X30 (- (* 939 S2) (* 827 S3)))
 (= X30 (+ (* 827 S2) (* 527 S3)))
 (= X30 (- (* 827 S2) (* 527 S3)))
 (= X30 (- (* 527 S2) (* 827 S3)))
 (= X30 (+ (* 827 S2) (* 1953 S3)))
 (= X30 (- (* 827 S2) (* 1953 S3)))
 (= X30 (- (* 1953 S2) (* 827 S3)))
 (= X30 (+ (* 827 S2) (* 1245 S3)))
 (= X30 (- (* 827 S2) (* 1245 S3)))
 (= X30 (- (* 1245 S2) (* 827 S3)))
 (= X30 (+ (* 827 S2) (* 471 S3)))
 (= X30 (- (* 827 S2) (* 471 S3)))
 (= X30 (- (* 471 S2) (* 827 S3)))
 (= X30 (+ (* 827 S2) (* 1263 S3)))
 (= X30 (- (* 827 S2) (* 1263 S3)))
 (= X30 (- (* 1263 S2) (* 827 S3)))
 (= X30 (+ (* 827 S2) (* 235 S3)))
 (= X30 (- (* 827 S2) (* 235 S3)))
 (= X30 (- (* 235 S2) (* 827 S3)))
 (= X30 (+ (* 827 S2) (* 999 S3)))
 (= X30 (- (* 827 S2) (* 999 S3)))
 (= X30 (- (* 999 S2) (* 827 S3)))
 (= X30 (+ (* 827 S2) (* 1251 S3)))
 (= X30 (- (* 827 S2) (* 1251 S3)))
 (= X30 (- (* 1251 S2) (* 827 S3)))
 (= X30 (+ (* 827 S2) (* 1385 S3)))
 (= X30 (- (* 827 S2) (* 1385 S3)))
 (= X30 (- (* 1385 S2) (* 827 S3)))
 (= X30 (+ (* 827 S2) (* X29 S3)))
 (= X30 (- (* 827 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 827 S3)))
 (= X30 (+ (* 961 S2) S3))
 (= X30 (- (* 961 S2) S3))
 (= X30 (- S2 (* 961 S3)))
 (= X30 (+ (* 961 S2) (* 961 S3)))
 (= X30 (- (* 961 S2) (* 961 S3)))
 (= X30 (+ (* 961 S2) (* 945 S3)))
 (= X30 (- (* 961 S2) (* 945 S3)))
 (= X30 (- (* 945 S2) (* 961 S3)))
 (= X30 (+ (* 961 S2) (* 947 S3)))
 (= X30 (- (* 961 S2) (* 947 S3)))
 (= X30 (- (* 947 S2) (* 961 S3)))
 (= X30 (+ (* 961 S2) (* 939 S3)))
 (= X30 (- (* 961 S2) (* 939 S3)))
 (= X30 (- (* 939 S2) (* 961 S3)))
 (= X30 (+ (* 961 S2) (* 527 S3)))
 (= X30 (- (* 961 S2) (* 527 S3)))
 (= X30 (- (* 527 S2) (* 961 S3)))
 (= X30 (+ (* 961 S2) (* 1953 S3)))
 (= X30 (- (* 961 S2) (* 1953 S3)))
 (= X30 (- (* 1953 S2) (* 961 S3)))
 (= X30 (+ (* 961 S2) (* 1245 S3)))
 (= X30 (- (* 961 S2) (* 1245 S3)))
 (= X30 (- (* 1245 S2) (* 961 S3)))
 (= X30 (+ (* 961 S2) (* 471 S3)))
 (= X30 (- (* 961 S2) (* 471 S3)))
 (= X30 (- (* 471 S2) (* 961 S3)))
 (= X30 (+ (* 961 S2) (* 1263 S3)))
 (= X30 (- (* 961 S2) (* 1263 S3)))
 (= X30 (- (* 1263 S2) (* 961 S3)))
 (= X30 (+ (* 961 S2) (* 235 S3)))
 (= X30 (- (* 961 S2) (* 235 S3)))
 (= X30 (- (* 235 S2) (* 961 S3)))
 (= X30 (+ (* 961 S2) (* 999 S3)))
 (= X30 (- (* 961 S2) (* 999 S3)))
 (= X30 (- (* 999 S2) (* 961 S3)))
 (= X30 (+ (* 961 S2) (* 1251 S3)))
 (= X30 (- (* 961 S2) (* 1251 S3)))
 (= X30 (- (* 1251 S2) (* 961 S3)))
 (= X30 (+ (* 961 S2) (* 1385 S3)))
 (= X30 (- (* 961 S2) (* 1385 S3)))
 (= X30 (- (* 1385 S2) (* 961 S3)))
 (= X30 (+ (* 961 S2) (* X29 S3)))
 (= X30 (- (* 961 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 961 S3)))
 (= X30 (+ (* 945 S2) S3))
 (= X30 (- (* 945 S2) S3))
 (= X30 (- S2 (* 945 S3)))
 (= X30 (+ (* 945 S2) (* 945 S3)))
 (= X30 (- (* 945 S2) (* 945 S3)))
 (= X30 (+ (* 945 S2) (* 947 S3)))
 (= X30 (- (* 945 S2) (* 947 S3)))
 (= X30 (- (* 947 S2) (* 945 S3)))
 (= X30 (+ (* 945 S2) (* 939 S3)))
 (= X30 (- (* 945 S2) (* 939 S3)))
 (= X30 (- (* 939 S2) (* 945 S3)))
 (= X30 (+ (* 945 S2) (* 527 S3)))
 (= X30 (- (* 945 S2) (* 527 S3)))
 (= X30 (- (* 527 S2) (* 945 S3)))
 (= X30 (+ (* 945 S2) (* 1953 S3)))
 (= X30 (- (* 945 S2) (* 1953 S3)))
 (= X30 (- (* 1953 S2) (* 945 S3)))
 (= X30 (+ (* 945 S2) (* 1245 S3)))
 (= X30 (- (* 945 S2) (* 1245 S3)))
 (= X30 (- (* 1245 S2) (* 945 S3)))
 (= X30 (+ (* 945 S2) (* 471 S3)))
 (= X30 (- (* 945 S2) (* 471 S3)))
 (= X30 (- (* 471 S2) (* 945 S3)))
 (= X30 (+ (* 945 S2) (* 1263 S3)))
 (= X30 (- (* 945 S2) (* 1263 S3)))
 (= X30 (- (* 1263 S2) (* 945 S3)))
 (= X30 (+ (* 945 S2) (* 235 S3)))
 (= X30 (- (* 945 S2) (* 235 S3)))
 (= X30 (- (* 235 S2) (* 945 S3)))
 (= X30 (+ (* 945 S2) (* 999 S3)))
 (= X30 (- (* 945 S2) (* 999 S3)))
 (= X30 (- (* 999 S2) (* 945 S3)))
 (= X30 (+ (* 945 S2) (* 1251 S3)))
 (= X30 (- (* 945 S2) (* 1251 S3)))
 (= X30 (- (* 1251 S2) (* 945 S3)))
 (= X30 (+ (* 945 S2) (* 1385 S3)))
 (= X30 (- (* 945 S2) (* 1385 S3)))
 (= X30 (- (* 1385 S2) (* 945 S3)))
 (= X30 (+ (* 945 S2) (* X29 S3)))
 (= X30 (- (* 945 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 945 S3)))
 (= X30 (+ (* 947 S2) S3))
 (= X30 (- (* 947 S2) S3))
 (= X30 (- S2 (* 947 S3)))
 (= X30 (+ (* 947 S2) (* 947 S3)))
 (= X30 (- (* 947 S2) (* 947 S3)))
 (= X30 (+ (* 947 S2) (* 939 S3)))
 (= X30 (- (* 947 S2) (* 939 S3)))
 (= X30 (- (* 939 S2) (* 947 S3)))
 (= X30 (+ (* 947 S2) (* 527 S3)))
 (= X30 (- (* 947 S2) (* 527 S3)))
 (= X30 (- (* 527 S2) (* 947 S3)))
 (= X30 (+ (* 947 S2) (* 1953 S3)))
 (= X30 (- (* 947 S2) (* 1953 S3)))
 (= X30 (- (* 1953 S2) (* 947 S3)))
 (= X30 (+ (* 947 S2) (* 1245 S3)))
 (= X30 (- (* 947 S2) (* 1245 S3)))
 (= X30 (- (* 1245 S2) (* 947 S3)))
 (= X30 (+ (* 947 S2) (* 471 S3)))
 (= X30 (- (* 947 S2) (* 471 S3)))
 (= X30 (- (* 471 S2) (* 947 S3)))
 (= X30 (+ (* 947 S2) (* 1263 S3)))
 (= X30 (- (* 947 S2) (* 1263 S3)))
 (= X30 (- (* 1263 S2) (* 947 S3)))
 (= X30 (+ (* 947 S2) (* 235 S3)))
 (= X30 (- (* 947 S2) (* 235 S3)))
 (= X30 (- (* 235 S2) (* 947 S3)))
 (= X30 (+ (* 947 S2) (* 999 S3)))
 (= X30 (- (* 947 S2) (* 999 S3)))
 (= X30 (- (* 999 S2) (* 947 S3)))
 (= X30 (+ (* 947 S2) (* 1251 S3)))
 (= X30 (- (* 947 S2) (* 1251 S3)))
 (= X30 (- (* 1251 S2) (* 947 S3)))
 (= X30 (+ (* 947 S2) (* 1385 S3)))
 (= X30 (- (* 947 S2) (* 1385 S3)))
 (= X30 (- (* 1385 S2) (* 947 S3)))
 (= X30 (+ (* 947 S2) (* X29 S3)))
 (= X30 (- (* 947 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 947 S3)))
 (= X30 (+ (* 939 S2) S3))
 (= X30 (- (* 939 S2) S3))
 (= X30 (- S2 (* 939 S3)))
 (= X30 (+ (* 939 S2) (* 939 S3)))
 (= X30 (- (* 939 S2) (* 939 S3)))
 (= X30 (+ (* 939 S2) (* 527 S3)))
 (= X30 (- (* 939 S2) (* 527 S3)))
 (= X30 (- (* 527 S2) (* 939 S3)))
 (= X30 (+ (* 939 S2) (* 1953 S3)))
 (= X30 (- (* 939 S2) (* 1953 S3)))
 (= X30 (- (* 1953 S2) (* 939 S3)))
 (= X30 (+ (* 939 S2) (* 1245 S3)))
 (= X30 (- (* 939 S2) (* 1245 S3)))
 (= X30 (- (* 1245 S2) (* 939 S3)))
 (= X30 (+ (* 939 S2) (* 471 S3)))
 (= X30 (- (* 939 S2) (* 471 S3)))
 (= X30 (- (* 471 S2) (* 939 S3)))
 (= X30 (+ (* 939 S2) (* 1263 S3)))
 (= X30 (- (* 939 S2) (* 1263 S3)))
 (= X30 (- (* 1263 S2) (* 939 S3)))
 (= X30 (+ (* 939 S2) (* 235 S3)))
 (= X30 (- (* 939 S2) (* 235 S3)))
 (= X30 (- (* 235 S2) (* 939 S3)))
 (= X30 (+ (* 939 S2) (* 999 S3)))
 (= X30 (- (* 939 S2) (* 999 S3)))
 (= X30 (- (* 999 S2) (* 939 S3)))
 (= X30 (+ (* 939 S2) (* 1251 S3)))
 (= X30 (- (* 939 S2) (* 1251 S3)))
 (= X30 (- (* 1251 S2) (* 939 S3)))
 (= X30 (+ (* 939 S2) (* 1385 S3)))
 (= X30 (- (* 939 S2) (* 1385 S3)))
 (= X30 (- (* 1385 S2) (* 939 S3)))
 (= X30 (+ (* 939 S2) (* X29 S3)))
 (= X30 (- (* 939 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 939 S3)))
 (= X30 (+ (* 527 S2) S3))
 (= X30 (- (* 527 S2) S3))
 (= X30 (- S2 (* 527 S3)))
 (= X30 (+ (* 527 S2) (* 527 S3)))
 (= X30 (- (* 527 S2) (* 527 S3)))
 (= X30 (+ (* 527 S2) (* 1953 S3)))
 (= X30 (- (* 527 S2) (* 1953 S3)))
 (= X30 (- (* 1953 S2) (* 527 S3)))
 (= X30 (+ (* 527 S2) (* 1245 S3)))
 (= X30 (- (* 527 S2) (* 1245 S3)))
 (= X30 (- (* 1245 S2) (* 527 S3)))
 (= X30 (+ (* 527 S2) (* 471 S3)))
 (= X30 (- (* 527 S2) (* 471 S3)))
 (= X30 (- (* 471 S2) (* 527 S3)))
 (= X30 (+ (* 527 S2) (* 1263 S3)))
 (= X30 (- (* 527 S2) (* 1263 S3)))
 (= X30 (- (* 1263 S2) (* 527 S3)))
 (= X30 (+ (* 527 S2) (* 235 S3)))
 (= X30 (- (* 527 S2) (* 235 S3)))
 (= X30 (- (* 235 S2) (* 527 S3)))
 (= X30 (+ (* 527 S2) (* 999 S3)))
 (= X30 (- (* 527 S2) (* 999 S3)))
 (= X30 (- (* 999 S2) (* 527 S3)))
 (= X30 (+ (* 527 S2) (* 1251 S3)))
 (= X30 (- (* 527 S2) (* 1251 S3)))
 (= X30 (- (* 1251 S2) (* 527 S3)))
 (= X30 (+ (* 527 S2) (* 1385 S3)))
 (= X30 (- (* 527 S2) (* 1385 S3)))
 (= X30 (- (* 1385 S2) (* 527 S3)))
 (= X30 (+ (* 527 S2) (* X29 S3)))
 (= X30 (- (* 527 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 527 S3)))
 (= X30 (+ (* 1953 S2) S3))
 (= X30 (- (* 1953 S2) S3))
 (= X30 (- S2 (* 1953 S3)))
 (= X30 (+ (* 1953 S2) (* 1953 S3)))
 (= X30 (- (* 1953 S2) (* 1953 S3)))
 (= X30 (+ (* 1953 S2) (* 1245 S3)))
 (= X30 (- (* 1953 S2) (* 1245 S3)))
 (= X30 (- (* 1245 S2) (* 1953 S3)))
 (= X30 (+ (* 1953 S2) (* 471 S3)))
 (= X30 (- (* 1953 S2) (* 471 S3)))
 (= X30 (- (* 471 S2) (* 1953 S3)))
 (= X30 (+ (* 1953 S2) (* 1263 S3)))
 (= X30 (- (* 1953 S2) (* 1263 S3)))
 (= X30 (- (* 1263 S2) (* 1953 S3)))
 (= X30 (+ (* 1953 S2) (* 235 S3)))
 (= X30 (- (* 1953 S2) (* 235 S3)))
 (= X30 (- (* 235 S2) (* 1953 S3)))
 (= X30 (+ (* 1953 S2) (* 999 S3)))
 (= X30 (- (* 1953 S2) (* 999 S3)))
 (= X30 (- (* 999 S2) (* 1953 S3)))
 (= X30 (+ (* 1953 S2) (* 1251 S3)))
 (= X30 (- (* 1953 S2) (* 1251 S3)))
 (= X30 (- (* 1251 S2) (* 1953 S3)))
 (= X30 (+ (* 1953 S2) (* 1385 S3)))
 (= X30 (- (* 1953 S2) (* 1385 S3)))
 (= X30 (- (* 1385 S2) (* 1953 S3)))
 (= X30 (+ (* 1953 S2) (* X29 S3)))
 (= X30 (- (* 1953 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 1953 S3)))
 (= X30 (+ (* 1245 S2) S3))
 (= X30 (- (* 1245 S2) S3))
 (= X30 (- S2 (* 1245 S3)))
 (= X30 (+ (* 1245 S2) (* 1245 S3)))
 (= X30 (- (* 1245 S2) (* 1245 S3)))
 (= X30 (+ (* 1245 S2) (* 471 S3)))
 (= X30 (- (* 1245 S2) (* 471 S3)))
 (= X30 (- (* 471 S2) (* 1245 S3)))
 (= X30 (+ (* 1245 S2) (* 1263 S3)))
 (= X30 (- (* 1245 S2) (* 1263 S3)))
 (= X30 (- (* 1263 S2) (* 1245 S3)))
 (= X30 (+ (* 1245 S2) (* 235 S3)))
 (= X30 (- (* 1245 S2) (* 235 S3)))
 (= X30 (- (* 235 S2) (* 1245 S3)))
 (= X30 (+ (* 1245 S2) (* 999 S3)))
 (= X30 (- (* 1245 S2) (* 999 S3)))
 (= X30 (- (* 999 S2) (* 1245 S3)))
 (= X30 (+ (* 1245 S2) (* 1251 S3)))
 (= X30 (- (* 1245 S2) (* 1251 S3)))
 (= X30 (- (* 1251 S2) (* 1245 S3)))
 (= X30 (+ (* 1245 S2) (* 1385 S3)))
 (= X30 (- (* 1245 S2) (* 1385 S3)))
 (= X30 (- (* 1385 S2) (* 1245 S3)))
 (= X30 (+ (* 1245 S2) (* X29 S3)))
 (= X30 (- (* 1245 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 1245 S3)))
 (= X30 (+ (* 471 S2) S3))
 (= X30 (- (* 471 S2) S3))
 (= X30 (- S2 (* 471 S3)))
 (= X30 (+ (* 471 S2) (* 471 S3)))
 (= X30 (- (* 471 S2) (* 471 S3)))
 (= X30 (+ (* 471 S2) (* 1263 S3)))
 (= X30 (- (* 471 S2) (* 1263 S3)))
 (= X30 (- (* 1263 S2) (* 471 S3)))
 (= X30 (+ (* 471 S2) (* 235 S3)))
 (= X30 (- (* 471 S2) (* 235 S3)))
 (= X30 (- (* 235 S2) (* 471 S3)))
 (= X30 (+ (* 471 S2) (* 999 S3)))
 (= X30 (- (* 471 S2) (* 999 S3)))
 (= X30 (- (* 999 S2) (* 471 S3)))
 (= X30 (+ (* 471 S2) (* 1251 S3)))
 (= X30 (- (* 471 S2) (* 1251 S3)))
 (= X30 (- (* 1251 S2) (* 471 S3)))
 (= X30 (+ (* 471 S2) (* 1385 S3)))
 (= X30 (- (* 471 S2) (* 1385 S3)))
 (= X30 (- (* 1385 S2) (* 471 S3)))
 (= X30 (+ (* 471 S2) (* X29 S3)))
 (= X30 (- (* 471 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 471 S3)))
 (= X30 (+ (* 1263 S2) S3))
 (= X30 (- (* 1263 S2) S3))
 (= X30 (- S2 (* 1263 S3)))
 (= X30 (+ (* 1263 S2) (* 1263 S3)))
 (= X30 (- (* 1263 S2) (* 1263 S3)))
 (= X30 (+ (* 1263 S2) (* 235 S3)))
 (= X30 (- (* 1263 S2) (* 235 S3)))
 (= X30 (- (* 235 S2) (* 1263 S3)))
 (= X30 (+ (* 1263 S2) (* 999 S3)))
 (= X30 (- (* 1263 S2) (* 999 S3)))
 (= X30 (- (* 999 S2) (* 1263 S3)))
 (= X30 (+ (* 1263 S2) (* 1251 S3)))
 (= X30 (- (* 1263 S2) (* 1251 S3)))
 (= X30 (- (* 1251 S2) (* 1263 S3)))
 (= X30 (+ (* 1263 S2) (* 1385 S3)))
 (= X30 (- (* 1263 S2) (* 1385 S3)))
 (= X30 (- (* 1385 S2) (* 1263 S3)))
 (= X30 (+ (* 1263 S2) (* X29 S3)))
 (= X30 (- (* 1263 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 1263 S3)))
 (= X30 (+ (* 235 S2) S3))
 (= X30 (- (* 235 S2) S3))
 (= X30 (- S2 (* 235 S3)))
 (= X30 (+ (* 235 S2) (* 235 S3)))
 (= X30 (- (* 235 S2) (* 235 S3)))
 (= X30 (+ (* 235 S2) (* 999 S3)))
 (= X30 (- (* 235 S2) (* 999 S3)))
 (= X30 (- (* 999 S2) (* 235 S3)))
 (= X30 (+ (* 235 S2) (* 1251 S3)))
 (= X30 (- (* 235 S2) (* 1251 S3)))
 (= X30 (- (* 1251 S2) (* 235 S3)))
 (= X30 (+ (* 235 S2) (* 1385 S3)))
 (= X30 (- (* 235 S2) (* 1385 S3)))
 (= X30 (- (* 1385 S2) (* 235 S3)))
 (= X30 (+ (* 235 S2) (* X29 S3)))
 (= X30 (- (* 235 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 235 S3)))
 (= X30 (+ (* 999 S2) S3))
 (= X30 (- (* 999 S2) S3))
 (= X30 (- S2 (* 999 S3)))
 (= X30 (+ (* 999 S2) (* 999 S3)))
 (= X30 (- (* 999 S2) (* 999 S3)))
 (= X30 (+ (* 999 S2) (* 1251 S3)))
 (= X30 (- (* 999 S2) (* 1251 S3)))
 (= X30 (- (* 1251 S2) (* 999 S3)))
 (= X30 (+ (* 999 S2) (* 1385 S3)))
 (= X30 (- (* 999 S2) (* 1385 S3)))
 (= X30 (- (* 1385 S2) (* 999 S3)))
 (= X30 (+ (* 999 S2) (* X29 S3)))
 (= X30 (- (* 999 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 999 S3)))
 (= X30 (+ (* 1251 S2) S3))
 (= X30 (- (* 1251 S2) S3))
 (= X30 (- S2 (* 1251 S3)))
 (= X30 (+ (* 1251 S2) (* 1251 S3)))
 (= X30 (- (* 1251 S2) (* 1251 S3)))
 (= X30 (+ (* 1251 S2) (* 1385 S3)))
 (= X30 (- (* 1251 S2) (* 1385 S3)))
 (= X30 (- (* 1385 S2) (* 1251 S3)))
 (= X30 (+ (* 1251 S2) (* X29 S3)))
 (= X30 (- (* 1251 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 1251 S3)))
 (= X30 (+ (* 1385 S2) S3))
 (= X30 (- (* 1385 S2) S3))
 (= X30 (- S2 (* 1385 S3)))
 (= X30 (+ (* 1385 S2) (* 1385 S3)))
 (= X30 (- (* 1385 S2) (* 1385 S3)))
 (= X30 (+ (* 1385 S2) (* X29 S3)))
 (= X30 (- (* 1385 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* 1385 S3)))
 (= X30 (+ (* X29 S2) S3))
 (= X30 (- (* X29 S2) S3))
 (= X30 (- S2 (* X29 S3)))
 (= X30 (+ (* X29 S2) (* X29 S3)))
 (= X30 (- (* X29 S2) (* X29 S3)))
))
(assert (and (> X30 0) (< X30 4096) (power2 S2) (power2 S3)))
(assert
 (= X30 2027)
)
(check-sat)
(exit)
